<?php
    $AjaxFunctions['showDropBehaviorGW'] = 'showDropBehaviorGW';
    $AjaxFunctions['getDropBehaviorGW'] = 'getDropBehaviorGW';
    $AjaxFunctions['formDropBehaviorGW'] = 'formDropBehaviorGW';
    $AjaxFunctions['saveDropBehaviorGW'] = 'saveDropBehaviorGW';
    $AjaxFunctions['deleteDropBehaviorGW'] = 'deleteDropBehaviorGW';
    $AjaxFunctions['showNotifyBehaviorGW'] = 'showNotifyBehaviorGW';
    $AjaxFunctions['formNotifyBehaviorGW'] = 'formNotifyBehaviorGW';
    $AjaxFunctions['saveNotifyBehaviorGW'] = 'saveNotifyBehaviorGW';
    $AjaxFunctions['deleteNotifyBehaviorGW'] = 'deleteNotifyBehaviorGW';
    $AjaxFunctions['showAnalyticsBehaviorGW'] = 'showAnalyticsBehaviorGW';
    $AjaxFunctions['saveAnalyticsBehaviorGW'] = 'saveAnalyticsBehaviorGW';
    $AjaxFunctions['deleteAnalyticsBehaviorGW'] = 'deleteAnalyticsBehaviorGW';
    $AjaxFunctions['getAnalyticsBehaviorGW'] = 'getAnalyticsBehaviorGW';
    $AjaxFunctions['getAnalyticsPatternsGW'] = 'getAnalyticsPatternsGW';
    $AjaxFunctions['getAnalyticsAudioGW'] = 'getAnalyticsAudioGW';
    $AjaxFunctions['showProfilesGW'] = 'showProfilesGW';
    $AjaxFunctions['formProfileGW'] = 'formProfileGW';
    $AjaxFunctions['saveProfileGW'] = 'saveProfileGW';
    $AjaxFunctions['deleteProfileGW'] = 'deleteProfileGW';
    $AjaxFunctions['setDefaultProfileGW'] = 'setDefaultProfileGW';

    ///////////////////////////////////////////////////////////////////////////
    // Behaviors
    ///////////////////////////////////////////////////////////////////////////

    function showDropBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );

        //TODO: implement SIPHeader
        $dropcomponents = array( 'SIPCode', /* 'SIPHeader', */
        'ISDNCause' );

        $yaml = new KGatewayProfileYaml( );

        $r = "<fieldset id='gateway-profile-drop-behavior'><legend>{$app->translate( 'gateway-profile-drop-behavior' )}</legend><div class='gateway-profile-drop-behavior'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add-drop-behavior' /><br /><br />";

        if( $yaml->countDropBehaviors( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-behavior-found' )}</p>";
        }
        else
        {
            $r .= '<table class=\'gateway-table gateway-profile-drop-behaviors zebra\'><thead>';
            $r .= "<tr><th>{$app->translate( 'Name' )}</th><th>{$app->translate( 'description' )}</th><th class='gateway-table-options'>{$app->translate( 'Options' )}</th></tr></thead><tbody>";
            foreach( $yaml->getAllDropBehaviors() as $behavior )
            {
                $components = array( );
                foreach( $dropcomponents as $c )
                {
                    $k = $app->translate( "gateway-profile-behavior-{$c}" );
                    if( isset( $behavior[$c] ) && $behavior[$c] )
                    {
                        $components[] = "{$k}: {$behavior[$c]}";
                    }
                }
                $components = implode( ', ', $components );
                $r .= "<tr><td>{$behavior['Name']}</td><td>{$components}</td><td class='gateway-table-options'><img class='gateway-profile-edit-drop-behavior' src='/imagens/edit.png' title='{$app->translate( 'edit' )}' border='0' /><img class='gateway-profile-delete-drop-behavior' src='/imagens/remove.png' title='{$app->translate( 'delete' )}' border='0' /></td></tr>";
            }
            $r .= '</tbody></table>';
        }

        $r .= "</div></fieldset>";

        return $r;
    }

    function getDropBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';

        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'gateway-profile-error-behavior-not-found' ) );

        try
        {
            $result = $yaml->getAllDropBehaviors();

            $reply = array(
                'success' => true,
                'message' => 'OK',
                'result' => $result );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function formDropBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $_name = isset( $_POST['name'] ) ? $_POST['name'] : null;
        // new/blank form
        if( is_null( $_name ) )
        {
            $behavior = array( 'Name' => '', 'SIPCode' => '', 'SIPHeader' => '', 'ISDNCause' => '' );
        }
        else
        {
            $behavior = $yaml->getDropBehavior( $_name );
            if( is_null( $behavior ) )
            {
                return $app->translate( 'gateway-profile-error-behavior-not-found' );
            }
        }

        $r = '<table class=\'gateway-table-form simpleTable zebra\'>';
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-name'>{$app->translate( 'Name' )}</label></td><td class='gateway-form-field-container-right'><input type='text' id='gateway-profile-behavior-name' name='Name' value='{$behavior['Name']}' /><input type='hidden' name='__oldname__' value='{$behavior['Name']}' /></td></tr>";
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-SIPCode'>{$app->translate( 'gateway-profile-behavior-SIPCode' )}</label></td><td class='gateway-form-field-container-right'><input type='text' id='gateway-profile-behavior-SIPCode' name='SIPCode' value='{$behavior['SIPCode']}' /></td></tr>";
        //@formatter:off
        //TODO: activate when SIP HEADER gets implemented
        /*$r .= "<tr><td class='label'><label for='gateway-profile-behavior-SIPHeader'>{$app->translate( 'gateway-profile-behavior-SIPHeader' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-behavior-help-SIPHeader' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right'><input type='text' id='gateway-profile-behavior-SIPHeader' name='SIPHeader' value='{$behavior['SIPHeader']}' /></td></tr>";*/
        //@formatter:on
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-ISDNCause'>{$app->translate( 'gateway-profile-behavior-ISDNCause' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-behavior-help-ISDNCause' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right'><input type='text' id='gateway-profile-behavior-ISDNCause' name='ISDNCause' value='{$behavior['ISDNCause']}' maxlength='3' /></td></tr>";
        $r .= '</table><br />';
        
        $r .= "<div class='textAlignRight'>";
        $r .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-profile-behavior-back' />";
        $r .= "<input type='button' value='{$app->translate( 'save' )}' id='gateway-profile-behavior-save' /></div>";
        return $r;
    }

    function saveDropBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-save' ) );

        try
        {
            $behavior = $_POST;
            if( isset( $behavior['__oldname__'] ) )
            {
                unset( $behavior['__oldname__'] );
            }
            $oldName = isset( $_POST['__oldname__'] ) && $_POST['__oldname__'] ? $_POST['__oldname__'] : '';
            $yaml->setDropBehavior( $behavior, $oldName );
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteDropBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-delete' ) );

        try
        {
            $name = isset( $_POST['name'] ) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->deleteDropBehavior( $name ) )
            {
                throw new Exception( 'gateway-profile-behavior-error-not-found' );
            }
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-deleted' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function showNotifyBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );

        $yaml = new KGatewayProfileYaml( );

        $r = "<fieldset id='gateway-profile-notify-behavior'><legend>{$app->translate( 'gateway-profile-notify-behavior' )}</legend><div class='gateway-profile-notify-behavior'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add-notify-behavior' /><br /><br />";

        if( $yaml->countNotifyBehaviors( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-behavior-found' )}</p>";
        }
        else
        {
            $r .= '<table class=\'gateway-table gateway-profile-notify-behaviors zebra\'><thead>';
            $r .= "<tr><th>{$app->translate( 'Name' )}</th><th>{$app->translate( 'description' )}</th><th class='gateway-table-options'>{$app->translate( 'Options' )}</th></tr></thead><tbody>";
            foreach( $yaml->getAllNotifyBehaviors() as $behavior )
            {
                $r .= "<tr><td>{$behavior['Name']}</td><td>{$app->translate( 'gateway-profile-behavior-SIPHeader' )}: {$behavior['SIPHeader']}</td><td class='gateway-table-options'><img class='gateway-profile-edit-notify-behavior' src='/imagens/edit.png' title='{$app->translate( 'edit' )}' border='0' /><img class='gateway-profile-delete-notify-behavior' src='/imagens/remove.png' title='{$app->translate( 'delete' )}' border='0' /></td></tr>";
            }
            $r .= '</tbody></table>';
        }

        $r .= '</div></fieldset>';

        return $r;
    }

    function formNotifyBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $_name = isset( $_POST['name'] ) ? $_POST['name'] : null;
        // new/blank form
        if( is_null( $_name ) )
        {
            $behavior = array( 'Name' => '', 'SIPHeader' => '' );
        }
        else
        {
            $behavior = $yaml->getNotifyBehavior( $_name );
            if( is_null( $behavior ) )
            {
                return $app->translate( 'gateway-profile-error-behavior-not-found' );
            }
        }

        $r = '<table class=\'gateway-table-form\'>';
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-name'>{$app->translate( 'Name' )}</label></td><td><input type='text' id='gateway-profile-behavior-name' name='Name' value='{$behavior['Name']}' /><input type='hidden' name='__oldname__' value='{$behavior['Name']}' /></td></tr>";
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-SIPHeader'>{$app->translate( 'gateway-profile-behavior-SIPHeader' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-behavior-help-SIPHeader' class='gateway-tooltip' /></td><td><input type='text' id='gateway-profile-behavior-SIPHeader' name='SIPHeader' value='{$behavior['SIPHeader']}' /></td></tr>";
        $r .= '</table><br />';
        $r .= "<input type='button' value='{$app->translate( 'save' )}' id='gateway-profile-behavior-save' />";
        $r .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-profile-behavior-back' />";
        return $r;
    }

    function saveNotifyBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-save' ) );

        try
        {
            $behavior = $_POST;
            if( isset( $behavior['__oldname__'] ) )
            {
                unset( $behavior['__oldname__'] );
            }
            $oldName = isset( $_POST['__oldname__'] ) && $_POST['__oldname__'] ? $_POST['__oldname__'] : '';
            $yaml->setNotifyBehavior( $behavior, $oldName );
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteNotifyBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-delete' ) );

        try
        {
            $name = isset( $_POST['name'] ) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->deleteNotifyBehavior( $name ) )
            {
                throw new Exception( 'gateway-profile-behavior-error-not-found' );
            }
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-deleted' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function showAnalyticsBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';

        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $r  = "<fieldset id='gateway-profile-hmp-behavior'>";
        $r .= "<legend>";
        $r .= "{$app->translate( 'gateway-profile-hmp-behavior' )}";
        $r .= "</legend>";
        $r .= "<div id='gateway-profile-hmp-form-div' class='gateway-profile-hmp-form'></div>";
        $r .= "<div class='gateway-profile-hmp-behavior'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add-hmp-behavior' />";
        $r .= "<br /><br />";

        if( $yaml->countAnalyticsBehaviors( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-behavior-found' )}</p>";
        }
        else
        {
            $r .= "<table class='gateway-table gateway-profile-hmp-behaviors zebra'>";
            $r .= "<thead>";
            $r .= "<tr>";
            $r .= "<th>{$app->translate( 'Name' )}</th>";
            $r .= "<th>{$app->translate( 'Locale' )}</th>";
            $r .= "<th class='gateway-table-options'>{$app->translate( 'Options' )}</th>";
            $r .= "</tr>";
            $r .= "</thead>";

            $r .= "<tbody>";
            foreach( $yaml->getAllAnalyticsBehaviors() as $behavior )
            {
                $locale = $behavior['Locale'] == "" ? "pt-BR" : $behavior['Locale'];

                $r .= "<tr>";
                $r .= "<td>{$behavior['Name']}</td>";
                $r .= "<td id='{$locale}'>{$app->translate( $locale )}</td>";
                $r .= "<td class='gateway-table-options'>";
                $r .= "<img class='gateway-profile-edit-hmp-behavior' src='/imagens/edit.png' title='{$app->translate( 'edit' )}' border='0' />";
                $r .= "<img class='gateway-profile-delete-hmp-behavior' src='/imagens/remove.png' title='{$app->translate( 'delete' )}' border='0' />";
                $r .= "</td>";
                $r .= "</tr>";
            }
            $r .= "</tbody>";

            $r .= "</table>";
        }

        $r .= "</div>";
        $r .= "</fieldset>";

        return $r;
    }

    function saveAnalyticsBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';

        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'gateway-profile-error-behavior-save' ) );

        try
        {
            $behavior = $_POST;

            if( isset( $behavior['__oldname__'] ) )
            {
                unset( $behavior['__oldname__'] );
            }

            $oldName =
                isset( $_POST['__oldname__'] ) && $_POST['__oldname__']
                    ? $_POST['__oldname__']
                    : '';

            $yaml->setAnalyticsBehavior( $behavior, $oldName );

            $yaml->save( );

            $reply = array(
                'success' => true,
                'message' => $app->translate( 'gateway-profile-behavior-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteAnalyticsBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';

        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'gateway-profile-error-behavior-delete' ) );

        try
        {
            $name = isset( $_POST['name'] ) ? $_POST['name'] : null;

            if( is_null( $name ) || !$yaml->deleteAnalyticsBehavior( $name ) )
            {
                throw new Exception( 'gateway-profile-behavior-error-not-found' );
            }

            $yaml->save( );

            $reply = array(
                'success' => true,
                'message' => $app->translate( 'gateway-profile-behavior-deleted' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function getAnalyticsBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';

        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'gateway-profile-error-behavior-not-found' ) );

        try
        {
            $behavior = $_POST;

            if ( $yaml->hasAnalyticsBehavior( $behavior['name'] ) )
            {
                $result = $yaml->getAnalyticsBehavior( $behavior['name'] );

                $reply = array(
                    'success' => true,
                    'message' => 'OK',
                    'result' => $result );
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function getAnalyticsPatternsGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KHMPAnalyticsYaml.php';

        $app = KSystem::getInstance( );

        $locale = '';

        $parameters = $_POST;

        if( isset( $parameters['Locale'] ) )
        {
            $locale = $parameters['Locale'];
        }

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'gateway-profile-error-behavior-not-found' ) );

        try
        {
            $yaml = new KHMPAnalyticsYaml( $locale );

            $result = $yaml->getAllPatterns( );

            $reply = array(
                'success' => true,
                'message' => 'OK',
                'result' => $result );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function getAnalyticsAudioGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileAudioFileManager.php';

        $app = KSystem::getInstance( );
        $manager = new KGatewayProfileAudioFileManager( );

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'gateway-profile-error-behavior-not-found' ) );

        try
        {
            $result = $manager->getFiles();

            $reply = array(
                'success' => true,
                'message' => 'OK',
                'result' => $result );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    ///////////////////////////////////////////////////////////////////////////
    // Profiles
    ///////////////////////////////////////////////////////////////////////////

    function showProfilesGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );

        $yaml = new KGatewayProfileYaml( );

        $r = "<fieldset id='gateway-profile-fs'><legend>{$app->translate( 'gateway-profiles' )}</legend><div class='gateway-profile'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add' /><br /><br />";

        if( $yaml->countProfiles( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-profile-found' )}</p>";
        }
        else
        {
            $r .= '<table class=\'zebra gateway-table gateway-profiles zebra\'><thead>';
            $r .= "<tr><th>{$app->translate( 'Name' )}</th><th>{$app->translate( 'description' )}</th><th class='gateway-table-options'>{$app->translate( 'Options' )}</th></tr></thead><tbody>";
            foreach( $yaml->getAllProfiles() as $profile )
            {
                $name = "<span border='0' " . ($yaml->isDefaultProfile( $profile['Name'] ) ? "style='font-weight: bold'" : "") . ">{$profile['Name']}</span>";
                $optDefault = "<img class='gateway-profile-set-as-default' src='/imagens/default.png' border='0' title='{$app->translate( 'gateway-profile-set-as-default' )}' width='16' height='16' " . ($yaml->isDefaultProfile( $profile['Name'] ) ? "style='visibility:hidden'" : "") . "/>";
                $optEdit = "<img class='gateway-profile-edit' src='/imagens/edit.png' title='{$app->translate( 'edit' )}' border='0' " . (( $profile['ReadOnly'] ) ? "style='visibility:hidden'" : "") . "/>";
                $optDelete = "<img class='gateway-profile-delete' src='/imagens/remove.png' title='{$app->translate( 'delete' )}' border='0' " . (( $profile['ReadOnly'] ) ? "style='visibility:hidden'" : "") . "/>";
                $optCopy = "<img class='gateway-profile-copy' src='/imagens/copy.png' title='{$app->translate( 'copy' )}' border='0'/>";
  
                $description = _getProfileDescription( $profile );
                
                $r .= "<tr><td>{$name}</td><td>{$description}</td><td class='gateway-table-options'>{$optDefault} {$optEdit} {$optCopy} {$optDelete}</td></tr>";
            }
            $r .= '</tbody></table>';
        }

        $r .= '</div></fieldset>';
        return $r;
    }

    function _profileCauseMapInput( &$cause, $type )
    {
        return "<input type='text' id='gateway-profile-cause-map-{$cause['Id']}-{$type}' value='{$cause[$type]}' maxlength='3' class='gateway-profile-cause-map-input' />";
    }

    function _profileCauseMapRetry( &$cause )
    {
        $retry = isset( $cause['Retry'] ) && $cause['Retry'] ? 'checked=\'checked\' ' : '';
        return "<input type='checkbox' id='gateway-profile-cause-map-{$cause['Id']}-Retry' ${retry}/>";
    }

    function formProfileGW( )
    {
        require_once KCONFIG . '/classes/KGatewayYaml.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        require_once KCONFIG . '/classes/KGatewayProfileAudioFileManager.php';
        require_once KROOT . '/classes/KLicense.php';
        require_once KROOT . '/classes/KFeatures.php';

        $app = KSystem::getInstance( );

        $yaml = new KGatewayProfileYaml( );
        $gatewayyaml = new KGatewayYaml( );
        $manager = new KGatewayProfileAudioFileManager( );
        $lm = new KLicenseManager( );

        $_name = isset( $_POST['name'] ) ? $_POST['name'] : null;

        if( is_null( $_name ) )
        {
            //@formatter:off
            $profile = array(
                'Name' => '',
                'EnableFeatures' => array( 'EchoCanceller' ),
                'DisableFeatures' => array(),
                'FAX' => array(
                    'Mode' => 'T38'
                ),
                'R2' => array(
                    'DoubleAnswer' => array(
                        'Enabled' => false,
                        'Timeout' => 1000
                    )
                ),
                'SIP' => array(
                    'CustomHeaders' => array(),
                    'RelayExtensionHeaders' => false
                ),
                'Cadences' => array(
                    'Enabled' => true,
                    'Trying' => '25,500,25,2000',
                    'Ringback' => '1000,4000'
                ),
                'CallAnalyzer' => ''
            );
            //@formatter:on
            $defaultProfile = $yaml->getDefaultProfile( );
            $profile['CauseMap'] = $defaultProfile['CauseMap'];
            unset( $defaultProfile );
        }
        else
        {
            $profile = $yaml->getProfile( $_name );
            if( !$profile )
            {
                throw new Exception( 'gateway-profile-error-not-found' );
            }
        }

        if( isset( $_POST['copy'] ) && $_POST['copy'] )
        {
            $profile['Name'] = '';
        }

        $r = "<div id='gateway-profile-hmp-form-div' class='gateway-profile-hmp-form'></div>";
        $r .= '<table class=\'gateway-table-form simpleTable\'>';
        $r .= "<tr><td class='label'><label for='gateway-profile-name'>{$app->translate( 'Name' )}</label></td><td class='gateway-form-field-container-right'><input type='text' id='gateway-profile-name' name='Name' value='{$profile['Name']}' /><input type='hidden' id='gateway-profile-oldname' name='__oldname__' value='{$profile['Name']}' /></td></tr>";

        // Call Analyzer Options
        $ca_behavior_name = $profile['CallAnalyzer'];
        $r .= "<tr>";
        $r .= "<td class='label'>{$app->translate( 'gateway-profile-call-analyzer' )}</td>";
        $r .= '<td class="gateway-form-field-container-right">';
        if ( $lm->anyLicenseHasAnyType( KLicense::TYPES_GATEWAY_ANALYTICS ) && KFeatures::checkFeature( 'CALL_ANALYZER' ) )
        {
            $r .= "<select id='gateway-profile-call-analyzer-option' class='gateway-profile-call-analyzer-option'>";
            $selected = ( $ca_behavior_name == '' ) ? 'selected' : '';
            $r .= "<option value='' {$selected}>{$app->translate( 'disabled' )}</option>";
            foreach( $yaml->getAllAnalyticsBehaviors() as $behavior )
            {
                $selected = ( $ca_behavior_name == $behavior["Name"] ) ? "selected" : "";
                $r .= "<option value='{$behavior["Name"]}' {$selected}>{$behavior["Name"]}</option>";
            }
            $r .= "<option value='add-behavior' class='option-action-add'>{$app->translate( 'add' )}...</option>";
            $r .= "</select>";
        }
        else
        {
            $r .= "<span class='gateway-profile-call-analyzer-required'>{$app->translate( 'gateway-profile-call-analyzer-required' )}</span>";
            $r .= "<input id='gateway-profile-call-analyzer-option' type='hidden' value='{$ca_behavior_name}' />";
        }
        $r .= "</td>";
        $r .= "</tr>";

        $r .= '</table>';

        // Audio
        $r .= "<fieldset><legend>{$app->translate( 'gateway-profile-audio' )}</legend>";
        $r .= '<table width="100%" class="gateway-profile-features-table gateway-table-form simpleTable"><tbody>';
        $r .= _getAudioFormCheckboxRow( $profile[ 'EnableFeatures' ], 'EchoCanceller', 'gateway-profile-features' );
        $r .= _getAudioFormCheckboxRow( $profile[ 'EnableFeatures' ], 'DTMFSupression', 'gateway-profile-features' );

        // Audio - Gain control
        $r .= "<td class='label'><label for='gateway-profile-features-GainControl'>{$app->translate( 'gateway-profile-audio-GainControl' )}</label></td>";
        $r .= '<td class="gateway-form-field-container-right"><select id="gateway-profile-features-GainControl">';

        foreach( array( '', 'AutoGainControl', 'SetVolumeGain' ) as $gain )
        {
            $selected = in_array( $gain, $profile['EnableFeatures'] ) ? ' selected=\'selected\'' : '';
            $key = $gain ? "gateway-profile-audio-{$gain}" : 'gateway-profile-audio-GainControlDisabled';
            $r .= "<option value='{$gain}'{$selected}>{$app->translate( $key )}</option>";
        }
        $r .= '</select>';

        $volumeGain = isset( $profile[ 'VolumeGain' ] ) ? (int)$profile[ 'VolumeGain' ] : 0;
        $r .= "<input type='text' value='{$volumeGain}' required='required' id='gateway-profile-features-VolumeGain' class='gateway-profile-volume-gain-input' disabled='disabled' maxlength='3' min='-10' max='10' />";
        $r .= '</td></tr>';


        $r .= "</tbody></table>";

        $r .= '</fieldset>';

        // FAX
        $r .= '<fieldset><legend>FAX</legend><table class=\'simpleTable gateway-table-form\'>';
        $select = '<select id=\'gateway-profile-fax-mode\'>';

        foreach( KGatewayProfileYaml::$faxModes as $mode )
        {
            $selected = ($mode === $profile['FAX']['Mode']) ? ' selected' : '';
            $key = "gateway-profile-fax-mode-{$mode}";
            $select .= "<option value='{$mode}'{$selected}>{$app->translate( $key )}</option>";
        }

        $select .= '</select>';
        $r .= "<tr><td class='label'><label for='gateway-profile-fax-mode'>{$app->translate( 'gateway-profile-fax-mode' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-fax' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right'>{$select}</td></tr>";
        unset( $select );
        $r .= '</table></fieldset>';
        
        /// R2
        $r .= '<fieldset><legend>R2</legend><table class=\'simpleTable gateway-table-form\'><tbody>';
        $checked = $profile['R2']['DoubleAnswer']['Enabled'] ? ' checked=\'checked\'' : '';
        $r .= "<tr><td class='label'><label for='gateway-profile-r2-double-answer-enabled'>{$app->translate( 'gateway-profile-r2-double-answer' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-r2-double-answer' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right form-checkbox-alone'><input type='checkbox' id='gateway-profile-r2-double-answer-enabled'{$checked}/></td></tr>";
        $r .= "<tr><td class='label'><label for='gateway-profile-r2-double-answer-timeout'>{$app->translate( 'gateway-profile-r2-double-answer-timeout' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-r2-timeout' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right'><input type='text' id='gateway-profile-r2-double-answer-timeout' value='{$profile['R2']['DoubleAnswer']['Timeout']}' maxlength='5' /></td></tr>";
        $r .= '</tbody></table></fieldset>';
        $r .= '<fieldset><legend>SIP</legend><table class=\'simpleTable gateway-table-form\'><tbody>';
        
		$r .= "<tr><td class='label'><label for='gateway-profile-sip-send-custom-header'>{$app->translate( 'gateway-profile-sip-send-custom-header' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-sip-send-custom-header' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right'>";
   		$r .= _getCustomHeadersInput( $profile, 'gateway-profile-sip-send-custom-header' );
        $r .= "</div><a href='#' id='gateway-custom-header-add'>{$app->translate( 'gateway-profile-add-custom-header' )}</a></td></tr>";

        /// SIP
		$checked = $profile['SIP']['RelayExtensionHeaders'] ? ' checked=\'checked\'' : '';
        $r .= "<tr><td class='label'><label for='gateway-profile-sip-relay-extensions'>{$app->translate( 'gateway-profile-sip-relay-extensions' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-sip-relay-extensions' class='gateway-tooltip' /></td><td class='gateway-form-field-container-right form-checkbox-alone'><input type='checkbox' id='gateway-profile-sip-relay-extensions'{$checked} /></td></tr>";
        $r .= '</tbody></table></fieldset></div><br />';

        /// Cadences
        $checked = $profile['Cadences']['Enabled'] ? ' checked=\'checked\'' : '';
        $r .= "<fieldset><legend><input type='checkbox' id='gateway-profile-cadences-enabled'{$checked} /> <label for='gateway-profile-cadences-enabled'>{$app->translate( 'gateway-profile-cadences' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-cadences' class='gateway-tooltip' /></legend><table class='simpleTable gateway-table-form'>";
        unset( $checked );
        $input = _getCadenceInput( $profile, 'Trying' );
        $r .= "<tr><td class='label'><label for='gateway-profile-cadence-Trying-0'>{$app->translate( 'gateway-profile-cadence-trying' )}</label></td><td class='gateway-form-field-container-right'>{$input}</td></tr>";
        $input = _getCadenceInput( $profile, 'Ringback' );
        $r .= "<tr><td class='label'><label for='gateway-profile-cadence-Ringback-0'>{$app->translate( 'gateway-profile-cadence-ringback' )}</label></td><td class='gateway-form-field-container-right'>{$input}</td></tr>";
        unset( $input );
        $r .= '</table></fieldset>';

        // issue #5308, User defined Cause Map
        $r .= "<fieldset><legend><span id='gateway-profile-show-hide-cause-map'>+ {$app->translate( 'gateway-profile-cause-map' )}</span></legend>";
        $r .= "<table id='gateway-profile-cause-map-table' class='zebra simpleTable gateway-table-form displayNone'><thead><tr><th>{$app->translate( 'gateway-profile-cause' )}</th><th>ISDN <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-cause-map-help-isdn' class='gateway-tooltip' /></th><th>R2 <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-cause-map-help-r2' class='gateway-tooltip' /></th><th>SIP <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-cause-map-help-sip' class='gateway-tooltip' /></th><th>Retry</tr></thead><tbody>";
        foreach( $profile['CauseMap'] as $cause )
        {
            $isdn = _profileCauseMapInput( $cause, 'ISDN' );
            $r2 = _profileCauseMapInput( $cause, 'R2' );
            $sip = _profileCauseMapInput( $cause, 'SIP' );
            $name = $app->translate( "gateway-profile-cause-map-name-{$cause['Id']}" );
            $retry = _profileCauseMapRetry( $cause );
            $r .= "<tr class='gateway-profile-cause-map'><td class='label'><input type='hidden' id='gateway-cause-map-{$cause['Id']}' value='${cause['Id']}' /><label for='gateway-profile-cause-map-{$cause['Id']}-ISDN'>{$cause['Id']}: {$name}</label></td><td>{$isdn}</td><td>{$r2}</td><td>{$sip}</td><td>{$retry}</td></tr>";
        }
        $r .= '</tbody></table></fieldset>';

        $r .= "<br /><div class='textAlignRight'>";
        $r .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-profile-back' />";
        $r .= "<input type='button' value='{$app->translate( 'save' )}' id='gateway-profile-save' />";
        $r .= "</div>";

        return $r;
    }

    function saveProfileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-save' ) );

        try
        {
            $profile = $_POST;
            if( isset( $profile['__oldname__'] ) )
            {
                unset( $profile['__oldname__'] );
            }
            $oldname = isset( $_POST['__oldname__'] ) && $_POST['__oldname__'] ? $_POST['__oldname__'] : null;

            $yaml->setProfile( $profile, $oldname );
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteProfileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-delete' ) );

        try
        {
            $name = (isset( $_POST['name'] ) && $_POST['name']) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->deleteProfile( $name ) )
            {
                $reply['message'] = $app->translate( 'gateway-profile-error-not-found' );
            }
            else
            {
                $yaml->save( );
                $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-deleted' ) );
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function setDefaultProfileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-set-default' ) );

        try
        {
            $name = (isset( $_POST['name'] ) && $_POST['name']) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->setDefaultProfile( $name ) )
            {
                $reply['message'] = $app->translate( 'gateway-profile-error-not-found' );
            }
            else
            {
                $yaml->save( );
                $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-default-set' ) );
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function _getCadenceInput( $profile, $cadence )
    {
        $app = KSystem::getInstance( );
        $parts = explode( ',', $profile['Cadences'][$cadence] );
        $r = "<table><thead><tr><th>{$app->translate( 'gateway-profile-cadence-tone' )}</th><th>{$app->translate( 'gateway-profile-cadence-silence' )}</th><th>{$app->translate( 'gateway-profile-cadence-tone' )}</th><th>{$app->translate( 'gateway-profile-cadence-silence' )}</th></tr></thead><tbody><tr>";
        $extra = $profile['Cadences']['Enabled'] ? '' : ' disabled';
        for( $i = 0; $i < 4; $i++ )
        {
            $data = isset( $parts[$i] ) ? $parts[$i] : '';
            $r .= "<td><input type='text' id='gateway-profile-cadence-{$cadence}-{$i}' class='gateway-profile-cadence-input' value='{$data}' maxlength='4'{$extra} /></td>";
        }
        return "{$r}</tr></tbody></table>";
    }

	function _getCustomHeadersInput( $profile, $id )
    {
        $app = KSystem::getInstance( );
		$klass = count( $profile['SIP']['CustomHeaders'] ) == 0 ? 'displayNone' : '';

        $r = "<table id='{$id}' class='{$klass}'><thead><tr><th>{$app->translate( 'Nome' )}</th><th>{$app->translate( 'QueryValue' )}</th><th>&nbsp;</th></tr></thead><tbody>";
        foreach( $profile['SIP']['CustomHeaders'] as &$header )
        {
        	$r .= "<tr class='gateway-profile-sip-send-custom-header' ><td><input type='text' value='{$header['Name']}' /></td><td><input type='text' value='{$header['Value']}' /></td>";
			$r .= "<td ><img class='button-remove-custom-header' src='/imagens/remove.png' border='0'</td></tr>";
        }
        return "{$r}</tbody></table>";
    }

    function _getProfileDescription( $profile )
    {
        $app = KSystem::getInstance( );

        $components = array( );
        if( isset( $profile['FAX']['Mode'] ) )
        {
            $faxmode = $app->translate( "gateway-profile-fax-mode-{$profile['FAX']['Mode']}" );
            $components[] = "FAX: {$faxmode}";
        }
        if( isset( $profile['R2']['DoubleAnswer']['Enabled'] ) && $profile['R2']['DoubleAnswer']['Enabled'] )
        {
            $components[] = "R2: {$app->translate( 'gateway-profile-r2-double-answer' )}";
        }
        if( isset( $profile['SIP']['RelayExtensionHeaders']) && $profile['SIP']['RelayExtensionHeaders'] )
        {
            $components[] = "SIP: {$app->translate( 'gateway-profile-sip-relay-extensions' )}";
        }

        if( isset( $profile['Cadences']['Enabled'] ) && $profile['Cadences']['Enabled'] )
        {
            $components[] = $app->translate( 'gateway-profile-cadences' );
        }

        if( isset( $profile['CallAnalyzer'] ) && $profile['CallAnalyzer'] != '' )
        {
            $components[] = $app->translate( 'gateway-profile-call-analyzer' );
        }

        return implode( ', ', $components );
    }

    function _getAudioFormCheckboxRow( $enable, $audio, $class )
    {
        $app = KSystem::getInstance( );

        $checked = in_array( $audio, $enable ) ? 'checked=\'checked\' ' : '';
        $key = "gateway-profile-audio-{$audio}";
        return "<tr><td class='label'><label for='{$class}-{$audio}'>{$app->translate( $key )}</label></td><td class='gateway-form-field-container-right form-checkbox-alone'><input type='checkbox' class='{$class}' id='{$class}-{$audio}' name='{$audio}' {$checked}/></td></tr>";
    }
