<?php
    require_once KCONFIG . '/classes/classKGatewayUtil.php';
    require_once KCONFIG . '/classes/KGatewayYaml.php';

    $AjaxFunctions['showRoutesSMS'] = 'showRoutesSMS';
	$AjaxFunctions['saveRouteSMS'] = 'saveRouteSMS';
    $AjaxFunctions['newRouteSMS'] = 'newRouteSMS';
    $AjaxFunctions['editRouteSMS'] = 'editRouteSMS';
    $AjaxFunctions['removeRouteSMS'] = 'removeRouteSMS';
    $AjaxFunctions['routesOrder'] = 'routesOrder';

    function showRoutesSMS( )
    {
        $app = KSystem::getInstance( );
        $kyaml = new KGatewayYaml( );

        $buffer = '';

        $buffer .= "<fieldset>";
        $buffer .= "<legend>{$app->translate( 'RoutesSMS' )}";
        $buffer .= "</legend>";
        $buffer .= "<div id='gateway-route-sms'>";
        $buffer .= "    <input type='button' value='{$app->translate( 'newRouteSMS' )}' class='gateway-route-add' />";
        $buffer .= "    <input type='button' id='gateway-enable-send-sms' onclick=\"sendTestSMS();\" value='{$app->translate( 'kgateway-test-send-sms' )}' /><br /><br />";
        $buffer .= "<div id='kgateway-send-sms-form' style='padding: 10px' class='displayNone' >";
        $buffer .= "<legend>{$app->translate( 'kgateway-send-sms' )}";
        $buffer .= "</legend>";
        $buffer .= "<div id='kgateway-send-sms-result' class='textAlignCenter displayNone sms-info'>";
        $buffer .= "</div>";
        $buffer .= "<br>";

        $buffer .= "<table id='kgateway-send-sms-table' class='tabelaDevice zebra sortable'>";
        $buffer .= "    <thead>";
        $buffer .= "        <tr>";
        $buffer .= "            <th>{$app->translate( 'kgateway-destination-number' )} </th>";
        $buffer .= "            <th>{$app->translate( 'kgateway-sms-message' )} </th>";
        $buffer .= "            <th>{$app->translate( 'kgateway-send-confirmation' )}</th>";
        $buffer .= "        </tr>";
        $buffer .= "    <tbody>";
        $buffer .= "        <tr>";
        $buffer .= "            <td>";
        $buffer .= "            <input type='text' name='kgateway-destination-numberr' id='kgateway-destination-number' value='' size=22 maxlength =22>";
        $buffer .= "            </td>";
        $buffer .= "            <td>";
        $buffer .= "            <input type='text' name='kgateway-kgateway-sms-message' id='kgateway-sms-message' value='' size=80 >";
        $buffer .= "            </td>";
        $buffer .= "            <td>";
        $buffer .= "            <input type='checkbox' name='kgateway-send-confirmation' id='kgateway-send-confirmation' value=''>";
        $buffer .= "            </td>";
        $buffer .= "        </tr>";
        $buffer .= "    </thead>";
        $buffer .= "    </tbody>";
        $buffer .= "</table>";
        $buffer .= "<br>";

        $buffer .= "<div class='textAlignCenter'>* {$app->translate( 'kgateway-send-sms-alert' )}";
        $buffer .= "</div>";
        $buffer .= "<div class='textAlignRight'>";
        $buffer .= "    <td><input type='button' id='kgateway-clear-send-sms' onclick=\"ClearSendSMS();\" value='{$app->translate( 'kgateway-clear-send-sms' )}' name='kgateway-clear-send-sms' /></td>";
        $buffer .= "    <td> <input type='button' id='kgateway-send-sms' onclick=\"SendSMS();\" value='{$app->translate( 'kgateway-send-sms' )}' name='kgateway-send-sms' /></div></td></tr>";
        $buffer .= "</div>";
        $buffer .= "<br>";

        if( $kyaml->countRoutesSMS( ) > 0 )
        {
            $buffer .= '<div id=\'gateway-route-list\'>';
            $buffer .= "<table id='gateway-route-list-table' class='zebra gateway-table'>";
            $buffer .= '<thead><tr>';
            $buffer .= "<th>{$app->translate( 'name' )}</th>";
            $buffer .= "<th>{$app->translate( 'destinationNumber' )}</th>";
            $buffer .= "<th>{$app->translate( 'DestinationNAP' )}</th>";
            $buffer .= "<th>{$app->translate( 'priority' )}</th>";
            $buffer .= "<th class='gateway-table-options'>{$app->translate( 'Options' )}</th>";
            $buffer .= '</tr><tr>';
            $buffer .= '</tr></thead><tbody>';
            foreach( $kyaml->getAllRoutesSMS() as $route )
            {
                $destination = $route['DestinationNAP'] == '<ANY>' ? $app->translate( 'gateway-route-any' ) : $route['DestinationNAP'];
                $buffer .= '<tr>';
                $buffer .= "<td>{$route['Name']}</td>";
                $buffer .= "<td>{$route['DestinationNumber']}</td>";
                $buffer .= "<td>{$destination}</td>";
                $buffer .= "<td>{$route['Priority']}</td>";
                $buffer .= "<td class='gateway-table-options'><img border='0' src='/imagens/edit.png' class='gateway-route-edit' title='{$app->translate( 'edit' )}' /><img border='0' src='/imagens/remove.png' class='gateway-route-delete' title='{$app->translate( 'delete' )}' /></td>";
                $buffer .= '</tr>';
            }
            $buffer .= '</tbody></table><br />';
            $buffer .= '</div>';
        }
        else
        {
            $buffer .= $app->translate( 'gateway-route-empty-list' );
        }
        $buffer .= '</div></fieldset>';

        return $buffer;
    }

    function saveRouteSMS( )
    {
        require_once KROOT . '/json_util.php';

        $app = KSystem::getInstance( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-route-error-save' ) );

        if( array_key_exists( '__oldname__', $_POST ) )
        {
            $oldName = $_POST['__oldname__'];
            unset( $_POST['__oldname__'] );
        }
        else
        {
            $oldName = '';
        }

        try
        {
            // Priority is numeric and cannot be null, 0 is default
            $priority = 0;
            if( is_numeric( $_POST['Priority'] ) )
                $priority = intval( $_POST['Priority'] );
            unset( $_POST['Priority'] );
            $_POST['Priority'] = $priority;
            if( $priority < 0 ) $priority = 0;
            else if( $priority > 99 ) $priority = 99;

            $kyaml = new KGatewayYaml( );
            $kyaml->setRouteSMS( $_POST, $oldName );
            $kyaml->save( );

            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-route-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function _formRouteSMS( $route = null, $kyaml = null )
    {
        require_once KROOT . '/classes/KJsonRpcClient.php';

        $app = KSystem::getInstance( );
        $jsonrpc = new KJsonRpcClient( 'kgateway' );

        $availableServiceProviders = ( $jsonrpc->PortabilityDriver( ) !== 'DISABLED' ) ? $jsonrpc->PortabilityServiceProviders( ) : array( );

        if( is_null( $route ) )
        {
            $route = array( 'Name' => '', 'DestinationNumber' => '', 'DestinationNAP' => '', 'DestinationServiceProvider' => array( ), 'PortabilityRegex' => '' );
        }

        if( !isset( $route['Priority'] ) )
        {
            $route['Priority'] = 0;
        }
        else
        {
            if( $route['Priority'] < 0 ) $route['Priority'] = 0;
            else if( $route['Priority'] > 99 ) $route['Priority'] = 99;
        }
        if( is_null( $kyaml ) || !($kyaml instanceof KGatewayYaml) )
        {
            $kyaml = new KGatewayYaml( );
        }
        $yaml = $kyaml->getYaml( );
        $naps = &$yaml['NAPs'];
        $serviceProviders = isset( $route['DestinationServiceProvider'] ) ? $route['DestinationServiceProvider'] : array( );

        $routeName = htmlspecialchars( $route['Name'], ENT_QUOTES );
        $routePriority = strval( $route['Priority'] );

        $buf = '';
        $buf .= '<table class=\'zebra simpleTable gateway-table-form\'>';
        $buf .= '<tr>';
        $buf .= "<td class='label'><label for='gateway-route-form-name'>{$app->translate( 'name' )}</label>:</td>";
        $buf .= "<td><input id='gateway-route-form-name' name='Name' type='text' value='{$routeName}' /><input type='hidden' name='__oldname__' value='{$routeName}' /></td>";
        $buf .= '</tr>';

        $buf .= '<tr>';
        $buf .= "<td class='label'><label for='gateway-route-form-priority'>{$app->translate( 'priority' )}</label>: <img khelp='{$app->translate( 'tooltip-priority' )}' src='/imagens/tooltip.png' class='gateway-tooltip' /></td>";
        $buf .= "<td><input id='gateway-route-form-priority' name='Priority' type='text' value='{$routePriority}' /></td>";
        $buf .= '</tr>';

        $buf .= '<tr>';
        $buf .= "<td class='label'><label for='gateway-route-form-destination'>{$app->translate( 'destinationNumber' )}</label>: <img khelp='{$app->translate( 'tooltip-numberB' )}' src='/imagens/tooltip.png' class='gateway-tooltip' /></td>";
        $buf .= "<td><input id='gateway-route-form-destination' name='DestinationNumber' type='text' value='{$route['DestinationNumber']}' /></td>";
        $buf .= '</tr>';

        if( count( $availableServiceProviders ) > 0 )
        {
            $opts = '';
            foreach( $availableServiceProviders as &$serviceProvider )
            {
                $selected = in_array( $serviceProvider->Code, $serviceProviders, true ) ? ' selected' : '';
                $opts .= "<option value='{$serviceProvider->Code}'{$selected}>{$serviceProvider->Name} - {$serviceProvider->Code}</option>";
            }
            $checked = count( $serviceProviders ) > 0 ? ' checked' : '';
            $regex = isset( $route['PortabilityRegex'] ) ? $route['PortabilityRegex'] : '';

            $buf .= '<tr>';
            $buf .= "<td class='label'><label for='gateway-route-form-destination-check-portability'>{$app->translate( 'gateway-route-form-destination-check-portability' )}</label></td><td><input id='gateway-route-form-destination-check-portability' type='checkbox' {$checked}/></td>";
            $buf .= '</tr><tr class="gateway-route-form-destination-portability">';
            $buf .= "<td class='label'><label for='gateway-route-form-destination-service-providers'>{$app->translate( 'gateway-route-form-destination-service-providers' )}</label>: <img khelp='{$app->translate( 'gateway-route-form-destination-service-providers-tooltip' )}' src='/imagens/tooltip.png' class='gateway-tooltip' /></td>";
            $buf .= "<td><select id='gateway-route-form-destination-service-providers' name='DestinationServiceProvider' multiple data-placeholder='{$app->translate( 'gateway-route-form-destination-service-providers-click-to-add' )}'>{$opts}</select></td>";
            $buf .= '</tr><tr class="gateway-route-form-destination-portability">';
            $buf .= "<td class='label'><label for='gateway-route-form-destination-portability-regex'>{$app->translate( 'gateway-route-form-destination-portability-regex' )}</label>: <img khelp='{$app->translate( 'gateway-route-form-destination-portability-regex-tooltip' )}' src='/imagens/tooltip.png' class='gateway-tooltip' /></td>";
            $buf .= "<td><input type='text' id='gateway-route-form-destination-portability-regex' name='PortabilityRegex' value='{$regex}' /></td>";
            $buf .= '</tr>';
        }

        $buf .= '<tr>';
        $buf .= "<td class='label'><label for='gateway-route-form-destination-nap'>{$app->translate( 'DestinationNAP' )}: <img khelp='{$app->translate( 'tooltip-destinationNAP' )}' src='/imagens/tooltip.png' class='gateway-tooltip' /></td>";

        $opts = '';
        if( $route['Name'] == '' )
        {
            $opts .= "<option value='<SELECT>' selected>{$app->translate( 'Select' )}</option>";
        }
        foreach( $naps as &$nap )
        {
        	if( $nap['Type'] != 'GSM' )
        	{
        		continue;
        	}
            $selected = ($nap['Name'] == $route['DestinationNAP']) ? ' selected' : '';
            $napName = htmlspecialchars( $nap['Name'], ENT_QUOTES );
            $opts .= "<option value='{$nap['Type']}>{$napName}'{$selected}>{$napName}</option>";
        }

        $buf .= "<td><select id='gateway-route-form-destination-nap' name='DestinationNAP'>{$opts}</select></td>";
        $buf .= '</tr>';

        $buf .= '</table><br /><div class="textAlignRight">';
        $buf .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-route-form-back' />";
        $buf .= "<input type='button' value='{$app->translate( 'save' )}' id='gateway-route-form-save' /></div>";

        $buf .= "<p>{$app->translate( 'gateway-route-help-regexp' )}:<br /><a href='http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/V1_chap09.html#tag_09_04' target='_blank'>http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/V1_chap09.html#tag_09_04</a></p>";

        return $buf;
    }

    function newRouteSMS( )
    {
        return _formRouteSMS( );
    }

    function editRouteSMS( )
    {
        $name = array_key_exists( 'name', $_POST ) ? $_POST['name'] : null;
        $app = KSystem::getInstance( );

        try
        {
            if( is_null( $name ) )
            {
                return $app->translate( 'gateway-route-error-not-found' );
            }
            else
            {
                $kyaml = new KGatewayYaml( );
                $route = $kyaml->getRouteSMS( $name );
                if( is_null( $route ) )
                {
                    return $app->translate( 'gateway-route-error-not-found' );
                }
                return _formRouteSMS( $route, $kyaml );
            }
        }
        catch( Exception $e )
        {
            return $app->translate( $e->getMessage( ) );
        }
    }

    function removeRouteSMS( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-route-error-delete' ) );

        $name = isset( $_POST['name'] ) ? $_POST['name'] : null;

        try
        {
            $kyaml = new KGatewayYaml( );
            if( $kyaml->deleteRouteSMS( $name ) )
            {
                $kyaml->save( );
                $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-route-deleted' ) );
            }
            else
            {
                throw new Exception( 'gateway-route-error-not-found' );
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function routesOrderSMS( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-route-error-reorder' ) );

        $order = isset( $_POST['order'] ) ? $_POST['order'] : null;
        try
        {
            $kyaml = new KGatewayYaml( );
            $kyaml->setRoutesOrderSMS( $order );
            $kyaml->save( );
            $reply = array( 'success' => true, 'message' => '' );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }



