<?php
    require_once KCONFIG . '/classes/classKCadences.php';
    require_once KCONFIG . '/classes/KSystemYaml.php';

    $AjaxFunctions['showProfiles'] = 'showProfiles';
    $AjaxFunctions['copyProfile'] = 'copyProfile';
    $AjaxFunctions['resetProfile'] = 'resetProfile';
    $AjaxFunctions['editProfile'] = 'editProfile';
    $AjaxFunctions['removeProfile'] = 'removeProfile';
    $AjaxFunctions['createProfile'] = 'createProfile';
    $AjaxFunctions['showLinksE1T1'] = 'showLinksE1T1';
    $AjaxFunctions['showCallProgressOptions'] = 'showCallProgressOptions';
    $AjaxFunctions['showCadence'] = 'showCadence';

    $AjaxFunctions['saveLinksE1T1'] = 'saveLinksE1T1';
    $AjaxFunctions['saveCallProgressOptions'] = 'saveCallProgressOptions';
    $AjaxFunctions['saveCadences'] = 'saveCadences';

    $AjaxFunctions['getTimeSlot'] = 'getTimeSlot';
    $AjaxFunctions['showGeneral'] = 'showGeneral';
    $AjaxFunctions['saveGeneral'] = 'saveGeneral';

    function showProfiles( )
    {
        global $image_dir;
        $app = KSystem::getInstance( );

        $configDir = $app->getConfigDir( );
        $buff = '';

        $buff .= '<div id="Profiles">';
        $buff .= '<fieldset>';
        $buff .= "<legend>{$app->translate( 'Profiles' )}</legend>";

        $defaultProfiles = array( 'R2', 'OpenR2', 'ISDN', 'ISUP', 'ISUPPassive', 'ISDNNetwork', 'ISDNPassive', 'GSM', 'FXS', 'LineSide', 'CASEL7', 'E1LC', 'Open CAS', 'Open CCS','FXO' );
        $profilesYAML = new KYaml( $configDir . '/profiles.yaml' );
        $profiles = $profilesYAML->getYaml( );
        $CGProfilesSize = sizeof( $profiles['ChannelGroupProfiles'] );

        $buff .= '<div id="CGProfiles">';
        $buff .= '<table class="zebra" id="tableProfiles" border="1"><thead>';
        $buff .= '<th width="40%">' . $app->translate( 'name' ) . '</th>';
        $buff .= '<th width="40%">' . $app->translate( 'type' ) . '</th>';
        $buff .= '<th width="20%">' . $app->translate( 'operation' ) . '</th></thead><tbody>';

        for( $x = 0; $x < $CGProfilesSize; $x++ )
        {
            $ProfileKeys = array_keys( $profiles['ChannelGroupProfiles'][$x] );

            $buff .= '<tr><td>' . $ProfileKeys[0] . '</td>';
            $buff .= '<td>' . $profiles['ChannelGroupProfiles'][$x][$ProfileKeys[0]]['Type'] . '</td>';
            $buff .= '<td>';

            if( $ProfileKeys[0] != 'ISUP' && $ProfileKeys[0] != 'ISUPPassive' && $ProfileKeys[0] != 'Open CAS' && $ProfileKeys[0] != 'Open CCS' )
            {
                $buff .= "<a href='#' onclick=\"editProfile('$ProfileKeys[0]');\">";
                $buff .= "<img src='$image_dir/imagens/edit.png' title='".$app->translate('edit')."' /></a>";
                $buff .= "<a href='#' class='marginRight5px marginLeft5px' onclick=\"copyProfile('$ProfileKeys[0]');\">";
                $buff .= "<img src='$image_dir/imagens/copy.png' title='".$app->translate('copy')."' /></a>";
                $buff .= "<a href='#' onclick=\"removeProfile('$ProfileKeys[0]');\" " . ( ( in_array( $ProfileKeys[0], $defaultProfiles ) ) ? 'style="visibility:hidden;"' : '') . ">";
                $buff .= "<img src='$image_dir/imagens/remove.png' title='".$app->translate('remove')."' /></a>";
            }
            else
                $buff .= ' - ';

            $buff .= '</td></tr>';
        }
        $buff .= '</tbody></table>';
        $buff .= '</div>';

        $buff .= '</fieldset>';
        $buff .= '<br>';
        $buff .= "<input class='floatRight' id='bResetProfiles' type='button' onclick='resetProfiles();' value='".$app->translate( 'restoreDefaultProfiles' )."'>";
        $buff .= '</div>';

        return $buff;
    }

    function removeProfile( )
    {
        Global $sistema;
        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;

        if( isset( $name ) )
        {
            $Profiles = new KProfiles( );
            $position = $Profiles->getProfilePosition( $name );
            $Profiles->profilesYaml->deleteVar( $position, "ChannelGroupProfiles" );
            $profilesData = $Profiles->profilesYaml->getYaml( );
            $keys = array_keys( $profilesData['ChannelGroupProfiles'] );

            for( $i = 0; $i < sizeof( $keys ); $i++ )
                $profiles['ChannelGroupProfiles'][] = $profilesData['ChannelGroupProfiles'][$keys[$i]];

            $Profiles->profilesYaml->yaml = $profiles;
            $Profiles->saveProfiles( );

            removeDeletedProfileFromLinks( $name );

            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function copyProfile( )
    {
        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;
        if( isset( $name ) )
        {
            $Profiles = new KProfiles( );
            $profile = $Profiles->getProfile( $name );
            $type = $profile[$name]['Type'];
            $subType = $profile[$name]['SubType'];
            $return = printProfile( $profile, $type, $name, $subType );

            return $return;
        }
    }

    function resetProfile( )
    {
        Global $sistema;

        $Profiles = new KProfiles( );
        $Profiles->resetDefaultProfiles( );
        return $sistema->retTranslate( 'ProfileReseted' );
    }

    function editProfile( )
    {
        $app = KSystem::getInstance( );
        $name = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : NULL;
        if( isset( $name ) )
        {
            $Profiles = new KProfiles( );
            $profile = $Profiles->getProfile( $name );

            if(isset($profile))
            {
                $type = $profile[$name]['Type'];
                $subType = isset( $profile[$name]['SubType'] ) ? $profile[$name]['SubType'] : '';
                $buff = '';
                $buff .= "<fieldset>";
                $buff .= "<legend>{$app->translate( 'Profiles' )}</legend>";
                $buff .= printProfile( $profile, $type, $name, $subType, $name );
                $buff .= "</fieldset>";
            }
            else
                $buff .= $app->translate('profileNotFound');

            return $buff;
        }
    }

    function createProfile( )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        $type = isset( $_REQUEST['type'] ) ? $_REQUEST['type'] : NULL;
        $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : NULL;

        if( isset( $data ) && isset( $type ) && isset( $action ) )
        {
            $data = explode( ',', $data );
            $variables = array( );

            foreach( $data as $d )
            {
                $tmp = array( );
                $tmp = explode( ':', $d );
                $variables[$tmp[0]] = $tmp[1];
            }

            $newProfile = $action == 'copy' ? true : false;
            switch($type)
            {
                case 'R2':
                    $return = createR2( $variables, $newProfile );
                    break;

                case 'ISDN':
                    $return = createIsdn( $variables, $newProfile );
                    break;

                case 'GSM':
                    $return = createGSM( $variables, $newProfile );
                    break;

                case 'FXS':
                    $return = createFXS( $variables, $newProfile );
                    break;

                case 'LineSide':
                    $return = createLineSide( $variables, $newProfile );
                    break;

                case 'FXO':
                    $return = createFXO( $variables, $newProfile );
                    break;

                default:
                    return 'No action.';
                    break;
            }
        }
        if( $return )
            return '1|' . $sistema->retTranslate( 'ConfiguracaoSalva' );
        else
            return '0|' . $sistema->retTranslate( 'nameAlreadyUsed' );
    }

    function showLinksE1T1( )
    {
        Global $sistema;

        $buff = '';

        $E1Links = $sistema->getE1T1Links( );
        $E1LinksSize = sizeof( $E1Links );

        $systemYaml = KSystemYaml::getInstance();

        $systemData = $systemYaml->getSystem();

        $configDir = $sistema->getConfigDir( );
        $deviceYaml   = new KYaml( $configDir . '/devices.yaml');
        $profilesYAML = new KYaml( $configDir . '/profiles.yaml' );
        $systemYAML   = new KYaml( $configDir . '/system.yaml' );


        $buff .= "<div id='ConfigE1'>";
        if( $E1LinksSize > 0 )
        {
            $advancedTable = isset( $_REQUEST['advancedTable'] ) ? true : false;

            if ( IS_GATEWAY )
            {
                $buff .= '<div class="textAlignCenter displayNone sms-info" id="gateway-reboot-is-needed">';
                $buff .= "<label>{$sistema->retTranslate( 'gateway-network-alert-reboot' )}</label>";
                $buff .= '<br /><br />';

                $buff .= "<input id='gateway-alert-reboot-bt' type='button' onclick='rebootGW();' value='{$sistema->retTranslate( 'gateway-reboot' )}' />";
                $buff .= "</div>";

                $buff .= '<br />';
            }

            if( !$advancedTable )
            {
                $buff .= '<fieldset>';
                $buff .= '<legend>Links E1/T1</legend>';
                $buff .= '<div id="ConfigE1Data">';
                $buff .= '<table id="nadvanced" class="zebra"><thead>';
                $buff .= '<tr class="first">';
                $buff .= '<th id="first-serial">Serial</td>';
                $buff .= '<th id="first-apelido">' . $sistema->retTranslate( 'apelido' ) . '</th>';
                $buff .= '<th id="first-profile">' . $sistema->retTranslate( 'telephony-singaling' ) . '</th>';
                $buff .= '<th id="first-clockValido">' . $sistema->retTranslate( 'SynchronismClock' ) . '</th>';
                if( !IS_GATEWAY )
                {
                    $buff .= '<th id="first-prefixo">' . $sistema->retTranslate( 'Prefixo' ) . '</th>';
                    $buff .= '<th id="first-prefixoOnIncoming">' . $sistema->retTranslate( 'UseCentralOfficePrefixOnIncomingCalls' ) . '</th>';
                }
                $buff .= '<th id="first-digitosEntrada">' . $sistema->retTranslate( 'digitosEntrada' ) . '</th>';
                $buff .= '<th id="first-crc4">CRC</th>';
                $buff .= '</tr></thead><tbody>';
            }
            else
            {
                $buff .= '<fieldset id="fieldMonster">';
                $buff .= '<legend>Links E1/T1</legend>';
                $buff .= '<div id="ConfigE1Data">';
                $buff .= '<table id="advanced" class="zebra"><thead>';
                $buff .= '<tr>';
                $buff .= '<th rowspan="2" id="nfirst-serial">Serial</td>';
                $buff .= '<th rowspan="2" id="nfirst-apelido">' . $sistema->retTranslate( 'apelido' ) . '</th>';
                $buff .= '<th rowspan="2" id="nfirst-profile">' . $sistema->retTranslate( 'telephony-singaling' ) . '</th>';
                $buff .= '<th rowspan="2" id="nfirst-clockValido">' . $sistema->retTranslate( 'SynchronismClock' ) . '</th>';
                if( !IS_GATEWAY )
                {
                    $buff .= '<th rowspan="2" id="nfirst-prefixo">' . $sistema->retTranslate( 'Prefixo' ) . '</th>';
                    $buff .= '<th rowspan="2" id="nfirst-prefixoOnIncoming">' . $sistema->retTranslate( 'UseCentralOfficePrefixOnIncomingCalls' ) . '</th>';
                }
                $buff .= '<th rowspan="2" id="nfirst-digitosEntrada">' . $sistema->retTranslate( 'digitosEntrada' ) . '</th>';
                $buff .= '<th rowspan="2" id="nfirst-crc4">CRC</th>';
                if ( IS_GATEWAY )
                {
                    $buff .= '<th rowspan="2">' . $sistema->retTranslate( 'K3LOperationModeE1T1' ) . '</th>';
                }
                else
                {
                    $buff .= '<th rowspan="2">' . $sistema->retTranslate( 'K3lR' ) . '</th>';
                }
                $buff .= '<th rowspan="2">' . $sistema->retTranslate( 'sensibilidadeCAS' ) . '</th>';
                $buff .= '<th colspan="3">' . $sistema->retTranslate( 'sensibilidadeFalhas' ) . '</th>';
                $buff .= '</tr><tr>';
                $buff .= '<th>' . $sistema->retTranslate( 'Partida' ) . '</th>';
                $buff .= '<th>' . $sistema->retTranslate( 'Queda' ) . '</th>';
                $buff .= '<th>' . $sistema->retTranslate( 'Alarme' ) . '</th>';
                $buff .= '</tr></thead><tbody>';
            }

            for( $x = 0; $x < $E1LinksSize; $x++ )
            {
                $dev_serial_link = $E1Links[ $x ];
                $realLink = explode( '.', $E1Links[$x] );
                $dev_serial = $realLink[0];
                $dev_link_index = $realLink[1];

                $way = $deviceYaml->getWay( "", $dev_serial ) . "|" . $dev_serial;
                $multipart = $way . "|Links|" . $dev_link_index . "|" . $dev_link_index;

                $linkType = $deviceYaml->getValue( 'Type', $multipart );
                $linkName = $deviceYaml->getValue( 'Name', $multipart );
                $linkProfile = $deviceYaml->getValue( 'Profile', $multipart );
                $linkCentralOfficePrefix = ( empty( $systemData[ 'CentralOfficePrefix' ][ $dev_serial_link ] ) ) ? '' : $systemData[ 'CentralOfficePrefix' ][ $dev_serial_link ];

                /// Link Name
                $buff .= '<tr class="device-' . $dev_serial . '">';
                $buff .= '<td>' . $dev_serial_link . '</td>';
                $buff .= '<td><input name="devices[' . $dev_serial . '][Links][' . $dev_link_index . '][Name]" value="' . $linkName . '" type="text" class="nick"></td>';
                $buff .= '<td>';

                /// Link Profile
                $optionsProfile = getProfile( $dev_serial_link, $profilesYAML );
                $optionsE1 = '';
                $optionsT1 = '';

                for( $i = 0; $i < sizeof( $optionsProfile['E1'] ); $i++ )
                {
                    $selected = $optionsProfile['E1'][$i] === $linkProfile ? "selected='selected' " : "";
                    $optionsE1 .= "<option value='{$optionsProfile['E1'][$i]}' {$selected} class='E1" . ( ( $linkType === 'E1' ) ? '' : ' displayNone' ) . "'>{$optionsProfile['E1'][$i]}</option>";
                }

                for( $i = 0; $i < sizeof( $optionsProfile['T1'] ); $i++ )
                {
                    $selected = $optionsProfile['T1'][$i] === $linkProfile ? "selected='selected' " : "";
                    $optionsT1 .= "<option value='{$optionsProfile['T1'][$i]}' {$selected} class='T1" . ( ( $linkType === 'T1' ) ? '' : ' displayNone' ) . "'>{$optionsProfile['T1'][$i]}</option>";
                }

                $buff .= '<select class="selector signaling" name="devices[' . $dev_serial . '][Links][' . $dev_link_index . '][Profile]">';
                $buff .= '<option value="Deactivated">Deactivated</option>';
                $buff .= '<optgroup label="E1" class="E1' . ( ( $linkType === 'E1' ) ? '' : ' displayNone' ) . '">' . $optionsE1 . '</optgroup>';
                $buff .= '<optgroup label="T1" class="T1' . ( ( $linkType === 'T1' ) ? '' : ' displayNone' ) . '">' . $optionsT1 . '</optgroup>';

                $buff .= '</select></td>';

                /// EnableLinkAsReference
                $buff .= '<td>';
                $buff .= "<select class='selector' name='system[EnableLinkAsReference][]'>";

                $selected = in_array( $dev_serial_link, $systemData[ 'EnableLinkAsReference' ] ) ? ' selected="selected"' : '';

                if( !$sistema->isPassiveDevice( $dev_serial ) )
                {
                    $buff .= '<option value=""'. $selected.'>'. $sistema->retTranslate( 'generate' ).'</option>';
                }

                $buff .= '<option value="'. $dev_serial_link . '"'. $selected.'>'. $sistema->retTranslate( 'receive' ).'</option>';
                $buff .= '</select></td>';

                if( !IS_GATEWAY )
                {
                    /// CentralOfficePrefix
                    $buff .= "<td><input name='system[CentralOfficePrefix][{$dev_serial_link}]' value='{$linkCentralOfficePrefix}' type='text' class='selector'></td>";

                    /// UseCentralOfficePrefixOnIncomingCalls
                    $checked = ( empty( $systemData[ 'UseCentralOfficePrefixOnIncomingCalls' ] ) || !in_array( $dev_serial_link, $systemData[ 'UseCentralOfficePrefixOnIncomingCalls' ] ) ) ? "" : "checked='checked'";
                    $buff .= "<td><input class='check' name='system[UseCentralOfficePrefixOnIncomingCalls][]' value='{$dev_serial_link}' type='checkbox' {$checked}/></td>";
                }

                /// IncomingDigitsCount
                $value = ( isset( $systemData[ 'IncomingDigitsCount' ][ $dev_serial_link ] ) ) ? $systemData[ 'IncomingDigitsCount' ][ $dev_serial_link ] : 4;
                $buff .= '<td>';
                $buff .= "<select name='system[IncomingDigitsCount][{$dev_serial_link}]' value='$value' type='text' class='selector'>";

                for( $i = 0; $i <= 20; $i++ )
                {
                    $selected = ( $i == $value ) ? "selected" : '';
                    $buff .= "<option value='$i' $selected>" . $i . "</option>";
                }
                $buff .= '</select></td>';

                /// CRC4
                $checked = ( in_array( $dev_serial_link, $systemData[ 'CRC4' ] ) ) ? ' checked="checked"' : '';

                $buff .= '<td><input class="check" name="system[CRC4][]" value="' . $dev_serial_link . '" type="checkbox"' . $checked . '></td>';

               if( $advancedTable )
               {
                   if ( IS_GATEWAY )
                   {
                       /// Link Type
                       $attr_name = 'name="devices[' . $dev_serial . '][Links][' . $dev_link_index . '][Type]"';

                       if ( $dev_link_index > 0 )
                       {
                           $buff .= '<td class="operationModeE1T1"><span>' . ( ( $linkType ) ? $linkType : 'E1' ) . '</span> <input type="hidden" ' . $attr_name . ' value="' . $linkType . '"/></td>';
                       }
                       else
                       {
                           $buff .= '<td>'
                                 . '<select onchange="changeOperationModeE1T1(this)" data-device="device-' . $dev_serial . '" ' . $attr_name . ' class="selector">'
                                 . '<option value="E1"' . ( ( $linkType === 'E1' ) ? ' selected="selected"' : '' ) . '>E1</option>'
                                 . '<option value="T1"' . ( ( $linkType === 'T1' ) ? ' selected="selected"' : '' ) . '>T1</option>'
                                 . '</select>'
                                 . '</td>';
                       }
                    }
                    else
                    {
                        $buff .= getK3Lr( $dev_serial_link, $x, $systemYAML );
                    }

                    //// CasLineValidateTime
                    $value = ( isset( $systemData[ 'CasLineValidateTime' ][ $dev_serial_link ] ) ) ? $systemData[ 'CasLineValidateTime' ][ $dev_serial_link ] : 20;

                    $buff .= "<td>";
                    $buff .= "<select name='system[CasLineValidateTime][{$dev_serial_link}]' class='selector'>";

                    for( $i = 5; $i <= 500; $i = $i + 5 )
                    {
                        $selected = ($i == $value) ? "selected" : '';
                        $buff .= "<option value='$i' $selected>" . $i . "</option>";
                    }
                    $buff .= "</select>";
                    $buff .= "</td>";

                    $buff .= linkTimers( $dev_serial_link, $x, $systemYAML );
               }

               $buff .= '</tr>';
            }

            $buff .= '</tbody></table></div>';
            $buff .= '</fieldset>';
            $buff .= '<br />';

            $tmp = ( $advancedTable ) ? 'false' : 'true';

            $buff .= '<div class="textAlignRight" style="min-width:300px;">';
            if($advancedTable)
            {
                $buff .= "<input type='button' onclick=\"advancedConfig({$tmp});\" value='" . $sistema->retTranslate( 'lessInfo' ) . "'>";
                $buff .= "<input id='saveLinksE1T1B' type='button' onclick=\"saveLinksE1T1();\" value='" . $sistema->retTranslate( 'save' ) . "'>";
            }
            else
            {
                $buff .= "<input type='button' onclick=\"advancedConfig({$tmp});\" value='" . $sistema->retTranslate( 'advancedConfig' ) . "'>";
                $buff .= "<input id='saveLinksE1T1B' type='button' onclick=\"saveLinksE1T1();\" value='" . $sistema->retTranslate( 'save' ) . "'>";
            }
            $buff .= '</div>';
        }
        else
        {
            $buff .= '<fieldset>';
            $buff .= '<legend>Links E1/T1</legend>';
            $buff .= '<div id="ConfigE1Data">';
            $buff .= "<input type='hidden' id='E1LinksTotal' name='E1LinksTotal' value='{$E1LinksSize}'/>";
            $buff .= '<table><tr><td>' . $sistema->retTranslate( 'NDeviceE1' ) . '</td></tr></table>';
            $buff .= '</div>';
            $buff .= '</fieldset>';
        }

        $buff .= '<script type="text/javascript">onload_config_links_E1T1()</script>';

        return $buff;
    }

    function showCallProgressOptions( )
    {
        Global $sistema;

        $buff = '';
        $configDir = $sistema->getConfigDir( );
        $sysYAML = new KYaml( $configDir . "/system.yaml" );

        $buff .= "<div id='CallProgressOption'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>Call progress</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'SilenceTimeToDisconnect' ) . "</td>";
        $buff .= "<td align='right'>";
        $SilenceTimeToDisconnect = $sysYAML->getValue( 'SilenceTimeToDisconnect' );
        $SilenceTimeToDisconnect = is_numeric($SilenceTimeToDisconnect) ? $SilenceTimeToDisconnect / 1000 : 990;
        $buff .= "<input maxlength='5' onkeypress='return serialMask(this, event);' onmouseup='return serialMask(this, event);' class='inputText' type='text' value='${SilenceTimeToDisconnect}' id='SilenceTimeToDisconnect' /> ";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'AnswerTimeout' ) . "</td>";
        $buff .= "<td align='right'>";
        $AnswerTimeout = $sysYAML->getValue( 'AnswerTimeout' );
        $AnswerTimeout = is_numeric($AnswerTimeout) ? $AnswerTimeout / 1000 : 90;

        $buff .= "<input maxlength='5' onkeypress='return serialMask(this, event);' onmouseup='return serialMask(this, event);' class='inputText' type='text' value='{$AnswerTimeout}' id='AnswerTimeout' /> ";

        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'VoiceAnswerThreshold' ) . "</td>";
        $buff .= "<td align='right'>";
        $VoiceAnswerThreshold = $sysYAML->getValue( 'VoiceAnswerThreshold' );
        $buff .= "<select id='VoiceAnswerThreshold' name='VoiceAnswerThreshold'>";
        for( $x = 100; $x <= 200; $x = $x + 10 )
        {
            $selected = ( $x == $VoiceAnswerThreshold ) ? 'selected' : '';
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr ><td align='left'>" . $sistema->retTranslate( 'TimeForAutomaticSeizeSuccess' ) . "</td>";
        $buff .= "<td align='right'>";
        $TimeForAutomaticSeizeSuccess = $sysYAML->getValue( 'TimeForAutomaticSeizeSuccess' );
        $buff .= "<select id='TimeForAutomaticSeizeSuccess' name='TimeForAutomaticSeizeSuccess'>";
        for( $x = 0; $x <= 5000; $x = $x + 1000 )
        {
            $selected = ( $x == $TimeForAutomaticSeizeSuccess ) ? 'selected' : '';
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'DedicatedLine' ) . "</td>";
        $buff .= "<td class='width110' align='center'>";

        $DedicatedLine = getBooleanValue( $sysYAML->yaml['CallProgress']['DedicatedLine'] ) ? "checked=''" : '';
        $buff .= "<input id='DedicatedLine' $DedicatedLine class='check' type='checkbox' value='DedicatedLine' name='DedicatedLine'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr ><td align='left'>" . $sistema->retTranslate( 'DetectSilenceAsAnswer' ) . "</td>";
        $buff .= "<td class='width110' align='center'>";
        $DetectSilenceAsAnswer = getBooleanValue( $sysYAML->yaml['CallProgress']['DetectSilenceAsAnswer'] ) ? "checked=''" : '';
        $buff .= "<input id='DetectSilenceAsAnswer' $DetectSilenceAsAnswer class='check' type='checkbox' value='DetectSilenceAsAnswer' name='DetectSilenceAsAnswer'>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "</tbody></table>";
        $buff .= "</fieldset>";
        $buff .= "</br>";

        $buff .= "<input id='saveCallProgressOptionsB' type='button' onclick='saveCallProgressOptions();' class='floatRight' value='" . $sistema->retTranslate( 'save' ) . "'/>";

        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;
    }

    function showCadence( )
    {
        Global $sistema, $image_dir;

        $buff = '';

        $buff .= "<div id='Cadences' >";
        $buff .= "<fieldset id='CPCadences'>";
        $buff .= "<legend>" . $sistema->retTranslate( 'Cadences' ) . "</legend>";

        $KCadencesObject = new KCadences( );
        $arrCadences = $KCadencesObject->getCadences( );

        $style = sizeof( $arrCadences ) > 0 ? "style='display: none;'" : "style='display: block;'";
        $buff .= "<div id='warningCadence' class='redalert' $style ><p>" . $sistema->retTranslate( 'needToAddCadence' ) . "<p></div>";

        $buff .= "<table class='zebra' id='cadenceTable'>";
        $buff .= '<thead><tr>';
        $buff .= '<th></th>';
        $buff .= '<th>' . $sistema->retTranslate( 'type' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'name' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Repetitions' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Tolerance' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Cadence' ) . '</th>';
        $buff .= '<th>' . $sistema->retTranslate( 'Options' ) . '</th>';
        $buff .= '</tr></thead><tbody>';

        $arrTypes = array( 0 => "Dial Tone", 1 => "Ring Back", 2 => "Busy", 3 => "Fast Busy" );

        $lastCandece = '@';
        $lastCSSClass = '';
        $qtd = 0;

        foreach( $arrCadences as $key1 => $val1 )
        {
            foreach( $val1 as $key2 => $val2 )
            {
                $buff .= "<tr id='trId_$key1'>";
                $buff .= "<td id='tdId_$key1' >";
                $buff .= "<select name='Id-$key1' id='Id-$key1' size='1' class='width40 selectCadence Id'>";
                foreach( range('A','Z') as $value )
                {
                    if( $value == $key2 )
                        $buff .= "<option value='$value' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$value'>$value</option>";
                }
                $buff .= '</select>';
                $buff .= '</td>';

                $buff .= '<td>';
                $buff .= "<select name='Type-$key1' id='Type-$key1' class='selectTypeCadence Type' >";
                foreach( $arrTypes as $key => $value )
                {
                    if( $key == $val2['Type'] )
                        $buff .= "<option value='$key' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$key'>$value</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";
                $buff .= "<td>";
                $buff .= "<input class='inputText Name' type='text' size='20' name='Name-$key1' id='Name-$key1' value='" . $val2['Name'] . "' /></td>";
                $buff .= '<td>';
                $buff .= "<select name='Repetitions-$key1' id='Repetitions-$key1' class='selectCadence Repetitions' >";
                foreach( range(1,8) as $value )
                {
                    if( $value == $val2['Repetitions'] )
                        $buff .= "<option value='$value' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$value'>$value</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";

                $buff .= "<td>";
                $buff .= "<select name='Tolerance:-$key1' id='Tolerance-$key1' class='selectCadence Tolerance' >";
                foreach( range(5,250,5) as $value )
                {
                    if( $value == $val2['Tolerance'] )
                        $buff .= "<option value='$value' selected='selected'>$value</option>";
                    else
                        $buff .= "<option value='$value'>$value</option>";
                }
                $buff .= "</select>";
                $buff .= "</td>";
                $buff .= "<td>";
                $buff .= "<input class='Cadence' type='text' size='10' name='Cadence-$key1' id='Cadence-$key1' value='" . implode( $val2['Cadence'], "," ) . "' />";
                $buff .= "</td>";
                $buff .= "<td>";
                $buff .= "<a onClick=\"deleteCadence('$key1');\">";
                $buff .= "<img class='cursorHand' title='".$sistema->retTranslate('remove')."' src='$image_dir/imagens/remove.png'/></a>";
                $buff .= "</td>";
                $buff .= "</tr>";
                $lastCandece = $key2;
            }
            $qtd++;
        }
        $buff .= "</tbody></table></br>";
        $buff .= "<input type='hidden' value='$lastCandece' name='lastCadence' id='lastCadence' />";

        $buff .= "<input type='button' value='" . $sistema->retTranslate( 'addNCandece' ) . "' onClick=\"newCadenceRow(document.getElementById('cadenceTable'));\" />";
        $buff .= "</br>";

        $buff .= "</fieldset>";
        $buff .= "<br>";

        $buff .= "<div class='floatRight'>";
        $buff .= "<input type='button' onclick='InitCadenceAssistant();' value='" . $sistema->retTranslate( 'InitCadenceAssistant' ) . "'>";
        $buff .= "<input id='saveCadencesB' type='button' class='floatRight' onclick='saveCadences();' value='" . $sistema->retTranslate( 'save' ) . "'>";
        $buff .= "</div>";

        $buff .= "<div id='dialog-modal' title='" . $sistema->retTranslate( 'CadencesAssistant' ) . "'></div>";
        $buff .= "</div>";

        return $buff;
    }

    function showGeneral( )
    {
        Global $sistema;

        require_once KCONFIG . '/classes/KHMPAnalyticsYaml.php';

        $configDir = $sistema->getConfigDir( );
        $sysYAML = new KYaml( $configDir . '/system.yaml' );

        $buff = '';

        $buff .= '<div id="geral">';
        $buff .= "<a class='collapsePara' onclick=\"changeArrow(this);\" href='#'>- " . $sistema->retTranslate( 'general' ) . "</a>";
        $buff .= '<fieldset>';
        $buff .= '<div id="divMfcPatternCountry">';
        $buff .= '<table class="simpleTable"><tbody>';
        $buff .= '<tr>';
        $buff .= '<td width="33%" align="left"><label for="MfcPatternCountry">' . $sistema->retTranslate( 'PaisPadraoMFC' ) . '</label></td>';
        $buff .= '<td width="33%" align="center"></td>';
        $buff .= '<td width="33%" align="center">';

        $arr = array( '0 - Brasil', '1 - Mexico', '2 - Argentina', '3 - Chile', '4 - Uruguai', '5 - Venezuela' );

        $MfcPatternCountry = $sysYAML->getValue( 'MfcPatternCountry', 'System' );

        $buff .= '<select id="MfcPatternCountry" name="MfcPatternCountry">';
        foreach( $arr as $country )
            $buff .= $MfcPatternCountry == $country ? "<option selected='selected' value='{$country}'>{$country}</option>" : "<option value='{$country}'>{$country}</option>";

        $buff .= '</select>';
        $buff .= '</td></tr>';

        if( ! IS_GATEWAY )
        {
            $LocaleTitle = $sistema->retTranslate( 'HMPDetectionLocale' );

            $buff .= '<tr>';
            $buff .= '<td width="33%" align="left"><label for="DetectionLocale">' . $LocaleTitle . '</label></td>';
            $buff .= '<td width="33%" align="center"></td>';
            $buff .= '<td width="33%" align="center">';

            $locales = KHMPAnalyticsYaml::getSupportedLocales();

            $DetectionLocale = $sysYAML->getValue( 'DetectionLocale', 'System', 'pt-BR' );

            $buff .= '<select id="DetectionLocale" name="DetectionLocale">';
            foreach( $locales as $l )
            {
                $display = $sistema->retTranslate( $l );
                $buff .= $DetectionLocale === $l ? "<option selected='selected' value='{$l}'>{$display}</option>" : "<option value='{$l}'>{$display}</option>";
            }

            $buff .= '</select>';
            $buff .= '</td></tr>';
        }

        $buff .= '</tbody></table>';
        $buff .= '</div>';
        $buff .= '</fieldset>';
        $buff .= '<br />';

        if( !IS_GATEWAY )
        {
            $buff .= "<a class='collapsePara' onclick=\"changeArrow(this);\" href='#'>- " . $sistema->retTranslate( 'FXOLineSensibility' ) . '</a>';
            $buff .= '<fieldset>';

            $FXOChannels = $sistema->getFXOChannels( );
            $FXOChannelsSize = sizeof( $FXOChannels );

            $buff .= '<div id="FXOData">';
            $buff .= "<input type='hidden' id='FXOChannelsTotal' name='FXOChannelsTotal' value='{$FXOChannelsSize}'/>";

            if( $FXOChannelsSize > 0 )
            {
                $buff .= "<table class='zebra simpleTable'>";

                $buff .= '<thead><tr>';

                $buff .= '<th width="33%">' . $sistema->retTranslate( 'Device' ) . '</th>';
                $buff .= '<th width="33%">&nbsp</th>';
                $buff .= '<th width="33%">' . $sistema->retTranslate( 'Sensibility' ) . '</th></tr></thead><tbody>';

                for( $x = 0; $x < $FXOChannelsSize; $x++ )
                {
                    $buff .= "<tr>";
                    $subFXOChannels = explode( '.', $FXOChannels[$x] );
                    $buff .= '<td>' . $subFXOChannels[0] . '</td>';
                    $buff .= '<td></td>';
                    $value = $sysYAML->getValue( $FXOChannels[$x], 'System|FXOLineSensibility' );
                    if( $value == 'yamlError' || $value == '' )
                        $value = "48";
                    $buff .= '<td>' . printFXO( $FXOChannels[$x], $x, $subFXOChannels[0], $value ) . '</td>';
                    $buff .= '</tr>';
                }
                $buff .= '</tbody></table>';
            }
            else
                $buff .= '<div class="NFXO">' . $sistema->retTranslate( 'NFXO' ) . '</div>';

            $buff .= '</div>';
            $buff .= '</fieldset>';
            $buff .= '<br />';
            $buff .= "<a class='collapsePara' onclick=\"changeArrow(this);\" href='#'>- GSMPin</a>";
            $buff .= '<fieldset>';

            $GSMPins = $sistema->getGSMPins( );
            $GSMPinsSize = sizeof( $GSMPins );

            $buff .= "<div id='GSMPinData'>";
            $buff .= "<input type='hidden' id='GSMPinsTotal' name='GSMPinsTotal' value='$GSMPinsSize'/>";

            if( $GSMPinsSize > 0 )
            {
                $buff .= "<table class='zebra'><thead>";
                $buff .= "<tr>";
                $buff .= "<th width='33%'>" . $sistema->retTranslate( 'Device' ) . "</th>";
                $buff .= "<th width='33%'>" . $sistema->retTranslate( 'Channel' ) . "</th>";
                $buff .= "<th width='33%'>" . $sistema->retTranslate( 'Pin' ) . "</th>";
                $buff .= "</tr></thead><tbody>";

                for( $x = 0; $x < $GSMPinsSize; $x++ )
                {
                    $subGSMPins = explode( '.', $GSMPins[$x] );
                    $buff .= "<tr>";
                    $buff .= '<td>' . $subGSMPins[0] . '</td>';
                    $buff .= '<td>' . $subGSMPins[1] . '</td>';

                    $value = $sysYAML->getValue( $GSMPins[$x], 'System|GSMPin' );
                    $value = $value == "yamlError" ? '' : $value;

                    $buff .= '<td>' . GSMPin( $GSMPins[$x], $x, $value ) . '</td>';
                    $buff .= '</tr>';
                }
                $buff .= '</tbody></table>';
            }
            else
                $buff .= '<div class="NGSMPin">' . $sistema->retTranslate( 'NGSMPin' ) . '</div>';

            $buff .= '</div>';
            $buff .= '</fieldset>';
            $buff .= '<br />';
        }

        $buff .= "<input id='saveGeneralB' type='button' class='floatRight' onclick='saveGeneral();' value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= '</div>';

        return $buff;

    }

    function saveGeneral( )
    {
        Global $sistema;

        $FXOLineSensibility = isset( $_REQUEST['FXOLineSensibility'] ) ? $_REQUEST['FXOLineSensibility'] : NULL;
        $GSMPin = isset( $_REQUEST['GSMPin'] ) ? $_REQUEST['GSMPin'] : NULL;
        $MfcPatternCountry = isset( $_REQUEST['MfcPatternCountry'] ) ? $_REQUEST['MfcPatternCountry'] : NULL;
        $DetectionLocale = isset( $_REQUEST['DetectionLocale'] ) ? $_REQUEST['DetectionLocale'] : NULL;

        $configDir = $sistema->getConfigDir( );
        $sysYaml = new KYaml( $configDir . "/system.yaml" );
        $yaml = $sysYaml->getYaml( );

        if( trim( $FXOLineSensibility ) != '' )
        {
            $FXOLineSensibility = explode( ',', $FXOLineSensibility );
            foreach( $FXOLineSensibility as $FXO )
            {
                $tmp = explode( ':', $FXO );
                $yaml['System']['FXOLineSensibility'][$tmp[0]] = $tmp[1];
            }
        }

        if( trim( $GSMPin ) != '' )
        {
            $GSMPin = explode( ',', $GSMPin );
            foreach( $GSMPin as $GSM )
            {
                $temp = explode( ':', $GSM );
                $yaml['System']['GSMPin'][$temp[0]] = $temp[1];
            }
        }

        if( trim( $MfcPatternCountry ) != '' )
            $yaml['System']['MfcPatternCountry'] = $MfcPatternCountry;

        if( trim( $DetectionLocale ) != '' )
            $yaml['System']['DetectionLocale'] = $DetectionLocale;

        $sysYaml->setYaml( $yaml );
        $sysYaml->save( );

        return $sistema->retTranslate( 'ConfiguracaoSalva' );

    }

    function GSMPin( $DeviceChannel, $number, $value = "" )
    {
        $return = '';
        $return .= "<input type='hidden' id='GSMPinA$number' name='GSMPinA$number' value='$DeviceChannel'/>";
        $return .= "<input name='GSMPinB$number' id='GSMPinB$number' value='$value' type='text' class='selector'>";
        return $return;
    }

    function saveLinksE1T1( )
    {
        Global $sistema;
        $devices = isset( $_REQUEST['devices'] ) ? $_REQUEST['devices'] : NULL;
        $system = isset( $_REQUEST['system'] ) ? $_REQUEST['system'] : NULL;

        $configDir = $sistema->getConfigDir( );

        if( !empty( $devices ) )
        {
            $deviceYaml = new KYaml( $configDir . "/devices.yaml" );

            foreach( $devices as $serial => $device )
            {
                $dev = $deviceYaml->getValue( $serial );

                foreach( $device[ 'Links' ] as $index => $link )
                {
                    if ( !is_array( $dev[ 'Links' ][ $index ] ) )
                    {
                        $dev[ 'Links' ][ $index ] = array(
                            "$index" => array()
                        );
                    }

                    if ( !empty( $link[ 'Type' ] ) )
                    {
                        $dev[ 'Links' ][ $index ][ $index ][ 'Type' ]    = $link[ 'Type' ];
                    }
                    if ( isset( $link[ 'Name' ] ) )
                    {
                        $dev[ 'Links' ][ $index ][ $index ][ 'Name' ]    = $link[ 'Name' ];
                    }
                    if ( isset( $link[ 'Profile' ] ) )
                    {
                        $dev[ 'Links' ][ $index ][ $index ][ 'Profile' ] = $link[ 'Profile' ];
                    }
                }

                $deviceYaml->changeVarValue( $serial, $dev );
            }

            $deviceYaml->saveYaml( true );
        }

        if( !empty( $system ) )
        {
            $systemYaml = KSystemYaml::getInstance();
            $newSystem = array();

            foreach( $system as $key => $value ) {
                switch( $key )
                {
                case 'EnableLinkAsReference':
                case 'CentralOfficePrefix':
                case 'IncomingDigitsCount':
                case 'UseCentralOfficePrefixOnIncomingCalls':
                case 'CRC4':
                case 'LinkTimers':
                case 'CasLineValidateTime':
                    $newSystem[ $key ] = $system[ $key ];
                    break;
                case 'K3Lr':
                    if ( isset( $value[ 'Links' ] ) )
                    {
                        $systemYaml->changeVarValue( 'Links', array_filter( $value[ 'Links' ], 'filterK3LNotempty' ), 'K3Lr' );
                    }
                    break;

                default:
                    continue;
                }
            }

            if ( empty( $newSystem[ 'CRC4' ] ) )
            {
                $newSystem[ 'CRC4' ] = array();
            }

            if ( empty( $newSystem[ 'UseCentralOfficePrefixOnIncomingCalls' ] ) )
            {
                $newSystem[ 'UseCentralOfficePrefixOnIncomingCalls' ] = array();
            }

            $systemYaml->setSystem( $newSystem );

            $systemYaml->save( );
        }

        return $sistema->retTranslate( 'ConfiguracaoSalva' );
    }

    function saveCallProgressOptions( )
    {
        Global $sistema;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : '';

        if( isset( $_REQUEST['data'] ) )
        {
            $configDir = $sistema->getConfigDir( );
            $sysYaml = new KYaml( $configDir . "/system.yaml" );

            $data = explode( '|', $data );

            foreach( $data as $d )
            {
                $cv = explode( ':', $d );

                if($cv[0] == 'SilenceTimeToDisconnect' || $cv[0] == 'AnswerTimeout')
                    $cv[1] = strlen($cv[1]) <= 5 ? intval($cv[1]) * 1000 : $cv[1];

                $sysYaml->changeVarValue( $cv[0], $cv[1] );
            }
            $sysYaml->save( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function saveCadences( )
    {
        Global $sistema;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $configDir = $sistema->getConfigDir( );
            $sysYaml = new KYaml( $configDir . "/system.yaml" );

            $new_cad = array( );
            if( $data != '' )
            {
                $data = explode( '|', $data );
                foreach( $data as $d )
                {
                    $index = explode( '_', $d );
                    $id = $index[0];
                    $values = explode( ';', $index[1] );

                    $new = array( );
                    foreach( $values as $v )
                    {
                        $cv = explode( ':', $v );

                        if( $cv[0] == "Cadence" )
                            $cv[1] = explode( ',', $cv[1] );

                        $new[$id][$cv[0]] = $cv[1];
                    }
                    $new_cad[] = $new;
                }
            }
            $sysYaml->changeVarValue( 'Cadences', $new_cad );
            $sysYaml->save( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    /******** aux functions *********/

    function printFXO( $DeviceChannel, $number, $serial, $value = "" )
    {
        $return = '';
        // $return .= "<input type='hidden' id='FXOLineSensibilityA$number'
        // name='FXOLineSensibilityA$number' value='$DeviceChannel'/>";
        $possibleValues = array( 24, 48 );
        $return .= "<select name='FXOLineSensibility$number' id='FXOLineSensibility$number' >";
        for( $x = 0; $x < sizeof( $possibleValues ); $x++ )
        {
            $selected = $value == $possibleValues[$x] ? "selected" : '';
            $return .= "<option value='$serial:$possibleValues[$x]' $selected>$possibleValues[$x]</option>";
        }
        $return .= "</select>";
        return $return;
    }

    function getTotalFreeMtp3Mtp2Links( $ss7 )
    {
        if( isset( $ss7['ss7']['Mtp2'] ) )
            $freeMtp2Links = sizeof( $ss7['ss7']['Mtp2'] );
        else
            $freeMtp2Links = 0;

        if( isset( $ss7['ss7']['Mtp3']['LinkSets'] ) )
        {
            $chaves = array_keys( $ss7['ss7']['Mtp3']['LinkSets'] );
            for( $x = 0; $x < sizeof( $chaves ); $x++ )
            {
                $getKeys = array_keys( $ss7['ss7']['Mtp3']['LinkSets'][$chaves[$x]] );
                $freeMtp2Links = $freeMtp2Links - sizeof( $ss7['ss7']['Mtp3']['LinkSets'][$chaves[$x]][$getKeys[0]]['Links'] );
            }
        }
        return $freeMtp2Links;
    }

    function zeroFill( $var, $size )
    {
        if( strlen( $var ) >= $size )
        {
            return $var;
        }
        return str_repeat( '0', $size - strlen( $var ) ) . $var;
    }

    function getProfile( $link, $profilesYaml )
    {
        global $sistema;

        $Profiles = new KProfiles( );
        $defaultE1Types = array( 'R2', 'ISDN', 'ISUP', 'CAS PBX', 'CAS', 'CCS' );
        $defaultT1Types = array( 'ISDN' );
        $profiles = $profilesYaml->yaml["ChannelGroupProfiles"];

        $newProfile = array( );
        $newProfile[] = 'Deactivated';
        $newProfile['E1'] = array();
        $newProfile['T1'] = array();
        $subName = explode( '.', $link );
        $passiveType = false;

        if( $sistema->isPassiveDevice( $subName[0] ) )
            $passiveType = true;

        for( $x = 0; $x < sizeof( $profiles ); $x++ )
        {
            $keys = array_keys( $profiles[$x] );
            $profile = $Profiles->getProfile( $keys[0] );
            $type = $profile[$keys[0]]['Type'];

            $profileSubType = isset( $profile[$keys[0]]["SubType"] ) ? $profile[$keys[0]]["SubType"] : '';
            $passiveProfile = $profileSubType == 'Passive';

            if( in_array( $type, $defaultT1Types ) && !$passiveProfile )
            {
                $newProfile['T1'][] = $keys[0];
            }

            if( $passiveType && $$passiveProfile )
            {
                $newProfile['E1'][] = $keys[0];
            }
            elseif( $profileSubType != 'Passive' && (in_array( $type, $defaultE1Types )) && !$passiveType )
            {
                $newProfile['E1'][] = $keys[0];
            }
        }

        return $newProfile;
    }

    function getLinkType($serial)
    {
        $app = KSystem::getInstance();
        $configDir = $app->getConfigDir();
        $deviceYaml = new KYaml( $configDir . "/devices.yaml" );
        $subName = explode( '.', $serial );
        $dev = $deviceYaml->getValue( $subName[0]);
        return $dev['Links'][$subName[1]][$subName[1]]['Type'];
    }

    function getK3Lr( $link, $number, $yamlData )
    {
        $deviceData = explode( ".", $link );
        $k3lrLinks = $yamlData->getValue( 'Links', 'K3Lr' );

        $k3lrLink = $k3lrLinks[$number];

        $value = ( empty( $k3lrLink[ 'ServerAddress' ] ) ) ? '' : $k3lrLink['ServerAddress'];
        $return = '<td>'
            . '<input type="hidden" name="system[K3Lr][Links]['.$number.'][Device]" value="' . $link . '" />'
            . '<input onkeyup="validateIP(this)" onkeydown="return maskIP(event, this);" name="system[K3Lr][Links]['.$number.'][ServerAddress]"  value="' . $value . '" type="text" class="selector2"/>'
            . '</td>';

        return $return;
    }

    function casLineValidateTime( $link, $number, $yamlData )
    {
        return $return;
    }

    function linkTimers( $link, $number, $yamlData )
    {
        Global $sistema;
        $return = '';

        $startTime = $yamlData->getValue( 'StartTime', "System|LinkTimers|$link" );
        $startValue = ($startTime == '' || $startTime == "yamlError") ? 150 : $startTime;

        $return .= "<td>";
        $return .= "<select name='system[LinkTimers][{$link}][StartTime]' class='selector'>";
        for( $st = 0; $st < 2000; $st = $st + 50 )
        {
            $selected = ($st == $startValue) ? "selected" : '';
            $return .= "<option value='$st' $selected>$st</option>";
        }
        $return .= "</select>";
        $return .= "</td>";

        $releaseTime = $yamlData->getValue( 'ReleaseTime', "System|LinkTimers|$link" );
        $releaseValue = $releaseTime == '' || $releaseTime == "yamlError" ? 150 : $releaseTime;

        $return .= "<td>";
        $return .= "<select name='system[LinkTimers][{$link}][ReleaseTime]' class='selector'>";

        for( $st = 0; $st < 2000; $st = $st + 50 )
        {
            $selected = $st == $releaseValue ? "selected" : '';
            $return .= "<option value='$st' $selected>$st</option>";
        }
        $return .= "</select>";
        $return .= "</td>";

        $AlarmTime = $yamlData->getValue( 'AlarmTime', "System|LinkTimers|$link" );
        $AlarmValue = ($AlarmTime == '' || $AlarmTime == "yamlError") ? 150 : $AlarmTime;

        $return .= "<td valign='top' align='right'>";
        $return .= "<select name='system[LinkTimers][{$link}][AlarmTime]' class='selector'>";

        for( $st = 0; $st < 2000; $st = $st + 50 )
        {
            $selected = ($st == $AlarmValue) ? 'selected' : '';
            $return .= "<option value='$st' $selected>$st</option>";
        }
        $return .= "</select>";
        $return .= "</td>";

        return $return;
    }

    function removeDeletedProfileFromLinks( $profileName )
    {
        Global $sistema;

        $configDir = $sistema->getConfigDir( );
        $deviceYaml = new KYaml( $configDir . '/devices.yaml' );
        $devicesYaml = $deviceYaml->getYaml( );
        $devices = $devicesYaml['Devices'];
        $dKeys = array_keys( $devices );

        foreach( $dKeys as $key )
        {
            $dev = $devices[$key];
            $devKeys = array_keys( $dev );
            $devLinks = $dev[$devKeys[0]]['Links'];
            $linkKeys = array_keys( $devLinks );
            foreach( $linkKeys as $k )
            {
                $keys = array_keys( $devLinks[$k] );
                foreach( $keys as $x )
                {
                    if( $devLinks[$k][$x]['Profile'] == $profileName )
                    {
                        $dev[$devKeys[0]]['Links'][$k][$x]['Profile'] = 'Deactivated';
                        $devFinal = $dev[$devKeys[0]];
                        $deviceYaml->changeVarValue( $devKeys[0], $devFinal );
                    }
                }
            }
        }
        $deviceYaml->saveYaml( true );
        return;
    }

    function filterK3LNotempty( $item ) {
        return ( !empty( $item[ 'ServerAddress' ] ) );
    }
