<?php
    require_once KCONFIG . '/classes/classKYaml.php';

    class KGatewayFTPYamlException extends KYamlException
    {
        /* VOID */
    }

    class KFTPYaml extends KYaml
    {
        const DEFAULT_RETENTION = 30;

        public function __construct( )
        {
            //@formatter:off
            $this->rules = array(
                'FTP' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'children' => array(
                        'Enabled' => array(
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED,
                            'type' => KYaml::TYPE_BOOLEAN,
                            'default' => false
                        ),
                        'Server' => array(
                            'type' => KYaml::TYPE_STRING,
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED
                        ),
                        'Port' => array(
                            'type' => KYaml::TYPE_INTEGER,
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED
                        ),
                        'User' => array(
                            'type' => KYaml::TYPE_STRING,
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED
                        ),
                        'Passwd' => array(
                            'type' => KYaml::TYPE_STRING,
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED
                        ),
                        'Path' => array(
                            'type' => KYaml::TYPE_STRING,
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED
                        )
                    )
                ),
                'CDR' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'children' => array(
                        'Retention' => array(
                            'type' => KYaml::TYPE_INTEGER,
                            'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED,
                            'default' => self::DEFAULT_RETENTION
                        ),
                        'Size' => array(
                            'type' => KYaml::TYPE_INTEGER
                        )
                    )
                )
            );
            //@formatter:on

            $app = KSystem::getInstance( );
            parent::__construct( $app->getConfigDir( ) . DIRECTORY_SEPARATOR . 'gatewayftp.yaml' );
        }

        public function getFTP( )
        {
            return $this->yaml['FTP'];
        }

        public function setFTP( $data )
        {
            $currentData = $this->getFTP( );
            $this->yaml['FTP'] = $data;
        }

        public function getCDRRetention( )
        {
            return isset( $this->yaml['CDR']['Retention'] ) ? $this->yaml['CDR']['Retention'] : self::DEFAULT_RETENTION;
        }

        public function setCDRRetention( $days )
        {
            $this->yaml['CDR']['Retention'] = $days;
        }

        public function getCDRSize( )
        {
            return $this->yaml['CDR']['Size'];
        }

        public function setCDRSize( $size )
        {
            $this->yaml['CDR']['Size'] = $size;
        }
    }
