<?php
    require_once KCONFIG . '/classes/classKYaml.php';
    require_once KCONFIG . '/classes/KSystemYaml.php';
    
    
    class KHMPAnalyticsYaml extends KYaml
    {
        
        function __construct( $locale = "" )
        {
            $arr_content = array(
                'type' => KYaml::TYPE_LISTHASH,
                'children' => array(

                    'Name' => array(
                        'type' => KYaml::TYPE_STRING,
                    ),
                    'State' => array(
                        'type' => KYaml::TYPE_STRING,
                    ),
                    'Classification' => array(
                        'type' => KYaml::TYPE_STRING,
                    ),
                    'Pattern' => array
                    (
                        'type' => KYaml::TYPE_LIST,
                        'flags' => KYaml::FLAG_NORMALIZE,
                        'children' => array(
                            '?' => array(
                                'type' => KYaml::TYPE_LISTHASH,
                                'children' => array(
                                
                                    'Tone' => array(
                                        'type' => KYaml::TYPE_STRING,
                                    ),
                                    'Min' => array(
                                        'type' => KYaml::TYPE_INTEGER,
                                    ),
                                    'Max' => array(
                                        'type' => KYaml::TYPE_INTEGER,
                                    )
                                )
                            
                            )
                        )
                    )
                    
                )
            );
            
            $this->rules = array(
                'Version' => array(
                    'type' => KYaml::TYPE_INTEGER,
                ),
                'Patterns' => array
                (
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'children' => array( '?' => $arr_content )
            
                )
            );

            if ( !in_array( $locale, $this->getSupportedLocales() ) )
            {
                Global $sistema;
                $sysYAML = new KYaml( $sistema->getConfigDir() . '/system.yaml' );
                $locale = $sysYAML->getValue( 'DetectionLocale', 'System', 'pt-BR' );
            }

            $app = KSystem::getInstance();

            $file = $app->getPackageVersionDir() . DIRECTORY_SEPARATOR . 'locale' . DIRECTORY_SEPARATOR . $locale . DIRECTORY_SEPARATOR . 'hmp_patterns.yaml';

            if ( file_exists( $file ) )
            {
                parent::__construct( $file );
            }
        }

        /**
         * Get patterns file version
         *
         * @return array
         */
        public function getVersion( )
        {
            return $this->yaml['Version'];
        }

        /**
         * Get all patterns
         *
         * @return array
         */
        public function getAllPatterns( )
        {
            return $this->yaml['Patterns'];
        }

        /**
         * Get supported locales
         *
         * @return array
         */
        public static function getSupportedLocales( )
        {
            return array('pt-BR','en-US','es-AR','es-BO','es-CL','es-CO','es-EC','es-MX','es-PE','es-PY','es-UY','es-VE');
        }

    }

