<?php
    require_once( KCONFIG . '/classes/classKYaml.php' );

    class KSystemYaml extends KYaml
    {
        static private $self = null;

        function __construct()
        {
            $app = KSystem::getInstance();
            parent::__construct( $app->getConfigDir() . DIRECTORY_SEPARATOR . 'system.yaml' );
        }

        static public function getInstance()
        {
            if ( is_null( self::$self ) )
            {
                self::$self = new KSystemYaml();
            }
            return self::$self;
        }

        public function getSystem( )
        {
            $systemYaml = KSystemYaml::getInstance(); 

            $yaml = $systemYaml->getYaml();

            foreach( $yaml[ 'System' ] as $key => $value )
            {
                switch ( $key )
                {
                    case 'EnableLinkAsReference':
                    case 'CRC4':
                    case 'UseCentralOfficePrefixOnIncomingCalls':
                       if ( !is_array( $value ) ) {
                           $yaml[ 'System' ][ $key ] = explode( ',', $value);
                       }
                       break;
                }
            }

            return $yaml[ 'System' ];
        }

        public function setSystem( $dict )
        {
            $systemYaml = KSystemYaml::getInstance(); 

            $yaml = $systemYaml->getYaml();

            foreach( $dict as $key => $value )
            {
                switch( $key )
                {
                case 'EnableLinkAsReference':
                case 'CRC4':
                case 'UseCentralOfficePrefixOnIncomingCalls':
                    if ( is_array( $value ) )
                    {
                        $value = implode( ',', array_filter( $value ) );
                    }
                    break;
                }

                $yaml[ 'System' ][ $key ] = $value;
            }

            $systemYaml->setYaml( $yaml );
        }
    }
