<?php
@session_start( );

if(!IS_ELASTIX)
    require_once KROOT . '/smarty-libs/Smarty.class.php';

$AjaxFunctions['getLogFile'] = 'getLogFile';
$AjaxFunctions['getLines'] = 'getLines';

$contador = 0;

function logToFile($msg) { 
   // open file
   $file = LogUtil::getLogDir( ) . 'portal.log';
   
   $fd = fopen($file, "a");
   // write string
   fwrite($fd, $msg . "\n");
   // close file
   fclose($fd);
}

//AJAX functions
function getLogFile( )
{
    if( isset( $_REQUEST['file'] ) )
    {
        $file = LogUtil::getLogDir( ) . $_REQUEST['file'];
        if( file_exists( $file ) )
        {
            $response = array( );
            $response['content']['file'] = $file;
            $response['content']['header'] = printLogTemplate( $_REQUEST['file'] );
            $response['success'] = true;
            $response['message'] = '';
            
            if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
                $ip = $_SERVER['HTTP_CLIENT_IP'];
            } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
                $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
            } else {
                $ip = $_SERVER['REMOTE_ADDR'];
            }
            
            logToFile(date("Y-m-d H:i:s") . " - Acessando interface do analizador (". $_REQUEST['file']. ") " . $ip);
            
        }
        else
            $response = errorMessage( 'Arquivo de log informado não existe!' );
    }
    else
        $response = errorMessage( 'Arquivo de log não informado!' );

    echo JSONencode( $response );
}

function isValidPeriod( $begin, $end ) {

    if (empty($begin)) {
        return JSONencode(errorMessage( 'Informe a data de início.' ));
    }
    
    if (empty($end)) {
        return JSONencode(errorMessage( 'Informe a data de fim.' ));
    }

    $tmpDate = explode( '/', $begin );
        
if (checkdate( $tmpDate[1], $tmpDate[0], $tmpDate[2] ) ) {
        return JSONencode(errorMessage( 'Data de início informada é inválida.' ));
    }
    
    $tmpDate = explode( '/', $end );
    
    if (checkdate( $tmpDate[1], $tmpDate[0], $tmpDate[2] ) ) {
        return JSONencode(errorMessage( 'Data de fim informada é inválida.' ));
    }
                
    if ( preg_match( "/(2[0-3]|[01][0-9]):[0-5][0-9]/", $begin ) && preg_match( "/(2[0-3]|[01][0-9]):[0-5][0-9]/", $end ) ) {
    
        return ( $begin <= $end ) ? true : JSONencode(errorMessage( 'Horário de início maior que horário de término' ));

    } else {
    
        return JSONencode(errorMessage( 'Os horários informados são inválidos.' ));
    }
    
    return true;
}

// Aux functions

function do_translation ($params, $content, $smarty, &$repeat, $template = null) {
    $app = KSystem::getInstance();
    return (empty($content)) ? '' : $app->translate($content);
}

function printLogTemplate( $file ) {
    $smarty = new Smarty( );
    $smarty->registerPlugin("block", "translate", "do_translation");
    
    if ($file === 'r2.log') {
        return $smarty->fetch( 'themes/default/R2LogAnalyser.tpl' );
    } else if ($file === 'isdn.log') {
        return $smarty->fetch( 'themes/default/ISDNLogAnaliser.tpl' );
    }
    
    return 'NAO ENCONTRADO';
    
}

function errorMessage( $msg ) {
    $response = array( );
    $response['success'] = false;
    $response['content'] = '';
    $response['message'] = $msg;
    return $response;
}
