<?php
    @session_start( );

    $AjaxFunctions['showFileDir'] = 'showFileDir';
	$AjaxFunctions['showFileCDRDir'] = 'showFileCDRDir';
    $AjaxFunctions['showPacketCapture'] = 'showPacketCapture';
    $AjaxFunctions['startPacketCapture'] = 'startPacketCapture';
    $AjaxFunctions['stopPacketCapture'] = 'stopPacketCapture';
    $AjaxFunctions['analyseLogDir'] = 'analyseLogDir';
    $AjaxFunctions['deleteFile'] = 'deleteFile';
    $AjaxFunctions['checkKtcpdump'] = 'checkKtcpdump';

    function showFileDir( )
    {
        Global $sistema;
        $return = "";

        $dir = isset( $_REQUEST['dir'] ) ? base64_decode( $_REQUEST['dir'] ) : NULL;

        if( isset( $dir ) && file_exists( $dir ) )
        {

            $dir = substr( $dir, -1 ) != DIRECTORY_SEPARATOR ? $dir . DIRECTORY_SEPARATOR : $dir;
            $result = listFilesFromDir( $dir );

            if( sizeof( $result ) > 0 )
            {
                $return .= "<input id='language' type='hidden' value='" . $sistema->getLanguage( ) . "'>";
                $return .= "<table id='tabelaLogs' class='zebra' border='1'><thead>";
                $return .= "<tr>";
                $return .= "<th width='10%' rowspan='2' scope='col' id='sizeDownload'>" . $sistema->retTranslate( 'size' ) . "</th>";
                $return .= "<th rowspan='2' scope='col' >" . $sistema->retTranslate( 'files' ) . "</th>";
                $return .= "<th width='15%' rowspan='2' scope='col' >" . $sistema->retTranslate( 'modificationDate' ) . "</th>";
                $return .= "<th colspan='3' scope='col' >" . $sistema->retTranslate( 'actions' ) . "</th>";
                $return .= "</tr>";
                $return .= "<tr>";

                $return .= "<th width='7%' scope='col' id='columnDownload'>" . $sistema->retTranslate( 'download' ) . "</th>";
                $return .= "<th width='7%' scope='col' id='columnRead'>" . $sistema->retTranslate( 'visualize' ) . "</th>";
                $return .= "<th width='7%' scope='col' id='columnAnalyse'>" . $sistema->retTranslate( 'analyse' ) . "</th>";

                $return .= "</tr></thead><tbody>";

                for( $x = 0; $x < sizeof( $result ); $x++ )
                    $return .= printFileInterface( $dir, $result[$x], $x );
                $return .= "</tbody></table>";
            }

            if( sizeof( $result ) == 0 )
                $return .= "<br>" . $sistema->retTranslate( 'noFilesAtFolder' );

        }
        return $return;
    }
    function getCaptureDirPath()
    {
        if(IS_CHANNEL)
            return '/var/log/khomp/capture';
        return '/var/local/ftp/capture';
    }
    function vdbg($var)
    {
        echo '<pre>'.var_export($var, true).'</pre>';
    }
    function getIPMap()
    {
        Global $sistema;
        $app = KSystem::getInstance();
        $devs = new KYaml($app->getConfigDir().'/devices.yaml');
        $devs = $devs->getYaml();
        $devs = $devs['Devices'];
        $ret = array();
        for($i=0; $i<count($devs); ++$i)
        {
            $serial = key($devs[$i]);
            $dev = $devs[$i][$serial];
            if(isset($dev['IP']))
                $ret[$serial.' - '.$dev['Type']] = $dev['IP'];
        }
        return $ret;
    }
    function deleteFile()
    {
        if(!isset($_REQUEST['file']))
        {
            return 'Could not delete file';
        }
        $file = $_REQUEST['file'];
        unlink(getCaptureDirPath().'/'.$file);
        return false;
    }
    function makeDeviceIpsSelect($disabled)
    {
        $buff = "<select {$disabled} id=\"deviceIpSelect\">";
        $m = getIPMap();
        foreach($m as $name => $ip)
        {
            $buff .= "<option value='${ip}'>{$name}</option>";
        }
        $buff .= '</select>';
        return $buff;
    }

    function showFileCDRDir( )
    {
        Global $sistema;
        $return = "";

        $dir = isset( $_REQUEST['dir'] ) ? base64_decode( $_REQUEST['dir'] ) : NULL;

        if( isset( $dir ) && file_exists( $dir ) )
        {

            $dir = substr( $dir, -1 ) != DIRECTORY_SEPARATOR ? $dir . DIRECTORY_SEPARATOR : $dir;
            $result = listFilesFromDir( $dir );

            if( sizeof( $result ) > 0 )
            {	
                $return .= "<input id='language' type='hidden' value='" . $sistema->getLanguage( ) . "'>";
                $return .= "<table id='tabelaLogs' class='zebra' border='1'><thead>";
                $return .= "<tr>";
                $return .= "<th width='10%' rowspan='2' scope='col' id='sizeDownload'>" . $sistema->retTranslate( 'size' ) . "</th>";
                $return .= "<th rowspan='2' scope='col' >" . $sistema->retTranslate( 'files' ) . "</th>";
                $return .= "<th width='15%' rowspan='2' scope='col' >" . $sistema->retTranslate( 'modificationDate' ) . "</th>";
                $return .= "<th colspan='2' scope='col' >" . $sistema->retTranslate( 'actions' ) . "</th>";
                $return .= "</tr>";
                $return .= "<tr>";

                $return .= "<th width='7%' scope='col' id='columnDownload'>" . $sistema->retTranslate( 'download' ) . "</th>";
                $return .= "<th width='7%' scope='col' id='columnRead'>" . $sistema->retTranslate( 'visualize' ) . "</th>";

                $return .= "</tr></thead><tbody>";

                for( $x = 0; $x < sizeof( $result); $x++ )
                    $return .= printFileCDRInterface( $dir, $result[$x], $x );
                $return .= "</tbody></table>";
            }

            if( sizeof( $result ) == 0 )
                $return .= "<br>" . $sistema->retTranslate( 'noFilesAtFolder' );

        }
        return $return;
    }
    function showPacketCaptureRunning( $config )
    {
        Global $sistema;

        require_once KROOT . '/classes/KLicenseLimits.php';
        require_once KCONFIG . '/ajax/auxFunctions.php';

        $limits = new KLicenseLimits();

        $model_storage_limit = round( $limits->getPacketCaptureStorageLimit() / ( 1024*1024 ) );

        $return = "";

        $return .= "<fieldset id='packetCaptureField'>";
        $return .= "<legend>".$sistema->retTranslate( 'packet_capture' )."</legend>";

        $return .= "<table class='packetCaptureTable' id='packetCaptureOptionsTable'>";
        $return .= "<tr class='highlight'>";
        $return .= "<td class='first title'><b>".$sistema->retTranslate( 'started' )."</b></td>";
        $return .= "<td class='last'>";
        $return .= $config['started'];
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "<tr>";
        $return .= "<td class='first title'>";
        $return .= '<b>'.$sistema->retTranslate( 'duration' )." (min)</b>";
        $return .= "</td>";
        $return .= "<td class='last'>";
        $return .= is_numeric( $config['duration'] ) ? $config['duration'] : "5";
        $return .= "</td>";
        $return .= "</tr>";
        if ( (!IS_CHANNEL) && $limits->getEBSLimit() > 0 )
        {
            $return .= "<tr>";
            $return .= "<td class='first title'><b>".$sistema->retTranslate( 'ebs_modules' )."</b></td>";
            $return .= "<td class='last'>";
            if ( $config['ebs'] === true )
            {
                $return .= $sistema->retTranslate( "capturing" );
            }
            else
            {
                $return .= $sistema->retTranslate( "no_capturing" );
            }
            $return .= "</td>";
            $return .= "</tr>";
        }
        if ( count( $config['filters'] ) > 0 )
        {
            $return .= "<tr>";
            $return .= "<td class='first title'><b>".$sistema->retTranslate( 'filters' )."</b></td>";
            $return .= "<td class='last'>";
            $return .= "<table class='packetCaptureTable' id='packetCaptureRulesTable'>";
            $return .= "<tbody id='packetCaptureRules'>";
            foreach( $config['filters'] as $filter )
            {
                $return .= "<tr>";
                $return .= "<td class='last'>";
                $return .= $filter;
                $return .= "</td>";
                $return .= "</tr>";
            }
            $return .= "</tbody>";
            $return .= "</table>";
            $return .= "</td>";
            $return .= "</tr>";
        }
        $return .= "</table>";

        $return .= "<div class='packetCaptureButton'>";
        $return .= "<input type='button' onclick='stopPacketCapture();' value='".$sistema->retTranslate( 'stop_capture' )."' />";
        $return .= "</div>";

        $return .= "</fieldset>";

        $return .= dumpsTable();
        $return .= "<span id=batman hidden></span>";

        return $return;
    }

    function dumpsTable()
    {
        $dir = getCaptureDirPath();

        if( !file_exists( $dir ) )
            return '';

        Global $sistema;
        $result = listFilesFromDir( $dir );
        $return = '';

        if( sizeof( $result ) > 0 )
        {
            $return .= "<div id='captureFiles'>";
            $return .= "<table id='captureFiles' class='zebra' border='1'><thead>";
            $return .= "<tr>";
            $return .= "<th width='10%' scope='col' id='sizeDownload'>" . $sistema->retTranslate( 'size' ) . "</th>";
            $return .= "<th scope='col' >" . $sistema->retTranslate( 'files' ) . "</th>";
            $return .= "<th width='15%' scope='col' >" . $sistema->retTranslate( 'modificationDate' ) . "</th>";
            $return .= "<th width='21%' scope='col' id='columnDownload'>" . $sistema->retTranslate( 'download' ) . "</th>";
            $return .= "</tr>";
            $return .= "<tr>";


            $return .= "</tr></thead><tbody>";

            Global $image_dir, $module_dir;

            for( $x = 0; $x < sizeof( $result ); $x++ )
            {
                $file = $dir . DIRECTORY_SEPARATOR . $result[$x];
                $size = sprintf( "%u", filesize( $file ) );
                $file64 = base64_encode( $file );

                $return .= "<tr>";
                $return .= "<td class='filesize'>" . getFileSizeStyle( $size ) . "</td>";
                $return .= "<td class='file'>" . $result[$x] . "</td>";
                $return .= "<td class='date'>" . date( "d/m/Y H:i:s", filemtime( $file ) ) . "</td>";
                $return .= "<td>";
                $return .= "<a onclick='return browserTest();' href=\"$module_dir/zipAjax.php?file=" . $file64 . "&type=file\" target='_self'>";
                $return .= "<img title='" . $sistema->retTranslate( 'download' ) . "' src='$image_dir/imagens/download.png' border='0' ></a>";
                $return .= "</a>";
                $return .= "&nbsp&nbsp&nbsp";
                $return .= "<a onclick='deleteFile(this,\"{$result[$x]}\")'>";
                $return .= "<img title='" . $sistema->retTranslate( 'delete' ) . "' src='$image_dir/imagens/remove.png' border='0' ></a>";
                $return .= "</a>";
                $return .= "</td></tr>";
            }

            $return .= "</tbody></table>";
            $return .= "</div>";
        }
        return $return;
    }
    function showPacketCapture( )
    {
        $config = loadConfiguration( '/tmp/capture.cfg' );
        $running = file_exists( '/var/run/ktcpdump.pid' ) && ( !empty( $config ) );
        if($running)
            return showPacketCaptureRunning($config);

        Global $sistema;
        require_once KROOT . '/classes/KLicenseLimits.php';
        require_once KCONFIG . '/ajax/auxFunctions.php';

        $limits = new KLicenseLimits();

        $model_storage_limit = round( $limits->getPacketCaptureStorageLimit() / ( 1024*1024 ) );

        $return = "";

        $return .= "<fieldset id='packetCaptureField'>";
        $return .= "<legend>".$sistema->retTranslate( 'packet_capture' )."</legend>";

        $return .= "<table class='packetCaptureTable' id='packetCaptureOptionsTable'>";
        $return .= "<tr>";
        $return .= "<td class='first title'>";
        $return .= $sistema->retTranslate( 'duration' )." (min)";
        $return .= "&nbsp;<img src='${image_dir}/imagens/tooltip.png' title='{$sistema->retTranslate( 'packet_capture_storage_limit' )} {$model_storage_limit} MB' class='gateway-tooltip' alt='tooltip' />";
        $return .= "</td>";
        $return .= "<td class='last'>";
        if(IS_CHANNEL)
            $return .= "<input type='text' id='pcoDuration' onkeypress='return validateNumeric(event);'>";
        else
            $return .= make_select( 'pcoDuration', range( 5, 60, 5 ), 5 );
        $return .= "</td>";
        $return .= "</tr>";
        if ( (!IS_CHANNEL) && $limits->getEBSLimit() > 0 )
        {
            $return .= "<tr>";
            $return .= "<td class='first title'>".$sistema->retTranslate( 'ebs_modules' )."</td>";
            $return .= "<td class='last'>";
            $return .= "<input type='checkbox' id='pcoEBS' />";
            $return .= "</td>";
            $return .= "</tr>";
        }
        if(IS_CHANNEL)
        {
            //$interfaces = $sistema->getAllInterfaces();
            //$interfaces = $sistema->getIPv4Interfaces();
            $interfaces = $sistema->getInterfaceNames();
            
            $return .= '<tr>';
            $return .= "<td class='first title'>{$sistema->retTranslate('network_interfaces')}:</td>";
            $return .= "<td class='last'>";
            $return .= "<input name=iface type='radio' onclick='radioOnChange()' id='radio0' />";
            $x=0;
            foreach($interfaces as $i)
            {
                $ip = explode(' ', $i);
                $return .= "<input id='netiface".$x++."' disabled  type='checkbox' value='".trim($ip[1], "()") . "' >{$i}<br>";
            }
            $return .= '</td></tr>';
            ////
            $return .= '<tr>';
            $return .= "<td class='first title'>".$sistema->retTranslate( 'select_device' )."</td>";
            $return .= "<td class='last'>";
            $return .= "<input type='radio' name='iface' id='radio1' onclick='radioOnChange()' />";
            $return .= makeDeviceIpsSelect('disabled');
            $return .= '</td></tr>';
        }
        $return .= "<tr>";
        $return .= "<td class='first title'>".$sistema->retTranslate( 'filters' )."</td>";
        $return .= "<td class='last'>";
        if(IS_CHANNEL)
            $return .= "<input checked type='radio' name='iface' id='radio2' onclick='radioOnChange()' >";
        $return .= "<table class='packetCaptureTable' id='packetCaptureRulesTable' style='display: inline'>";
        $return .= "<tbody id='packetCaptureRules'>";
        $return .= "</tbody>";
        $return .= "</table>";
        $return .= "<div>";
        $return .= "<span id='addFilter' class='includeCaptureFilter' onclick=\"createPacketCaptureRule();\">";
        $return .= $sistema->retTranslate( 'add_filter' );
        $return .= "</span>";
        $return .= "</div>";
        $return .= "</td>";
        $return .= "</tr>";

        $return .= "<tr><td class='first title'>";
        $return .= "DTMF Debug:";
        $return .= "</td><td class='last'>";
        $return .= "<input type='checkbox' id='dtmfdebug'  >";
        $return .= "<span id='dtmf_debug_span' >";
        $return .= $sistema->retTranslate('channels_optional') . ': ';
        $return .= "<input size=2 type='text' id='dtmf_chan_first' disabled>";
        $return .= " - ";
        $return .= "<input size=2 type='text' id='dtmf_chan_last'  disabled>";
        $return .= "</span>";
        $return .= "</td></tr>";
        $return .= "<tr><td class='first title'>";
        $return .= "MFC Debug:";
        $return .= "</td><td class='last'>";
        $return .= "<input type='checkbox' id='mfcdebug' >";
        $return .= "<span id='mfc_debug_span' >";
        $return .= $sistema->retTranslate('channels_optional') . ': ';
        $return .= "<input size=2 type='text' id='mfc_chan_first' disabled>";
        $return .= " - ";
        $return .= "<input size=2 type='text' id='mfc_chan_last'  disabled>";
        $return .= "</span>";
        $return .= "</td></tr>";

        $return .= "</table>";
        

        $return .= "<div class='packetCaptureButton'>";
        $return .= "<input type='button' onclick='startPacketCapture();' value='".$sistema->retTranslate( 'capture' )."' />";
        $return .= "</div>";

        $return .= "</fieldset>";

        $return .= dumpsTable();

        return $return;
    }

    function startPacketCapture( )
    {
        Global $sistema;

        $return = array( "return" => true, "message" => "" );

        try
        {
            if ( isset( $_REQUEST['form'] ) )
            {
                require_once KROOT . '/classes/KLicenseLimits.php';

                $limits = new KLicenseLimits();

                $model_storage_limit = round( $limits->getPacketCaptureStorageLimit() / ( 1024*1024 ) );

                $form = json_decode( $_REQUEST['form'], true );
                $duration = ( is_numeric( $form['duration'] ) ? intval( $form['duration'] ) : 5 );

                $hosts = '';

                foreach( $form['filters'] as $filter )
                {
                    if ( $hosts !== '' )
                    {
                        $hosts .= ' or ';
                    }
                    if(!IS_CHANNEL)
                    {
                        if ( filter_var( $filter, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 ) === FALSE )
                        {
                            if ( filter_var( $filter, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6 ) === FALSE )
                            {
                                throw new Exception( 'invalid_ip' );
                            }
                            else
                            {
                                $hosts .= 'ip6 ';
                            }
                        }
                    }
                    $hosts .= 'host '.$filter;
                }

                if(!IS_CHANNEL)
                {
                    if ( $form['ebs'] === true )
                    {
                        if ( $hosts !== '' )
                        {
                            $hosts .= ' or ';
                        }

                        $hosts .= 'host 172.31.249.1';
                    }
                    else if ( count( $form['filters'] ) === 0 )
                    {
                        $hosts = 'not host 172.31.249.1';
                    }
                }
                else
                {
                    /* IP address validation */
                    $host = explode ( " " , $hosts );
                    if ( filter_var( $host[1], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 ) === FALSE )
                    {
                        if ( filter_var( $host[1], FILTER_VALIDATE_IP, FILTER_FLAG_IPV6 ) === FALSE )
                        {
                            throw new Exception( 'invalid_ip' );
                        }
                    }
                }

                $hosts = '"('.$hosts.')"';

                if(IS_GATEWAY)
                {
                    $ktcpdump = '/usr/sbin/ktcpdump';
                    $tcpdump = '/usr/sbin/tcpdump';
                    $gzip = '/bin/gzip';
                }
                else if(IS_CHANNEL)
                {   //ktcpdump's CheckTools checks if 'whereis' and 'cut' are installed.
                    exec("whereis -b ktcpdump|cut -d' ' -f2", $ktcpdump);
                    exec("whereis -b tcpdump |cut -d' ' -f2", $tcpdump);
                    exec("whereis -b gzip    |cut -d' ' -f2", $gzip);
                    $ktcpdump = $ktcpdump[0];
                    $tcpdump = $tcpdump[0];
                    $gzip = $gzip[0];

                    set_debug_options(true, $form);
                }

                $ktcpdump_pid = '/var/run/ktcpdump.pid';

                $output_file = '"'.date("Ymd-His").'.cap.gz"';

                $form['started'] = date("Y/m/d H:i:s");

                if ( ( !file_exists( $ktcpdump ) )
                    or ( !file_exists( $tcpdump ) )
                    or ( !file_exists( $gzip ) ) )
                {
                    throw new Exception( 'no_capture_tool' );
                }

                $command = $ktcpdump.' start -f '.$hosts.' -s '.$model_storage_limit.' -t '.$duration.' -n '.$output_file;


                exec( $command, $out, $code );
                exec( "echo '${command}' >> /home/kira/debug");

                if ( ( $code !== 0 ) || ( !file_exists( $ktcpdump_pid ) ) )
                {
                    throw new Exception( 'could_not_capture' );
                }

                saveConfiguration( '/tmp/capture.cfg', $form );
            }
            else
            {
                throw new Exception( 'invalid_request_to_capture' );
            }
        }
        catch ( Exception $e )
        {
            $return['return'] = false;
            $return['message'] = $sistema->retTranslate( $e->getMessage() );
        }

        return json_encode( $return );
    }

    function set_debug_options($set, $form)
    {
        $set_str = $set ? 'on' : 'off';
        Global $sistema;

        if(isset($form['dtmfdebug']))
        {
            exec("whereis -b pidof | cut -d' ' -f2", $command);
            exec("$command[0] asterisk", $dummy, $ret);
            if($ret!=0)
                throw new Exception( 'asterisk_not_running' );
            if($form['dtmfdebug'])
            {
                $board = "";
                $f = '';
                $l = '';
                if(isset($form['serial']))
                    $board = $sistema->serialToBoard($form['serial']);
                if(isset($form['dtmf_chan_first']))
                    $f = $form['dtmf_chan_first'];
                if(isset($form['dtmf_chan_last']))
                    $l = $form['dtmf_chan_last'];
                if(!isset($form['dtmf_chan_first']) and isset($form['serial']))
                    exec("/usr/sbin/asterisk -rx 'khomp set debug dtmf ${set_str} ${board}");
                else
                    for($i=$f; $i <= $l; ++$i)
                        exec("/usr/sbin/asterisk -rx 'khomp set debug dtmf ${set_str} ${board} ${i}'");
            }
        }
        if(isset($form['mfcdebug']))
        {
            exec("whereis -b pidof | cut -d' ' -f2", $command);
            exec("$command[0] asterisk", $dummy, $ret);
            if($ret!=0)
                throw new Exception( 'asterisk_not_running' );
            if($form['mfcdebug'])
            {
                $board = "";
                $f = '';
                $l = '';
                if(isset($form['serial']))
                    $board = $sistema->serialToBoard($form['serial']);
                if(isset($form['mfc_chan_first']))
                    $f = $form['mfc_chan_first'];
                if(isset($form['mfc_chan_last']))
                    $l = $form['mfc_chan_last'];
                if(!isset($form['mfc_chan_first']) and isset($form['serial']))
                    exec("/usr/sbin/asterisk -rx 'khomp set debug mfc ${set_str} ${board}");
                else
                    for($i=$f; $i <= $l; ++$i)
                        exec("/usr/sbin/asterisk -rx 'khomp set debug mfc ${set_str} ${board} ${i}'");
            }
        }
    }

    function checkKtcpdump()
    {
        if(!IS_CHANNEL)
            return;
        $form = json_decode( $_REQUEST['form'], true );
        stopPacketCapture();

        set_debug_options(false, $form);
    }

    function stopPacketCapture( )
    {
        Global $sistema;

        $return = array( "return" => true, "message" => "" );

        try
        {
            if(IS_CHANNEL)
            {
                exec("whereis -b ktcpdump | cut -d' ' -f2", $command);
                $command = $command[0] . ' stop';
            }
            else
                $command = '/usr/sbin/ktcpdump stop';

            exec( $command, $out, $code );

            usleep( 400000 );

            if ( file_exists( '/var/run/ktcpdump.pid' ) )
            {
                throw new Exception( 'could_not_stop_capture' );
            }

            if ( file_exists('/tmp/capture.cfg') ) // PHP short-circuiting is not safe =(
            if ( !unlink( '/tmp/capture.cfg' ) )
            {
                trigger_error( "Could not remove '/tmp/capture.cfg'", E_USER_WARNING );
            }
        }
        catch ( Exception $e )
        {
            $return['return'] = false;
            $return['message'] = $sistema->retTranslate( $e->getMessage() );
        }

        return json_encode( $return );
    }

    function analyseLogDir()
    {
        Global $sistema;
        $logDir = isset( $_REQUEST['logDir'] ) ? $_REQUEST['logDir'] : NULL;
        $oper = isset( $_REQUEST['oper'] ) ? $_REQUEST['oper'] : NULL;

        if( isset( $logDir ) && isset( $oper ) )
        {
            $logDir = base64_decode( $logDir );
            if( $oper == "sizeOf" )
                $size = getFileSizeStyle( dirSize( $logDir ) );

            if( isset( $size ) )
                return str_replace( '@@@', $size, $sistema->retTranslate( 'sizeOfLogDir' ) );
        }
    }

    // aux functions
    function loadConfiguration( $path )
    {
        if ( !file_exists( $path ) )
            return array();

        $configuration = unserialize( file_get_contents( $path ) );

        if ( !is_array( $configuration ) )
            return array();

        return $configuration;
    }

    function saveConfiguration( $path, $configuration )
    {
        if ( is_array( $configuration ) )
        {
            file_put_contents( $path, serialize( $configuration ) );
        }
    }

    function dirsize( $dir )
    {
        $size = 0;
        if( is_dir( $dir ) )
        {
            $objects = scandir( $dir );
            foreach( $objects as $object )
                if( $object != "." && $object != ".." && $object != 'index.php' )
                    if( filetype( $dir . DIRECTORY_SEPARATOR . $object ) == "dir" )
                        $size += dirsize( $dir . DIRECTORY_SEPARATOR . $object );
                    else
                        $size += sprintf( "%u", filesize( $dir . DIRECTORY_SEPARATOR . $object ) );
            reset( $objects );
        }
        return $size;
    }

    function deleteDir( $dirPath )
    {
        if( !file_exists($dirPath) )
            return;
        if( !is_dir($dirPath) )
            return;
        if( substr( $dirPath, strlen($dirPath) - 1, 1 ) != '/' )
        {
            $dirPath .= '/';
        }
        $files = glob( $dirPath . '*', GLOB_MARK );
        foreach( $files as $file )
        {
            if( is_dir($file) )
            {
                deleteDir( $file );
            } else {
                unlink( $file );
            }
        }
        rmdir( $dirPath );
    }

    function printFileInterface( $dir, $file, $index )
    {
        Global $sistema, $image_dir, $module_dir;

        $return = "";
        $tmpFile = $dir . $file;
        $extension = end( explode( ".", $file ) );
        $nameFile = end( explode( DIRECTORY_SEPARATOR, $file ) );

        if( $extension != 'zip' )
        {
            $return = '<tr>';
            if( is_dir( $tmpFile ) )
            {
                $return .= "<td> - </td>";
                $return .= "<td class='file'>" . $file . "/</td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
            }
            else
            {
                $file64 = base64_encode( $tmpFile );

                $size = sprintf( "%u", filesize( $tmpFile ) );
                $return .= "<td class='filesize'>" . getFileSizeStyle( $size ) . "</td>";
                $return .= "<td class='file'>" . $file . "</td>";
                $return .= "<td class='date'>" . date( "d/m/Y H:i:s", filemtime( $tmpFile ) ) . "</td>";

                if( $size < 5241287 )
                {
                    $return .= "<td>";
                    $return .= "<a onclick='return browserTest();' href=\"$module_dir/zipAjax.php?file=" . $file64 . "&type=file\" target='_self'>";
                    $return .= "<img title='" . $sistema->retTranslate( 'download' ) . "'  src='$image_dir/imagens/download.png' border='0' ></a>";
                    //$return .= "<a><img title='" . $sistema->retTranslate( 'delete' ) . "'   src='$image_dir/imagens/remove.png' border='0' ></a>";
                    if( $nameFile == 'isdn.log' )
                    {
                        $return .= "<a style='margin-right: -20px; margin-left: 5px;' onclick='return browserTest();' href=\"$module_dir/pcap_download.php?file=" . $file64 . "&pcap=true\" target='_self'>";
                        $return .= "<img title='" . $sistema->retTranslate( 'downloadPcap' ) . "' src='$image_dir/imagens/pcap.png' border='0' ></a>";
                    }

                    $return .= '</td>';
                }
                else
                {
                    if( $extension == 'gz' )
                    {
                        $return .= "<td>";
                        $return .= "<a onclick='return browserTest();' href=\"$module_dir/zipAjax.php?file=" . $file64 . "&type=file\" target='_self'>";
                        $return .= "<img title='" . $sistema->retTranslate( 'download' ) . "' src='$image_dir/imagens/download.png' border='0' ></a>";
                        //$return .= "<a><img title='" . $sistema->retTranslate( 'delete' ) . "'   src='$image_dir/imagens/remove.png' border='0' ></a></td>";
                    }
                    else
                    {
                        $return .= "<td>";
                        $return .= "<span id='downloadZipDir' class='cursorHand' onclick=\"zipBigFile('" . $file64 . "');\">";
                        $return .= "<img id='downFile' title='" . $sistema->retTranslate( 'download' ) . "' src='$image_dir/imagens/download.png' border='0' >";
                        //$return .= "<a><img title='" . $sistema->retTranslate( 'delete' ) . "'   src='$image_dir/imagens/remove.png' border='0' ></a>";
                        $return .= "</span>";
                        $return .= "<a id='zipFileLink' onclick='return browserTest();' href='' target='_self'>";
                        $return .= "<input type='button' name='zipFileButton' id='zipFileButton' value='x' onclick='' style='display:none' ></a>";
                        $return .= "<a><img id='downFile' title='" . $sistema->retTranslate( 'download' ) . "' style='display:none' src='$image_dir/imagens/download.png' border='0' ></a>";

                        if( $nameFile == 'isdn.log' )
                        {
                            $return .= "<a style='margin-right: -20px; margin-left: 5px;' onclick='return browserTest();' href=\"$module_dir/pcap_download.php?file=" . $file64 . "&pcap=true\" target='_self'>";
                            $return .= "<img title='" . $sistema->retTranslate( 'downloadPcap' ) . "' src='$image_dir/imagens/pcap.png' border='0' ></a>";
                        }

                        $return .= "</a></td>";
                    }
                }

                if( $size < 2000000000 )
                {
                    $return .= "<td>";
                    if( $extension != 'gz' )
                    {
                        $return .= "<div class='cursorHand' onclick='openLog(\"$file64\");'>";
                        $return .= "<img title='" . $sistema->retTranslate( 'view' ) . "' src='$image_dir/imagens/view1.png' border='0'>";
                        $return .= "</div>";
                    }
                    else
                        $return .= '-';
                    $return .= "</td>";
                }
                else
                {
                    $return .= "<td>";
                    if( $extension != 'gz' )
                    {
                        $return .= "<div class=cursorHand;' onclick=\"alert('" . $sistema->retTranslate( 'filesTooBig' ) . "');\">";
                        $return .= "<img title='" . $sistema->retTranslate( 'view' ) . "' src='$image_dir/imagens/view1.png' border='0'>";
                        $return .= "</div>";
                    }
                    $return .= "</td>";
                }
                $nameFile = end( explode( DIRECTORY_SEPARATOR, $file ) );
                if ($nameFile == 'isdn.log') {
                        $return .= "<td>";
                        $return .= "<div class='cursorHand' onclick=\"KLogAnalyser.openLogAnalyser('{$nameFile}');\">";
                        $return .= "<img title='" . $sistema->retTranslate( 'analyseLog' ) . "' src='$image_dir/imagens/analyse.png' border='0'>";
                        $return .= "</div>";
                        $return .= "</td>";

                } else if ($nameFile === 'r2.log') {
                        $return .= "<td>";
                        $return .= "<div class='cursorHand' onclick=\"KLogAnalyser.openLogAnalyser('{$nameFile}');\">";
                        $return .= "<img title='" . $sistema->retTranslate( 'analyseLog' ) . "' src='$image_dir/imagens/analyse.png' border='0'>";
                        $return .= "</div>";
                        $return .= "</td>";

                } else {
                    $return .= "<td>-</td>";
                }
            }
            $return .= "</tr>";
        }
        return $return;
    }

    function printFileCDRInterface( $dir, $file, $index )
    {
        Global $sistema, $image_dir, $module_dir;
		
        $return = "";
        $tmpFile = $dir . $file;
        $extension = end( explode( ".", $file ) );
        $nameFile = end( explode( DIRECTORY_SEPARATOR, $file ) );
		
        if( $extension != 'zip' )
        {
            $return = '<tr>';
			
            if( is_dir( $tmpFile ) )
            {
                $return .= "<td> - </td>";
                $return .= "<td class='file'>" . $file . "/</td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
                $return .= "<td> - </td>";
            }
            else
            {
                $file64 = base64_encode( $tmpFile );

                $size = sprintf( "%u", filesize( $tmpFile ) );
                $return .= "<td class='filesize'>" . getFileSizeStyle( $size ) . "</td>";
                $return .= "<td class='file'>" . $file . "</td>";
                $return .= "<td class='date'>" . date( "d/m/Y H:i:s", filemtime( $tmpFile ) ) . "</td>";

                if( $size < 5241287 )
                {
                    $return .= "<td>";
                    $return .= "<a onclick='return browserTest();' href=\"$module_dir/zipAjax.php?file=" . $file64 . "&type=file\" target='_self'>";
                    $return .= "<img title='" . $sistema->retTranslate( 'download' ) . "'  src='$image_dir/imagens/download.png' border='0' ></a>";
                    if( $nameFile == 'isdn.log' )
                    {
                        $return .= "<a style='margin-right: -20px; margin-left: 5px;' onclick='return browserTest();' href=\"$module_dir/pcap_download.php?file=" . $file64 . "&pcap=true\" target='_self'>";
                        $return .= "<img title='" . $sistema->retTranslate( 'downloadPcap' ) . "' src='$image_dir/imagens/pcap.png' border='0' ></a>";
                    }

                    $return .= '</td>';
                }
                else
                {
                    if( $extension == 'gz' )
                    {
                        $return .= "<td>";
                        $return .= "<a onclick='return browserTest();' href=\"$module_dir/zipAjax.php?file=" . $file64 . "&type=file\" target='_self'>";
                        $return .= "<img title='" . $sistema->retTranslate( 'download' ) . "' src='$image_dir/imagens/download.png' border='0' ></a></td>";
                    }
                    else
                    {
                        $return .= "<td>";
                        $return .= "<span id='downloadZipDir' class='cursorHand' onclick=\"zipBigFile('" . $file64 . "');\">";
                        $return .= "<img id='downFile' title='" . $sistema->retTranslate( 'download' ) . "' src='$image_dir/imagens/download.png' border='0' >";
                        $return .= "</span>";
                        $return .= "<a id='zipFileLink' onclick='return browserTest();' href='' target='_self'>";
                        $return .= "<input type='button' name='zipFileButton' id='zipFileButton' value='x' onclick='' style='display:none' >";
                        $return .= "<img id='downFile' title='" . $sistema->retTranslate( 'download' ) . "' style='display:none' src='$image_dir/imagens/download.png' border='0' >";
                       
                        $return .= "</a></td>";
                    }
                }

                if( $size < 2000000000 )
                {
                    $return .= "<td>";
                    if( $extension != 'gz' )
                    {
                        $return .= "<div class='cursorHand' onclick='openLog(\"$file64\");'>";
                        $return .= "<img title='" . $sistema->retTranslate( 'view' ) . "' src='$image_dir/imagens/view1.png' border='0'>";
                        $return .= "</div>";
                    }
                    else
                        $return .= '-';
                    $return .= "</td>";
                }
                else
                {
                    $return .= "<td>";
                    if( $extension != 'gz' )
                    {
                        $return .= "<div class=cursorHand;' onclick=\"alert('" . $sistema->retTranslate( 'filesTooBig' ) . "');\">";
                        $return .= "<img title='" . $sistema->retTranslate( 'view' ) . "' src='$image_dir/imagens/view1.png' border='0'>";
                        $return .= "</div>";
                    }
                    $return .= "</td>";
                }
            }
  
            $return .= "</tr>";
		    
        }
        return $return;
    }

    function getFileSizeStyle( $size )
    {
        $kb = 1024;
        $mb = 1048576;
        $gb = 1073741824;

        if( !$size )
            return '0 bytes';
        elseif( $size < $kb )
            return $size . ' bytes';
        elseif( $size < $mb )
            return round( $size / $kb, 2 ) . ' KB';
        elseif( $size < $gb )
            return round( $size / $mb, 2 ) . ' MB';
        else
            return round( $size / $gb, 2 ) . ' GB';
    }

    function listFilesFromDir( $dir_ )
    {
        $sRootPath = $dir_ . DIRECTORY_SEPARATOR;
        $dir = dir( $dir_ );
        $files = array( );
        $dirs = array( );

        while( ($sDir = $dir->read( )) !== false )
        {

            if( $sDir != '.' && $sDir != '..' )
            {
                if( is_dir( $dir_ . $sDir ) )
                    $dirs[] = $sDir;
                else
                    $files[] = $sDir;
            }
        }

        natcasesort( $files );
        natcasesort( $dirs );

        $final = array( );
        foreach( $dirs as $k => $v )
        {
            $final[] = $v;
        }
        foreach( $files as $k => $v )
        {
            $final[] = $v;
        }

        return $final;
    }

