<?php
    session_name( 'elastixSession' );
    @session_start( );

    function _moduleContent( &$smarty, $module_name )
    {
        global $dicionario, $sistema, $image_dir, $module_dir;

        require_once 'modules/khomp/constants.php';
        require_once KROOT . '/classes/KSystem.php';
        $app = KSystem::getInstance( );

        require_once KROOT . '/topo.php';
        require_once KROOT . '/rodape.php';
        require_once KROOT . '/util.php';
        require_once KCONFIG . '/classes/classKSistema.php';
        require_once KDIAGNOSTIC . '/languages/dictionary.php';
        require_once KDIAGNOSTIC . '/menu.php';

        $image_dir = "modules/khomp";
        $module_dir = "modules/{$module_name}";

        if( !isset( $_SESSION['sis'] ) )
        {
            $sistema = new KSistema( $app->getLanguage( ) );
        }
        else
        {
            $sistema = unserialize( $_SESSION['sis'] );
            $sistema->setLanguage( $app->getLanguage( ) );
        }
        $_SESSION['sis'] = serialize( $sistema );

        $_SESSION['loginAccess']['configuration'] = 'full';
        $_SESSION['loginAccess']['monitoring'] = 'full';
        $_SESSION['loginAccess']['diagnostic'] = 'full';
        $_SESSION['loginAccess']['administration'] = 'full';
        $_SESSION['login'] = 'elastix-user';
        $_SESSION['installDir'] = '/etc/khomp/';

        $ajaxTo = isset( $_REQUEST['ajaxTo'] ) ? $_REQUEST['ajaxTo'] : NULL;
        if( isset( $ajaxTo ) )
        {
            require_once KROOT . '/json_util.php';
            require_once KDIAGNOSTIC . '/ajax/includeAjaxFiles.php';
            if( function_exists( $AjaxFunctions[$ajaxTo] ) )
            {
                return call_user_func_array( $AjaxFunctions[$ajaxTo], array( $_REQUEST ) );
            }
            else
            {
                return "Undefined function {$ajaxTo}";
            }
        }
        else
        {
            reimplementation( $smarty, $module_name );
        }

        //ataching timestamp to prevent cache
        $smarty->assign( 'KWEBLOGVIEWER_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/kweblogviewer.css" ) );
        $smarty->assign( 'TREEVIEW_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/treeMenu/jquery.treeview.css" ) );
        $smarty->assign( 'TREE_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/treeMenu/tree.js" ) );
        $smarty->assign( 'KWEBLOGVIEWER_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/kweblogviewer.js" ) );
        $smarty->assign( 'MESSSAGES_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/messages.js" ) );

        $smarty->assign( 'ELASTIX_IMG', '-elastix' );
        $smarty->assign( "ELASTIX_CSS_CORRECTION", "<link rel='stylesheet' type='text/css' media='screen' href='modules/khomp/js/elastix-correction.css'>" );

        $smarty->assign( 'TREEVIEW_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.treeview.js' ) );
        $smarty->assign( 'GERAL_JS_TS', filemtime( '/var/www/html/modules/khomp/js/geral.js' ) );
        $smarty->assign( 'GERAL_CSS_TS', filemtime( '/var/www/html/modules/khomp/js/geral.css' ) );
        $smarty->assign( 'LANG', $sistema->getLanguage( ) );

        return $smarty->fetch( "/var/www/html/modules/{$module_name}/themes/default/default.tpl" );
    }

    function reimplementation( $smarty, $module_name )
    {
        global $image_dir;
        $app = KSystem::getInstance( );

        $smarty->assign( 'MENU', showDirTree( ) );
        $smarty->assign( 'waitForDownload', $app->translate( 'waitForDownload' ) );

        $smarty->assign( 'MODULO_PAI', 'modules/khomp' );
        $smarty->assign( 'MODULO', "modules/{$module_name}" );
        $topo = Topo::printTopo( '', '', 'none', '', '', 'modules/khomp' );
        $smarty->assign( 'TOP', $topo );
        $rodape = Rodape::printRodape( );
        $smarty->assign( 'RODAPE', $rodape );
    }
