<?php
    require_once '../constants.php';
    require_once KROOT . '/classes/KSystem.php';
    $app = KSystem::getInstance( );
    $app->redirectIfNotLogged( );

    require_once KROOT . '/smarty-libs/Smarty.class.php';
    require_once KROOT . '/topo.php';
    require_once KROOT . '/rodape.php';
    require_once KCONFIG . '/classes/classKSistema.php';
    require_once KCONFIG . '/classes/classKService.php';
    require_once KDIAGNOSTIC . '/languages/dictionary.php';
    require_once KDIAGNOSTIC . '/menu.php';
    require_once KDIAGNOSTIC . '/classes/classKLogs.php';
    require_once KDIAGNOSTIC . '/logUtil.php';

    //ini_set('display_errors', 1);

    global $sistema, $module_dir;

    if( !isset( $_SESSION['sis'] ) )
    {
        $sistema = new KSistema( $app->getLanguage( ) );
        $_SESSION['sis'] = serialize( $sistema );
    }
    else
    {
        $sistema = unserialize( $_SESSION['sis'] );
        $sistema->setLanguage( $app->getLanguage( ) );
    }

    $smarty = new Smarty( );
    $module_dir = '.';

    if( $_SESSION['loginAccess']['diagnostic'] == 'full' )
    {
        $ajaxTo = isset( $_REQUEST['ajaxTo'] ) ? $_REQUEST['ajaxTo'] : NULL;
        if( isset( $ajaxTo ) )
        {
            require_once KROOT . '/json_util.php';
            require_once KDIAGNOSTIC . '/ajax/includeAjaxFiles.php';
            if( function_exists( $AjaxFunctions[$ajaxTo] ) )
            {
                header('Content-type: application/json');
                
                /// Comprimindo a saida...
                ini_set("zlib.output_compression", "On");
                
                echo call_user_func_array( $AjaxFunctions[$ajaxTo], array( $_REQUEST ) );
            }
            else
            {
                echo 'Undefined function {$ajaxTo}';
            }
            exit();
        }
    }
    else
        $smarty->assign( 'CONTEUDO', $app->translate( 'noPermissionToThisPage' ) );

    $smarty->assign( 'MODULO_PAI', '..' );
    $smarty->assign( 'MODULO', '.' );

    $topo = Topo::printTopo( 'diagnostic', $_SESSION['loginAccess']['configuration'], $_SESSION['loginAccess']['monitoring'], $_SESSION['loginAccess']['diagnostic'], $_SESSION['loginAccess']['administration'], '..' );
    $klog = new Klogs( 'logs.xml' );
    $neverSet = $klog->checkIfNeverIsSet();
    if( count( $neverSet ) > 0 )
    {
        $neverSet = implode( ', ', $neverSet );
        $topo .= "<div id='log-performance-warning'>{$app->translate( 'log-performance-warning')}<br /><br />{$neverSet}</div>";
    }
    $smarty->assign( 'TOP', $topo );

    $smarty->assign( 'MENU', showDirTree( ) );
    $smarty->assign( 'waitForDownload', $sistema->retTranslate( 'waitForDownload' ) );

    $rodape = Rodape::printRodape( );
    $smarty->assign( 'RODAPE', $rodape );

    //css conflict with elastix framework
    $juicss = filemtime( '../js/jquery/css/ui-khomp/jquery-ui-1.10.4.custom.min.css' );
    $css_conflict = '<link rel="stylesheet" type="text/css" media="screen" href="/js/jquery/css/ui-khomp/jquery-ui-1.10.4.custom.min.css?' . $juicss . '" />';
    $smarty->assign( 'CSS_CONFLICT', $css_conflict );

    //js conflict with elastix framework
    $jmin = filemtime( '../js/jquery/jquery.js' );
    $js_conflict = '<script type="text/javascript" src="/js/jquery/jquery.js?' . $jmin . '"></script>';
    $jui = filemtime( '../js/jquery/jquery-ui.js' );
    $js_conflict .= '<script type="text/javascript" src="/js/jquery/jquery.ui.js?' . $jui . '" ></script>';
    $smarty->assign( 'JS_CONFLICT', $js_conflict );

    //ataching timestamp to prevent cache
    $smarty->assign( 'KWEBLOGVIEWER_CSS_TS', filemtime( './css/kweblogviewer.css' ) );
    $smarty->assign( 'TREEVIEW_CSS_TS', filemtime( './css/treeMenu/jquery.treeview.css' ) );
    $smarty->assign( 'TREEVIEW_JS_TS', filemtime( '../js/jquery/jquery.treeview.js' ) );
    $smarty->assign( 'TREE_JS_TS', filemtime( './css/treeMenu/tree.js' ) );
    $smarty->assign( 'GERAL_JS_TS', filemtime( '../js/geral.js' ) );
    $smarty->assign( 'GERAL_CSS_TS', filemtime( '../js/geral.css' ) );
    $smarty->assign( 'CUSTOM_CSS', ( !file_exists( '../css/custom.css' ) ) ? '' : '<link type="text/css" rel="stylesheet" href="../css/custom.css"/>' );
    $smarty->assign( 'LANG', $sistema->getLanguage( ) );
    $smarty->assign( 'KWEBLOGVIEWER_JS_TS', filemtime( './js/kweblogviewer.js' ) );
    $smarty->assign( 'MESSSAGES_JS_TS', filemtime( './js/messages.js' ) );
    $smarty->assign( 'WEBANALYSER_JS_TS', filemtime( './css/kwebloganalyser.css' ) );

    $smarty->display( 'themes/default/default.tpl' );
