(function (Khomp) {

    /// Calling party number (pg 70)

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;
    var attributes = InformationElements.attributes;
    var Util = Khomp.Util;

    InformationElements.elementsDecoders[0x6c] = function (values) {

        var objValue = {};

        /// Octet 3
        var octet3 = values.shift();

        /// Type of number (bits 7,6,5)
        var typeOfNumber = (octet3 & 0x70) >> 4;

        objValue['Type of number'] = attributes[0x36][typeOfNumber] || typeOfNumber;

        if (typeOfNumber === 0x00 || typeOfNumber === 0x01 || typeOfNumber === 0x02 || typeOfNumber === 0x04) {

            /// Numbering plan (applies for type of number = 000, 001, 010 and 100)
            /// Numbering plan identification

            var numberPlanIdentification = (octet3 & 0x0f);

            objValue['Numbering plan'] = attributes[0x27][numberPlanIdentification] || numberPlanIdentification;
        }

        var extensionIndicator = (((octet3 & 0x80) >> 7) === 0) ? true : false;

        if (extensionIndicator) {
            /// Octet 3a
            var octet3a = values.shift();

            /// Presentation indicator (bits 7,6) (octeto 3a)
            var presentationIndicator = (octet3a & 0x60) >> 5;

            /// Screening indicator (bits 2,1) (octeto 3a)
            var screeningIndicator = (octet3a & 0x03);

            objValue['Screening indicator'] = attributes[0x31][screeningIndicator] || screeningIndicator;
            objValue['Presentation indicator'] = attributes[0x2b][presentationIndicator] || presentationIndicator;
        }

        /// Octet 4
        var octet4x;

        /// Number digits (octeto 4) IA5 characters
        objValue['Number digits'] = '';

        /// Traduzido de acordo com tabela IA5
        objValue['Number digits'] = Util.translateIA5(values);
        // while (values.length) {

            // octet4x = values.shift();

            // objValue['Number digits'] += Util.translateIA5(octet4x);
        // }

        return objValue;
    };

})(Khomp);
