(function (Khomp) {

    /// Progress indicator (1E)
    /// Página 95 da ITU Q931.

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;
    var attributes = InformationElements.attributes;

    InformationElements.elementsDecoders[0x1e] = function (values) {

        var objValue = {};

        var octet3 = values.shift();
        var octet4 = values.shift();

        /// Octeto 3 bits 7,6
        var codingStandard = (octet3 & 0x60) >> 5;

        /// Octeto 3 bits 4,3,2,1
        var location = (octet3 & 0x0f);

        /// Octeto 4 bits 7,6,5,4,3,2,1
        var progressDescription = (octet4 & 0x7f);

        objValue[InformationElements.attributeNames[0x06]] = attributes[0x06][codingStandard] || codingStandard;
        objValue.Location = attributes[0x16][location] || location;
        objValue['Progress description'] = attributes[0x2d][progressDescription] || progressDescription;

        if (values.length) {
            objValue['Não decodificado'] = values.join(' ');
        }

        return objValue;
    };
})(Khomp);
