(function (Khomp) {

    /// Transit network selection
    /// Página 100 da ITU Q931.

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;
    var attributes = InformationElements.attributes;

    InformationElements.elementsDecoders[0x78] = function (values) {

        var objValue = {};
        var octet3 = values.shift();

        var typeOfNetworkIdentification = (octet3 & 0x70) >> 4;
        var networkIdentificationPlan = (octet3 & 0x0f);

        objValue['Type of network identification'] = attributes[0x35][typeOfNetworkIdentification] || typeOfNetworkIdentification;
        objValue['Network identification plan'] = attributes[0x20][networkIdentificationPlan] || networkIdentificationPlan;

        objValue['Network identification'] = values.join(' ');

        return objValue;
    };
})(Khomp);
