<?php
    if( file_exists( '/etc/elastix.conf' ) )
    {
        session_name( 'elastixSession' );
        require_once '/var/www/html/modules/khomp/constants.php';
    }
    else
    {
        require_once '../constants.php';
    }

    @session_start( );
    set_time_limit( 0 );
    unset( $_SESSION['logdir'] );

    require ("logUtil.php");
    require_once KROOT . '/classes/KSystem.php';
    header( "Content-Type: text/html; charset=UTF-8", true );

    $app = KSystem::getInstance();
    $logdir = LogUtil::getLogDir( );
    $type = $_REQUEST['type'];

    if( isset( $_SESSION['login'] ) && $_SESSION['loginAccess']['diagnostic'] == 'full' )
    {
        if( PHP_OS == "WINNT" )
            shell_exec( KROOT . "\\..\\..\\Tools\\system_report.bat {$logdir}" );
        else
        {
            if( function_exists( 'posix_getuid' ) )
                $root = posix_getuid( ) == 0;
            else
            {
                $ret = shell_exec( 'whoami' );
                $root = strcasecmp( $ret, 'root' );
            }
            $prepend = $root ? '' : '/usr/bin/sudo -u root ';

            shell_exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/system_report.sh" );
            shell_exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh copyoutput" );

        }
        appendDateOnReportFiles( );

        if( $type == '24hours' )
            echo getLogsDownload( 'logs24hours' );
        else
            echo getLogsDownload( 'logs48hours' );
    }
    else
        echo $app->translate('noPermission');

    function getLogsDownload( $fileName )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];
        $today = date( "Ymd-His" );

        $fileName = LogUtil::getTempDir( ) . $fileName . '-' . $today . '.tar.gz';
        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }
    }

    function getAllLogsDownload( )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];

        $today = date( "Ymd-His" );
        $fileName = LogUtil::getTempDir( ) . '/AllLogs-' . $today . '.tar.gz';

        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }
    }

    function getLastDateLogsDownload( $lastDate, $period )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];

        $today = date( "Ymd-His" );
        $fileName = LogUtil::getTempDir( ) . '/last' . $period . 'Logs-' . $today . '.tar.gz';
        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }
    }

    function getLastLogsDownloadFile( )
    {
        $zipMe = array( );
        $zipMe = $_SESSION['logZipMe'];

        $today = date( "Ymd-His" );
        $fileName = LogUtil::getTempDir( ) . '/basicLogs-' . $today . '.tar.gz';

        if( ZipLastLogs( $zipMe, $fileName ) )
        {
            unset( $_SESSION['logZipMe'] );
            return $fileName;
        }

    }

    function getDownloadFile( $zip_name )
    {
        if( $fd = fopen( $zip_name, "r" ) )
        {
            $fsize = sprintf( "%u", filesize( $zip_name ) );
            $path_parts = pathinfo( $zip_name );
            $ext = strtolower( $path_parts["extension"] );
            header( "Content-type: application/zip" );
            header( "Content-Disposition: attachment; filename=\"" . $path_parts["basename"] . "\"" );
        }
        header( "Content-length: $fsize" );
        header( "Cache-control: private" );
        while( !feof( $fd ) )
        {
            $buffer = fread( $fd, 2048 );
            echo $buffer;
        }
        fclose( $fd );
        exit ;
    }

    function ZipLastLogs( $filesToZip, $zipName, $overwrite = true )
    {
        Global $sistema;

        if( !$overwrite )
            return false;
        $valid_files = array( );
        if( is_array( $filesToZip ) )
        {
            foreach( $filesToZip as $file )
            {
                if( file_exists( $file ) )
                    $valid_files[] = $file;
            }
        }

        $logdir = LogUtil::getLogDir( );

        $dirs = array( 'reports', 'outputs' );
        foreach( $dirs as $key )
        {
            if( file_exists( $logdir . $key ) )
            {
                $configDir = scandir( $logdir . $key );
                $reports = array( );
                foreach( $configDir as $configFile )
                {
                    if( $configFile != "." && $configFile != ".." )
                        $valid_files[] = $logdir . $key . DIRECTORY_SEPARATOR . $configFile;
                }
            }
        }

        if( count( $valid_files ) )
        {
            $path = KROOT . '\\..\\..\\Tools\\';
            if( PHP_OS == "WINNT" )
            {
                if( file_exists( "{$path}tar.exe" ) && file_exists( "{$path}gzip.exe" ) )
                {
                    if( sizeof( $valid_files ) > 1 )
                    {
                        if( sizeof( $valid_files ) == 1 )
                        {
                            exec( "{$path}tar.exe -c " . $valid_files[0] . " | {$path}gzip.exe > {$zipName}" );
                        }
                        else
                        {
                            $tmpDir = LogUtil::getTempDir( );

                            exec( "{$path}tar.exe -cf {$tmpDir}temp.tar " . str_replace( "\\", '\\\\', $valid_files[0] ) );
                            unset( $valid_files[0] );

                            foreach( $valid_files as $f )
                                exec( "{$path}tar.exe -r --file={$tmpDir}temp.tar " . str_replace( "\\", '\\\\', $f ) );

                            exec( "{$path}gzip.exe -c5 {$tmpDir}temp.tar > {$zipName}" );
                        }
                    }

                    return file_exists( $zipName );
                }
                else
                    return false;
            }
            else
            {
                if( file_exists( '/bin/gzip' ) && file_exists( '/bin/tar' ) )
                {
                    if( sizeof( $valid_files ) == 1 )
                        exec( "/bin/tar -c " . $valid_files[0] . " | /bin/gzip > {$zipName}" );
                    else
                    {
                        $tmpDir = LogUtil::getTempDir( );

                        exec( "/bin/tar -cf {$tmpDir}temp.tar " . $valid_files[0] );
                        unset( $valid_files[0] );

                        foreach( $valid_files as $f )
                            exec( "/bin/tar -r --file={$tmpDir}temp.tar {$f}");

                        exec( "/bin/gzip -c5 {$tmpDir}temp.tar > {$zipName}" );
                        unlink("{$tmpDir}temp.tar");
                    }
                    return file_exists( $zipName );
                }
                else
                    return false;
            }
        }
        else
            return false;

    }

    function appendDateOnReportFiles( )
    {
        $logdir = LogUtil::getLogDir( );
        if( file_exists( $logdir . 'reports' ) )
        {
            $reportDir = scandir( $logdir . 'reports' );
            foreach( $reportDir as $file )
            {
                if( $file != "." && $file != ".." )
                {
                    $fh = fopen( $logdir . 'reports' . DIRECTORY_SEPARATOR . $file, 'a+' );
                    $date = "\r\nGerado em " . date( "d/m/Y-H:i:s" ) . " UTC\r\n";
                    fwrite( $fh, $date );
                    fclose( $fh );
                }
            }
        }
    }