<?php
    class LogUtil
    {
        public static function getLogDir( )
        {
            if( isset( $_SESSION['logdir'] ) )
                $logdir = $_SESSION['logdir'];
            else
            {
                if( PHP_OS == "WINNT" )
                {
                    $winVersion = PHP_WINDOWS_VERSION_MAJOR . "." . PHP_WINDOWS_VERSION_MINOR;
                    $logdir = exec( '..\\..\\..\\Tools\\kwebhelper configdir' );

                    $sysdata = explode( "\\", $logdir );
                    if( $winVersion >= 6.0 )
                    {
                        if( sizeof( $sysdata ) <= 3 )
                            $logdir = $sysdata[0] . "\\ProgramData\\" . $sysdata[1] . "\\logdir\\";
                        else
                            $logdir = $sysdata[0] . "\\" . $sysdata[1] . "\\" . $sysdata[2] . "\\logdir\\";
                    }
                    elseif( $winVersion > 5.0 && $winVersion <= 5.2 )
                        $logdir = $sysdata[0] . "\\" . $sysdata[1] . "\\" . $sysdata[2] . "\\khomp\\logdir\\";
                }
                else
                    $logdir = "/var/log/khomp/";
                $_SESSION['logdir'] = $logdir;
            }
            return $logdir;
        }

        public static function getKhompDir( )
        {
            if( isset( $_SESSION['khompdir'] ) )
                $logdir = $_SESSION['khompdir'];
            else
            {
                if( PHP_OS == "WINNT" )
                {
                    $winVersion = PHP_WINDOWS_VERSION_MAJOR . "." . PHP_WINDOWS_VERSION_MINOR;
                    $logdir = exec( '..\\..\\..\\Tools\\kwebhelper configdir' );

                    $sysdata = explode( "\\", $logdir );
                    if( $winVersion >= 6.0 )
                    {
                        if( sizeof( $sysdata ) <= 3 )
                            $logdir = $sysdata[0] . "\\ProgramData\\" . $sysdata[1] . "\\";
                        else
                            $logdir = $sysdata[0] . "\\" . $sysdata[1] . "\\" . $sysdata[2] . "\\";
                    }
                    elseif( $winVersion > 5.0 && $winVersion <= 5.2 )
                        $logdir = $sysdata[0] . "\\" . $sysdata[1] . "\\" . $sysdata[2] . "\\khomp\\";
                }
                else
                    $logdir = "/var/log/khomp/";
                 $_SESSION['khompdir'] = $logdir;
            }
            return $logdir;
        }

        public static function getFileSizeStyle( $size )
        {
            $kb = 1024;
            $mb = 1048576;
            $gb = 1073741824;

            if( !$size )
                return '0 bytes';
            elseif( $size < $kb )
                return $size . ' bytes';
            elseif( $size < $mb )
                return round( $size / $kb, 2 ) . ' KB';
            elseif( $size < $gb )
                return round( $size / $mb, 2 ) . ' MB';
            else
                return round( $size / $gb, 2 ) . ' GB';
        }

        public static function getTempDir( )
        {
            if( PHP_OS == "WINNT" )
            {
                if( getenv( 'WINDIR' ) )
                    return getenv( 'WINDIR' ) . "\\Temp\\";
                if( ini_get( 'upload_tmp_dir' ) )
                    return ini_get( 'upload_tmp_dir' );
                else
                    return "C:\\Windows\\Temp\\";
            }
            else
                return "/tmp/";
        }

    }
