<?php
    @session_start( );
    $AjaxFunctions['showVoIPChannels'] = 'showVoIPChannels';
    $AjaxFunctions['showChannels'] = 'showChannels';
    $AjaxFunctions['showModularChannels'] = 'showModularChannels';

    function showChannels( )
    {
        Global $image_dir;
        $app = KSystem::getInstance( );
        $link = isset( $_REQUEST['link'] ) ? $_REQUEST['link'] : NULL;
        $board = isset( $_REQUEST['board'] ) ? $_REQUEST['board'] : NULL;

        $buff = '';
        if( isset( $link ) && isset( $board ) )
        {
            try
            {
                $deviceList = $_SESSION['DeviceList'];
                $deviceList[$board] = Populator::populateChannels( $deviceList[$board], $link );
                $_SESSION['DeviceList'] = $deviceList;

                $devType = $deviceList[$board]['type'];
                $devModel = $deviceList[$board]['model'];

                $end = count( $deviceList[$board]['links'][$link]['channels'] );
                
                if($link != 99)
                {
                    $start = $link * 30;
                    $endd = ($end-1)+$start;
                }
                else
                {
                    $start = 0;
                    $endd = $end-1;
                }
                
                $groupCh = "{$start}|$endd";

                $buff .= "<input type='hidden' id='linkNow' value='{$link}' />";
                $buff .= "<input type='hidden' id='boardNow' value='{$board}' />";
                $buff .= "<input type='hidden' id='groupCh' value='{$groupCh}' />";

                $buff .= '<table id="channelsTable" border="1" class="tabelaChannel zebra">';
                $buff .= '<thead><tr>';
                $buff .= '<th rowspan="2" class="channel" scope="col">' . $app->translate( 'channel' ) . '</th>';
                $buff .= '<th rowspan="2" class="signaling" scope="col">' . $app->translate( 'signaling' ) . '</th>';
                $buff .= '<th rowspan="2" class="status" scope="col">' . $app->translate( 'status' ) . '</th>';
                $buff .= '<th rowspan="2" class="details" scope="col">' . $app->translate( 'details' ) . '</th>';

                //verifica se é FXS, se for não mostra a coluna de número discado
                if( $deviceList[$board]['links'][$link]['channels'][0]['signaling'] != 'Analog Terminal' )
                    $buff .= '<th rowspan="2" class="dialNumber" scope="col">' . $app->translate( 'DialNumber' ) . '</th>';

                $buff .= '<th rowspan="2" class="callDuration" scope="col">' . $app->translate( 'CallDuration' ) . '</th>';
                $buff .= '<th rowspan="2" class="averageTimeCalls" scope="col">' . $app->translate( 'averageTimeCalls' ) . '</th>';
                $buff .= '<th rowspan="2" class="inbound" scope="col">' . $app->translate( 'inbound' ) . '</th>';
                $buff .= '<th colspan="3" class="outbound" scope="col">' . $app->translate( 'outbound' ) . '</th>';

                if( strpos( $devModel, 'GSM' ) !== false )
                {
                    $buff .= '<th rowspan="2" class="sim_card" scope="col">' . $app->translate( 'sim_card' ) . '</th>';
                    $buff .= '<th rowspan="2" class="oper" scope="col">' . $app->translate( 'oper' ) . '</th>';
                    $buff .= '<th rowspan="2" class="strength" scope="col">' . $app->translate( 'strength' ) . '</th>';
                    $buff .= '<th rowspan="2" class="IMEI" scope="col">IMEI</th>';
                    $buff .= '<th rowspan="2" class="ICCID" scope="col">ICCID</th>';
                }
                $buff .= '<th rowspan="2" class="options" scope="col">' . $app->translate( 'options' ) . '</th>';
                $buff .= '</tr>';

                $buff .= '<tr>';
                $buff .= '<th class="outbound count" scope="col">' . $app->translate( 'count' ) . '</th>';
                $buff .= '<th class="outbound failed" scope="col">' . $app->translate( 'failed' ) . '</th>';
                $buff .= '<th class="outbound succeed" scope="col">' . $app->translate( 'succeed' ) . '</th>';
                $buff .= '</tr></thead><tbody>';

                $multiCh = 1;
                if( $link != 99 )
                {
                    if( !isset( $deviceList[$board]['isE1'] ) )
                        $deviceList[$board]['isE1'] = Populator::isE1( $deviceList[$board]['serial'] );
                    $multiCh = $deviceList[$board]['isE1'] ? 30 : 24;
                }

                for( $j = 0; $j < $end; $j++ )
                {
                    $id = ($link == 99) ? $j : (($multiCh * $link) + $j);

                    $buff .= '<tr>';
                    $buff .= "<td class='channel' id='channels-{$id}-id'>{$id}</td>";
                    $serial = $deviceList[$board]['serial'];

                    $signaling = $deviceList[$board]['links'][$link]['channels'][$j]['signaling'];
                    $callStatus = $deviceList[$board]['links'][$link]['channels'][$j]['callStatus'];
                    $details = $deviceList[$board]['links'][$link]['channels'][$j]['details'];
                    $callDuration = $deviceList[$board]['links'][$link]['channels'][$j]['CallDuration'];
                    $averageTimeCalls = Populator::getAverageCallTime( $serial, $id );

                    $buff .= "<td class='signaling' id='channels-{$id}-signaling' >{$signaling}</td>";
                    $buff .= "<td class='status' id='channels-{$id}-status' >{$callStatus}</td>";
                    $buff .= "<td class='details' id='channels-{$id}-details' >" . str_replace( ',', ', ', $details ) . "</td>";

                    if( $signaling != 'Analog Terminal' )
                    {
                        $dialNumber = $deviceList[$board]['links'][$link]['channels'][$j]['DialNumber'];
                        $buff .= "<td class='dialNumber' id='channels-{$id}-dialNumber' >{$dialNumber}</td>";
                    }
                    $buff .= "<td class='callDuration' id='channels-{$id}-callDuration' >{$callDuration}</td>";

                    $buff .= "<td class='averageTimeCalls' id='channels-{$id}-averageTimeCalls' >{$averageTimeCalls}</td>";

                    $inbound = $deviceList[$board]['links'][$link]['channels'][$j]['inbound'];
                    $in = $inbound > 0 ? "<b>{$inbound}</b>" : $inbound;
                    $buff .= "<td class='inbound' id='channels-{$id}-inbound' >{$in}</td>";

                    $outbound = $deviceList[$board]['links'][$link]['channels'][$j]['outbound'];
                    $out = $outbound > 0 ? "<b>{$outbound}</b>" : $outbound;
                    $buff .= "<td class='outbound' id='channels-{$id}-outbound' >{$out}</td>";

                    $failed = $deviceList[$board]['links'][$link]['channels'][$j]['failed'];
                    $fail = $failed > 0 ? "<b>{$failed}</b>" : $failed;
                    $buff .= "<td class='outbound' id='channels-{$id}-failed' >{$fail}</td>";

                    $succeed = $deviceList[$board]['links'][$link]['channels'][$j]['succeed'];
                    $suc = $succeed > 0 ? "<b>{$succeed}</b>" : $succeed;

                    $buff .= "<td class='outbound' id='channels-{$id}-succeed' >{$suc}</td>";

                    if( strpos( $devModel, 'GSM' ) !== false )
                    {
                        $sim = $deviceList[$board]['links'][$link]['channels'][$j]['sim'];
                        $buff .= "<td id='channels-{$id}-sim' class='sim_card' >";

                        if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                        {
                            $buff .= "<select class='sim_card_list' name='SelectSIM' title='" . $app->translate( 'channels.switch-sim-card' ) . "'>";
                            for( $i = 0; $i < 2; $i++ )
                            {
                                $is_active = intval( $sim ) == intval( $i );
                                $selected = $is_active ? "selected='selected'" : "";
                                $buff .= "<option {$selected} value='$board.$j.$i'>$i</option>";
                            }
                            $buff .= '</select></td>';
                        }
                        else
                            $buff .= "$sim</td>";

                        $oper  = $deviceList[$board]['links'][$link]['channels'][$j]['oper'];
                        $str   = $deviceList[$board]['links'][$link]['channels'][$j]['strength'];
                        $IMEI  = $deviceList[$board]['links'][$link]['channels'][$j]['IMEI'];
                        $ICCID = $deviceList[$board]['links'][$link]['channels'][$j]['ICCID'];

                        $buff .= "<td class='oper' id='channels-{$id}-oper' >{$oper}</td>";
                        $buff .= "<td class='strength' id='channels-{$id}-strength' >{$str}</td>";
                        $buff .= "<td class='IMEI' id='channels-{$id}-IMEI' >{$IMEI}</td>";
                        $buff .= "<td class='ICCID' id='channels-{$id}-ICCID' >{$ICCID}</td>";
                    }

                    $buff .= "<td class='options displayFlex' id='channels-{$id}-options' >";
                    if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                    {
                        $buff .= "<a href='#' onclick='clearChannelStats({$serial},{$id})' >";
                        $buff .= "<img title='{$app->translate('clearCallStats')}' src='$image_dir/imagens/clear.png' /></a>";

                        if( strpos( $devModel, 'GSM' ) !== false )
                            $buff .= "<a href='#' onclick='resetGSMChannel({$serial},{$id})' ><img title='{$app->translate('resetChannel')}' class='marginLeft3px' src='$image_dir/imagens/reset.png' /></a>";

                        $buff .= "<div class='miniChart' id='chart{$serial}-{$id}' ></div>";
                        $buff .= '</td>';
                    }
                    else
                        $buff .= '-';
                }
                $buff .= '</td></tr></tbody></table></br>';
                unset($_SESSION['ChannelMiniCharts']);
            }
            catch(Exception $e)
            {
                $deviceList['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                $deviceList['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
                return JSONencode( $deviceList );
            }
        }

        $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
        $ret['Message']['error'] = MonitorService::checkMediaServerMessages( );
        $ret['HTML'] = $buff;
        return JSONencode( $ret );
    }

    function showVoIPChannels( )
    {
        $app = KSystem::getInstance( );

        $board = isset( $_REQUEST['board'] ) ? $_REQUEST['board'] : NULL;
        $link = isset( $_REQUEST['link'] ) ? $_REQUEST['link'] : NULL;
        $groupCh = isset( $_REQUEST['gc'] ) ? $_REQUEST['gc'] : NULL;
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;
        $deviceList = $_SESSION['DeviceList'];

        if( $board != NULL && $link != NULL && $serial != NULL && $groupCh != NULL )
        {
            try
            {
                $gc = explode( '|', $groupCh );
                $deviceList[$board] = Populator::populateChannels( $deviceList[$board], $link, $gc[0], $gc[1] );

                $_SESSION['DeviceList'] = $deviceList;
                $devModel = $deviceList[$board]['model'];

                $buff = '';
                $buff .= "<input type='hidden' id='linkNow' value='{$link}' />";
                $buff .= "<input type='hidden' id='boardNow' value='{$board}' />";
                $buff .= "<input type='hidden' id='groupCh' value='{$groupCh}' />";

                $buff .= '<table id="channelsTable" border="1" class="tabelaChannel zebra">';
                $buff .= '<thead><tr>';
                $buff .= '<th rowspan="2" class="channel" scope="col">' . $app->translate( 'channel' ) . '</th>';
                $buff .= '<th rowspan="2" class="signaling" scope="col">' . $app->translate( 'signaling' ) . '</th>';
                $buff .= '<th rowspan="2" class="status" scope="col">' . $app->translate( 'status' ) . '</th>';
                $buff .= '<th rowspan="2" class="details" scope="col">' . $app->translate( 'details' ) . '</th>';
                $buff .= '<th rowspan="2" class="dialNumber" scope="col">' . $app->translate( 'DialNumber' ) . '</th>';
                $buff .= '<th rowspan="2" class="callDuration" scope="col">' . $app->translate( 'CallDuration' ) . '</th>';
                $buff .= '<th rowspan="2" class="averageTimeCalls" scope="col">' . $app->translate( 'averageTimeCalls' ) . '</th>';
                $buff .= '<th rowspan="2" class="inbound" scope="col">' . $app->translate( 'inbound' ) . '</th>';
                $buff .= '<th colspan="3" class="outbound" scope="col">' . $app->translate( 'outbound' ) . '</th>';
                $buff .= '<th rowspan="2" class="options" scope="col">' . $app->translate( 'options' ) . '</th>';
                $buff .= '</tr>';

                $buff .= '<tr>';
                $buff .= '<th class="outbound count" scope="col">' . $app->translate( 'count' ) . '</th>';
                $buff .= '<th class="outbound failed" scope="col">' . $app->translate( 'failed' ) . '</th>';
                $buff .= '<th class="outbound succeed" scope="col">' . $app->translate( 'succeed' ) . '</th>';
                $buff .= '</tr></thead>';

                $buff .= '<tbody>';

                $gc = explode( '|', $groupCh );

                $j = $gc[0];
                $end = $gc[1];

                $multiCh = 1;
                if( isset( $deviceList[$board]['links'][0] ) )
                {
                    if( !isset( $deviceList[$board]['isE1'] ) )
                        $deviceList[$board]['isE1'] = Populator::isE1( $serial );
                    $multiCh = $deviceList[$board]['isE1'] ? 30 : 24;
                }

                for( $j; $j <= $end; $j++ )
                {
                    $buff .= '<tr>';
                    $id = $link == 99 ? $j : (($multiCh * $link) + $j);
                    $buff .= "<td class='channel' id='channels-{$id}-id'>{$id}</td>";

                    $sig = $deviceList[$board]['links'][$link]['channels'][$j]['signaling'];
                    $callStatus = $deviceList[$board]['links'][$link]['channels'][$j]['callStatus'];
                    $details = $deviceList[$board]['links'][$link]['channels'][$j]['details'];
                    $dialNbr = $deviceList[$board]['links'][$link]['channels'][$j]['DialNumber'];
                    $callDuration = $deviceList[$board]['links'][$link]['channels'][$j]['CallDuration'];

                    $buff .= "<td class='signaling' id='channels-{$id}-signaling' >{$sig}</td>";
                    $buff .= "<td class='status' id='channels-{$id}-status' >{$callStatus}</td>";
                    $buff .= "<td class='details' id='channels-{$id}-details' >" . str_replace( ',', ', ', $details ) . "</td>";
                    $buff .= "<td class='dialNumber' id='channels-{$id}-dialNumber' >{$dialNbr}</td>";
                    $buff .= "<td class='callDuration' id='channels-{$id}-callDuration' >{$callDuration}</td>";

                    $averageTimeCalls = Populator::getAverageCallTime( $serial, $id );
                    $buff .= "<td class='averageTimeCalls' id='channels-{$id}-averageTimeCalls' >{$averageTimeCalls}</td>";

                    $inbound = $deviceList[$board]['links'][$link]['channels'][$j]['inbound'];
                    $in = $inbound > 0 ? "<b>{$inbound}</b>" : $inbound;
                    $buff .= "<td class='inbound' id='channels-{$id}-inbound' >{$in}</td>";

                    $outbound = $deviceList[$board]['links'][$link]['channels'][$j]['outbound'];
                    $out = $outbound > 0 ? "<b>{$outbound}</b>" : $outbound;
                    $buff .= "<td class='outbound' id='channels-{$id}-outbound' >{$out}</td>";

                    $failed = $deviceList[$board]['links'][$link]['channels'][$j]['failed'];
                    $fail = $failed > 0 ? "<b>{$failed}</b>" : $failed;
                    $buff .= "<td class='outbound' id='channels-{$id}-failed' >{$fail}</td>";

                    $succeed = $deviceList[$board]['links'][$link]['channels'][$j]['succeed'];
                    $suc = $succeed > 0 ? "<b>{$succeed}</b>" : $succeed;

                    // $percent = $succeed > 0 && $outbound > 0 ? (($succeed *
                    // 100) / $outbound) : 0;
                    // $buff .= "<td class='outbound' id='channels-{$id}-succeed'
                    // >{$suc} | {$percent}%</td>";

                    $buff .= "<td class='outbound' id='channels-{$id}-succeed' >{$suc}</td>";

                    $buff .= "<td class='options displayFlex' id='channels-{$id}-options' >";

                    if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                    {
                        $buff .= "<a href='#' onclick='clearChannelStats({$serial},{$id})' >";
                        $buff .= "<img title='{$app->translate('clearCallStats')}' src='$image_dir/imagens/clear.png' /></a>";
                        $buff .= "<div class='miniChart' id='chart{$serial}-{$id}' ></div>";

                    }
                    else
                        $buff .= '-';
                    $buff .= '</td>';
                }
                $buff .= '</td></tr></tbody></table></br>';
                unset($_SESSION['ChannelMiniCharts']);
            }
            catch(Exception $e)
            {
                $deviceList['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                $deviceList['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
                return JSONencode( $deviceList );
            }
        }

        $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
        $ret['Message']['error'] = MonitorService::checkMediaServerMessages( );
        $ret['HTML'] = $buff;
        return JSONencode( $ret );
    }

    function showModularChannels( )
    {
        Global $image_dir;
        $app = KSystem::getInstance( );

        $board = isset( $_REQUEST['board'] ) ? $_REQUEST['board'] : NULL;
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;
        $link = isset( $_REQUEST['link'] ) ? $_REQUEST['link'] : NULL;
        $startCh = isset( $_REQUEST['startChannel'] ) ? $_REQUEST['startChannel'] : NULL;
        $endCh = isset( $_REQUEST['endChannel'] ) ? $_REQUEST['endChannel'] : NULL;

        $buff = '';

        if( isset( $serial ) && isset( $startCh ) && isset( $endCh ) )
        {
            try
            {
                $buff .= '<input type="hidden" id="linkNow" value="99" />';
                $buff .= "<input type='hidden' id='boardNow' value='{$board}' />";
                $buff .= "<input type='hidden' id='groupCh' value='{$startCh}|" . ($endCh - 1) . "' />";

                $buff .= '<table id="channelsTable" border="1" class="tabelaChannel zebra">';
                $buff .= '<thead><tr>';
                $buff .= '<th rowspan="2" class="channel" scope="col">' . $app->translate( 'channel' ) . '</th>';
                $buff .= '<th rowspan="2" class="signaling" scope="col">' . $app->translate( 'signaling' ) . '</th>';
                $buff .= '<th rowspan="2" class="status" scope="col">' . $app->translate( 'status' ) . '</th>';
                $buff .= '<th rowspan="2" class="details" scope="col">' . $app->translate( 'details' ) . '</th>';
                $buff .= '<th rowspan="2" class="dialNumber" scope="col">' . $app->translate( 'DialNumber' ) . '</th>';
                $buff .= '<th rowspan="2" class="callDuration" scope="col">' . $app->translate( 'CallDuration' ) . '</th>';
                $buff .= '<th rowspan="2" class="averageTimeCalls" scope="col">' . $app->translate( 'averageTimeCalls' ) . '</th>';
                $buff .= '<th rowspan="2" class="inbound" scope="col">' . $app->translate( 'inbound' ) . '</th>';
                $buff .= '<th colspan="3" class="outbound" scope="col">' . $app->translate( 'outbound' ) . '</th>';

                $gsmCh = Populator::getGSMChannelsCount( $serial );
                if( strpos( $gsmCh, ',' ) > 0 )
                {
                    $gsmCh = explode( ',', $gsmCh );
                    if( sizeof( $gsmCh > 0 ) )
                    {
                        $buff .= '<th rowspan="2" class="sim_card" scope="col">' . $app->translate( 'sim_card' ) . '</th>';
                        $buff .= '<th rowspan="2" class="oper" scope="col"><b>' . $app->translate( 'oper' ) . '</b></th>';
                        $buff .= '<th rowspan="2" class="strength" scope="col"><b>' . $app->translate( 'strength' ) . '</b></th>';
                        $buff .= '<th rowspan="2" class="IMEI" scope="col"><b>IMEI</b></th>';
                        $buff .= '<th rowspan="2" class="ICCID" scope="col"><b>ICCID</b></th>';
                    }
                }
                else
                    $gsmCh = array( );

                $buff .= '<th rowspan="2" class="options" scope="col">' . $app->translate( 'options' ) . '</th>';
                $buff .= '<tr>';
                $buff .= '<th class="outbound count" scope="col">' . $app->translate( 'count' ) . '</th>';
                $buff .= '<th class="outbound failed" scope="col">' . $app->translate( 'failed' ) . '</th>';
                $buff .= '<th class="outbound succeed" scope="col">' . $app->translate( 'succeed' ) . '</th>';
                $buff .= '</tr>';

                $buff .= '</tr>';
                $buff .= '</thead><tbody>';

                for( $j = $startCh; $j < $endCh; $j++ )
                {
                    $status_channel = Populator::getCallStatus( $serial, $j );
                    $status_tmp = Populator::getCallStatusValue( $status_channel );
                    $sig = Populator::getChannelSignaling( $serial, $j );
                    $signaling = Populator::getSignalingValue( $sig );
                    $ai = Populator::getAddInfo( $serial, $j );
                    $addInfo = Populator::getAddInfoValueModular( $ai, $sig );
                    $info_channel = Populator::getChannelStats( $serial, $j );

                    $infos = explode( ',', $info_channel );
                    $oper = '-';
                    $strength = '-';
                    $IMEI = '-';
                    $ICCICD = '-';

                    $isGSMCh = in_array( $j, $gsmCh );

                    if( $isGSMCh )
                    {
                        $strength = Populator::getGSMSignalStrengh( $serial, $j );
                        $strength = $strength == '255' || $strength == '' ? '-' : "{$strength}%";

                        $oper = Populator::getGSMOperName( $serial, $j );
                        $oper = $oper == '' ? '-' : $oper;

                        $IMEI = Populator::getGSMIMEI( $serial, $j );
                        $IMEI = ($IMEI == '') ? '-' : $IMEI;

                        $ICCID = Populator::getGSMICCID( $serial, $j );
                        $ICCID = ($ICCID == '') ? '-' : $ICCID;
                    }
                    $buff .= '<tr>';
                    $id = $j;

                    $buff .= "<td class='channel' id='channels-{$id}-id'>{$id}</td>";
                    $buff .= "<td class='signaling' id='channels-{$id}-signaling'>{$signaling}</td>";
                    $buff .= "<td class='status' id='channels-{$id}-status'>{$status_tmp}</td>";
                    $buff .= "<td class='details' id='channels-{$id}-details'>" . str_replace( ',', ', ', $addInfo ) . "</td>";

                    $dial_number = Populator::getDialNumber( $serial, $j );
                    $call_duration = Populator::getCallDuration( $serial, $j );

                    $dial_number = $dial_number != '' ? $dial_number : '-';
                    $buff .= "<td class='dialNumber' id='channels-{$id}-dialNumber' >{$dial_number}</td>";
                    $buff .= "<td class='callDuration' id='channels-{$id}-callDuration' >{$call_duration}</td>";

                    $averageTimeCalls = Populator::getAverageCallTime( $serial, $j );
                    $buff .= "<td class='averageTimeCalls' id='channels-{$id}-averageTimeCalls' >{$averageTimeCalls}</td>";

                    $in = $infos[0] > 0 ? "<b>$infos[0]</b>" : $infos[0];
                    $buff .= "<td class='inbound' id='channels-{$id}-inbound'>{$in}</td>";

                    // $percent = $infos[0] > 0 && $infos[1] > 0 ? (($infos[0] *
                    // 100) / $infos[1]) : 0;

                    $out = $infos[1] > 0 ? "<b>$infos[1]</b>" : $infos[1];
                    $buff .= "<td class='outbound' id='channels-{$id}-outbound'>{$out}</td>";

                    $fail .= $infos[3] > 0 ? "<b>$infos[3]</b>" : $infos[3];
                    $buff .= "<td class='outbound' id='channels-{$id}-failed' >{$infos[3]}</td>";

                    $suc .= $infos[2] > 0 ? "<b>$infos[2]</b>" : $infos[2];
                    // $buff .= "<td class='outbound'
                    // id='channels-{$id}-succeed'>{$infos[2]} |
                    // {$percent}%</td>";
                    $buff .= "<td class='outbound' id='channels-{$id}-succeed'>{$infos[2]}</td>";

                    if( sizeof( $gsmCh ) > 0 )
                    {
                        if( in_array( $j, $gsmCh ) )
                        {
                            $sim = Populator::getGSMSIM( $serial, $j );
                            $buff .= "<td id='channels-{$id}-sim' class='sim_card' >";

                            if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                            {
                                $buff .= '<select class="sim_card_list" name="SelectSIM" title=' . $app->translate( 'channels.switch-sim-card' ) . '">';
                                for( $i = 0; $i < 2; $i++ )
                                {
                                    $is_active = intval( $sim ) == intval( $i );
                                    $selected = $is_active ? "selected='selected'" : "";
                                    $buff .= "<option {$selected} value='$board.$j.$i'>$i</option>";
                                }
                                $buff .= '</select></td>';
                            }
                            else
                                $buff .= "$sim</td>";

                            $buff .= "<td class='oper' id='channels-{$id}-oper'>{$oper}</td>";
                            $buff .= "<td class='strength' id='channels-{$id}-strength'>{$strength}</td>";
                            $buff .= "<td class='IMEI' id='channels-{$id}-IMEI'>{$IMEI}</td>";
                            $buff .= "<td class='ICCID' id='channels-{$id}-ICCID'>{$ICCID}</td>";
                        }
                        else
                            $buff .= '<td class="sim_card">-</td><td class="oper">-</td><td class="strength">-</td><td class="IMEI">-</td><td class="ICCID">-</td>';
                    }

                    $buff .= "<td class='options-extra displayFlex' id='channels-{$id}-options' >";
                    if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                    {
                        $buff .= "<a href='#' onclick='clearChannelStats({$serial},{$id})' >";
                        $buff .= "<img title='{$app->translate('clearCallStats')}' src='$image_dir/imagens/clear.png' /></a>";
                        if( $isGSMCh )
                            $buff .= "<a href='#' onclick='resetGSMChannel({$serial},{$id})' ><img title='{$app->translate('resetChannel')}' class='marginLeft3px' src='$image_dir/imagens/reset.png' /></a>";
                        else
                            $buff .= "<a><img title='{$app->translate('resetChannelDenied')}' class='marginLeft3px' src='$image_dir/imagens/resetdenied.png' /></a>";

                        $buff .= "<div class='miniChart' id='chart{$serial}-{$id}' ></div></td>";
                    }
                    else
                        $buff .= '-';
                }
                $buff .= '</td></tr></tbody></table></br>';
                unset($_SESSION['ChannelMiniCharts']);
            }
            catch(Exception $e)
            {
                $deviceList['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                $deviceList['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
                return JSONencode( $deviceList );
            }
        }

        $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
        $ret['Message']['error'] = MonitorService::checkMediaServerMessages( );
        $ret['HTML'] = $buff;
        return JSONencode( $ret );
    }
