<?php
    session_name( 'elastixSession' );
    @session_start( );

    function _moduleContent( &$smarty, $module_name )
    {
        global $dicionario, $sistema, $image_dir, $boardModel, $module_dir;

        require_once 'modules/khomp/constants.php';
        require_once KROOT . '/classes/KSystem.php';
        $app = KSystem::getInstance( );

        require_once KROOT . '/topo.php';
        require_once KROOT . '/rodape.php';
        require_once KROOT . '/util.php';
        require_once KCONFIG . '/classes/classKSistema.php';
        require_once KMONITOR . '/languages/dictionary.php';
        require_once KMONITOR . '/mapDevices.php';
        require_once KMONITOR . '/monitorService.php';
        require_once KMONITOR . '/monitorDevice.php';
        require_once KMONITOR . '/monitorLink.php';
        require_once KMONITOR . '/monitorChannel.php';

        $image_dir = "modules/khomp";
        $module_dir = "modules/{$module_name}";

        if( !isset( $_SESSION['sis'] ) )
        {
            $sistema = new KSistema( $app->getLanguage( ) );
        }
        else
        {
            $sistema = unserialize( $_SESSION['sis'] );
            $sistema->setLanguage( $app->getLanguage( ) );
        }
        $_SESSION['sis'] = serialize( $sistema );

        $_SESSION['loginAccess']['configuration'] = 'full';
        $_SESSION['loginAccess']['monitoring'] = 'full';
        $_SESSION['loginAccess']['diagnostic'] = 'full';
        $_SESSION['loginAccess']['administration'] = 'full';
        $_SESSION['login'] = 'elastix-user';
        $_SESSION['installDir'] = '/etc/khomp/';

        $ajaxTo = isset( $_REQUEST['ajaxTo'] ) ? $_REQUEST['ajaxTo'] : NULL;
        if( isset( $ajaxTo ) )
        {
            require_once KROOT . '/json_util.php';
            require_once KMONITOR . '/ajax/includeAjaxFiles.php';

            if( function_exists( $AjaxFunctions[$ajaxTo] ) )
            {
                return call_user_func_array( $AjaxFunctions[$ajaxTo], array( $_REQUEST ) );
            }
            else
            {
                return "Undefined function {$ajaxTo}";
            }
        }
        else
        {
            reimplementation( $smarty, $module_name );
        }

        return $smarty->fetch( "/var/www/html/modules/{$module_name}/themes/default/default.tpl" );
    }

    function reimplementation( $smarty, $module_name )
    {
        global $image_dir;
        $app = KSystem::getInstance( );

        $location = isset( $_REQUEST['location'] ) ? $_REQUEST['location'] : NULL;
        if( isset( $location ) )
        {
            switch( $location )
            {
                case 'services':
                    try
                    {
                        $monitor = new MonitorService( );
                        $smarty->assign( "CONTENT", $monitor->showServices( ) );
                    }
                    catch(Exception $e)
                    {
                        unset( $_SESSION['DeviceList'] );
                        $_SESSION['errorMessage'] = $app->translateErrMessage( $e->getMessage( ) );
                        MonitorService::checkAllServices( );
                        $smarty->assign( "CONTENT",MonitorService::showServices( ));
                    }
                    $smarty->assign( "LEGEND", $app->translate( 'services' ) );
                    $smarty->assign( "MODULE", 'Services' );
                    $smarty->assign( "JSmodule", 'Services' );
                    break;

                case 'devices':
                    try
                    {
                        $monitor = new MonitorDevice( );
                        $smarty->assign( "CONTENT", $monitor->showDevices() );
                    }
                    catch(Exception $e)
                    {
                        unset( $_SESSION['DeviceList'] );
                        $_SESSION['errorMessage'] = $app->translateErrMessage( $e->getMessage( ) );
                        $smarty->assign( "CONTENT", MonitorDevice::showDevices( ) );
                    }
                    $smarty->assign( "LEGEND", $app->translate( 'devices' ) );
                    $smarty->assign( "MODULE", 'Devices' );
                    $smarty->assign( "JSmodule", 'Devices' );
                    break;

                case 'links':
                    try
                    {
                        $monitor = new MonitorLink( );
                        $smarty->assign( "CONTENT", $monitor->showLinks( ) );
                    }
                    catch(Exception $e)
                    {
                        unset( $_SESSION['DeviceList'] );
                        $_SESSION['errorMessage'] = $app->translateErrMessage( $e->getMessage( ) );
                        $smarty->assign( "CONTENT", MonitorLink::showLinks() );
                    }
                    $smarty->assign( "LEGEND", $app->translate( 'links' ) );
                    $smarty->assign( "MODULE", 'Links' );
                    $smarty->assign( "JSmodule", 'Links' );
                    break;

                case 'channels':
                    try
                    {
                        $monitor = new MonitorChannel( );
                    }
                    catch(Exception $e)
                    {
                        unset( $_SESSION['DeviceList'] );
                        $_SESSION['errorMessage'] = $app->translateErrMessage( $e->getMessage( ) );
                    }
                    $content = MonitorChannel::getMessages( );
                    $content .= MonitorChannel::getDevices( );
                    $smarty->assign( 'CONTENT', $content );
                    $smarty->assign( "CONTENT", $content );
                    $smarty->assign( "LEGEND", $app->translate( 'channels' ) );
                    $smarty->assign( "MODULE", 'Channels' );
                    $smarty->assign( "JSmodule", 'Channels' );
                    break;
                default:
                    
                    try
                    {
                        $monitor = new MonitorDevice( );
                        
                    }
                    catch(Exception $e)
                    {
                        unset( $_SESSION['DeviceList'] );
                        $_SESSION['errorMessage'] = $app->translateErrMessage( $e->getMessage( ) );
                    }
                    $smarty->assign( "CONTENT", MonitorDevice::showDevices( ) );
                    $smarty->assign( "LEGEND", $app->translate( 'devices' ) );
                    $smarty->assign( "MODULE", 'Devices' );
                    $smarty->assign( "JSmodule", 'Devices' );
                    break;
            }
        }
        else
        {
            try
            {
                $monitor = new MonitorDevice( );
                $smarty->assign( "CONTENT", $monitor->showDevices( ) );
            }
            catch(Exception $e)
            {
                unset( $_SESSION['DeviceList'] );
                $_SESSION['errorMessage'] = $app->translateErrMessage( $e->getMessage( ) );
            }
            
            $smarty->assign( "CONTENT", MonitorDevice::showDevices( ) );
            $smarty->assign( "LEGEND", $app->translate( 'devices' ) );
            $smarty->assign( "MODULE", 'Devices' );
            $smarty->assign( "JSmodule", 'Devices' );

        }

        $smarty->assign( 'MODULO_PAI', 'modules/khomp' );
        $smarty->assign( 'MODULO', "modules/{$module_name}" );
        $topo = Topo::printTopo( '', '', 'none', '', '', 'modules/khomp' );
        $smarty->assign( 'TOP', $topo );
        $rodape = Rodape::printRodape( );
        $smarty->assign( 'FOOTER', $rodape );

        $smarty->assign( 'DEVICES', $app->translate( 'devices' ) );
        $smarty->assign( 'LINKS', $app->translate( 'links' ) );
        $smarty->assign( 'CHANNELS', $app->translate( 'channels' ) );
        $smarty->assign( 'SERVICES', $app->translate( 'services' ) );
        $smarty->assign( 'REFRESH', $app->translate( 'refresh' ) );
        $smarty->assign( 'REFRESH_DELAY', $app->translate( 'refreshDelay' ) );
        $smarty->assign( 'NOT_REFRESH', $app->translate( 'notRefresh' ) );
        $smarty->assign( 'DELAY1', $app->translate( 'delay1' ) );
        $smarty->assign( 'DELAY2', $app->translate( 'delay2' ) );
        $smarty->assign( 'DELAY3', $app->translate( 'delay3' ) );

        $SO = (PHP_OS == 'WINNT') ? 'WIN' : 'LINUX';
        $smarty->assign( 'SO', $SO );

        $smarty->assign( "DESVIO_X", '150' );
        $smarty->assign( "DESVIO_Y", '150' );
        $smarty->assign( 'MODULO_PAI', 'modules/khomp' );
        $smarty->assign( 'MODULO', "modules/{$module_name}" );

        $smarty->assign( 'ELASTIX_IMG', '-elastix' );
        $smarty->assign( 'HAVE_LINK', true );
        $smarty->assign( "ELASTIX_CSS_CORRECTION", "<link rel='stylesheet' type='text/css' media='screen' href='modules/khomp/js/elastix-correction.css'>" );

        //ataching timestamp to prevent cache
        $smarty->assign( 'KWEBMONITOR_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/estilos/kwebmonitor.css" ) );
        $smarty->assign( 'GERAL_JS_TS', filemtime( '/var/www/html/modules/khomp/js/geral.js' ) );
        $smarty->assign( 'GERAL_CSS_TS', filemtime( '/var/www/html/modules/khomp/js/geral.css' ) );
        $smarty->assign( 'UTIL_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/util.js" ) );
        $smarty->assign( 'KWEBMONITOR_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/kwebmonitor.js" ) );
        $smarty->assign( 'KCHART_TS', filemtime( "/var/www/html/modules/{$module_name}/js/kcharts.js" ) );
        $smarty->assign( 'JQPLOT_TS', filemtime( "/var/www/html/modules/{$module_name}/js/jquery.jqplot.min.js" ) );
        $smarty->assign( 'JQPLOT_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/jquery.jqplot.min.js" ) );
        $smarty->assign( 'JQPLOT_PIE_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/jqplot.pieRenderer.min.js" ) );
        $smarty->assign( 'JQPLOT_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/estilos/jquery.jqplot.min.css" ) );
        $smarty->assign( 'JQPLOT_BAR_RENDER', filemtime( "/var/www/html/modules/{$module_name}/js/jqplot/jqplot.barRenderer.js" ) );
        $smarty->assign( 'JQPLOT_HIGHLIGHTER', filemtime( "/var/www/html/modules/{$module_name}/js/jqplot/jqplot.highlighter.js" ) );
        $smarty->assign( 'JQPLOT_AXIS_RENDER', filemtime( "/var/www/html/modules/{$module_name}/js/jqplot/jqplot.categoryAxisRenderer.min.js" ) );
        $smarty->assign( 'JQPLOT_POINT_LABELS', filemtime( "/var/www/html/modules/{$module_name}/js/jqplot/jqplot.pointLabels.min.js") );
        $smarty->assign( 'JQUERY_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.js' ) );
        $smarty->assign( 'CHOSEN_JS_TS', filemtime( '/var/www/html/modules/khomp//js/jquery/chosen.jquery.min.js' ) );
        
        // Charts
        $smarty->assign( 'CHANNELS', $app->translate('channels') );
        $smarty->assign( 'CHANNEL', $app->translate('chart_channel') );
        $smarty->assign( 'CHANNEL_STATUS', $app->translate('chart_channel_status') );
        $smarty->assign( 'CALLS', $app->translate('chart_calls') );
        $smarty->assign( 'REASON_FAILS', $app->translate('chart_reason_fails') );
        $smarty->assign( 'FAILS', $app->translate('chart_fails') );
        $smarty->assign( 'INC_OUT', $app->translate('chart_inc_out_calls') );
        $smarty->assign( 'OUT_CALLS', $app->translate('chart_out_calls') );
        $smarty->assign( 'REFRESH_CHARTS', $app->translate('refresh_charts') );
        $smarty->assign( 'CH_STATUS_CHART_TITLE', $app->translate('ch_status_chart_title'));
        $smarty->assign( 'INC_OUT_CHART_TITLE', $app->translate('inc_out_chart_title'));
        $smarty->assign( 'STATUS_CHART_TITLE', $app->translate('call_status_chart_title'));
        $smarty->assign( 'FAIL_CHART_TITLE', $app->translate('fail_chart_title'));

    }
