var historyChartsWay = [];
var deviceHasLinks = false;

function backCharts( )
{
    var arr = historyChartsWay.pop( );
    var arr_key = Object.keys( arr );
    switch(arr_key[0])
    {
        case 'deviceQuadChart' :
            $( '#device-quad-charts-btn' ).click( );
            break;

        case 'chartsForAllLinks' :
            $( '#linkCharts' ).dialog( 'destroy' );
            openDialogQuadCharts( arr[arr_key[0]], 'device', false );
            $( '#all-links-btn' ).click( );
            break;
    }
}

function verifyBackButton( )
{
    if( historyChartsWay.length > 0 )
        $( '.backButton' ).removeClass( 'displayNone' );
    else
        $( '.backButton' ).addClass( 'displayNone' );
}

function clearCharts( )
{
    $( '.doubleChart' ).children( ).html( '' ).attr( 'style', '' );
    $( '.simpleChart' ).html( '' ).attr( 'style', '' );
}

function refreshCharts( param )
{
    $( '.active-chart-button' ).click( );
}

function showRefreshingCharts( )
{
    $( '.refreshingCharts' ).removeClass( 'visibilityHidden' );
}

function hideRefreshingCharts( )
{
    $( '.refreshingCharts' ).addClass( 'visibilityHidden' );
}

function clearQuadCharts( )
{
    $.each( $( '.box-chart' ), function( k, v )
    {
        $( v ).html( '' );
    } );
}

function clearQuadChartsByLink( )
{
    $( '#holderQuadChartsLinks' ).children( ).remove( );
}

function getChartsForAllLinks( )
{
    var param = param != undefined ? param : $( '#paramchartKey' ).val( );
    var params = getArrayParamsToMakeChart( param );
    params['ajaxTo'] = 'getChartsForAllLinks';

    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        beforeSend : showRefreshingCharts( ),
        complete : hideRefreshingCharts,
        data : params,
        dataType : "json",
        success : function( ret )
        {
            verifyBackButton( );
            $( '#holderChartsForAllLinks' ).children( ).remove( );
            $( '.extraTitle' ).html( '&nbsp;> ' + miniChartLabel['device'] + ' ' + params['serial'] + ' > Links' );

            if( ret.success )
            {
                $.each( ret.content, function( k, v )
                {
                    var id = 'holderChartsForAllLinks-' + k;
                    var title = $( '#statusChartTitle' ).val( );
                    if( v.content[1] != undefined )
                    {
                        $( '#holderChartsForAllLinks' ).append( '<div class="box-chart" id="' + id + '"></div>' );

                        renderPieChart( id, v.content[1], title, ['#FF0000', "#2196F3", "#F7B100"] );
                        $( '#' + id ).click( function( )
                        {
                            historyChartsWay.push(
                            {
                                'chartsForAllLinks' : params['serial']
                            } );
                            $( '#deviceCharts' ).dialog( 'destroy' );
                            openDialogQuadCharts( params['serial'] + '-' + k, 'link', true );

                        } ).addClass( 'cursorHand' );
                        $( '#' + id ).append( '<div class="jqplot-title-link" >Link ' + k + '</div>' );
                    }
                    else
                    {
                        $( '#holderChartsForAllLinks' ).append( '<div class="box-chart" id="' + id + '" />' );
                        appendNoDataBox( id, title );
                        $( '#' + id ).append( '<div class="jqplot-title-link extra-link" >Link ' + k + '</div>' );
                    }
                } );
            }
            else
                $( '#holderChartsForAllLinks' ).html( '<div class="box-nodata">' + ret.message + '</div>' );
        }
    } );
}

function createQuadCharts( param )
{
    var param = param != undefined ? param : $( '#paramchartKey' ).val( );
    var params = getArrayParamsToMakeChart( param );
    params['ajaxTo'] = 'getQuadChartsData';
    clearQuadCharts( );

    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        beforeSend : showRefreshingCharts( ),
        complete : hideRefreshingCharts,
        data : params,
        dataType : "json",
        success : function( ret )
        {
            verifyBackButton( );
            var json = ret.content;
            var ch_status_title = $( '#channelsStatusChartTitle' ).val( );
            var inc_out_ch_title = $( '#incOutChartTitle' ).val( );
            var status_ch_title = $( '#statusChartTitle' ).val( );
            var fail_ch_title = $( '#failChartTitle' ).val( );
            var extra = '';

            if( params['link'] != undefined )
                extra = ' > Link ' + params['link'];

            if( params['channel'] != undefined )
                extra = ' > ' + miniChartLabel['channel'] + ' ' + params['channel'];

            $( '.extraTitle' ).html( '&nbsp;> ' + miniChartLabel['device'] + ' ' + params['serial'] + extra );

            if( param != 'channel' )
            {
                if( json.ChannelStatus.success )
                    renderPieChart( param + '1a', json.ChannelStatus.content, ch_status_title, ["#FF0000", "#2196F3", "#F7B100"] );
                else
                    appendNoDataBox( param + '1a', ch_status_title, json.ChannelStatus.message );
            }

            if( json.CallStatus.content[0] != undefined )
                renderPieChart( param + '2a', json.CallStatus.content[0], inc_out_ch_title, ["#2196F3", "#F7B100"] );
            else
                appendNoDataBox( param + '2a', inc_out_ch_title, json.CallStatus.message );

            if( json.CallStatus.content[1] != undefined )
            {
                renderPieChart( param + '3a', json.CallStatus.content[1], status_ch_title, ['#FF0000', "#2196F3", "#F7B100"] );

                if( params['link'] == undefined && params['channel'] == undefined )
                {
                    $( '#' + param + '3a' ).unbind( 'jqplotDataClick' ).removeClass( 'cursorHand' );
                    if( deviceHasLinks )
                    {
                        $( '#' + param + '3a' ).bind( 'jqplotDataClick', function( ev, seriesIndex, pointIndex, data )
                        {
                            historyChartsWay.push(
                            {
                                'deviceQuadChart' : ''
                            } );
                            $( '#all-links-btn' ).click( );
                        } ).addClass( 'cursorHand' );
                    }
                }
            }
            else
                appendNoDataBox( param + '3a', status_ch_title, json.FailStatus.message );

            if( json.FailStatus.success )
                renderPieChart( param + '4a', json.FailStatus.content, fail_ch_title, ["#FF0000", "#2196F3", "#F7B100", "#F2682E", "#839557", "#84CDF4", "#934691", "#2A2C7F", '#8E8E8E'] );
            else
                appendNoDataBox( param + '4a', fail_ch_title, json.FailStatus.message );
        }
    } );
}

function appendNoDataBox( id, title )
{
    var img = "<img class='chartDisabled' src='" + image_dir + "/imagens/disabled_chart.png' title='" + miniChartLabel['nodata'] + "' />";
    $( '#' + id ).removeClass( 'jqplot-target' ).html( '<div class="fail-title jqplot-title">' + title + '</div><div class="box-nodata"><div>' + img + '</div></div>' );
}

function openDialogQuadCharts( serial, param, openFirstTab )
{
    $( '#chartKey' ).val( serial );
    $( '#paramchartKey' ).val( param );

    if( $( '#links-' + serial + '-link-0' ).length > 0 )
    {
        deviceHasLinks = true;
        $( '#all-links-btn' ).show( );
    }
    else
    {
        $( '#all-links-btn' ).hide( );
        deviceHasLinks = false;
    }

    $( '#' + param + 'Charts' ).tabs( ).dialog(
    {
        title : '',
        modal : true,
        width : 1000,
        height : 850,
        resizable : false,
        dialogClass : "dialog-shadow",
        close : function( )
        {
            onCloseDialog( param );
        },
    } );

    verifyBackButton( );
    $( ".ui-widget-overlay" ).click( function( )
    {
        onCloseDialog( param );
    } );
    if( openFirstTab )
    {
        $( '.active-chart-button' ).removeClass( 'active-chart-button' );
        $( '#' + param + 'Charts > .nav-buttons-holder > .chart-nav-buttons ' ).first( ).click( ).addClass( 'active-chart-button' );
    }
}

function onCloseDialog( param )
{
    historyChartsWay = [];
    $( '.extraTitle' ).html( '' );
    $( '#' + param + 'Charts' ).dialog( 'destroy' ).tabs( 'destroy' );
    $( '#' + param + 'Charts .ui-tabs-nav a' ).removeData( "cache.tabs" );
}

function renderPieChart( idTarget, series, title, arr_colors )
{
    $( '#' + idTarget ).children( ).remove( );
    var plot3 = $.jqplot( idTarget, [series],
    {
        seriesDefaults :
        {
            renderer : $.jqplot.PieRenderer,
            rendererOptions :
            {
                thickness : 50,
                ringMargin : 10,
                fill : true,
                padding : 10,
                sliceMargin : 3,
                startAngle : 270,
                showDataLabels : true,
                dataLabels : 'percent',
                shadow : false,
            }
        },
        grid :
        {
            borderColor : '#FFF',
            drawBorder : true,
            drawGridlines : false,
            background : "#FFF",
            shadow : false,
        },
        legend :
        {
            show : true,
            location : 'w',
            showSwatch : false,
        },
        title : title,
        seriesColors : arr_colors
    } );
}

function getArrayParamsToMakeChart( type )
{
    $key_val = $( '#chartKey' ).val( );
    switch(type)
    {
        case 'device':
        case 'serial':
            return array_params =
            {
                serial : $key_val
            };

        case 'link':
            $tmp = $key_val.split( '-' );
            return array_params =
            {
                serial : $tmp[0],
                link : $tmp[1]
            };

        default:
            $tmp = $key_val.split( '-' );
            return array_params =
            {
                serial : $tmp[0],
                channel : $tmp[1]
            };
    }
}

function startMiniChart( arr, param )
{
    $.each( arr, function( k, v )
    {
        var serial = k;
        var series = [];
        var max = 0;
        $.each( v, function( idx, s )
        {
            max += s;
            series.push( [s] );
        } );
        plotMiniCharts( serial, series, max, param );
    } );
}

function plotMiniCharts( serial, arr_series, max, param )
{
    var MAX_X_AXIS = max;
    var arr_series_percent = [];

    if( MAX_X_AXIS > 0 )
    {
        $.each( arr_series, function( k, v )
        {
            arr_series_percent.push( [(v * 100) / MAX_X_AXIS] );
        } );
        var colors = ['#2196F3', '#f96868', '#F7B100'];
    }
    else
    {
        arr_series_percent = [[100], [0], [0]];
        var colors = ['#DDD', '#DDD', '#DDD'];
    }

    if( $( '#chart' + serial ).length > 0 )
    {
        $( '#chart' + serial ).children( ).remove( );
        plot3 = $.jqplot( 'chart' + serial, arr_series_percent,
        {
            stackSeries : true,
            seriesColors : colors,
            seriesDefaults :
            {
                renderer : $.jqplot.BarRenderer,
                shadow : false,
                rendererOptions :
                {
                    barMargin : -100,
                    barDirection : 'horizontal',
                    highlightMouseOver : false,
                    barWidth : 120,
                    barPadding : 0,
                },
            },
            grid :
            {
                borderColor : '#FFF',
                drawBorder : true,
                drawGridlines : false,
                background : "#FFF",
                shadow : false,
            },
            axes :
            {
                xaxis :
                {
                    showTicks : false,
                    max : 100
                },
                yaxis :
                {
                    showTicks : false
                }
            },
            highlighter :
            {
                show : false
            },
        } );
    }

    $( '#chart' + serial ).bind( 'jqplotDataMouseOver', function( ev, seriesIndex, pointIndex, data )
    {
        var valor = data;
        var percent = Math.ceil( data[0] );
        var pos = $( '#chart' + serial ).offset( );
        var qty = arr_series[seriesIndex];

        if( MAX_X_AXIS > 0 )
            var text = miniChartLabel[seriesIndex] + ' : ' + qty + miniChartLabel['of'] + MAX_X_AXIS + ' (' + percent + '%)';
        else
            var text = miniChartLabel['nodata'];

        var w = $( '#labelMiniChart' ).width( );
        $( '#labelMiniChart' ).text( text ).offset(
        {
            top : pos.top - 19,
            left : pos.left - w + 110
        } ).show( );
    } );

    if( MAX_X_AXIS > 0 )
    {
        $( '#chart' + serial ).unbind( 'jqplotDataClick' ).bind( 'jqplotDataClick', function( ev, seriesIndex, pointIndex, data )
        {
            openDialogQuadCharts( serial, param, true );
        } ).addClass( 'cursorHand' );
    }

    $( '.miniChart' ).mouseout( function( )
    {
        $( '#labelMiniChart' ).offset(
        {
            left : 0,
            top : 0
        } ).hide( );
    } );
}

function showTab( comp, id, zzz )
{
    $( '.active-chart-button' ).removeClass( 'active-chart-button' );
    $( comp ).addClass( 'active-chart-button' );
    $( '.tab' ).hide( );
    $( '#' + id ).show( );
    window[zzz]( );
}