var kgatewayrpc = $.rpc.service( "/rpc/json.fcgi/kgateway" );

var kgatewaydata =
{
    NapTypeId :
    {
        SIP : 0,
        Trunk : 1,
        GSM : 2
    },
    NapTypeString : ["SIP", "Trunk", "GSM"],
    NapSipRegisterStateString : ["Register disabled", "Requesting register", "Requesting unregister", "Register success", "Register error"]
};

var timestampToDate = function( ts )
{
    if( ts > 0 )
    {
        var date_ = new Date( ts * 1000 );
        return date_.toLocaleString( );
    }
    else
    {
        return "<span class='kgateway-monitor-timestamp-never'>" + ajaxI18N( 'kgateway-monitor-timestamp-never' ) + "</span>";
    }
};

function kgatewayFormatSimCardCurrentDeviceChannelAndIndex( sim )
{
    if( sim.Device != null )
    {
        var klass = sim.Device.Selected ? "kgateway-monitor-sim-card-selected" : "kgateway-monitor-sim-card-not-selected";
        return "<span class='" + klass + "'>D" + sim.Device.Serial + " C" + sim.Device.Channel + " SIM " + sim.Device.Index + "</span>";
    }
    else
    {
        return "<span class='kgateway-monitor-sim-card-current-device-unknown'>" + ajaxI18N( "kgateway-monitor-sim-card-current-device-unknown" ) + "</span>";
    }
}

function kgatewayFormatSimCardSMSStatus( sim )
{
    if (sim.Device.SMSStatus == "SMS_IDLE")
    {
        return ajaxI18N("kgateway-monitor-sms-idle");
    }
    else if (sim.Device.SMSStatus == "SMS_SENDING")
    {
        return ajaxI18N("kgateway-monitor-sms-sending");
    }
    else if (sim.Device.SMSStatus =="SMS_LIMIT_REACHED")
    {
        return ajaxI18N("kgateway-monitor-sms-limit-reached");
    }
    else
    {
        return ajaxI18N("kgateway-monitor-sms-receiving");
    }
}

function kgatewayMonitorIsRpcError( err )
{
    if( err )
    {
        ShowNotice( err.message, false );
        return true;
    }
    return false;
}

function kgatewayMinuteFormat( minute )
{
    var klass = '';
    if( minute < 0 )
    {
        klass = 'fuu';
    }
    return $( "<span />" )
        .attr( { 'class' : klass } )
        .text( Number( minute.toFixed( 2 ) ) );
}

function kgatewaySMSFormat( amount )
{
    var klass = '';
    if( amount < 0 )
    {
        klass = 'fuu';
    }
    return $( "<span />" )
        .attr( { 'class' : klass } )
        .text( Number( amount.toFixed( 2 ) ) );
}

var kgatewayMonitorChangeMinutesLeft = function( evt, elm )
{
    var ktype = $( this ).attr( "ktype" );
    var idattr = ktype == "SIM" ? "ICCID" : "NAP";
    var minutesleft = $( this ).attr( "MinutesLeft" );

    if( minutesleft < 0 )
    {
        minutesleft = 0;
    }
    else
    {
        minutesleft = Math.round( minutesleft );
    }

    //@formatter:off
    var $content = $( "<div />" )
      .attr(
        {
          "id" : ktype + "-" + $( this ).attr( idattr ) + "-dialog"
        }
      )
      .append( $( "<div />" ).append( ajaxI18N( "kgateway-monitor-gsm-change-value" ) ) )
      .append( $( "<br />" ) )
      .append(
        $( "<input />" ).attr(
          {
            "name" : idattr,
            "type" : "hidden",
            "value" : $( this ).attr( idattr )
          }
        )
      )
      .append(
        $( "<input />" ).attr(
          {
            "name" : "ktype",
            "type" : "hidden",
            "value" : $( this ).attr( "ktype" )
          }
        )
      )
      .append(
        $( "<input />" ).attr(
          {
            "name" : "ktype",
            "type" : "hidden",
            "value" : $( this ).attr( "ktype" )
          }
        )
      )
      .append(
        $( "<label />").attr(
          {
            "for" : "MinutesLeft"
          } ).append( ajaxI18N( "kgateway-monitor-minutes" ) )
        )
      .append( ":&nbsp;" )
      .append(
        $( "<input />" ).attr(
          {
            "id" : "MinutesLeft",
            "name" : "MinutesLeft",
            "maxlength" : 7,
            "value" : minutesleft
          } )
          .mask( "9?999999" )
      );

    //@formatter:on
    var btnsave = ajaxI18NToLocaleCharset( 'kgateway-monitor-save' );
    var btncancel = ajaxI18NToLocaleCharset( 'kgateway-monitor-cancel' );
    var _buttons =
    {
    };
    _buttons[btnsave] = function( )
    {
        var $this = $( this );
        var _data =
        {
        };
        $( this ).find( "input" ).each( function( idx, elm )
        {
            var $elm = $( elm );
            _data[ $elm.attr( "name" )] = $.trim( $elm.val( ) );
        } );

        _data["MinutesLeft"] = parseInt( _data["MinutesLeft"] );

        var ktype = _data["ktype"];
        delete _data["ktype"];

        var rpcfn = undefined;

        switch( ktype )
        {
            case "SIM":
                rpcfn = kgatewayrpc.GsmSimCardModifyUsage;
                break;
            case "NAP":
                rpcfn = kgatewayrpc.GsmNapModifyUsage;
                break;
            default:
                throw "kgateway-gsm-invalid-type";
        }

        $( "#refreshing" ).show( );
        rpcfn( _data ).then( function( err, data )
        {
            if( kgatewayMonitorIsRpcError( err ) )
            {
                return;
            }
            ShowNotice( ajaxI18N( "kgateway-monitor-gsm-change-value-done" ), true );
            switch( ktype )
            {
                case "SIM":
                    $( "#kgateway-monitor-sim-cards-status-table tbody" ).children( ).remove( );
                    kgatewayMonitorSimCardsStatus( );
                    break;
                case "NAP":
                    kgatewayMonitorNapStatus( );
                    break;
            }
            $( "#refreshing" ).hide( );
            $this.dialog( "destroy" );
        } );
    };
    _buttons[btncancel] = function( )
    {
        $( this ).dialog( "destroy" );
    };

    var title = $( this ).attr( idattr );
    if( idattr == "ICCID" )
    {
        title = kgatewayFormatICCID( title );
    }
    $( "<div />" ).append( $content ).dialog(
    {
        autoOpen : true,
        closeOnEscape : true,
        modal : true,
        draggable : false,
        resizable : false,
        title : ktype + ": " + title,
        close : function( )
        {
            $( this ).dialog( "destroy" );
        },
        buttons : _buttons
    } );
};

var kgatewayMonitorChangeSMSLeft = function( evt, elm )
{
    var ktype = $( this ).attr( "ktype" );
    var idattr = ktype == "SIM" ? "ICCID" : "NAP";
    var smsleft = $( this ).attr( "SMSLeft" );

    if( smsleft < 0 )
    {
        smsleft = 0;
    }
    else
    {
        smsleft = Math.round( smsleft );
    }

    //@formatter:off
    var $content = $( "<div />" )
      .attr(
        {
          "id" : ktype + "-" + $( this ).attr( idattr ) + "-dialog"
        }
      )
      .append( $( "<div />" ).append( ajaxI18N( "kgateway-monitor-gsm-change-value" ) ) )
      .append( $( "<br />" ) )
      .append(
        $( "<input />" ).attr(
          {
            "name" : idattr,
            "type" : "hidden",
            "value" : $( this ).attr( idattr )
          }
        )
      )
      .append(
        $( "<input />" ).attr(
          {
            "name" : "ktype",
            "type" : "hidden",
            "value" : $( this ).attr( "ktype" )
          }
        )
      )
      .append(
        $( "<input />" ).attr(
          {
            "name" : idattr,
            "type" : "hidden",
            "value" : $( this ).attr( idattr )
          }
        )
      )
      .append(
        $( "<input />" ).attr(
          {
            "name" : "ktype",
            "type" : "hidden",
            "value" : $( this ).attr( "ktype" )
          }
        )
      )
      .append(
        $( "<input />" ).attr(
          {
            "name" : "ktype",
            "type" : "hidden",
            "value" : $( this ).attr( "ktype" )
          }
        )
      )
      .append(
        $( "<label />").attr(
          {
            "for" : "SMSLeft"
          } ).append( ajaxI18N( "kgateway-monitor-sms" ) )
        )
      .append( ":&nbsp;" )
      .append(
        $( "<input />" ).attr(
          {
            "id" : "SMSLeft",
            "name" : "SMSLeft",
            "maxlength" : 7,
            "value" : smsleft
          } )
          .mask( "9?999999" )
      );

    //@formatter:on
    var btnsave = ajaxI18NToLocaleCharset( 'kgateway-monitor-save' );
    var btncancel = ajaxI18NToLocaleCharset( 'kgateway-monitor-cancel' );
    var _buttons =
    {
    };
    _buttons[btnsave] = function( )
    {
        var $this = $( this );
        var _data =
        {
        };
        $( this ).find( "input" ).each( function( idx, elm )
        {
            var $elm = $( elm );
            _data[ $elm.attr( "name" )] = $.trim( $elm.val( ) );
        } );

        _data["SMSLeft"] = parseInt( _data["SMSLeft"] );

        var ktype = _data["ktype"];
        delete _data["ktype"];

        var rpcfn = undefined;

        switch( ktype )
        {
            case "SIM":
                rpcfn = kgatewayrpc.GsmSimCardModifyUsage;
                break;
            case "NAP":
                rpcfn = kgatewayrpc.GsmNapModifyUsage;
                break;
            default:
                throw "kgateway-gsm-invalid-type";
        }

        $( "#refreshing" ).show( );
        rpcfn( _data ).then( function( err, data )
        {
            if( kgatewayMonitorIsRpcError( err ) )
            {
                return;
            }
            ShowNotice( ajaxI18N( "kgateway-monitor-gsm-change-value-done" ), true );
            switch( ktype )
            {
                case "SIM":
                    $( "#kgateway-monitor-sim-cards-status-table tbody" ).children( ).remove( );
                    kgatewayMonitorSimCardsStatus( );
                    break;
                case "NAP":
                    kgatewayMonitorNapStatus( );
                    break;
            }
            $( "#refreshing" ).hide( );
            $this.dialog( "destroy" );
        } );
    };
    _buttons[btncancel] = function( )
    {
        $( this ).dialog( "destroy" );
    };

    var title = $( this ).attr( idattr );
    if( idattr == "ICCID" )
    {
        title = kgatewayFormatICCID( title );
    }
    $( "<div />" ).append( $content ).dialog(
    {
        autoOpen : true,
        closeOnEscape : true,
        modal : true,
        draggable : false,
        resizable : false,
        title : ktype + ": " + title,
        close : function( )
        {
            $( this ).dialog( "destroy" );
        },
        buttons : _buttons
    } );
};

function kgatewayMonitorNapStatus( )
{
    $( "#refreshing" ).show( );
    var togglenext = function( ev )
    {
        var $next = $( this ).next();
        $( this ).removeClass( "ui-icon-circle-plus ui-icon-circle-minus" ).addClass( $next.is( ":visible" ) ? "ui-icon-circle-plus" : "ui-icon-circle-minus" );
        $next.toggle();
    };

    kgatewayrpc.StatusNaps( ).then( function( err, data )
    {
        if( kgatewayMonitorIsRpcError( err ) )
        {
            return;
        }

        var $table = $( "#kgateway-monitor-nap-status-table" );
        $table.hide( );

        // destroy tablesorter plugin
        $table.trigger( "destroy" );
        $table.find( "tbody" ).children( ).remove( );

        $( data ).each( function( idx, elm )
        {
            var $tr = $( "<tr />" );
            var $divname = $( "<div />" );
            if( !elm.Active )
            {
                //@formatter:off
                $divname.append( kuiInlineIcon( "alert", kuiInlineIconColors.red, kuiInlineIconTextPosition.right, { } ) );
                //@formatter:on
            }
            $divname.append( elm.Name );

            var activestr = elm.Active ? ajaxI18N( "kgateway-monitor-active" ) : "<span class='kgateway-monitor-inactive'>" + ajaxI18N( "kgateway-monitor-inactive" ) + "</span>";

            var details = $( "<div />" );

            switch( elm.Type )
            {
                case kgatewaydata.NapTypeId.SIP:
                    // SIP
                    // this nap uses SIP register
                    if( elm.SIP.Register != undefined )
                    {
                        //@formatter:off
                        var registerdetails = $( "<div />" )
                                .addClass( "more-details" )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-last-try" ) + ": " + timestampToDate( elm.SIP.Register.LastTry ) )
                                .append( $( "<br />" ) )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-last-success" ) + ": " + timestampToDate( elm.SIP.Register.LastSuccess ) )
                                .append( $( "<br />" ) )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-last-error-code" ) + ": " + elm.SIP.Register.LastErrorCode );
                        registerdetails.hide();

                        var registerdiv = $( "<div />" )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-status" ) + ": " + kgatewaydata.NapSipRegisterStateString[elm.SIP.Register.State] )
                                .append( kuiInlineIcon( "circle-plus", kuiInlineIconColors.green, kuiInlineIconTextPosition.left, { } ).addClass( "more-details" ).click( togglenext ) )
                                .append( registerdetails );

                        details.append( registerdiv );
                        //@formatter:on
                    }
                    if( elm.SIP.KeepAlive != undefined )
                    {
                        //@formatter:off
                        var keepalivedetails = $( "<div />" )
                                .addClass( "more-details" )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-last-try" ) + ": " + timestampToDate( elm.SIP.KeepAlive.LastTry ) )
                                .append( $( "<br />" ) )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-last-success" ) + ": " + timestampToDate( elm.SIP.KeepAlive.LastSuccess ) )
                                .append( $( "<br />" ) )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-register-last-error-code" ) + ": " + elm.SIP.KeepAlive.LastErrorCode );
                        keepalivedetails.hide();

                        var keepalivediv = $( "<div />" )
                                .append( ajaxI18N( "kgateway-monitor-nap-sip-keep-alive-is-alive" ) + ": " + ajaxI18N( elm.SIP.KeepAlive.IsAlive ? "kgateway-monitor-nap-sip-keep-alive-success" : "kgateway-monitor-nap-sip-keep-alive-error" ) )
                                .append( kuiInlineIcon( "circle-plus", kuiInlineIconColors.green, kuiInlineIconTextPosition.left, { } ).addClass( "more-details" ).click( togglenext ) )
                                .append( keepalivedetails );

                        details.append( keepalivediv );
                        //@formatter:on
                    }
                    break;
                case kgatewaydata.NapTypeId.GSM:
                    // GSM
                    // this nap has shared minutes
                    if( elm.GSM.Shared != undefined )
                    {
                        //@formatter:off
                        details.append( ajaxI18N( "kgateway-monitor-nap-gsm-shared-minutes-left" ) + ": " )
                               .append( kgatewayMinuteFormat( elm.GSM.Shared.MinutesLeft ) )
                               .append( kuiIconButton( "pencil", { ktype : "NAP", NAP : elm.Name, MinutesLeft : elm.GSM.Shared.MinutesLeft }, kgatewayMonitorChangeMinutesLeft ) )
                               .append( $( "<br />" ) )

                               .append( ajaxI18N( "kgateway-monitor-nap-gsm-shared-sms-left" ) + ": " )
                               .append( kgatewaySMSFormat( elm.GSM.Shared.SMSLeft ) )
                               .append( kuiIconButton( "pencil", { ktype : "NAP", NAP : elm.Name, SMSLeft : elm.GSM.Shared.SMSLeft }, kgatewayMonitorChangeSMSLeft ) )
                               .append( $( "<br />" ) )

                               .append( ajaxI18N( "kgateway-monitor-last-update" ) + ": " + timestampToDate( elm.GSM.Shared.LastUpdate ) );
                        //@formatter:on
                    }
                    break;
            }

            //@formatter:off
            $tr.append( $( "<td class='name' />" ).append( $divname ) )
               .append( $( "<td />" ).append( kgatewaydata.NapTypeString[elm.Type] ) )
               .append( $( "<td />" ).append( activestr ) )
               .append( $( "<td />" ).append( elm.Channel.Fail ) )
               .append( $( "<td />" ).append( elm.Channel.Idle ) )
               .append( $( "<td />" ).append( elm.Channel.Busy ) )
               .append( $( "<td class='details' />" ).append( details ) );
            //@formatter:on

            $table.append( $tr );
        } );

        $table.tablesorter(
        {
            cssAsc : 'tablesorter-asc',
            cssDesc : 'tablesorter-desc',
            cssHeader : 'tablesorter-undefined',
            headers :
            {
                3 :
                {
                    sorter : false
                },
                4 :
                {
                    sorter : false
                }
            },
            sortList : kuiTablesorterGetLastState( $table, [[0, 0]] )
        } );
        $table.bind( "sortEnd", kuiTablesorterTrackState );

        $table.show( );
        $( "#refreshing" ).hide( );
    } );
}

function kgatewayMonitorSimCardsStatus( )
{
    $( "#refreshing" ).show( );

    kgatewayrpc.GsmSimCards( ).then( function( err, data )
    {
        if( kgatewayMonitorIsRpcError( err ) )
        {
            return;
        }
        var $table = $( "#kgateway-monitor-sim-cards-status-table" );
        $table.hide( );

        // destroy tablesorter plugin
        $table.trigger( "destroy" );
        $table.find( "tbody" ).children( ).remove( );

        $( data.SIMs ).each( function( idx, elm )
        {
            var $tr = $( "<tr />" );
            var iccid = $( "<td />" )
                .addClass( "simcard" )
                .append( SimCardToStringMonitor( elm ) );
            if( !elm.Configured )
            {
                iccid.append( kuiInlineIcon( "star", kuiInlineIconColors.blue, kuiInlineIconTextPosition.left, { title : ajaxI18NToLocaleCharset( 'kgateway-monitor-sim-card-discovered' ) } ) );
            }

            var details = $( "<div />" );
            var activestr = elm.Active ? ajaxI18N( "kgateway-monitor-active" ) : "<span class='kgateway-monitor-inactive'>" + ajaxI18N( "kgateway-monitor-inactive" ) + "</span>";
            var napstr = elm.NAP ? elm.NAP : "<span class='kgateway-monitor-sim-card-has-no-nap'>" + ajaxI18N( "kgateway-monitor-sim-card-has-no-nap" ) + "</span>";

            if (elm.Active) {
                var status_sms = kgatewayFormatSimCardSMSStatus(elm);
            }
            else
            {
                var status_sms = "-";
            }

            //@formatter:off
            details.append( ajaxI18N( "kgateway-monitor-sim-card-channel" ) + ": " + kgatewayFormatSimCardCurrentDeviceChannelAndIndex( elm ) );
           //@formatter:on
            details.append( $( "<br />" ) );
            if( elm.TimeTracker )
            {
                //@formatter:off
                details.append( ajaxI18N( "kgateway-monitor-last-update" ) + ": " + timestampToDate( elm.TimeTracker.LastUpdate ) )
                  .append( $( "<br />" ) );
                //@formatter:on
            }
            //@formatter:off
            $tr.append( iccid )
              .append( $( "<td />" ).append( napstr ) )
              .append( $( "<td />" ).append( activestr ) )
              .append( $( "<td />" ).append( status_sms ) )
              .append( $( "<td />" )
                .append( elm.TimeTracker ? kgatewayMinuteFormat( elm.TimeTracker.MinutesLeft ) : '-' )
                .append( elm.TimeTracker && !elm.TimeTracker.Shared ? kuiIconButton( "pencil", { ktype : "SIM", ICCID : elm.ICCID, MinutesLeft : elm.TimeTracker.MinutesLeft }, kgatewayMonitorChangeMinutesLeft ) : '' )
              )
              .append( $( "<td />" ).append( elm.TimeTracker ? elm.TimeTracker.MinutesConfigured : '-' ) )
              .append( $( "<td />" )
                .append( elm.TimeTracker ? kgatewaySMSFormat( elm.TimeTracker.SMSLeft ) : '-' )
                .append( elm.TimeTracker && !elm.TimeTracker.Shared ? kuiIconButton( "pencil", { ktype : "SIM", ICCID : elm.ICCID, SMSLeft : elm.TimeTracker.SMSLeft }, kgatewayMonitorChangeSMSLeft ) : '' )
              )
              .append( $( "<td />" ).append( elm.TimeTracker ? elm.TimeTracker.SMSConfigured : '-' ) )
              .append( $( "<td class='details' />" ).append( details ) );
            //@formatter:on

            $table.append( $tr );
        } );

        $table.tablesorter(
        {
            cssAsc : 'tablesorter-asc',
            cssDesc : 'tablesorter-desc',
            cssHeader : 'tablesorter-undefined',
            headers :
            {
                0 :
                {
                    sorter : false
                },
                5 :
                {
                    sorter : false
                },
                7 :
                {
                    sorter : false
                },
                8 :
                {
                    sorter : false
                }
            },
            sortList : kuiTablesorterGetLastState( $table, [[3, 0], [2, 1]] )
        } );
        $table.bind( "sortEnd", kuiTablesorterTrackState );

        $table.show( );

        if( data.SIMs.length > 0 )
        {
            $( "#kgateway-monitor-sim-cards-status-fieldset" ).show( );
        }
        $( "#refreshing" ).hide( );
    } );
}

function SimCardToStringMonitor( sim )
{
    var $span = $( "<span />" );

    $span.append( 'ICCID: ' + kgatewayFormatICCID( sim.ICCID ) );

    $span.append( $( "<br />" ) );
    if( "IMSI" in sim && sim.IMSI )
        $span.append( 'IMSI: ' + kgatewayFormatIMSI( sim.IMSI ) );

    if( "IMSI" in sim && sim.IMSI.slice( 0, 5 ) in serviceProviders )
    {
        $span.append( " - " + serviceProviders[sim.IMSI.slice( 0, 5 ) ] );
    }

    return $span;
}

var serviceProviders = {
    "72400" : "NEXTEL",
    "72402" : "TIM",
    "72403" : "TIM",
    "72404" : "TIM",
    "72405" : "CLARO",
    "72406" : "VIVO",
    "72410" : "VIVO",
    "72411" : "VIVO",
    "72415" : "CTBC",
    "72416" : "BRASIL TELECOM",
    "72423" : "VIVO",
    "72431" : "OI",
    "72432" : "CTBC",
    "72433" : "CTBC",
    "72434" : "CTBC",
    "72439" : "NEXTEL"
};

// cache I18N translations
//@formatter:off
I18NReadToCache( [
    "kgateway-monitor-inactive",
    "kgateway-monitor-active",
    "kgateway-monitor-minutes",
    "kgateway-monitor-save",
    "kgateway-monitor-cancel",
    "kgateway-monitor-inactive",
    "kgateway-monitor-last-update",
    "kgateway-monitor-timestamp-never",
    "kgateway-monitor-sim-card-channel",
    "kgateway-monitor-sim-card-has-no-nap",
    "kgateway-monitor-sim-card-nap-unknown",
    "kgateway-monitor-sim-card-current-device-unknown",
    "kgateway-monitor-nap-sip-register-status",
    "kgateway-monitor-nap-sip-register-last-try",
    "kgateway-monitor-nap-sip-register-last-success",
    "kgateway-monitor-nap-sip-register-last-error-code",
    "kgateway-monitor-nap-gsm-shared-minutes-left",
    "kgateway-monitor-nap-gsm-shared-sms-left",
    "kgateway-monitor-gsm-change-value",
    "kgateway-monitor-gsm-change-value-done",
    "kgateway-monitor-sms-idle",
    "kgateway-monitor-sms-sending",
    "kgateway-monitor-sms-receiving",
    "kgateway-monitor-sms-send-info",
    "kgateway-monitor-sms-limit-reached"
] );
//@formatter:on
