var GLOBALAjaxURL = "index.php?rawmode=yes&menu=kmonitor";

$( document ).ready( function( )
{
    currentMonitoring = $( '#current-monitoring' ).val( );
    $( '#' + currentMonitoring + '-button' ).removeClass( 'green-dark' ).addClass( 'green-light' );
} );

function updateDataChannels( justRefresh )
{
    var $gcc = $( '#groupCh' );
    var gc = $gcc.length > 0 ? $gcc.val( ) : '|';
    var $board = $( '#boardNow' );
    var $link = $( '#linkNow' );

    if( ($board.length > 0 && $link.length > 0) || justRefresh )
    {
        var boardNow = $board.val( );
        var linkNow = $link.val( );
        jQuery.kajax(
        {
            data :
            {
                'ajaxTo' : 'updateDataChannels',
                'boardNow' : boardNow,
                'linkNow' : linkNow,
                'gc' : gc
            },
            url : GLOBALAjaxURL,
            dataType : "json",
            before : showRefreshing( ),
            success : function( json )
            {
                if( json['Message']['error'] == '' && json['Message']['warning'] == '' )
                {
                    if( $( '#accordian-devices-channels' ).length == 0 )
                    {
                        sleep( 1000 );
                        window.location.reload( true );
                    }
                    else
                    {
                        $( '#divErrorMessage, #divAlertMessage' ).hide( 'slow' );
                        blockDeviceMenu( false );
                    }
                }
                else
                {
                    if( json['Message']['error'] != '' )
                    {
                        $( '#divAlertMessage' ).hide( 'slow' );
                        $( '#divErrorMessage' ).show( 'slow' );
                        $( '#divErrorMessageLine' ).html( json['Message']['error'] );
                        blockDeviceMenu( true );
                    }
                    else
                    {
                        blockDeviceMenu( false );

                        if( json['Message']['warning'] != '' )
                        {
                            $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                            $( '#divAlertMessage' ).show( 'slow' );
                            $( '#divErrorMessage' ).hide( 'slow' );
                        }
                    }
                }
                if( countElements( json['Devices'] ) > 0 )
                {
                    jsonDev = json['Devices'][boardNow];
                    if( linkNow == 99 )
                    {
                        var groupCh = $( '#groupCh' ).val( );
                        var chs = groupCh.split( '|' );
                        var start = chs[0];
                        var end = chs[1];
                    }
                    else
                    {
                        var qtdeCh = countElements( jsonDev.links[linkNow].channels );
                        var start = 0;
                        var end = qtdeCh - 1;
                    }
                    if( jsonDev['isE1'] != undefined )
                        var chMulti = jsonDev['isE1'] ? 30 : 24;

                    for( var start; start <= end; start++ )
                    {
                        var ch = start;
                        if( linkNow != 99 )
                            var ch = (chMulti * linkNow) + start;

                        var actualChannel = jsonDev.links[linkNow].channels[start];
                        $( "#channels-" + ch + "-signaling" ).html( actualChannel.signaling );
                        $( "#channels-" + ch + "-status" ).html( actualChannel.callStatus );
                        $( "#channels-" + ch + "-details" ).html( actualChannel.details.replace( /,/g, ', ' ) );

                        var inbound = actualChannel.inbound;
                        var $inbound = $( "#channels-" + ch + "-inbound" );
                        $inbound.html( inbound );
                        if( inbound > 0 )
                            $inbound.removeClass( 'fontWeightNormal' ).addClass( 'fontWeightBold' );

                        var outbound = actualChannel.outbound;
                        var $outbound = $( "#channels-" + ch + "-outbound" );
                        $outbound.html( outbound );
                        if( outbound > 0 )
                            $outbound.removeClass( 'fontWeightNormal' ).addClass( 'fontWeightBold' );

                        // percent = actualChannel.succeed > 0 &&
                        // actualChannel.outbound > 0 ? ((actualChannel.succeed * 100) / actualChannel.outbound) : 0;

                        var succeed = actualChannel.succeed;
                        var $succeed = $( "#channels-" + ch + "-succeed" );
                        // $succeed.html( succeed + ' | ' + percent.toFixed( ) + '%' );
                        $succeed.html( succeed );
                        if( succeed > 0 )
                            $succeed.removeClass( 'fontWeightNormal' ).addClass( 'fontWeightBold' );

                        var failed = actualChannel.failed;
                        var $failed = $( "#channels-" + ch + "-failed" );
                        $failed.html( failed );
                        if( failed > 0 )
                            $failed.removeClass( 'fontWeightNormal' ).addClass( 'fontWeightBold' );

                        var $simSelect = $( '#channels-' + ch + '-sim select' ).val( boardNow + '.' + ch + '.' + actualChannel.sim );

                        var operName = actualChannel.oper;
                        var $oper = $( "#channels-" + ch + "-oper" );
                        if( $oper.length > 0 )
                            $oper.html( operName );

                        var $strength = $( "#channels-" + ch + "-strength" );
                        if( $strength.length > 0 )
                            $strength.html( actualChannel.strength );

                        var $imei = $( "#channels-" + ch + "-IMEI" );
                        if( $imei.length > 0 )
                            $imei.html( actualChannel.IMEI );

                        var $iccid = $( "#channel-" + ch + "-ICCID" );
                        if( $iccid.length > 0 )
                            $iccid.html( actualChannel.ICCID );

                        $( "#channels-" + ch + "-callDuration" ).html( actualChannel.CallDuration );
                        $( "#channels-" + ch + "-dialNumber" ).html( actualChannel.DialNumber );
                        $( "#channels-" + ch + "-averageTimeCalls" ).html( actualChannel.AverageCallTime );

                    }
                }
                if($('.options').is(':visible') && countElements(json['MiniCharts']))
                    startMiniChart( json['MiniCharts'], 'channel' );

                $( '#refreshing' ).hide( );
            }
        } );
    }
    var delay = $( "#refreshDelay" ).val( );
    if( !justRefresh && delay > 0 )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1;
        if( bool )
        {
            var intervalo = delay * 1000;
            setTimeout( "updateDataChannels(false)", intervalo );
        }
    }
}

function saveSoftpbxName()
{
    //var name = $('#softpbxname').val();
    var name = $('#softpbxnameinput').val();
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'saveSoftpbxName',
            'data': name
        },
        url : GLOBALAjaxURL,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( ajaxI18N(text), true );
            updateData(true, 'Services');
        }
    } );

    $('#pbxname').html(name);
    buff  = "<a href='#!' onclick=\"editPbxName();\">";
    buff += "<img src='/imagens/edit.png' title='edit' /></a>";
    $('#pbxnamebutton').html(buff);
}
function editPbxName()
{
    var div0 = $('#pbxname');
    var div1 = $('#pbxnamebutton');
    inp  = '<input size="10" maxlength="150" id="softpbxnameinput" class="inputText" type="text" ';
    inp += 'value="' + div0.text().trim() + '">';
    
    link =  "<a href='#!' onclick=\"saveSoftpbxName();\">";
    link += "<img src='/imagens/editark.gif' title='save' /></a>";

    div0.html(inp);
    div1.html(link);
}

function exibicaoGC( serial, board, link, gc, comp )
{
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'showVoIPChannels',
            'gc' : gc,
            'serial' : serial,
            'link' : link,
            'board' : board
        },
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( json )
        {
            showHideMessagesOnChannelMonitoring( json );
            if( json['HTML'] != '' )
            {
                $( "#exibicao" ).html( json['HTML'] );
                setAndExecuteFilter( false );
                clickMe( comp );
                updateDataChannels( true );
            }
        }
    } );
}

function exibicao( link, board, comp )
{
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'showChannels',
            'link' : link,
            'board' : board
        },
        url : GLOBALAjaxURL,
        before : showRefreshing( ),
        dataType : "json",
        success : function( json )
        {
            showHideMessagesOnChannelMonitoring( json );
            if( json['HTML'] != '' )
            {
                $( "#exibicao" ).html( json['HTML'] );
                setAndExecuteFilter( false );
                clickMe( comp );
                updateDataChannels( true );
            }
            enableSwitchSimCard( );
        }
    } );
}

function showModularChannels( board, serial, link, startCh, chCount, comp )
{
    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        data :
        {
            'ajaxTo' : 'showModularChannels',
            'board' : board,
            'serial' : serial,
            'link' : link,
            'startChannel' : startCh,
            'endChannel' : chCount
        },
        dataType : "json",
        success : function( json )
        {
            showHideMessagesOnChannelMonitoring( json );
            if( json['HTML'] != '' )
            {
                $( '#exibicao' ).html( json['HTML'] );
                $( '#exibicao' ).show( );
                setAndExecuteFilter( );
                $( '#span-board-' + board ).removeClass( 'green-dark' ).addClass( 'green-light' );
                $( '#span-ch-modular' ).removeClass( 'green-dark' ).addClass( 'green-light' );
                clickMe( comp );
                updateDataChannels( true );
                enableSwitchSimCard( );
            }
        }
    } );
}

function showHideMessagesOnChannelMonitoring( json )
{
    if( json['Message']['error'] == '' && json['Message']['warning'] == '' )
    {

        $( '#divErrorMessage, #divAlertMessage' ).hide( 'slow' );
        $( '.active-devices' ).show( 'slow' );
    }
    else
    {
        if( json['Message']['error'] != '' )
        {
            $( '#divAlertMessage' ).hide( 'slow' );
            $( '#divErrorMessage' ).show( 'slow' );
            $( '#divErrorMessageLine' ).html( json['Message']['error'] );
        }
        else
        {
            if( json['Message']['warning'] != '' )
            {
                $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                $( '#divAlertMessage' ).show( 'slow' );
                $( '#divErrorMessage' ).hide( 'slow' );
            }
        }
    }
}

//Links
function updateDataLinks( justRefresh )
{
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'updateDataLinks'
        },
        url : GLOBALAjaxURL,
        dataType : "json",
        before : showRefreshing( ),
        success : function( json )
        {
            if( json['Message']['error'] == '' && json['Message']['warning'] == '' )
            {
                if( $( '#linkTable' ).length == 0 && $( '#noDeviceLink' ).length == 0 )
                {
                    sleep( 1000 );
                    window.location.reload( true );
                }
                else
                    $( '#divErrorMessage, #divAlertMessage' ).hide( 'slow' );
            }
            else
            {
                if( json['Message']['error'] != '' )
                {
                    $( '#divErrorMessageLine' ).html( json['Message']['error'] );
                    $( '#divErrorMessage' ).show( 'slow' );
                    $( '#divAlertMessage' ).hide( 'slow' );
                }
                else
                {
                    if( json['Message']['warning'] != '' )
                    {
                        $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                        $( '#divAlertMessage' ).show( 'slow' );
                        $( '#divErrorMessage' ).hide( 'slow' );
                    }
                }
            }

            var count_json = countElements( json['Devices'] );
            if( count_json > 0 )
            {
                for( i = 0; i < count_json; i++ )
                {
                    var serial = json['Devices'][i].serial;
                    for( j = 0; j < countElements( json['Devices'][i].links ); j++ )
                    {
                        var link = json['Devices'][i].links[j];
                        var statusLink = link.status;
                        var idLink = link.id;

                        $( "#links-" + serial + "-status-" + idLink ).html( "<b>" + statusLink + "</b>" );
                        var $celulaAlarm = $( "#links-" + serial + "-alarms-" + idLink );

                        if( link.alarms != undefined )
                        {
                            var texto = "";
                            var arr_tmp = Array( );

                            $.each( json['Devices'][i].links[j]["alarms"], function( k, v )
                            {
                                if( v > 0 )
                                    arr_tmp.push( k );
                            } );
                            texto = arr_tmp.length == 0 ? '-' : ajaxI18N( arr_tmp.join( ', ' ) );
                            texto = (texto.split( ',' )).join( '<br/>' );
                            $celulaAlarm.html( texto );
                        }
                        else
                            $celulaAlarm( "<b>N/A</b>" );

                        if( link.variations != undefined )
                        {
                            var image = existeVariations( link.variations ) ? image_dir + '/imagens/view2.png' : image_dir + '/imagens/view1.png';
                            $( "#links-" + serial + "-variations-span-" + idLink + " img" ).attr( 'src', image );
                        }
                    }
                }
            }
            startMiniChart( json['MiniCharts'], 'link' );
            $( '#refreshing' ).hide( );
        }
    } );

    var delay = $( "#refreshDelay" ).val( );
    if( !justRefresh && delay > 0 )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1;
        if( bool )
        {
            var intervalo = delay * 1000;
            setTimeout( "updateDataLinks(false)", intervalo );
        }
    }
}

function viewVariations( event, serial, link )
{
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'viewVariations',
            'link' : link,
            'serial' : serial
        },
        url : GLOBALAjaxURL,
        dataType : "html",
        success : function( result )
        {
            var div = $( "#popup" );
            var elem = $( event.target );
            var pos = elem.position( );
            div.html( result ).css(
            {
                'top' : pos.top,
                'left' : pos.left + elem.width( )
            } ).show( 'slow' );
            $( '.blockscreen' ).removeClass( 'displayNone' );
        }
    } );
}

function existeVariations( arr )
{
    var result = false;
    $.each( arr, function( k, v )
    {
        if( v > 0 )
        {
            result = true;
            return;
        }
    } );
    return result;
}

function operationLink( serial, boardLink, operacao )
{
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'operationLink',
            'serial' : serial,
            'link' : boardLink,
            'operation' : operacao
        },
        url : GLOBALAjaxURL,
        dataType : "text",
        type : "POST",
        before : showRefreshing( ),
        success : function( result )
        {
            result = result.replace( /(\r\n|\n|\r)/gm, "" );
            if( result )
            {
                ShowNotice( ajaxI18N( 'performOperation' ), true );
                if( operacao == 'clean' )
                    $( "#links-" + serial + "-variations-span-" + boardLink ).removeClass( 'fontWeightBold' ).addClass( 'fontWeightNormal' );
            }
            else
                ShowNotice( ajaxI18N( 'CanPerformOperation' ), false );
            $( '#refreshing' ).hide( );
        }
    } );
}

function switchSimCard( selector )
{
    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'switchSimCard',
            'selector' : selector
        },
        url : GLOBALAjaxURL,
        dataType : "text",
        type : "POST",
        success : function( result )
        {
            result = result.replace( /(\r\n|\n|\r)/gm, "" );
            if( result )
                ShowNotice( ajaxI18N( 'performOperation' ), true );
            else
                ShowNotice( ajaxI18N( 'CanPerformOperation' ), false );
            updateDataChannels( true );
            $( '#refreshing' ).hide( );
        }
    } );
}

function enableSwitchSimCard( )
{
    $( 'select.sim_card_list' ).each( function( )
    {
        var $this = $( this );
        $this.css( 'background-color', $this.parent( ).css( 'background-color' ) );
        $this.change( function( )
        {
            switchSimCard( $this.find( ':selected' ).attr( 'value' ) );
            console.log( 'Calling switchSimCard: ' + $this.find( ':selected' ).attr( 'value' ) );
        } );
    } );
}

//Devices
function updateDataDevices( justRefresh )
{
    jQuery.kajax(
    {
        data :
        {
            'ajaxTo' : 'updateDataDevices'
        },
        url : GLOBALAjaxURL,
        dataType : "json",
        before : showRefreshing( ),
        success : function( json )
        {
            if( json['Message']['error'] == '' && json['Message']['warning'] == '' )
            {
                if( $( '#devicesTable' ).length == 0 )
                {
                    sleep( 1000 );
                    window.location.reload( true );
                }
                else
                    $( '#divErrorMessage, #divAlertMessage' ).hide( 'slow' );
            }
            else
            {
                if( json['Message']['error'] != '' )
                {
                    $( '#divErrorMessageLine' ).html( json['Message']['error'] );
                    $( '#divErrorMessage' ).show( 'slow' );
                    $( '#divAlertMessage' ).hide( 'slow' );
                }
                else
                {
                    if( json['Message']['warning'] != '' )
                    {
                        $( '#divAlertMessageLine' ).html( json['Message']['warning'] );
                        $( '#divAlertMessage' ).show( 'slow' );
                        $( '#divErrorMessage' ).hide( 'slow' );
                    }
                }
            }

            var json_count = countElements( json['Devices'] );
            if( json_count > 0 )
            {
                for( i = 0; i < json_count ; i++ )
                {
                    var device = json['Devices'][i];
                    var serial = device['serial'];
                    var status = device.status;
                    $( "#status-" + serial.replace( ' ', '_' ) ).html( "<b>" + status + "</b>" );
                    for( j = 0; j < countElements( device.links ); j++ )
                        $( "#links-" + serial + "-link-" + j ).html( "Link " + j + " : <b>" + device.links[j].status + "</b><br />" );

                    $.each( device.channels, function( k, v )
                    {
                        $( "#channels-" + serial + "-" + k ).html( "<b>" + v + "</b>" );
                    } );
                }
            }
            startMiniChart( json['MiniCharts'], 'device'  );
            $( '#refreshing' ).hide( );
        }
    } );

    var delay = $( "#refreshDelay" ).val( );
    if( !justRefresh && delay > 0 )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1;
        if( bool )
        {
            var intervalo = delay * 1000;
            setTimeout( "updateDataDevices(false)", intervalo );
        }
    }
}

//Servicos
function updateDataServices( justRefresh )
{
    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        data :
        {
            'ajaxTo' : 'updateDataServices'
        },
        dataType : "text",
        before : showRefreshing( ),
        success : function( ret )
        {
            $( '#monitor-content' ).html( ret );
            $( '#refreshing' ).hide( );
        }
    } );

    var delay = $( "#refreshDelay" ).val( );
    if( !justRefresh && delay > 0 )
    {
        var bool = $( '#ctrlMonitoracao' ).val( ) == 1;
        if( bool )
        {
            var intervalo = delay * 1000;
            setTimeout( "updateDataServices(false)", intervalo );
        }
    }
}

function isKhompAPIServerActive( )
{
    return $( '#real-status-Khomp_API_Server' ).val( );
}

function isKhompQueryServerActive( )
{
    return $( '#real-status-Khomp_Query_Server' ).val( );
}

function isKhompMediaServerActive( )
{
    var $kmp = $( "#real-status-Khomp_Media_Server" );
    return $kmp.length ? $kmp.val( ) : true;
}

function startService( service )
{
    if( service == "Khomp API Server" && !isKhompMediaServerActive( ) && SO == "WIN" )
    {
        if( ajaxConfirm( 'needToStartKMP' ) )
        {
            jQuery.kajax(
            {
                type : "POST",
                data :
                {
                    'ajaxTo' : 'startStopServices',
                    'action' : 'start',
                    'service' : 'service'
                },
                url : GLOBALAjaxURL,
                dataType : "json",
                before : showRefreshing( ),
                success : function( ret )
                {
                    ShowNotice( ret['message'], ret['success'] );
                    $( '#refreshing' ).hide( );
                }
            } );
        }
        else
            return false;
    }
    else
    {
        jQuery.kajax(
        {
            type : "POST",
            data :
            {
                'ajaxTo' : 'startStopServices',
                'action' : 'start',
                'service' : service
            },
            url : GLOBALAjaxURL,
            before : showRefreshing( ),
            dataType : "json",
            success : function( ret )
            {
                ShowNotice( ret['message'], ret['success'] );
                $( '#refreshing' ).hide( );
            }
        } );
    }
}

function stopService( service )
{
    if( service == "Khomp Media Server" && isKhompAPIServerActive( ) && SO == "WIN" )
    {
        if( ajaxConfirm( 'needToStopK3L' ) )
        {
            jQuery.kajax(
            {
                type : "POST",
                data :
                {
                    'ajaxTo' : 'startStopServices',
                    'action' : 'stop',
                    'service' : service
                },
                url : GLOBALAjaxURL,
                before : showRefreshing( ),
                dataType : "json",
                success : function( ret )
                {
                    ShowNotice( ret['message'], ret['success'] );
                    $( '#refreshing' ).hide( );
                }
            } );
        }
        else
            return false;
    }
    else
    {
        jQuery.kajax(
        {
            type : "POST",
            data :
            {
                'ajaxTo' : 'startStopServices',
                'action' : 'stop',
                'service' : service
            },
            url : GLOBALAjaxURL,
            dataType : "json",
            before : showRefreshing( ),
            success : function( ret )
            {
                ShowNotice( ret['message'], ret['success'] );
                $( '#refreshing' ).hide( );
            }
        } );
    }
}

function resetDevice( board )
{
    if( confirmI18N( 'sureToResetDevice' ) )
    {
        jQuery.kajax(
        {
            type : "POST",
            data :
            {
                'ajaxTo' : 'resetDevice',
                'board' : board
            },
            url : GLOBALAjaxURL,
            dataType : "json",
            success : function( ret )
            {
                ShowNotice( ret['message'], ret['success'] );
            }
        } );
    }
}

function resetGSMChannel( serial, channel )
{
    if( confirmI18N( 'sureToResetGSMChannel' ) )
    {
        jQuery.kajax(
        {
            type : "POST",
            data :
            {
                'ajaxTo' : 'resetGSMChannel',
                'serial' : serial,
                'channel' : channel
            },
            url : GLOBALAjaxURL,
            dataType : "json",
            success : function( ret )
            {
                ShowNotice( ret['message'], ret['success'] );
            }
        } );
    }
}

function clearChannelStats( serial, channel )
{
    if( confirmI18N( 'sureToClearChannelStats' ) )
    {
        jQuery.kajax(
        {
            type : "POST",
            data :
            {
                'ajaxTo' : 'clearChannelStats',
                'serial' : serial,
                'channel' : channel
            },
            url : GLOBALAjaxURL,
            dataType : "json",
            success : function( ret )
            {
                ShowNotice( ret['message'], ret['success'] );
                updateDataChannels( true );
            }
        } );
    }
}

function setAccordianMenu( )
{
    $( "#accordian-devices-channels h3" ).click( function( )
    {
        var ul = $( this ).next( );
        var h3 = ul.parent( ).children( 'h3' );
        if( h3.hasClass( 'ImClosed' ) )
        {
            ul.slideDown( );
            h3.removeClass( 'ImClosed' ).addClass( 'ImOpened' );
        }
        else
        {
            ul.slideUp( );
            h3.removeClass( 'ImOpened' ).addClass( 'ImClosed' );
        }
    } );
    $( '#accordian-devices-channels a' ).first( ).click( );
    setAndExecuteFilter( );
}

function openFilter( )
{
    $( '#openFilter' ).addClass( 'displayNone' );
    $( '#filter, #closeFilter' ).removeClass( 'displayNone' );
}

function closeFilter( )
{
    $( '#filter, #closeFilter' ).addClass( 'displayNone' );
    $( '#openFilter' ).removeClass( 'displayNone' );
}

function hideDeviceToChose( )
{
    $( '#holderDevices ul' ).hide( );
}

function showDeviceToChose( )
{
    $( '#holderDevices ul' ).show( );
}

function setAndExecuteFilter( )
{
    var values = getCookieValue( 'kwebmonitor-columns-filter' );
    $( '#filter input[type=checkbox]:checked' ).attr( 'checked', false );
    $.each( values.split( ',' ), function( k, v )
    {
        $( '#' + v ).attr( 'checked', true );
    } );
    executeFilter( false );
}

function executeFilter( comp )
{
    var columns = [];
    var channelPage = $( '.sanfona' ).length > 0;
    $.each( $( '.sanfona input[type=checkbox]' ), function( k, v )
    {
        $comp = $( v );
        if( $comp.is( ':checked' ) )
        {
            $( '.' + $comp.val( ) ).show( );
            columns.push( $( v ).val( ) );
        }
        else
            $( '.' + $comp.val( ) ).hide( );
    } );

    if( channelPage )
    {
        if( columns.length > 0 )
            setCookieValue( 'kwebmonitor-columns-filter', columns );
        else
            ShowNotice( ajaxI18N( 'needToSelectAtLeastOnecolumn' ), false );
    }

    if(comp)
    {
        var opt = $(comp);
        if(opt.val() == 'options' && opt.is(':checked'))
            updateDataChannels(true);
    }
}

function clickMe( comp )
{
    $( '.clicked' ).removeClass( 'clicked' );
    $( comp ).addClass( 'clicked' );
}

function blockDeviceMenu( bool )
{
    $blocker = $( '.accordian-blocker' );
    var height = $( '#accordian-devices-channels' ).css( 'height' );
    $blocker.css( 'height', height );
    bool ? $blocker.show( ) : $blocker.hide( );
}

function showRefreshing( )
{
    $( '#refreshing' ).show( );
}
