<?php
    /* include SocketConnection */
    require_once ('socketconnection.php');

    /* Only for debug proposes use ?example */
    if( isset( $_REQUEST['example'] ) )
        error_reporting( E_ALL );

    /* Important defines */
    define( 'QUERIST_CONNECT_ERROR', 'cantCreateConnection' );
    define( 'QUERIST_ASK_ERROR', 'cantConnectKQueryServer' );
    define( 'QUERIST_ASK_INVALID', 'k3lDown' );

    /*
     * Handle the requests to query information
     */
    class Querist
    {
        /* Last error ocurred will be setted here */
        static public $last_error = '';

        /* Ask for a specific function */
        public static function ask( $query, &$buffer, $other_conn = NULL )
        {
            // trigger_error($query);
            $conn = (!$other_conn ? new SocketConnection( ) : $other_conn);
            if( !$conn )
            {
                Querist::$last_error = QUERIST_CONNECT_ERROR;
                trigger_error( 'QUERIST_CONNECT_ERROR -> ' . $last_error . ' ' . $query );
                throw new Exception( Querist::$last_error, 1 );
            }
            if( !$conn->writeAndRecv( $query, $buffer ) )
            {
                Querist::$last_error = QUERIST_ASK_ERROR;
                trigger_error( 'QUERIST_ASK_ERROR -> ' . $last_error . ' ' . $query );
                throw new Exception( Querist::$last_error, 1 );
            }
            if( strstr( $buffer, 'Query failed' ) !== FALSE )
            {
                // Querist::$last_error = QUERIST_ASK_INVALID . ',' . $buffer;
                Querist::$last_error = QUERIST_ASK_INVALID;
                trigger_error( 'QUERIST_ASK_INVALID -> ' . $last_error . ' ' . $query );
                throw new Exception( Querist::$last_error, 1 );
            }
            return true;
        }

    }

    function querist_example( )
    {
        $in = 'QUERY ' . $_REQUEST['query'];
        print $in;
        $out = '';

        if( !Querist::ask( $in, $out ) )
        {
            echo Querist::$last_error . '<br/>';
        }

        var_dump( $out );
    }

    /* Only for debug/test proposes use ?example */
    if( isset( $_REQUEST['example'] ) )
        querist_example( );