<?php
    require_once 'constants.php';
    require_once KROOT . '/classes/KSystem.php';
    //ini_set('display_errors', 'On');
    $app = KSystem::getInstance( );

    require_once KROOT . '/languages/dictionary.php';

    $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : NULL;
    if( isset( $action ) )
    {
        if( $action == 'logoff' )
        {
            session_destroy( );
            $host = $_SERVER['HTTP_HOST'];
            header( "Location: http://{$host}/?language={$app->getLanguage()}" );
            exit ;
        }
    }

    require_once KROOT . '/smarty-libs/Smarty.class.php';
    require_once KROOT . '/topo.php';
    require_once KROOT . '/rodape.php';
    $smarty = new Smarty( );


    $error = isset( $_REQUEST['error'] ) ? $_REQUEST['error'] : NULL;
    if( isset( $error ) )
    {
        $smarty->assign( 'ERROR', getErrorMessage( $error ) );
    }

    $userAuthentication = true;
    // challenge-response authentication
    if( IS_GATEWAY && isset( $_GET['challenge'] ) )
    {
        $login = $app->authenticationChallenge();
        if( $login )
        {
            $smarty->assign( 'LOGIN', $app->authenticationChallenge() );
            $smarty->assign( 'LOGINOPTS', 'readonly="true"' );
            $smarty->assign( 'USER', $app->translate( 'challenge' ) );
            $userAuthentication = false;
        }
    }
    // user-password authentication
    if( $userAuthentication )
    {
        $smarty->assign( 'LOGINOPTS', '' );
        $smarty->assign( 'USER', $app->translate( 'user' ) );
    }

    $smarty->assign( 'AUTENTICATION', $app->translate( 'autentication' ) );
    $smarty->assign( 'PASSWORD', $app->translate( 'password' ) );
    $smarty->assign( 'ENTER', $app->translate( 'login' ) );
    $smarty->assign( 'ERR_MSG_LOGIN', $app->translate( 'loginRequired' ) );
    $smarty->assign( 'ERR_MSG_PASSWORD', $app->translate( 'passwordRequired' ) );

    $smarty->assign( 'YOU_ARE_USING', $app->translate( 'youAreUsing' ) );
    $smarty->assign( 'SOME_FUNC_ARE_LIMITED', $app->translate( 'someFuncAreLimited' ) );
    $smarty->assign( 'YOUR_BROWSER_ISNT_COMPATIBLE', $app->translate( 'yourBrowserIsntCompatible' ) );

    $topo = Topo::printTopo( '', false, false, false, false );
    $smarty->assign( 'TOP', $topo );
    $rodape = Rodape::printRodape( );
    $smarty->assign( 'FOOTER', $rodape );

    //ataching timestamp to prevent cache
    $smarty->assign( 'PRINCIPAL_CSS_TS', filemtime( 'KWebConfig/css/principal.css' ) );
    $smarty->assign( 'GERAL_JS_TS', filemtime( './js/geral.js' ) );
    $smarty->assign( 'GERAL_CSS_TS', filemtime( './js/geral.css' ) );
    $smarty->assign( 'CUSTOM_CSS', ( !file_exists( './css/custom.css' ) ) ? '' : '<link type="text/css" rel="stylesheet" href="css/custom.css"/>' );
    $smarty->assign( 'JQUERY_JS_TS', filemtime( './js/jquery/jquery.js' ) );
    $smarty->assign( 'JMIN_JS_TS', filemtime( './js/jquery/jquery.min.js' ) );
    $smarty->assign( 'VALIDATE_JS_TS', filemtime( './js/jquery/jquery-1.6.validate.js' ) );
    $smarty->assign( 'JSTZ_JS_TS', filemtime( './js/jstz-1.0.4.min.js' ) );

    $smarty->display( 'themes/default/default.tpl' );

    function getErrorMessage( $code )
    {
        $app = KSystem::getInstance( );

        switch( $code )
        {
            case 'Kerr1':
                return $app->translate( 'UserOrPasswdIncorrect' );
            case 'Kerr2':
                return $app->translate( 'UsersFileNotfound' );
            case 'Kerr3':
                return $app->translate( 'SessionExpired' );
            default:
                return $app->translate( 'UnknowError' );
        }
    }
