<?php
    @session_start( );

    $AjaxFunctions['printAdminInterface'] = 'printAdminInterface';
    $AjaxFunctions['addNewUser'] = 'addNewUser';
    $AjaxFunctions['removeUser'] = 'removeUser';
    $AjaxFunctions['changePassword'] = 'changePassword';
    $AjaxFunctions['saveModifications'] = 'saveModifications';
    $AjaxFunctions['deleteLicense'] = 'deleteLicense';
    $AjaxFunctions['uploadLicense'] = 'uploadLicense';

    if( IS_GATEWAY )
    {
        $AjaxFunctions['reboot'] = 'reboot';
        $AjaxFunctions['shutdown'] = 'shutdown';
        $AjaxFunctions['runFirmwareUpdate'] = 'runFirmwareUpdate';
    }

    function shutdown( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );

        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-shutdown-error' ) );

        if( function_exists( 'posix_getuid' ) )
            $root = posix_getuid( ) == 0;
        else
        {
            $ret = shell_exec( 'whoami' );
            $root = strcasecmp( $ret, 'root' );
        }
        $prepend = $root ? '' : '/usr/bin/sudo -u root ';
        $output = array( );
        exec( "{$prepend}/usr/sbin/khomp-sudo /sbin/shutdown -hP now", $output, $excode );
        if( $excode == 0 )
        {
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-shutdown-success' ) );
        }

        return JSONencode( $reply );
    }

    function reboot( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );

        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-reboot-error' ) );

        if( function_exists( 'posix_getuid' ) )
            $root = posix_getuid( ) == 0;
        else
        {
            $ret = shell_exec( 'whoami' );
            $root = strcasecmp( $ret, 'root' );
        }
        $prepend = $root ? '' : '/usr/bin/sudo -u root ';
        $output = array( );

        exec( "{$prepend} kwebhelper resetallmodules", $output, $excode_reset_ebs );
        if( $excode_reset_ebs !== 0 )
        {
            return JSONencode( array(
              'success' => false,
              'message' => $app->translate("gateway-error-kwebhelper-resetallmodules") . ": (" . $excode_reset_ebs . ") " . implode(' ', $output)
            ) );
        }

        exec( "{$prepend}/usr/sbin/khomp-sudo /sbin/shutdown -r now", $output, $excode );
        if( $excode == 0 )
        {
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-reboot-success' ) );
        }

        return JSONencode( $reply );
    }

    function addNewUser( )
    {
        global $sistema;

        $filename = getUsersConfig( );
        if( file_exists( $filename ) )
        {
            if( $_SESSION['loginAccess']['administration'] == 'full' )
            {
                $KYaml = new KYaml( $filename );
                if( !isset( $KYaml->yaml['Users'][$_REQUEST['login']] ) )
                {
                    $user = array( 'password' => md5( "KWebPortal" . $_REQUEST['password'] ), 'configuration' => $_REQUEST['configuration'], 'administration' => $_REQUEST['administration'], 'diagnostic' => $_REQUEST['diagnostic'], 'monitoring' => $_REQUEST['monitoring'] );
                    $KYaml->createVar( $_REQUEST['login'], "Users", $user );
                    $KYaml->save( );

                    if( IS_GATEWAY )
                    {
                        $pwdfile = '/etc/vsftpd/passwd';
                        PwdfileManage( $pwdfile, $_REQUEST['login'], $_REQUEST['password'], 'add' );
                    }

                    $response['executed'] = true;
                    $response['message'] = $sistema->retTranslate( 'userRegisteredSuccess' );
                    $response['users'] = printUserAdministration( );
                }
                else
                {
                    $response['users'] = printUserAdministration( );
                    $response['executed'] = false;
                    $response['message'] = $sistema->retTranslate( 'userAlreadyRegistered' );
                }
                $response['loggedUser'] = $_SESSION['login'];
            }
            else
            {
                $response['users'] = printUserAdministration( );
                $response['executed'] = false;
                $response['message'] = $sistema->retTranslate( 'pDenied' );
            }
        }
        return JSONencode( $response );
    }

    function removeUser( )
    {
        global $sistema;

        $filename = getUsersConfig( );
        if( file_exists( $filename ) )
        {
            if( $_SESSION['loginAccess']['administration'] == 'full' )
            {
                $KYaml = new KYaml( $filename );
                if( isset( $KYaml->yaml['Users'][$_REQUEST['login']] ) )
                {
                    if( $_REQUEST['login'] != $_SESSION['login'] )
                    {
                        $KYaml->deleteVar( $_REQUEST['login'] );
                        $KYaml->save( );
                        $response['users'] = printUserAdministration( );

                        if( IS_GATEWAY )
                        {
                            $pwdfile = '/etc/vsftpd/passwd';
                            PwdfileManage( $pwdfile, $_REQUEST['login'], '', 'del' );
                        }

                        $response['executed'] = true;
                        $response['message'] = $sistema->retTranslate( 'userRemovedSuccess' );
                    }
                    else
                    {
                        $response['users'] = printUserAdministration( );
                        $response['executed'] = false;
                        $response['message'] = $sistema->retTranslate( 'cantRemoveUser' );
                    }
                }
                else
                {
                    $response['users'] = printUserAdministration( );
                    $response['executed'] = false;
                    $response['message'] = $sistema->retTranslate( 'userNotFound' );
                }
                $response['loggedUser'] = $_SESSION['login'];
            }
            else
            {
                $response['users'] = printUserAdministration( );
                $response['executed'] = false;
                $response['message'] = $sistema->retTranslate( 'pDenied' );
            }
        }
        return JSONencode( $response );
    }

    function changePassword( )
    {
        global $sistema;

        $filename = getUsersConfig( );
        $KYaml = new KYaml( $filename );
        if( isset( $KYaml->yaml['Users'][$_REQUEST['login']] ) )
        {
            if( $_REQUEST['self'] == 'true' )
            {
                if( $_REQUEST['login'] == $_SESSION['login'] )
                {
                    $KYaml = new KYaml( $filename );
                    $KYaml->yaml['Users'][$_REQUEST['login']]['password'] = md5( "KWebPortal" . $_REQUEST['password'] );
                    $KYaml->save( );
                    $response['users'] = printSelfAdministration( );

                    if( IS_GATEWAY )
                    {
                        $pwdfile = '/etc/vsftpd/passwd';
                        PwdfileManage( $pwdfile, $_REQUEST['login'], $_REQUEST['password'], 'add' );
                    }

                    $response['executed'] = true;
                    $response['message'] = $sistema->retTranslate( 'passwordChangedSuccess' );
                }
                else
                {
                    $response['users'] = printSelfAdministration( );
                    $response['executed'] = false;
                    $response['message'] = $sistema->retTranslate( 'pDenied' );
                }
            }
            else
            {
                if( $_SESSION['loginAccess']['administration'] == 'full' )
                {
                    $KYaml = new KYaml( $filename );
                    $KYaml->yaml['Users'][$_REQUEST['login']]['password'] = md5( "KWebPortal" . $_REQUEST['password'] );
                    $KYaml->save( );
                    $response['users'] = printUserAdministration( );

                    if( IS_GATEWAY )
                    {
                        $pwdfile = '/etc/vsftpd/passwd';
                        PwdfileManage( $pwdfile, $_REQUEST['login'], $_REQUEST['password'], 'add' );
                    }

                    $response['executed'] = true;
                    $response['message'] = $sistema->retTranslate( 'passwordChangedSuccess' );
                }
                else
                {
                    $response['users'] = printUserAdministration( );
                    $response['executed'] = false;
                    $response['message'] = $sistema->retTranslate( 'pDenied' );
                }
            }
        }
        else
        {
            $response['users'] = printUserAdministration( );
            $response['executed'] = false;
            $response['message'] = $sistema->retTranslate( 'userNotFound' );
        }
        return JSONencode( $response );

    }

    function saveModifications( )
    {
        global $sistema;

        $filename = getUsersConfig( );
        if( file_exists( $filename ) )
        {
            if( $_SESSION['loginAccess']['administration'] == 'full' )
            {
                $KYaml = new KYaml( $filename );
                $data = $_REQUEST['data'];
                $data = explode( "@", $data );
                for( $i = 0; $i < sizeof( $data ); $i++ )
                {
                    $user = explode( "|", $data[$i] );
                    $login = $user[0];
                    if( isset( $KYaml->yaml['Users'][$login] ) )
                    {
                        $KYaml->yaml['Users'][$login]['configuration'] = $user[1];
                        $KYaml->yaml['Users'][$login]['monitoring'] = $user[2];
                        $KYaml->yaml['Users'][$login]['diagnostic'] = $user[3];
                        $KYaml->yaml['Users'][$login]['administration'] = $user[4];
                    }
                    $KYaml->save( );
                }
                $response['users'] = printUserAdministration( );
                $response['executed'] = true;
                $response['message'] = $sistema->retTranslate( 'modificationsSavedSuccess' );
                $response['loggedUser'] = $_SESSION['login'];
            }
            else
            {
                $response['users'] = printUserAdministration( );
                $response['executed'] = false;
                $response['message'] = $sistema->retTranslate( 'pDenied' );
            }
            return JSONencode( $response );
        }
    }

    function printAdminInterface( )
    {
        $buff = '';
        if( isset( $_SESSION['login'] ) )
        {
            if( $_SESSION['loginAccess']['administration'] == 'full' )
                $buff .= printUserAdministration( );
            else
                $buff .= printSelfAdministration( );
        }
        return $buff;
    }

    function printSelfAdministration( )
    {
        global $sistema;

        $buff = '';

        $buff .= "<div id='saved_notice'><span></span></div>";
        $buff .= "<div id ='divNewPassword' style='display: block;'>";
        $buff .= "<fieldset><legend>Redefinir senha</legend><br>";

        $buff .= "<center><div id='newUserIntern'>";
        $buff .= $sistema->retTranslate( 'user' );
        $buff .= "<input id='loginNewPassword' type='text' disabled='disabled' value='" . $_SESSION['login'] . "'/><br>";

        $buff .= $sistema->retTranslate( 'newPassword' ) . "<input id='newPassword1' type='password' value=''/><br>";
        $buff .= $sistema->retTranslate( 'repetePassword' ) . "<input id='newPassword2' type='password' value=''/><br>";
        $buff .= "</div>";

        $buff .= "<div id='divNewPasswordButtons'>";
        $buff .= "<br><input type='button' value='" . $sistema->retTranslate( 'save' ) . "' onclick='changePassword(true);' />";
        $buff .= "</div></center>";
        $buff .= "</fieldset>";
        $buff .= "</div>";

        return $buff;
    }

    function printUserAdministration( )
    {
        global $sistema;
        $app = KSystem::getInstance( );

        $buff = '';

        if( IS_GATEWAY && !$app->authenticationUsingChallengeResponse() )
        {
            $buff .= printGatewayButtons( );
        }

        $buff .= "<div id='saved_notice'><span></span></div>";

        $buff .= "<div id= 'divNewPassword'>";
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'changePassword' ) . "</legend>";

        $buff .= "<center>";
        $buff .= "<div id='newUserIntern'>";

        $buff .= "<table class='simpleTable'>";
        $buff .= "<tr><td class='textAlignRight'>";
        $buff .= "<label for='loginNewPassword' >" . $sistema->retTranslate( 'user' ) . "</label>";
        $buff .= "</td>";
        $buff .= "<td class='textAlignLeft'>";
        $buff .= "<input id='loginNewPassword' type='text' disabled='disabled' value=''/><br>";
        $buff .= "</td></tr>";

        $buff .= "<tr><td class='textAlignRight'>";
        $buff .= "<label for='newPassword1' >" . $sistema->retTranslate( 'newPassword' ) . "</label>";
        $buff .= "</td>";
        $buff .= "<td class='textAlignLeft'>";
        $buff .= "<input id='newPassword1' type='password' value=''/>";
        $buff .= "</td>";
        $buff .= "<tr><td class='textAlignRight'>";
        $buff .= "<label for='newPassword2' >" . $sistema->retTranslate( 'repetePassword' ) . "</label>";
        $buff .= "</td>";
        $buff .= "<td class='textAlignLeft'><input id='newPassword2' type='password' value=''/>";
        $buff .= "</td></tr>";
        $buff .= "</table>";

        $buff .= "</div><br>";

        $buff .= "<div id='divNewPasswordButtons'>";
        $buff .= "<input type='button' value='" . $sistema->retTranslate( "save" ) . "' onclick='changePassword(false);' />";
        $buff .= "<input type='button' value='" . $sistema->retTranslate( "cancel" ) . "' onclick='closeChangePassword();' />";
        $buff .= "</div>";
        $buff .= "</center>";

        $buff .= "</fieldset>";
        $buff .= "</div>";

        $buff .= "<div id= 'divNewUser'>";
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'newUser' ) . "</legend>";
        $buff .= "<center><div id= 'divNewUserDados'>" . $sistema->retTranslate( "user" );
        $buff .= "<input class='marginBottom5px marginLeft3px' type='text' value='' id='user'><br>" . $sistema->retTranslate( "password" );
        $buff .= "<input class='marginBottom5px marginLeft3px' type='password' value='' id='password1'><br>" . $sistema->retTranslate( "repetePassword" );
        $buff .= "<input class='marginBottom5px marginLeft3px' type='password' value='' id='password2'><br>";
        $buff .= "</div><br>";
        $buff .= "<table id='tabelaUsuarioNovo' border='1' class='zebra marginBottom10px' ><thead>";
        $buff .= "<tr>";
        $buff .= "<th>" . $sistema->retTranslate( "configuration" ) . "</th>";
        $buff .= "<th >" . $sistema->retTranslate( "monitoring" ) . "</th>";
        $buff .= "<th>" . $sistema->retTranslate( "diagnostic" ) . "</th>";
        $buff .= "<th>" . $sistema->retTranslate( "administration" ) . "</th>";
        $buff .= "</tr></thead><tbody>";
        $buff .= "<tr>";
        $buff .= "<td><select class='combo' id='newUserConfig'><option value='none'>none</option><option value='full'>full</option></select></td>";
        $buff .= "<td><select class='combo' id='newUserMonitoring'><option value='none'>none</option><option value='read'>read</option><option value='full'>full</option></select></td>";
        $buff .= "<td><select class='combo' id='newUserDiagnostic'><option value='none'>none</option><option value='full'>full</option></select></td>";
        $buff .= "<td><select class='combo' id='newUserAdmin'><option value='none'>none</option><option value='full'>full</option></select></td>";
        $buff .= "</tr>";
        $buff .= "</tbody></table>";

        $buff .= "<input type='button' value='" . $sistema->retTranslate( "save" ) . "' onclick='saveNewUser();' />";
        $buff .= "<input type='button' value='" . $sistema->retTranslate( "clear" ) . "' onclick='clearNewUserData();'/>";
        $buff .= "<input type='button' value='" . $sistema->retTranslate( 'back' ) . "' onclick='hideNewUser();'/>";

        $buff .= "</center></fieldset>";
        $buff .= "</div>";

        $buff .= "<div id= 'divUsers'>";
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'systemUsers' ) . "</legend><br>";

        $users = array( );
        $filename = getUsersConfig( );
        if( file_exists( $filename ) )
        {
            $KYaml = new KYaml( $filename );
            $users = $KYaml->yaml['Users'];
        }
        if( sizeof( $users ) < 1 )
            echo $sistema->retTranslate( 'noUsers' ) . "<br><br>";
        else
        {
            $buff .= "<table class='zebra' id='users' border='1'><thead>";
            $buff .= "<tr>";
            $buff .= "<th class='th-users' >" . $sistema->retTranslate( "user" ) . "</td>";
            $buff .= "<th class='th-configuration'>" . $sistema->retTranslate( "configuration" ) . "</td>";
            $buff .= "<th class='th-monitoring'>" . $sistema->retTranslate( "monitoring" ) . "</td>";
            $buff .= "<th class='th-diagnostic'>" . $sistema->retTranslate( "diagnostic" ) . "</td>";
            $buff .= "<th class='th-administration'>" . $sistema->retTranslate( "administration" ) . "</td>";
            $buff .= "<th class='th-options'>" . $sistema->retTranslate( "options" ) . "</td>";
            $buff .= "</tr></thead><tbody>";

            $cont = 0;
            foreach( $users as $k => $v )
            {
                $a0 = '';
                $a1 = '';
                $c0 = '';
                $c1 = '';
                $d0 = '';
                $d1 = '';
                $m0 = '';
                $m1 = '';
                $m2 = '';

                switch ($v['configuration'])
                {
                    case 'none':
                        $c0 = 'selected';
                        break;
                    case 'full':
                        $c1 = 'selected';
                        break;
                }
                switch ($v['monitoring'])
                {
                    case 'none':
                        $m0 = 'selected';
                        break;
                    case 'read':
                        $m1 = 'selected';
                        break;
                    case 'full':
                        $m2 = 'selected';
                        break;
                }
                switch ($v['diagnostic'])
                {
                    case 'none':
                        $d0 = 'selected';
                        break;
                    case 'full':
                        $d1 = 'selected';
                        break;
                }
                switch ($v['administration'])
                {
                    case 'none':
                        $a0 = 'selected';
                        break;
                    case 'full':
                        $a1 = 'selected';
                        break;
                }

                if( $_SESSION['login'] === $k )
                    $userLogged = true;
                else
                    $userLogged = false;

                $buff .= "<tr>";
                $buff .= "<td id='login-user-$cont'>" . $k . "</td>";
                $buff .= "<td><select class='combo' id='config-user-$cont'><option $c0 value='none'>none</option><option $c1 value='full'>full</option></select></td>";
                $buff .= "<td><select class='combo' id='monitoring-user-$cont'><option $m0 value='none'>none</option><option $m1 value='read'>read</option><option $m2 value='full'>full</option></select></td>";
                $buff .= "<td><select class='combo' id='diagnostic-user-$cont'><option $d0 value='none'>none</option><option $d1 value='full'>full</option></select></td>";

                if( $userLogged )
                    $buff .= "<td><select disabled class='combo' id='admin-user-$cont'><option $a0 value='none'>none</option><option $a1 value='full'>full</option></select></td>";
                else
                    $buff .= "<td><select class='combo' id='admin-user-$cont'><option $a0 value='none'>none</option><option $a1 value='full'>full</option></select></td>";

                $buff .= "<td><img src='/imagens/changePassword.png' width='20' height='20' border='0' class='cursorHand' title='" . $sistema->retTranslate( 'changePassword' ) . "' onclick=\"showChangePassword('$k');\" border='0'>";

                if( $userLogged )
                    $buff .= "<img width='20' height='20' border='0' src='/imagens/cantRemove.png' border='0' title='" . $sistema->retTranslate( 'cantRemoveUser' ) . "'>";
                else
                    $buff .= "<img width='20' height='20' border='0' src='/imagens/remove.png' class='cursorHand' title='" . $sistema->retTranslate( 'removeUser' ) . "' onclick=\"removeUser('$k');\" border='0'>";

                $buff .= "</tr>";
                $cont++;
            }
            $buff .= "</tbody></table><br><br>";

            $buff .= '<div class="floatRight" >';
            $buff .= "<input type='button' value='" . $sistema->retTranslate( 'saveModifications' ) . "' onclick='saveModifications();' />";

        }
        $buff .= "<input type='button' value='" . $sistema->retTranslate( 'newUser' ) . "' onclick='openNewUser();' />";
        $buff .= '</div>';

        $buff .= "</fieldset>";
        $buff .= "</div>";

        if( !$app->authenticationUsingChallengeResponse() )
        {
            $buff .= printLicenseManager( );
            $buff .= printHardwareID( );
        }

        if( IS_GATEWAY && !$app->authenticationUsingChallengeResponse() )
        {
            $hn = php_uname( 'n' );
            $buff .= '<div id="remote-shell-content" style="display: none;">';
            $buff .= "<p>{$app->translate( 'remote-shell-help' )}</p><input type='button' value='{$app->translate( 'remote-shell-download-key' )}' id='remote-shell-download-key' />";
            $buff .= '</div>';
            $buff .= printProvisioning( );
            $buff .= printFirmwareUpdate( );
        }

        return $buff;
    }

    function printHardwareID( )
    {
        $buff = "<div id='hardware-id'><fieldset><legend>Hardware ID</legend>";
        $buff .= "<table border='1' id='hardware-id-tbl' class='zebra'><tr><td class='combo'>";

        $prog = PHP_OS == "WINNT" ? KROOT . '\\..\\..\\Tools\\kwebhelper.exe' : '/usr/sbin/kwebhelper';

        if( !file_exists( $prog ) )
        {
            $buff .= "Tool necessary for obtaining Hardware ID was not found.";
        }
        else
        {
            exec( $prog . ' gethardwareid', $data );
            $buff .= $data[0];
        }

        $buff .=  "</td></tr></table></fieldset></div>";
        return $buff;
    }

    function printLicenseManager( )
    {
        require_once KROOT . '/classes/KLicense.php';

        $app = KSystem::getInstance( );
        $kyaml = new KYaml( "{$app->getConfigDir( )}/devices.yaml" );
        $yaml = $kyaml->getYaml( );

        if( array_key_exists( 'Devices', $yaml ) )
        {
            $devices = &$yaml['Devices'];
        }
        else
        {
            $devices = array( );
        }

        $buf = "<div id='license-manager'><fieldset><legend>{$app->translate( 'license-manager' )}</legend>";
        try
        {
            $manager = new KLicenseManager( );
            $licenses = $manager->getLicenses( );

            if( count( $licenses ) == 0 )
            {
                $buf .= "<div>{$app->translate( 'license-manager-empty-list')}</div><br />";
            }
            else
            {
                $buf .= "<table border='1' class='zebra'><thead><tr><th width='10%'>ID</th><th width='15%'>{$app->translate( 'license-manager-serial-number' )}</th><th width='15%'>{$app->translate( 'license-manager-expiration-date' )}</th><th>{$app->translate( 'license-manager-type' )}</th><th>{$app->translate( 'license-manager-customer-info' )}</th><th width='5%'>{$app->translate( 'options' )}</th></tr></thread><tbody>";
                $c = 0;
                foreach( $licenses as $license )
                {
                    $licenseinfo = '';
                    foreach( $license->getKeys() as $key )
                    {
                        $val = $license->__get( $key );
                        $licenseinfo .= "<span class='key'>{$key}</span>: <span class='value'>{$val}</span><br />";
                    }

                    $cls = '';

                    $_expires = $license->getExpires( );
                    $_expires = "{$_expires[2]}/{$_expires[1]}/{$_expires[0]}";

                    if( $license->isValid() === false )
                    {
                        $img = 'expired';
                        $cls .= ' not-configured';
                        $reason = $app->translate( 'license-manager-device-not-configured' );
                        $licenseinfo = "<span class='expired value'>{$reason}</span><br />{$licenseinfo}";
                    }
                    elseif( $license->isExpired( ) )
                    {
                        $img = 'expired';
                        $cls .= ' expired';
                        $reason = $app->translate( 'license-manager-expired' );
                        $licenseinfo = "<span class='expired value'>{$reason}</span><br />{$licenseinfo}";
                    }
                    elseif( $license->willExpire( ) )
                    {
                        $img = 'ok';
                        $cls .= ' will-expire';
                        $reason = 'Ok';
                    }
                    elseif( !$license->hasSignature( ) )
                    {
                        $img = 'expired';
                        $cls .= ' not-configured';
                        $reason = $app->translate( 'license-manager-no-signature' );
                        $licenseinfo = "<span class='expired value'>{$reason}</span><br />{$licenseinfo}";
                    }
                    else
                    {
                        $img = 'on';
                        $reason = 'Ok';
                    }
                    $buf .= "<tr class='license-manager-row {$cls}'><td>";
                    $buf .= "<div title='{$reason}' class='license-status license-{$img}'>&nbsp;</div>";
                    $buf .= "<span>{$license->id}</span>";
                    $buf .= "</td><td>{$license->formatted_serial_number()}</td><td>{$_expires}</td><td>{$license->getTypeAsString( ', ', '%n(%v)' )}</td><td>{$license->customer_info}</td>";
                    $buf .= "<td><img src='/imagens/download.png' name='{$license->getFilename()}' class='cursorHand license-manager-download' title='{$app->translate( 'download' )}' /><img src='/imagens/remove.png' name='{$license->getFilename()}' class='cursorHand license-manager-delete' title='{$app->translate( 'delete' )}' /></td>";
                    $buf .= '</tr>';
                    $buf .= "<tr id='license-manager-row-{$license->id}' class='info'><td colspan='6'><div>{$licenseinfo}</div></td></tr>";

                    $c++;
                }
                unset( $c );
                $buf .= '</tbody></table><br /><br />';
            }

            $buf .= "<form class='textAlignCenter' action='?rawmode=yes&ajaxTo=uploadLicense' enctype='multipart/form-data' method='POST' id='license-manager-upload'>{$app->translate( 'license-manager-upload' ) }: <input type='file' name='license-manager-file' /> <input type='submit' value='{$app->translate( 'send' ) }' /></form><br>";
            // ugly (very ugly) initialization
            $buf .= '<script type="text/javascript">$( initLicenseManager );</script>';

        }
        catch( KLicenseManagerException $e )
        {
            $buf .= "<div>{$app->translate( $e->getMessage() )}</div><br />";
        }
        return "{$buf}</fieldset></div>";
    }

    function printProvisioning( )
    {
        $app = KSystem::getInstance( );

        $buf = "<div id='provisioning'><fieldset id='upload-provisioning'><legend>{$app->translate( 'provisioning' )}</legend>";
        $buf .= "<table class='provisioning'><tr><td align='center'>";
        $buf .= "<button id='provisioning-download'>{$app->translate( 'provisioning-download' )}</button>";
        $buf .= "</td></tr><tr class='empty'><td>&nbsp;</td></tr><tr><td align='center'>";
        $buf .= "<form id='provisioning-upload' name='uploadform'>";
        $buf .= "{$app->translate( 'provisioning-upload' ) }: ";
        $buf .= "<input id='provisioning-upload-file' type='file' name='provisioning-upload-file' />";
        $buf .= "<button id='provisioning-upload-send'>{$app->translate( 'send' )}</button></form>";
        $buf .= "</td></tr></table>";

        $buf .= '<script type="text/javascript">configurationFilesSetup();</script>';
        return "{$buf}</fieldset></div>";
    }

    function printGatewayButtons( )
    {
        $app = KSystem::getInstance( );

        $model  = "";
        $serial = "";
        $hardware_id = "";

        if( !isset( $_SESSION['gateway-model'] ) )
        {
            exec( "/usr/sbin/kgateway --pretty-model", $moutput, $excode );
            if( $excode == 0 )
            {
                $model = $moutput[0];
            }

            $_SESSION['gateway-model'] = $model;
        }
        else
        {
            $model = $_SESSION['gateway-model'];
        }
        if( !isset( $_SESSION['gateway-serial'] ) )
        {
            exec( "/bin/hostname -s", $soutput, $excode );
            if( $excode == 0 )
            {
                $serial = $soutput[0];
            }
            $_SESSION['gateway-serial'] = $serial;
        }
        else
        {
            $serial = $_SESSION['gateway-serial'];
        }
        if( !isset( $_SESSION['gateway-hardware_id'] ) )
        {
            exec( "/usr/sbin/kwebhelper gethardwareid", $houtput, $excode );
            if( $excode == 0 )
            {
                $hardware_id = $houtput[0];
                $_SESSION['gateway-hardware_id'] = $hardware_id;
            }
        }
        else
        {
            $hardware_id = $_SESSION['gateway-hardware_id'];
        }

        $buff  = "<div id='gateway-admin-buttons-container'>";
        $buff .=    "<input type='button' id='gateway-mib' onclick='downloadMIB()' value='{$app->translate( 'gateway-mib' )}' />";
        $buff .=    "<input type='button' id='gateway-info' onclick='showGatewayInfo()' value='{$app->translate( 'gateway-info' )}' />";
        $buff .=    "<input type='button' id='remote-shell' onclick='remoteShellGW()' value='{$app->translate( 'remote-shell' )}' />";
        $buff .=    "<input type='button' id='gateway-shutdown' onclick='shutdownGW()' value='{$app->translate( 'gateway-shutdown' )}' />";
        $buff .=    "<input type='button' id='gateway-reboot' onclick='rebootGW()' value='{$app->translate( 'gateway-reboot' )}' />";
        $buff .=    "<div id='gateway-admin-buttons-wait'>";
        $buff .=        "<div class='shutdown'>{$app->translate( 'gateway-shutdown-wait' )}</div>";
        $buff .=        "<div class='reboot'>{$app->translate( 'gateway-reboot-wait' )}</div>";
        $buff .=        "<br />";
        $buff .=        "<div class='countdown'>&nbsp;</div>";
        $buff .=    "</div>";
        $buff .=    "<div id='gateway-info-show'>";
        $buff .=        "<table id='gateway-info-table' class='zebra'>";
        if ( $model !== "" )
        {
            $buff .=        "<tr>";
            $buff .=            "<td>{$app->translate( 'Modelo' )}:</td>";
            $buff .=            "<td>{$model}</td>";
            $buff .=        "</tr>";
        }
        if ( $serial !== "" )
        {
            $buff .=        "<tr>";
            $buff .=            "<td>Serial:</td>";
            $buff .=            "<td>{$serial}</td>";
            $buff .=        "</tr>";
        }
        if ( $hardware_id !== "" )
        {
            $buff .=        "<tr>";
            $buff .=            "<td>Hardware ID:</td>";
            $buff .=            "<td>{$hardware_id}</td>";
            $buff .=        "</tr>";
        }
        $buff .=        "</table>";
        $buff .=    "</div>";
        $buff .= "</div>";
        $buff .= "<div style='clear: both;'>&nbsp;</div>";

        return $buff;
    }

    function printFirmwareUpdate( )
    {
        //@formatter:off
        /*
         $app = KSystem::getInstance( );
         $buf = "<fieldset id='gateway-firmware-update'><legend>{$app->translate(
         'gateway-firmware-update' )}</legend>";

         $buf .= "<form action='?rawmode=yes&ajaxTo=uploadFirmware'
         enctype='multipart/form-data' method='POST'
         id='gateway-firmware-upload'>{$app->translate( 'gateway-firmware-upload'
         ) }: <input type='file' name='gateway-firmware-file' /> <input
         type='submit' value='{$app->translate( 'send' ) }' /> <div
         id='gateway-firmware-progress'>&nbsp;</div></form>";
         // ugly (very ugly) initialization
         //$buf .= '<script type="text/javascript">$( initFirmwareUpdate
         // );</script>';
         $buf .= '</fieldset>';
         return $buf;
         */
        //@formatter:on
        global $sistema;

        $buff = '';

        $buff .= "<div id='saved_notice'><span></span></div>";
        $buff .= "<fieldset id='upload-firmware'><legend>" . $sistema->retTranslate( 'updateFirmware' ) . "</legend>";

        $buff .= "<meta name='viewport' content='width=device-width'>";
        $buff .= "<link rel='stylesheet' href='./Upload/css/bootstrap.min.css'>";
        $buff .= "<link rel='stylesheet' href='./Upload/css/jquery.fileupload-ui.css'>";
        $buff .= "<div class='container'>";
        $buff .= "<br>";

        $buff .= "<form id='fileupload' action='./Upload/server/php/' method='POST' enctype='multipart/form-data'>";
        $buff .= "<div class='row fileupload-buttonbar'>";
        $buff .= "<div class='span7'>";
        $buff .= "<span class='btn btn-success fileinput-button'>";
        $buff .= "<button type='button' onclick='$(\"#gateway-select-firmware\").click()'>" . $sistema->retTranslate( 'selectFile' ) . "</button>";
        $buff .= "<input type='file' name='files[]' class='displayNone' id='gateway-select-firmware' multiple>";
        $buff .= "</span>";

        $buff .= "<button type='submit' class='btn btn-primary start'>";
        $buff .= "<span>" . $sistema->retTranslate( 'addAllFiles' ) . "</span>";
        $buff .= "</button>";
        $buff .= "<button type='reset' class='btn btn-warning cancel'>";
        $buff .= "<span>" . $sistema->retTranslate( 'cancellAllFiles' ) . "</span>";
        $buff .= "</button>";
        $buff .= "<button type='button' class='btn btn-danger delete'>";
        $buff .= "<span>" . $sistema->retTranslate( 'delete' ) . "</span>";
        $buff .= "</button>";
        $buff .= "<input type='checkbox' class='toggle'>";
        $buff .= "</div>";
        $buff .= "<div class='span5'>";
        $buff .= "<div class='progress progress-success progress-striped active fade'>";
        $buff .= "<div class='bar' style='width:0%;'></div>";
        $buff .= "</div>";
        $buff .= "</div>";
        $buff .= "</div>";
        $buff .= "<div class='fileupload-loading'></div>";
        $buff .= "<br>";
        $buff .= "<table class='simpleTable table table-striped zebra'><tbody class='files' data-toggle='modal-gallery' data-target='#modal-gallery'></tbody></table>";
        $buff .= "</form>";
        $buff .= "<br>";
        $buff .= "</div>";

        $buff .= "<div id='modal-gallery' class='modal modal-gallery hide fade'>";
        $buff .= "<div class='modal-header'>";
        $buff .= "<a class='close' data-dismiss='modal'>&times;</a>";
        $buff .= "<h3 class='modal-title'></h3>";
        $buff .= "</div>";
        $buff .= "<div class='modal-body'><div class='modal-image'></div></div>";
        $buff .= "<div class='modal-footer'>";
        $buff .= "<a class='btn modal-download' target='_blank'>";
        $buff .= "<i class='icon-download'></i>";
        $buff .= "<span>Download</span>";
        $buff .= "</a>";
        $buff .= "<a class='btn btn-success modal-play modal-slideshow' data-slideshow='5000'>";
        $buff .= "<i class='icon-play icon-white'></i>";
        $buff .= "<span>Slideshow</span>";
        $buff .= "</a>";
        $buff .= "<a class='btn btn-info modal-prev'>";
        $buff .= "<i class='icon-arrow-left icon-white'></i>";
        $buff .= "<span>Previous</span>";
        $buff .= "</a>";
        $buff .= "<a class='btn btn-primary modal-next'>";
        $buff .= "<span>Next</span>";
        $buff .= "<i class='icon-arrow-right icon-white'></i>";
        $buff .= "</a>";
        $buff .= "</div>";
        $buff .= "</div>";

        //@formatter:off
        $buff .= "<script id='template-upload' type='text/x-tmpl'>
            {% for (var i=0, file; file=o.files[i]; i++) { %}
                <tr class='template-upload fade'>
                    <td class='preview'><span class='fade'></span></td>
                    <td class='name'><span>{%=file.name%}</span></td>
                    <td class='size'><span>{%=o.formatFileSize(file.size)%}</span></td>
                    {% if (file.error) { %}
                        <td class='error' colspan='2'><span class='label label-important'>{%=locale.fileupload.error%}</span> {%=locale.fileupload.errors[file.error] || file.error%}</td>
                    {% } else if (o.files.valid && !i) { %}
                        <td>
                            <div class='progress progress-success progress-striped active'><div class='bar' style='width:0%;'></div></div>
                        </td>
                        <td class='start'>{% if (!o.options.autoUpload) { %}
                            <button class='btn btn-primary'>
                                <span>" . $sistema->retTranslate( 'send' ) . "</span>
                            </button>
                        {% } %}</td>
                    {% } else { %}
                        <td colspan='2'></td>
                    {% } %}
                    <td class='cancel'>{% if (!i) { %}
                        <button class='btn btn-warning'>
                            <span>" . $sistema->retTranslate( 'cancel' ) . "</span>
                        </button>
                    {% } %}</td>
                </tr>
            {% } %}
        </script>

        <script id='template-download' type='text/x-tmpl'>
        {% for (var i=0, file; file=o.files[i]; i++) { %}
            <tr class='template-download fade'>
                {% if (file.error) { %}
                    <td></td>
                    <td class='name'><span>{%=file.name%}</span></td>
                    <td class='size'><span>{%=o.formatFileSize(file.size)%}</span></td>
                    <td class='error' colspan='2'><span class='label label-important'>
                    " . $sistema->retTranslate( 'error' ) . "
                    </span><!--{%=locale.fileupload.errors[file.error] || file.error%}--></td>
                {% } else { %}
                    <td class='preview'>{% if (file.thumbnail_url) { %}
                        <a title='{%=file.name%}' rel='gallery' download='{%=file.name%}'><img src='{%=file.thumbnail_url%}'></a>
                    {% } %}</td>
                    <td class='name'>
                        <a title='{%=file.name%}' rel='{%=file.thumbnail_url&&'gallery'%}' download='{%=file.name%}'>{%=file.name%}</a>
                    </td>
                    <td class='size'><span>{%=o.formatFileSize(file.size)%}</span></td>
                    <td colspan='2'></td>
                {% } %}
                <td class='delete'>
                    <button class='btn btn-danger' data-type='{%=file.delete_type%}' data-url='{%=file.delete_url%}'>
                        <span>" . $sistema->retTranslate( 'delete' ) . "</span>
                    </button>
                    <input type='checkbox' name='delete' value='1'>
                </td>
                <td class='ss'>

                {% if (!file.error) { %}
                    <input type='button' onclick=\"RunFirmwareUpdate('{%=file.name%}');\" name='buttonRunScript' value='" . $sistema->retTranslate( 'update' ) . "' />
                {% } %}

            </td>
            </tr>
        {% } %}";
        //@formatter:on
        $buff .= "</script>";

        //TODO: remove the duplicated jquery
        // $buff .= "<script src='./Upload/js/jquery.min.js'></script>";
        $buff .= "<script src='./Upload/js/jquery.migrate.min.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/vendor/jquery.ui.widget.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/tmpl.min.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/load-image.min.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/canvas-to-blob.min.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/jquery.iframe-transport.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/jquery.fileupload.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/jquery.fileupload-ip.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/jquery.fileupload-ui.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/locale.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/main.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/bootstrap.min.js'></script>";
        $buff .= "<script type='text/javascript' src='./Upload/js/bootstrap-image-gallery.min.js'></script>";
        $buff .= '<script type="text/javascript" src="/js/jquery/jquery.ui.js"></script>';
        // $buff .= '<script type="text/javascript" src="/js/jquery/jquery.ui.draggable.js"></script>';
        // $buff .= '<script type="text/javascript" src="/js/jquery/jquery.ui.sortable.js"></script>';
        // $buff .= '<script type="text/javascript" src="/js/jquery/jquery.ui.widget.js"></script>';
        $buff .= '<script type="text/javascript" src="/js/jquery/jquery.form.js"></script>';

        if( IS_GATEWAY )
        {
            $buff .= '<script type="text/javascript" src="/js/jquery/jquery.download.js"></script>';
            $buff .= '<script type="text/javascript" src="/js/jquery/jquery.cookie.js"></script>';
        }

        $buff .= "</fieldset>";

        return $buff;
    }

    /** $action pode ser:
     *     'add' -> Adiciona ou altera senha no arquivo
     *     'del' -> Deleta senha do arquivo
     *     'clean' -> Deleta TODAS as senhas do arquivo
     */
    function PwdfileManage( $file, $user, $pass, $action )
    {
        $lines = file( $file );
        foreach( $lines as $i => $line )
        {
            $line_user = strtok( $line, ':' );
            $line_pass = strtok( ':' );
            if( !$line_user || !$line_pass )
                continue;
            else if( $user == $line_user || $action == 'clean' )
                unset( $lines[$i] );
        }
        if( $action != 'del' && $action != 'clean' )//se for diferente de
        {
            $crypt_pass = crypt( $pass, base64_encode( $pass ) );
            $lines[] = "$user:$crypt_pass\n";
        }
        file_put_contents( $file, implode( $lines ) );
    }

    function runFirmwareUpdate( )
    {
        global $sistema;

        $firmwareUpdate = false;
        $buff = '';
        if( isset( $_REQUEST['update'] ) )
        {
            $firmwareUpdate = $_REQUEST['update'];
            exec( "/usr/sbin/khomp-sudo /usr/sbin/kgateway-upgrade -f '{$firmwareUpdate}' &" );

            $buff .= "<div id='saved_notice' style='display: block;'>";
            $buff .= "<span>" . $sistema->retTranslate( 'awaiting update' ) . "</span>";
            $buff .= "<span id='time-slot'>60</span>s";
            $buff .= "</div>";
        }
        return $buff;
    }

    function deleteLicense( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );
        $name = array_key_exists( 'name', $_POST ) ? $_POST['name'] : null;
        $reply = array( 'success' => false, 'message' => $app->translate( 'license-error-delete' ) );

        if( !is_null( $name ) )
        {
            require_once KROOT . '/classes/KLicense.php';

            try
            {
                $manager = new KLicenseManager( );
                $manager->deleteLicense( $name );
                $reply = array( 'success' => true, 'message' => $app->translate( 'license-deleted' ) );
            }
            catch( KLicenseManagerException $e )
            {
                $reply['message'] = $app->translate( $e->getMessage( ) );
            }
            catch( KLicenseException $e )
            {
                $reply['message'] = $app->translate( $e->getMessage( ) );
            }
        }
        return JSONencode( $reply );
    }

    function uploadLicense( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );
        require_once KROOT . '/classes/KLicense.php';
        $reply = array( 'success' => false, 'message' => $app->translate( 'license-error-upload' ) );

        if( array_key_exists( 'license-manager-file', $_FILES ) )
        {
            try
            {
                $manager = new KLicenseManager( );
                $manager->uploadLicense( $_FILES['license-manager-file'] );
                $reply = array( 'success' => true, 'message' => $app->translate( 'license-uploaded' ) );
            }
            catch( KLicenseManagerException $e )
            {
                $reply['message'] = $app->translate( $e->getMessage( ) );
            }
            catch( KLicenseException $e )
            {
                $reply['message'] = $app->translate( $e->getMessage( ) );
            }
        }
        return JSONencode( $reply );
    }
