<?php
    @session_start( );

    $AjaxFunctions['createDevice'] = 'createDevice';
    $AjaxFunctions['showManualCreateDevice'] = 'showManualCreateDevice';
    $AjaxFunctions['showAutoCreateDevice'] = 'showAutoCreateDevice';
    $AjaxFunctions['showDevices'] = 'showDevices';
    $AjaxFunctions['checkDevice'] = 'checkDevice';
    $AjaxFunctions['manualCreateDevice'] = 'manualCreateDevice';
    $AjaxFunctions['autoCreateDevice'] = 'autoCreateDevice';
    $AjaxFunctions['removeDevice'] = 'removeDevice';
    $AjaxFunctions['editDevice'] = 'editDevice';
    $AjaxFunctions['saveDevice'] = 'saveDevice';
    $AjaxFunctions['k3lReload'] = 'k3lReload';
    $AjaxFunctions['changeDeviceOrder'] = 'changeDeviceOrder';
    $AjaxFunctions['getAjaxProfiles'] = 'getAjaxProfiles';

    function changeDeviceOrder( )
    {
        Global $sistema;
        $deviceList = isset( $_REQUEST['deviceList'] ) ? $_REQUEST['deviceList'] : NULL;

        if( isset( $deviceList ) )
            $sistema->changeDeviceOrder( $deviceList );
    }

    function k3lReload( )
    {
        Global $sistema;
        $result = reload( 'k3lreload' );

        if( $result == 'OK' )
            return 'ok|' . $sistema->retTranslate( 'K3LRealoaded' );
        else
            return 'notok|' . $sistema->retTranslate( 'K3LNRunning' );
    }

    function showDevices( )
    {
        Global $sistema, $image_dir;

        $buff = '';

        $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . '/devices.yaml' );
        $data = $DevicesYAML->getYaml( );

        $data = $data['Devices'];
        $maxBoards = sizeof( $data );
        $columCount = 1;
        $deviceOriginalOrder = '';

        $buff .= '<div id="divDevices">';
        $buff .= '<fieldset id="deviceList">';
        $buff .= '<legend>' . $sistema->retTranslate( 'Devices' ) . '</legend>';

        if( $maxBoards > 0 )
        {
            $buff .= '<ul class="devList" id="sortableDevice">';
            for( $i = 0; $i < $maxBoards; $i++ )
            {
                $deactivated = false;
                $tmp = array_keys( $data[$i] );
                $serial = $tmp[0];

                if( $deviceOriginalOrder == '' )
                    $deviceOriginalOrder = $serial;
                else
                    $deviceOriginalOrder .= "|" . $serial;

                if( isset( $data[$i][3] ) && ($data[$i][3] > 22 || (($data[$i][3] === 0) && ($data[$i][4] === 0))) )
                {
                    $jsfunction = "onclick=\"alert('" . $sistema->retTranslate( "placaDesconhecida" ) . "');\"";
                    $img = "<img src='$image_dir/imagens/fail.png'/>";
                    $data[$i][1] = $sistema->retTranslate( "placaDesc" );
                }
                else
                {
                    $deactivated = $sistema->getDeactivatedE1( $serial );
                    $sentence = "";
                    if( $deactivated )
                        $sentence = $sistema->retTranslate( "E1Deactivated" );

                    if( @ereg( 'EBS', $data[$i][$serial]['Type'] ) && ($data[$i][$serial]['IP'] == '') )
                    {
                        $deactivated = true;
                        if( $sentence == "" )
                            $sentence = $sistema->retTranslate( "noIP" );
                        else
                            $sentence .= " | " . $sistema->retTranslate( "noIP" );
                    }

                    if( @ereg( 'EBS', $data[$i][$serial]['Type'] ) && checkIPConflict( $data[$i][$serial]['IP'], $serial, $DevicesYAML->getYaml( ) ) )
                    {
                        $deactivated = true;
                        if( $sentence == "" )
                            $sentence = $sistema->retTranslate( "IPConflict" );
                        else
                            $sentence .= " | " . $sistema->retTranslate( "IPConflict" );
                    }
                    $jsfunction = "onmousedown='getMousePosition(event);' onclick=\"checkDeviceOrder('$serial',event)\"";
                    $type = getDeviceType( $data[$i][$serial]['Type'] );
                    $img = "<img src='$image_dir/imagens/$type.png' />";

                }

                if( !IS_GATEWAY )
                {
                    $columDelete = '<table class="deleteDevice"><tr>';
                    $columDelete .= '<td></td>';
                    $columDelete .= '<td valign="top" width="5%">';
                    $columDelete .= "<a class='profile' href='#' onClick=\"javascript: removeDevice('$serial')\">X</a>";
                    $columDelete .= "</td>";
                    $columDelete .= "</tr></table>";
                }

                $buff .= "<li>";
                $buff .= "<input type='hidden' value='$serial' id='serial$i' />";
                $buff .= '<div class="listDevices" >';
                $buff .= '<div class="remove-device">';
                if( !IS_GATEWAY )
                    $buff .= "<a title='" . $sistema->retTranslate( 'removeDevice' ) . "' class='remove-device-icon' href='#' onClick=\"removeDevice('$serial');\">X</a>";

                $buff .= '</div>';
                $buff .= "<a class='cursorHand' $jsfunction>";
                $buff .= "<div class='img-device-holder'><img src='$image_dir/imagens/$type.png' /></div>";
                $buff .= "<div class='device-info-holder{$type}'>";

                $version = isset( $data[$i][$serial]['Version'] ) ? $data[$i][$serial]['Version'] : '';
                $buff .= '<div>' . $sistema->retTranslate( $data[$i][$serial]['Type'] ) . " {$version}</div>";
                $deactivated_img = $deactivated ? "<img id='pngAlert' src='$image_dir/imagens/alert.png' title='$sentence' >" : '';

                $buff .= '<div class="ip-holder">';
                $buff .= '<div class="marginTop5px marginBottom5px">' . $sistema->retTranslate( 'placas_Serial' ) . ": {$serial}" . $deactivated_img . '</div>';
                if( strpos( $data[$i][$serial]['Type'], 'EBS' ) !== FALSE )
                {
                    if( $data[$i][$serial]['IP'] != '' )
                        $buff .= '<div class="ip-holder">IP: ' . $data[$i][$serial]['IP'] . '</div>';
                    else
                        $buff .= '<div class="ip-holder">IP: <span class="red">' . $sistema->retTranslate( 'NConfigurado' ) . '</span></div>';
                }
                else
                    $buff .= '<br/>';

                $buff .= '</a></div>';
                $buff .= '</div>';
                $buff .= "</li>";
            }
            $buff .= "</ul>";
            $buff .= "<input type='hidden' value='$deviceOriginalOrder' id='originalDeviceOrder' />";
        }
        else
            $buff .= "<p>" . $sistema->retTranslate( 'noDevicesConfigured' ) . "</p>";

        $buff .= "</fieldset>";
        $buff .= "<br>";

        if( !IS_GATEWAY )
        {
            $buff .= '<div class="floatRight" >';
            $buff .= "<input type='button' id='bAutomatico' value='" . $sistema->retTranslate( "DetectarPlacas" ) . "' onClick='preCreateDevice();'>";
            $buff .= "<input type='button' id='bManual' value='" . $sistema->retTranslate( "AdicionarManualmente" ) . "' onClick='preManualCreateDevice();'>";
            $buff .= '</div>';
        }
        $buff .= "</div>";

        return $buff;
    }

    function showAutoCreateDevice( )
    {
        Global $sistema;
        $time = isset( $_REQUEST['time'] ) ? $_REQUEST['time'] : '';
        $buff = '';

        $buff .= "<fieldset id='deviceList'>";
        $buff .= "<legend>" . $sistema->retTranslate( 'Devices' ) . "</legend>";
        $buff .= getNotInstalledDevices( $time );
        $buff .= "</fieldset>";
        $buff .= "<br>";

        return $buff;
    }

    function showManualCreateDevice( )
    {
        Global $sistema, $invDevices, $boardNames;

        $return = '';
        $return .= '<table class="tableDeviceManual simpleTable">';
        $return .= '<tr>';
        $return .= '<td width="10%" align="left">' . $sistema->retTranslate( 'Serial' ) . '</td>';
        $return .= '<td width="90%" align="left">';
        $return .= '<input type="text" name="manualSerial" id="manualSerial" value="" onkeyup="validateSerial(this);" onmouseup="return serialMask(this, event);" onKeyPress="return serialMask(this, event);">';
        $return .= '<span id="serialResult"></span></td>';
        $return .= '</tr>';
        $return .= '<tr>';
        $return .= '<td valign="top" width="10%" align="left">' . $sistema->retTranslate( 'Modelo' ) . '</td>';
        $return .= '<td  width="90%" align="left">';
        $return .= "<a class='profile' href='#' onClick=\"changeArrow(this);showId('manualModulos');\">- " . $sistema->retTranslate( 'Modulos' ) . '</a>';
        $return .= '<fieldset id="manualModulos" style="display: block;">';
        $return .= getModuleDevices( );
        $disp = "style='display: none;'";
        $return .= '</fieldset><br>';
        $return .= "<a class='profile' href='#' onClick=\"changeArrow(this);showId('manualModular');\">+ " . $sistema->retTranslate( 'Modular' ) . '</a>';
        $return .= "<fieldset id='manualModular' {$disp}>";
        $return .= getModularDevices( );
        $return .= '</fieldset><br>';
        $return .= "<a class='profile' href='#' onClick=\"changeArrow(this);showId('manualPlacas');\">+ " . $sistema->retTranslate( 'BPlacas' ) . '</a>';
        $return .= "<fieldset id='manualPlacas' {$disp}>" . getBoardDevices( ) . "</fieldset><br>";
        $return .= '</td>';
        $return .= '</tr>';
        $return .= '<tr>';
        $return .= "<td colspan='2'>";
        $return .= '<div class="floatRight">';
        $return .= '<input type="button" id="buttonManualCreate" value="' . $sistema->retTranslate( 'Adicionar' ) . '" onClick="manualCreateDevice();">';
        $return .= '<input type="button" value="' . $sistema->retTranslate( 'back' ) . '" onClick="showDevices();">';
        $return .= '</div>';
        $return .= '</td>';
        $return .= '</table>';

        return $return;
    }

    function autoCreateDevice( )
    {
        Global $sistema;
        $serial = isset( $_REQUEST['serialGroup'] ) ? $_REQUEST['serialGroup'] : NULL;
        if( isset( $serial ) )
        {

            if( checkSerialIsAReplacer( $serial ) )
                return JSONencode( array( 'success' => false, 'message' => $sistema->retTranslate( 'SerialAlreadyConfiguredAsReplacer' ), 'content' => '' ) );

            $serialGroup = explode( '|', $serial );
            $seriais = array( );
            for( $x = 0; $x < sizeof( $serialGroup ); $x++ )
            {
                $deviceSerial = explode( ":", $serialGroup[$x] );
                $seriais[] = $deviceSerial[0];

                //boards
                if( sizeof( $deviceSerial ) == 1 )
                {
                    $sistema->createDevice( $deviceSerial[0] );
                    $dev = $sistema->getDevice( $deviceSerial[0] );
                    //ebs
                }
                elseif( sizeof( $deviceSerial ) == 2 )
                {
                    $extra = explode( ";", $deviceSerial[1] );
                    $sistema->createDevice( $deviceSerial[0], $extra );
                }

            }
            return JSONencode( array( 'success' => true, 'content' => sizeof( $seriais ) > 1 ? '' : $seriais[0] ) );
        }
    }

    function manualCreateDevice( )
    {
        Global $sistema;

        $serial = isset( $_REQUEST['serialGroup'] ) ? $_REQUEST['serialGroup'] : NULL;
        $deviceDef = isset( $_REQUEST['deviceDef'] ) ? $_REQUEST['deviceDef'] : NULL;

        if( isset( $serial ) && isset( $deviceDef ) )
        {
            if( strlen( $serial ) >= 3 )
            {
                $sistema->manualCreateDevice( $serial, $deviceDef );
                return JSONencode( array( 'success' => true, 'content' => $serial ) );
            }
            else
                return JSONencode( array( 'false' => true, 'content' => '', 'message' => $sistema->retTranslate( 'WSerial' ) ) );
        }
    }

    function checkDevice( )
    {
        Global $sistema;

        $serial = isset( $_REQUEST['serialGroup'] ) ? $_REQUEST['serialGroup'] : NULL;

        if( isset( $serial ) )
        {
            if( checkSerialIsAReplacer( $serial ) )
                return 2;

            $serials = $sistema->getDeviceSerials( );

            if( in_array( $serial, $serials ) )
                return 1;
            else
                return 0;
        }
        return '';
    }

    function removeDevice( )
    {
        Global $sistema;
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;

        if( isset( $serial ) )
            $sistema->deleteDevice( $serial );

        return $sistema->retTranslate( 'deviceRemoved' );
    }

    function editDevice( )
    {
        Global $sistema;
        $app = KSystem::getInstance( );

        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;

        $buff = '';

        if( isset( $serial ) )
        {
            $buff .= "<div id='deviceOpen'>";

            $DevicesYAML = new KYaml( $app->getConfigDir( ) . "/devices.yaml" );
            $dev = $DevicesYAML->getValue( $serial );

            $device = $app->translate( $dev['Type'] );

            $buff .= "<fieldset id='Device'>";
            $buff .= '<legend>' . $device . ' - ' . 'Serial ' . $serial . '</legend>';

            $isBoard = !isset( $dev['IP'] );
            if( isset( $dev['IP'] ) )
            {
                if( IS_GATEWAY )
                {
                    // OK, this is very, very, very ugly, but work as expected!
                    // Converting this table to input type=hidden will break the
                    // form validation (save button action)!
                    $buff .= '<table class=\'zebra displayNone\'>';
                }
                else
                {
                    $buff .= '<table class="zebra">';
                }
                $buff .= "<tbody><tr>";
                $buff .= '<td width="70%" class="textAlignLeft">' . $app->translate( 'deviceIP' ) . '</td>';
                // $buff .= "<td></td>";
                // $buff .= "<td></td>";
                $buff .= "<td width='30%' class='textAlignCenter'>";
                $ip = $dev['IP'];
                $buff .= "<input id='IP' type='text' onclick='validateIP(this)' onkeyup='validateIP(this)' onmouseup='validateIP(this)' onkeydown='return maskIP(event, this);' value='$ip' name='IP'>";
                $buff .= "</td>";
                $buff .= "</tr>";

                if( isset( $dev['Links'] )  && !strpos( $dev['Type'], 'HI' ) !== FALSE)
                {
                    $LOM = trim( $dev['LinkOperationMode'] );
                    $disabled = $LOM == '' ? '' : 'disabled="disabled"';
                    $buff .= '<tr><td class="textAlignLeft">' . $app->translate( 'LinkOperationMode' ) . '</td>';
                    $buff .= '<td class="textAlignCenter">';
                    $buff .= "<select {$disabled} id='LinkOperationMode' onchange='getAjaxProfiles(this,false);'>";
                    $buff .= $LOM == 'E1' ? '<option selected value="E1">E1</option>' : '<option value="E1">E1</option>';
                    $buff .= $LOM == 'T1' ? '<option selected value="T1">T1</option>' : '<option value="T1">T1</option>';
                    $buff .= '</select>';
                    $buff .= '</td></tr>';
                }
                $buff .= '</tbody></table>';
            }

            $buff .= '<br/>';

            $cont = 0;
            if( isset( $dev['Links'] ) )
            {

                if( $isBoard )
                    $buff .= '<div class="red">' . $app->translate( 'boardConfigNeedToRestartAPI' ) . '</div>';

                $buff .= '<table class="zebra"><thead>';
                $buff .= "<tr>";
                $buff .= "<th width='35%' >Link</th>";
                $buff .= "<th width='35%'>" . $app->translate( 'SynchronismClock' ) . "</th>";
                $buff .= "<th class='textAlignCenter' width='30%'>{$app->translate( 'telephony-singaling' )}</th>";
                $buff .= "</tr></thead><tbody>";
                $keys = array_keys( $dev['Links'] );
                $sysYAML = loadSystemYAML( );
                $sys = $sysYAML->getYaml( );
                $reference = explode( ',', $sys['System']['EnableLinkAsReference'] );

                foreach( $keys as $k )
                {
                    $valor = $dev['Links'][$k][$cont]['Profile'];
                    $chave = array_keys( $dev['Links'][$k] );
                    $profiles = getProfiles( "Links|$cont|" . $chave[0], $dev );
                    $buff .= "<tr>";
                    $buff .= "<td class='textAlignCenter'>$cont</td>";

                    $buff .= "<td class='textAlignCenter'>";
                    $buff .= "<select id='Clock-$cont' name='Clock:$cont'>";

                    if( in_array( "$serial.$cont", $reference ) )
                    {
                        $receive = "selected=''";
                        $generate = "";
                    }
                    else
                    {
                        $generate = "selected=''";
                        $receive = "";
                    }

                    if( @ereg( 'HI', $device ) || @ereg( 'KPR', $device ) )
                    {
                        $buff .= "<option value='receive' $receive>" . $app->translate( 'receive' ) . "</option>";
                    }
                    else
                    {
                        $buff .= "<option value='receive' $receive>" . $app->translate( 'receive' ) . "</option>";
                        $buff .= "<option value='generate' $generate >" . $app->translate( 'generate' ) . "</option>";
                    }

                    $buff .= "</select>";

                    $buff .= "</td>";
                    $buff .= "<td class='textAlignCenter'>";
                    $buff .= "<select class='profiles' id='Links-$cont' name='Links:$cont'>";
                    foreach( $profiles as $p )
                        $buff .= ($p == $valor) ? "<option value='$valor' selected=''>$valor</option>" : "<option value='$p'>$p</option>";
                    $buff .= "</select>";
                    $buff .= "</td>";
                    $buff .= "</tr>";
                    $cont++;
                }
                $buff .= '</tbody></table>';
                $buff .= "<input type='hidden' id='qtdeLinks' value='" . sizeof( $keys ) . "' >";
            }

            if( isset( $dev['ChannelGroups'] ) )
            {
                $buff .= "<table class='zebra' id='channelGroup'><thead>";
                $buff .= "<tr>";
                $buff .= "<th width='35%'>" . $app->translate( 'ChannelGroup' ) . '</th>';
                $buff .= "<th width='35%'>" . $app->translate( 'Canais' ) . "</th>";
                $buff .= "<th class='textAlignCenter' width='30%'>" . $app->translate( 'Profile' ) . "</th>";
                $buff .= "</tr></thead><tbody>";
                $aux = 0;
                $keys = array_keys( $dev['ChannelGroups'] );
                foreach( $keys as $k )
                {
                    $chaves = array_keys( $dev['ChannelGroups'][$k] );
                    $profiles = getProfiles( "ChannelGroups|$aux|" . $chaves[0], $dev );
                    foreach( $chaves as $ch )
                    {
                        $buff .= "<tr>";
                        $buff .= "<td class='textAlignCenter'>" . $dev['ChannelGroups'][$k][$chaves[0]]['Type'] . "</td>";
                        $v = explode( '-', $chaves[0] );

                        $qtdeCanais = abs( ($v[0] - $v[1]) - 1 );
                        $buff .= '<td><span >' . $qtdeCanais;
                        $buff .= $qtdeCanais == 1 ? $app->translate( 'canal' ) : $app->translate( 'canais' );
                        $buff .= ' (' . $chaves[0] . ')</span></td>';
                        $valor = utf8_encode( $dev['ChannelGroups'][$k][$ch]['Profile'] );
                        $buff .= "<td class='textAlignCenter;'><select id='ChannelGroups:$k:$ch' name='ChannelGroups:$k:$ch'>";
                        foreach( $profiles as $p )
                            $buff .= $p == $valor ? "<option value='$valor' selected=''>$valor</option>" : "<option value='$p'>$p</option>";
                        $buff .= "</select></td></tr>";
                    }
                    $cont++;
                    $aux++;
                }
                $buff .= '</tbody></table>';
            }

            if( isset( $dev['IP'] ) )
            {
                $buff .= '<br/>';
                $replace = ($dev['Replacer']) != '' ? $dev['Replacer'] : '';

                $buff .= '<span id="MaintenanceClosed" class="' . ($replace != '' ? 'displayNone' : '') . '" onclick="openMaintenance();">' . $app->translate( 'MaintenanceClosed' ) . '</span>';
                $buff .= '<span id="MaintenanceOpened" class="' . ($replace != '' ? '' : 'displayNone') . '" onclick="closeMaintenance();">' . $app->translate( 'MaintenanceOpened' ) . '</span>';

                $buff .= '<div id="Maintenance" class="' . ($replace != '' ? '' : 'displayNone') . '">';
                $buff .= '<table class="zebra" border="0"><tbody><tr>';

                $buff .= '<td width="70%" class="textAlignLeft">';
                $buff .= '<label for="Replacer">' . $app->translate( 'Replacer' ) . '</label>';

                $buff .= '</td>';
                $buff .= '<td width="30%" class="textAlignCenter">';

                $buff .= "<input id='Replacer' type='text' onkeypress='return serialMask(this, event);' onmouseup='return serialMask(this, event);' onkeyup='validateSerial(this);' value='$replace' name='Replacer'>";

                $buff .= '</td></tr></tbody></table>';
                $buff .= '</div>';
            }

            $buff .= "</fieldset>";
            $buff .= '<br/>';
            $buff .= "<div class='textAlignRight'>";
            $buff .= "<input type='button' onclick='showDevices();' value='" . $app->translate( 'back' ) . "'>";
            $buff .= "<input type='button' onclick=\"saveDevice('$serial');\" value='" . $app->translate( 'Salvar' ) . "'>";
            $buff .= "</div>";
            $buff .= "</div>";

            return $buff;
        }
    }

    function checkSerialIsAReplacer( $serial )
    {
        Global $sistema;

        $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . "/devices.yaml" );
        $deviceYAML = $DevicesYAML->getYaml( );

        for( $i = 0; $i < sizeof( $deviceYAML['Devices'] ); $i++ )
        {
            $keys = array_keys( $deviceYAML['Devices'][$i] );
            if( isset( $deviceYAML['Devices'][$i][$keys[0]]['Replacer'] ) && $deviceYAML['Devices'][$i][$keys[0]]['Replacer'] == $serial )
                return true;
        }

        return false;
    }

    function checkReplacerConflict( $serial, $replacer, $devicesYAML )
    {
        if( $serial == $replacer )
            return 3;

        $deviceYAML = $devicesYAML->getYaml( );
        for( $i = 0; $i < sizeof( $deviceYAML['Devices'] ); $i++ )
        {
            $keys = array_keys( $deviceYAML['Devices'][$i] );
            if( $keys[0] != $serial )
            {
                if( $keys[0] == $replacer )
                    return 2;

                if( $deviceYAML['Devices'][$i][$keys[0]]['Replacer'] == $replacer )
                    return 1;
            }
        }
        return 0;
    }

    function getReplacerErrorMessage( $code )
    {
        Global $sistema;
        switch ($code)
        {
            case 1:
                return '1|' . $sistema->retTranslate( 'ReplacerConflict' );

            case 2:
                return '2|' . $sistema->retTranslate( 'ReplacerAlreadyConfiguredAsDevice' );

            case 3:
                return '3|' . $sistema->retTranslate( 'ReplacerAndDeviceAreTheSame' );

            default:
                return '1|' . $sistema->retTranslate( 'ReplacerConflict' );
        }
    }

    function saveDevice( )
    {
        Global $sistema;

        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        $ip = isset( $_REQUEST['ip'] ) ? $_REQUEST['ip'] : NULL;
        $replacer = isset( $_REQUEST['Replacer'] ) ? $_REQUEST['Replacer'] : NULL;

        if( isset( $serial ) && isset( $data ) )
        {
            $DevicesYAML = new KYaml( $sistema->getConfigDir( ) . "/devices.yaml" );
            $dev = $DevicesYAML->getValue( $serial );
            $needChangeCGQty = false;
            if( isset( $ip ) )
            {
                $check = checkIPConflict( $ip, $serial, $DevicesYAML->getYaml( ) );
                if( $check )
                    return '4|' . $sistema->retTranslate( 'IPAlreadyUsed' );
                else
                    $dev['IP'] = $ip;
            }

            if( isset( $_REQUEST['LinkOperationMode'] ) )
            {
                if( $dev['LinkOperationMode'] == '' )
                {
                    $LOM = trim( $_REQUEST['LinkOperationMode'] );
                    if( $LOM == 'E1' || $LOM == 'T1' )
                    {
                        $dev['LinkOperationMode'] = $LOM;
                        $needChangeCGQty = true;
                    }
                }
            }

            if( isset( $replacer ) )
            {
                $check_repl = checkReplacerConflict( $serial, $replacer, $DevicesYAML );

                if( $check_repl > 0 )
                    return getReplacerErrorMessage( $check_repl );
                else
                    $dev['Replacer'] = $replacer;
            }
            else if( isset( $dev['Replacer'] ) )
                $dev['Replacer'] = '';

            $data = explode( '|', $data );
            foreach( $data as $d )
            {
                $tmp = explode( ':', $d );

                if( $tmp[0] == 'Links' )
                {
                    $dev[$tmp[0]][$tmp[1]][$tmp[1]]['Profile'] = $tmp[2];
                    if( isset( $LOM ) )
                        $dev[$tmp[0]][$tmp[1]][$tmp[1]]['Type'] = $LOM;
                }
                elseif( $tmp[0] == 'ChannelGroups' )
                {
                    $dev[$tmp[0]][$tmp[1]][$tmp[2]]['Profile'] = utf8_decode( $tmp[3] );
                }
                else
                {
                    $sys = loadSystemYAML( );
                    $yaml = $sys->getYaml( );

                    if( $yaml['System']['EnableLinkAsReference'] != '' )
                        $refs = explode( ',', $yaml['System']['EnableLinkAsReference'] );
                    else
                        $refs = array( );

                    $link = "$serial.$tmp[1]";

                    if( $tmp[2] == 'receive' )
                    {
                        if( !in_array( $link, $refs ) )
                            $refs[] = $link;
                    }
                    else
                    {
                        if( in_array( $link, $refs ) )
                        {
                            $key = array_search( $link, $refs );
                            unset( $refs[$key] );
                        }
                    }
                    $arr_tmp = array( );
                    foreach( $refs as $r )
                        $arr_tmp[] = $r;

                    $size = sizeof( $arr_tmp );
                    if( $size == 0 )
                        $yaml['System']['EnableLinkAsReference'] = '';
                    elseif( $size == 1 )
                        $yaml['System']['EnableLinkAsReference'] = $arr_tmp[0];
                    else
                        $yaml['System']['EnableLinkAsReference'] = implode( ',', $arr_tmp );

                    $sys->setYaml( $yaml );
                    $sys->save( );
                }

            }
            /** ALERT **/
            /* Modificação enquanto não tem configuração! */
            $dev['CustomTonesProfile'] = 'Profile1';
            /** fim da modificação **/

            if( $needChangeCGQty && $dev['LinkOperationMode'] == 'T1' )
            {
                $ch_qty = sizeof( $dev['ChannelGroups'] );
                if($ch_qty > 0)
                {
                    $channel_group = array( );
                    for( $i = 0; $i < $ch_qty; $i++ )
                    {
                        $key = array_keys( $dev['ChannelGroups'][$i] );
                        $tmp = explode( '-', $key[0] );
                        $qty_links = sizeof($dev['Links']);
                        $newKey = strval( $tmp[0] - (6*$qty_links) ) . "-" . strval( $tmp[1] - (6*$qty_links) );
                        $new = replace_key_function( $dev['ChannelGroups'][$i], $key[0], $newKey );
                        $channel_group[$i] = $new;
                    }
                    $dev['ChannelGroups'] = $channel_group;
                }
            }

            $DevicesYAML->changeVarValue( $serial, $dev );
            $DevicesYAML->saveYaml( true );

            return '0|' . $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    //***** aux func ********//

    function checkIPConflict( $ip, $serial, $yaml )
    {
        if( trim( $ip ) == '' )
            return false;

        $devices = $yaml['Devices'];
        $keys = array_keys( $devices );

        foreach( $keys as $k )
        {
            $x = array_keys( $devices[$k] );

            if( $x[0] != $serial )
            {
                if( isset( $devices[$k][$x[0]]['IP'] ) && $devices[$k][$x[0]]['IP'] == $ip )
                    return true;
            }
        }
        return false;
    }

    function getProfiles( $path, $device )
    {
        Global $sistema;
        $Profiles = new KProfiles( );
        $pathParts = explode( '|', $path );
        $isT1 = isset( $device['LinkOperationMode'] ) ? $device['LinkOperationMode'] == 'T1' : FALSE;
        $Devicetype = $device[$pathParts[0]][$pathParts[1]][$pathParts[2]]['Type'];

        $defaultE1Types = array( 'R2', 'ISDN', 'ISUP', 'CAS PBX', 'CAS', 'CCS' );
        $defaultT1Types = array( 'ISDN' );
        $defaultGSMTypes = array( 'GSM' );
        $defaultFXOTypes = array( 'FXO' );
        $defaultFXSTypes = array( 'FXS' );

        $profilesYaml = new KYaml( $sistema->getConfigDir( ) . "/profiles.yaml" );
        $profiles = $profilesYaml->yaml["ChannelGroupProfiles"];

        $newProfile = array( );
        $isProfileForLink = strpos($path, 'Link') !== FALSE ? TRUE : FALSE;

        if( $Devicetype == 'E1' || $Devicetype == 'T1' )
            $newProfile[] = "Deactivated";

        switch ($Devicetype)
        {
            case 'FXO':
                $defaultTypes = $defaultFXOTypes;
                break;
            case 'FXS':
                $defaultTypes = $defaultFXSTypes;
                break;
            case 'GSM':
                $defaultTypes = $defaultGSMTypes;
                break;
            case 'E1':
                $defaultTypes = $defaultE1Types;
                break;
            case 'T1':
                $defaultTypes = $defaultT1Types;
                break;
        }

        for( $x = 0; $x < sizeof( $profiles ); $x++ )
        {
            $keys = array_keys( $profiles[$x] );
            $profile = $Profiles->getProfile( $keys[0] );
            $type = $profile[$keys[0]]['Type'];

            $profileSubType = isset( $profile[$keys[0]]['SubType'] ) ? $profile[$keys[0]]['SubType'] : '';

            if( in_array( $type, $defaultTypes ) )
            {
                if( (strpos( $device['Type'], 'HI' ) !== FALSE && $Devicetype == "E1") || strpos( $device['Type'], 'KPR' ) !== FALSE )
                {
                    if( strpos( $profileSubType, 'Passive' ) !== FALSE )
                        $newProfile[] = $keys[0];
                }
                else
                {
                    if( !@ereg( "Passive", $profileSubType ) )
                        $newProfile[] = $keys[0];
                }
            }
        }
        return $newProfile;
    }

    function getModuleDevices( )
    {
        Global $sistema, $invDevices, $boardNames;

        $EBSNames = getEBSNames( $invDevices );
        $return = '';
        $return .= "<table class='zebra tableIE tableHoverLine'><tbody>";
        for( $i = 0; $i < sizeof( $EBSNames ); $i++ )
        {
            $return .= "<tr><td>";
            $invDevData = implode( "|", $invDevices[$EBSNames[$i]] );
            $return .= "<input name='manualDevice' id='manualDevice{$i}' value='{$invDevData}' type='radio'>";
            $return .= "</td>";
            $return .= "<td width='90%' align='left'><label class='cursorHand' for='manualDevice{$i}'>" . $sistema->retTranslate( $EBSNames[$i] ) . '</label></td>';
            $return .= "</tr>";
        }
        $return .= "</tbody></table>";

        return $return;
    }

    function getNotInstalledDevices( $time = '' )
    {
        Global $sistema;
        $return = '';

        if( $time === '' )
            $time = 30;

        $data = $sistema->getNotInstalledDevices( $time );
        $tmpData = getDeviceList( $data );

        $return .= "<table class='simpleTable' ><tbody>";
        $return .= "<tr><td colspan='3'>" . $sistema->retTranslate( "TempoKibs" ) . "</td><td colspan='2'>";
        $return .= getKibsTime( $time );
        $return .= "</td></tr></tbody></table></br>";

        $return .= "<table class='zebra tableHoverLine'><thead>";
        if( $tmpData == "" )
            $return .= "<tr><td colspan='4'>" . $sistema->retTranslate( "NDevice" ) . "</td></tr>";
        else
        {
            $return .= "<tr>";
            $return .= "<th></th>";
            $return .= "<th align='center' width='25%'>" . $sistema->retTranslate( "type" ) . "</th>";
            $return .= "<th align='center' width='25%'>" . $sistema->retTranslate( "Serial" ) . "</th>";
            $return .= "<th align='center' width='40%'>" . $sistema->retTranslate( "Modelo" ) . "</th>";
            $return .= "</tr></thead><tbody>";
            $return .= $tmpData;
        }
        $return .= "</tbody></table><br>";

        $return .= '<div class="floatRight">';
        $return .= "<input class='width100;' type='button' value='" . $sistema->retTranslate( "back" ) . "' onClick='showDevices();'> ";
        if( $tmpData != "" ) {
            $return .= "<input class='width100' id='buttonAutoCreate' type='button' value='" . $sistema->retTranslate( "Adicionar" ) . "' onClick='autoCreateDevice();'>";
        }

        $return .= '</div>';

        return $return;
    }

    function getDeviceList( $data )
    {
        Global $sistema;

        $dataSize = sizeof( $data );
        $return = "";
        $nome = "deviceList";
        for( $x = 0; $x < $dataSize; $x++ )
        {

            $return .= "<tr><td>";
            $disabled = $data[$x][1] == 'ERROR' ? 'disabled' : '';
            $return .= "<input {$disabled} class='check' type='checkbox' name='$nome$x' id='$nome$x' value='" . $data[$x][0] . "'>";
            $return .= "<input type='hidden' name='version$x' id='version$x' value='" . $data[$x][5] . "'>";
            $return .= "</td>";
            $devType = $data[$x][1] == 'ERROR' ? '-' : $sistema->retTranslate( $sistema->getDeviceType( $data[$x] ) );
            $return .= '<td>' . $devType . '</td>';
            $return .= '<td>' . $data[$x][0] . '</td>';
            $devName = $data[$x][1] != 'ERROR' ? $sistema->retTranslate( getName( $data[$x][1], $x, $data[$x] ) ) : $sistema->retTranslate( 'invalidDevice' );
            $return .= "<td>{$devName}</td>";
            $return .= "</tr>";
        }
        return $return;
    }

    function getName( $name, $deviceOrder, $device = '' )
    {
        require_once (dirname( __FILE__ ) . "/../placas.php");
        Global $sistema, $boardNames, $invDevices;

        $return = '';

        $EBSNames = getEBSNames( $invDevices );

        if( $name != "" && !@ereg( "EBS", $name ) )
            return $name;

        if( $name == "" || !isset( $invDevices[$name] ) )
        {
            $return .= "<select class='width125px' name='deviceListType$deviceOrder' id='deviceListType$deviceOrder'>";
            $return .= "<option value=''>" . $sistema->retTranslate( 'selectType' ) . "</option>";
            for( $i = 0; $i < sizeof( $EBSNames ); $i++ )
            {
                $EBSTypeSubTypeLink = implode( ";", $invDevices[$EBSNames[$i]] );
                $return .= "<option value='$EBSTypeSubTypeLink'>" . $sistema->retTranslate( $EBSNames[$i] ) . "</option>";
            }
            $return .= "</select>";
        }
        else
        {
            $deviceName = $name;
            if( isset( $invDevices[$deviceName] ) )
                $deviceType = implode( ";", $invDevices[$deviceName] );
            else
                $deviceType = "0;0;0";

            $return = "<input type='hidden' id='deviceListType$deviceOrder' name='deviceListType$deviceOrder' value='$deviceType'/>" . $sistema->retTranslate( $deviceName );
        }
        return $return;
    }

    function getKibsTime( $time )
    {
        Global $sistema;
        $all = $sistema->retTranslate( "all" );
        $group = array( '05 min' => 5, '30 min' => 30, '01 h' => 60, '05 h' => 300, '10 h' => 600, '01 d' => 1440, '05 d' => 7200, '10 d' => 14400, "$all" => 0 );
        $GKeys = array_keys( $group );
        $select = "<select id='kibsTime' onChange='preCreateDevice(this.value);' class='selector2'>";
        for( $i = 0; $i < sizeof( $GKeys ); $i++ )
        {
            $selected = $group[$GKeys[$i]] == $time ? 'selected' : '';
            $select .= "<option value='" . $group[$GKeys[$i]] . "' $selected>" . $GKeys[$i] . "</option>";
        }
        $select .= "</select>";
        $select .= "<a href='#' onclick='refreshKibsTime();'>" . $sistema->retTranslate( 'refresh' ) . "</a>";

        return $select;
    }

    function getModularDevices( )
    {
        Global $sistema, $invDevices, $boardNames;

        $ModularNames = getModularNames( $invDevices );
        $totalModular = sizeof( $ModularNames );
        $return = '';
        $return .= "<input type='hidden' value='$totalModular' id='totalTypes' />";
        $return .= "<table class='zebra tableHoverLine'><tbody>";

        for( $i = 0; $i < $totalModular; $i++ )
        {
            $return .= "<tr><td>";
            $invDevData = implode( "|", $invDevices[$ModularNames[$i]] );
            $return .= "<input name='manualDevice' id='manualModDevice{$i}' onClick=\"hideModularTypes();showModularType('modularType{$i}');\" value='{$invDevData}' type='radio'>";
            $return .= "</td>";
            $return .= "<td width='70%' align='left'><label class='cursorHand' for='manualModDevice{$i}'>" . $sistema->retTranslate( $ModularNames[$i] ) . '</label></td>';
            $return .= "<td width='20%' align='left'>";
            $return .= "<div id='modularType$i' style='display: none;'>";
            $return .= "<input name='manualType{$i}' id='manualType{$i}' value='SPX' type='radio' checked> SPX ";
            $return .= "<input name='manualType{$i}' id='manualType{$i}' value='CTI' type='radio'> CTI";
            $return .= "</div>";
            $return .= "</td></tr>";
        }
        $return .= "</tbody></table>";

        return $return;
    }

    function getBoardDevices( )
    {
        Global $sistema;
        $devices = $sistema->getBoardDevices( );

        $devices = cleanArray( $devices );
        $return = '';
        if( sizeof( $devices ) > 0 )
        {
            $return .= "<table class='zebra tableHoverLine'><tbody>";
            for( $x = 0; $x < sizeof( $devices ); $x++ )
            {
                $return .= "<tr><td>";
                $return .= "<input type='radio' name='manualDevice' id='manualBoardDevice{$x}' value='" . $devices[$x]['id'] . "'>";
                $return .= "</td>";
                $return .= "<td width='90%' align='left'><label for='manualBoardDevice{$x}' class='cursorHand'>" . $sistema->retTranslate( $devices[$x]['name'] ) . '</label></td>';
                $return .= "</tr>";
            }
            $return .= "</tbody></table>";
        }
        return $return;
    }

    function getEBSNames( $invDevices )
    {
        $keys = array_keys( $invDevices );
        $data = array( );
        for( $i = 0; $i < sizeof( $keys ); $i++ )
        {
            if( @ereg( "EBS", $keys[$i] ) && @!ereg( 'Modular', $keys[$i] ) )
                $data[] = $keys[$i];
        }
        return $data;
    }

    function getModularNames( $invDevices )
    {
        $keys = array_keys( $invDevices );
        $data = array( );
        for( $i = 0; $i < sizeof( $keys ); $i++ )
        {
            if( @ereg( 'Modular', $keys[$i] ) )
            {
                $keys[$i] = @ereg_replace( "_CTI", '', $keys[$i] );
                $keys[$i] = @ereg_replace( "_SPX", '', $keys[$i] );
                if( !in_array( $keys[$i], $data ) )
                    $data[] = $keys[$i];
            }
        }
        return $data;
    }

    function cleanArray( $array )
    {
        $tmpArray = array( );
        for( $i = 0; $i < sizeof( $array ); $i++ )
        {
            $check = false;
            for( $j = $i + 1; $j < sizeof( $array ); $j++ )
            {
                if( $array[$i]['name'] == $array[$j]['name'] )
                    $check = true;
            }
            if( $check == false )
                $tmpArray[] = $array[$i];
        }
        return $tmpArray;
    }

    function getDevicetype( $device )
    {
        if( @ereg( "EBS-Modular", $device ) )
            return "Modular";
        elseif( @ereg( "EBS", $device ) )
            return "Modulo";
        elseif( @ereg( "USB", $device ) )
            return "USB";
        else
            return "Placa";
    }

    function getAjaxProfiles( )
    {
        Global $sistema;
        $type = isset( $_REQUEST['type'] ) ? trim( $_REQUEST['type'] ) : '';
        $passive = isset( $_REQUEST['passive'] ) ? trim( $_REQUEST['passive'] ) === 'true' : false;

        $response = array( );
        $response[] = "Deactivated";

        $profilesYaml = new KYaml( $sistema->getConfigDir( ) . "/profiles.yaml" );
        $profiles = $profilesYaml->yaml["ChannelGroupProfiles"];

        $E1Types = array( 'R2', 'ISDN', 'ISUP', 'CAS PBX', 'CAS', 'CCS' );

        foreach( $profiles as $key => $value )
        {
            $keys = array_keys( $value );
            $name = $keys[0];
            $profileType = $value[$name]['Type'];
            $profileSubType = $value[$name]['SubType'];

            switch ($type)
            {
                case 'E1':
                    if( in_array( $profileType, $E1Types ) )
                    {
                        if( !isset( $value[$name]['T1Mode'] ) || $value[$name]['T1Mode'] === FALSE )
                        {
                            if( $passive )
                            {
                                if( $profileSubType == 'Passive' )
                                    $response[] = $name;
                            }
                            else
                            {
                                if( $profileSubType != 'Passive' )
                                    $response[] = $name;
                            }
                        }
                    }
                    break;

                case 'T1':
                    if( isset( $value[$name]['T1Mode'] ) && $value[$name]['T1Mode'] === TRUE )
                        $response[] = $name;
                    break;

                default:
                    break;
            }
        }
        return JSONencode( $response );

    }
