<?php
    require_once KCONFIG . '/classes/KFirewallYaml.php';

    $AjaxFunctions['showSimpleFilter'] = 'showSimpleFilter';
    $AjaxFunctions['getFilterChain'] = 'getFilterChain';
    $AjaxFunctions['stageSimpleFilter'] = 'stageSimpleFilter';
/*
    $AjaxFunctions['showFilter'] = 'showFilter';
    $AjaxFunctions['showFilterChain'] = 'showFilterChain';
    $AjaxFunctions['getFilterChainDescriptions'] = 'getFilterChainDescriptions';
    $AjaxFunctions['saveFilter'] = 'saveFilter';
*/
    $AjaxFunctions['commitFirewallConfiguration'] = 'commitFirewallConfiguration';

    function _simpleFilterTable( $chain, $id, $name )
    {
        $app = KSystem::getInstance();
        $buf = "<fieldset><legend>{$name}</legend><table id='{$id}' class='gateway-table-form'><thead>";
        $buf .= "<tr><th>{$app->translate( 'gateway-firewall-simple-ip-address' )}</th></tr>";
        $buf .= '</thead><tbody>';

        foreach( $chain['Rules'] as &$rule )
        {
            $buf .= "<tr><td><input type='text' name='{$id}-list[]' value='{$rule['SourceAddress']}' /></td></tr>";
        }

        return "{$buf}</tbody></table><br /><input type='button' id='{$id}-add' value='{$app->translate( 'add' )}' /></fieldset>";
    }

    function showSimpleFilter()
    {
        $app = KSystem::getInstance();
        return "<fieldset id='gateway-firewall'><legend>{$app->translate( 'gateway-firewall' )}</legend></fieldset>";
    }

    function showFilter()
    {
        $app = KSystem::getInstance();

        $buf = "<fieldset><legend>{$app->translate( 'gateway-firewall' )}</legend>";
        $buf .= "<div id='gateway-firewall'><table id='gateway-firewall-table' class='gateway-table zebra sortable'><thead><tr>";
        $buf .= "<th>{$app->translate( 'gateway-firewall-acl' )}</th><th>{$app->translate( 'gateway-firewall-acl-description' )}</th><th>{$app->translate( 'options' )}</th>";
        $buf .= '</tr></thead><tbody>';
        $buf .= '</tbody></table><br />';
        $buf .= "<input type='button' value='{$app->translate( 'gateway-firewall-add-acl' )}' id='gateway-firewall-add-acl' />";
        $buf .= '</div></fieldset>';

        $buf .= '<select id=\'gateway-firewall-rule-protocol-tmpl\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$protocols as $proto )
        {
            $buf .= "<option value='{$proto}'>{$proto}</option>";
        }
        $buf .= '</select>';

        $buf .= '<select id=\'gateway-firewall-rule-action-tmpl\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$actions as $action )
        {
            $buf .= "<option value='{$action}'>{$action}</option>";
        }
        $buf .= '</select>';

        $buf .= '<select id=\'gateway-firewall-rule-ip-state-is-tmpl\' multiple=\'multiple\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$states as $state )
        {
            $buf .= "<option value='{$state}'>{$state}</option>";
        }
        $buf .= '</select>';

        $buf .= '<select id=\'gateway-firewall-rule-ip-track-tmpl\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$trackingModes as $track )
        {
            $buf .= "<option value='{$track}'>{$track}</option>";
        }
        $buf .= '</select>';

        return $buf;
    }

    function showFilterChain()
    {
        $app = KSystem::getInstance();

        $buf = '<select id=\'gateway-firewall-rule-protocol-tmpl\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$protocols as $proto )
        {
            $buf .= "<option value='{$proto}'>{$proto}</option>";
        }
        $buf .= '</select>';

        $buf .= '<select id=\'gateway-firewall-rule-action-tmpl\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$actions as $action )
        {
            $buf .= "<option value='{$action}'>{$action}</option>";
        }
        $buf .= '</select>';

        $buf .= '<select id=\'gateway-firewall-rule-ip-state-is-tmpl\' multiple=\'multiple\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$states as $state )
        {
            $buf .= "<option value='{$state}'>{$state}</option>";
        }
        $buf .= '</select>';

        $buf .= '<select id=\'gateway-firewall-rule-ip-track-tmpl\' class=\'displayNone\'>';
        foreach( KFirewallYaml::$trackingModes as $track )
        {
            $buf .= "<option value='{$track}'>{$track}</option>";
        }
        $buf .= '</select>';

        $buf .= "<fieldset id='gateway-firewall-acl-fs'><legend>{$app->translate( 'gateway-firewall-acl' )}</legend></fieldset><br />";

        $buf .= "<fieldset><legend>{$app->translate( 'gateway-firewall-acl-rules' )}</legend><table id='gateway-firewall-acl-rules-table' class='gateway-form-table'><thead><tr>";
        $buf .= "<th>{$app->translate( 'gateway-firewall-acl-rule-sourceaddress' )}</th><th>{$app->translate( 'gateway-firewall-acl-rule-protocol' )}</th><th>{$app->translate( 'gateway-firewall-acl-rule-action' )}</th><th>{$app->translate( 'gateway-firewall-acl-protocol-rule-options' )}</th>";
        $buf .= '</tr></thead><tbody></tbody></table>';
        $buf .= "<br /><input type='button' value='{$app->translate( 'gateway-firewall-acl-add-rule' )}' id='gateway-firewall-acl-add-rule' /></fieldset><br /><br /><input type='button' value='{$app->translate( 'save' )}' />&nbsp;<input type='button' value='{$app->translate( 'back' )}' />";

        return $buf;
    }

    function getFilterChainDescriptions()
    {
        require_once KROOT . '/json_util.php';

        $kyaml = new KFirewallYaml();

        $chains = $kyaml->getAllFilterChains();
        $ret = array();
        foreach( $chains as &$chain )
        {
            $ret[$chain['Name']] = $chain['Description'];
        }
        return JSONencode( $ret );
    }
    
    function getFilterChain()
    {
        require_once KROOT . '/json_util.php';

        $name = $_POST['name'];
        $core = $_POST['core'] === 'true';

        if( empty( $name ) )
        {
            $chain = array(
                'Name' => '',
                'Description' => '',
                'Rules' => array()
            );
            if( !$core )
            {
                $chain['__CoreRule__'] = array(
                    'Protocol' => 'ANY',
                    'Action' => 'Chain',
                    'Chain' => ''
                );
            }
        }
        else
        {
            $kyaml = new KFirewallYaml();
            $chain = $kyaml->getFilterChain( $name, $core );
            if( !$core )
            {
                $chain['__CoreRule__'] = $kyaml->getFilterChainRule( $name, 'INPUT', true );
            }
        }
        return JSONencode( $chain );
    }

    function stageSimpleFilter( )
    {
        require_once KROOT . '/json_util.php';
        $message = array( 'message' => '', 'success' => false );
        $app = KSystem::getInstance();

        try
        {
            $kyaml = new KFirewallYaml( );

            $chain = $kyaml->getFilterChain( 'ALWAYS-ACCEPT', false );
            $chain['Rules'] = array();
            foreach( $_POST['ACCEPT'] as $rule )
            {
                $chain['Rules'][] = array(
                    'Protocol' => 'IP',
                    'SourceAddress' => $rule,
                    'Action' => 'ACCEPT'
                );
            }
            $kyaml->setFilterChain( $chain, $chain['Name'] );
            $chain = $kyaml->getFilterChain( 'ALWAYS-DROP', false );
            $chain['Rules'] = array();
            foreach( $_POST['DROP'] as $rule )
            {
                $chain['Rules'][] = array(
                    'Protocol' => 'IP',
                    'SourceAddress' => $rule,
                    'Action' => 'DROP'
                );
            }
            $kyaml->setFilterChain( $chain, $chain['Name'] );

            $kyaml->stage();
            $message = array( 'message' => $app->translate( 'gateway-firewall-staged' ), 'success' => true );
        }
        catch( Exception $e )
        {
            $message['message'] = $app->translate( $e->getMessage( ) );
        }

        // force browser to close the connection on reply, so the commit
        // request must use a new connection, avoiding problems with firewall
        // state checking
        header( 'Connection: close' );
        return JSONencode( $message );
    }

    function commitFirewallConfiguration( )
    {
        require_once KROOT . '/json_util.php';
        $message = array( 'message' => '', 'success' => false );
        $app = KSystem::getInstance();

        try
        {
            $kyaml = new KFirewallYaml( );
            $kyaml->save();
            $message = array( 'message' => $app->translate( 'gateway-firewall-committed' ), 'success' => true );
        }
        catch( Exception $e )
        {
            $message['message'] = $app->translate( $e->getMessage() );
        }

        return JSONencode( $message );
    }
