<?php
    $AjaxFunctions['showPortabilityGW'] = 'showPortabilityGW';
    $AjaxFunctions['savePortabilityGW'] = 'savePortabilityGW';
    $AjaxFunctions['showLocalPortabilityGW'] = 'showLocalPortabilityGW';
    $AjaxFunctions['showWebservicePortabilityGW'] = 'showWebservicePortabilityGW';
    $AjaxFunctions['importPortabilityFileGW'] = 'importPortabilityFileGW';

    class KFormatHelper
    {
        protected $app;

        public function __construct( )
        {
            $this->app = KSystem::getInstance( );
        }
        public function help( $name )
        {
            return "<img class=\"gateway-tooltip\" src=\"/imagens/tooltip.png\" title=\"{$this->app->translate( $name )}\" />";
        }

    };

    function showPortabilityGW( )
    {
        $app = KSystem::getInstance( );

        $buff = "<fieldset class='gateway-form'><legend>{$app->translate( 'gateway-portability' )}</legend>";
        $buff .= '<table class=\'zebra simpleTable gateway-table-form\'><tbody>';
        $buff .= "<tr><td class='label'><label for='gateway-portability-driver'>{$app->translate( 'gateway-portability-driver' )}</label></td><td class='gateway-form-field-container-right'><select id='gateway-portability-driver'></select></td></tr>";
        $buff .= '</tbody></table><br /><div id="gateway-portability-options" class="displayNone">&nbsp;</div>';
        $buff .= "<br /><div class='textAlignRight'><input id='gateway-portability-save' type='button' value='{$app->translate( 'save' )}' /></div>";
        $buff .= "</fieldset>";

        return $buff;
    }

    function savePortabilityGW()
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayYaml.php';

        $app = KSystem::getInstance( );
        $return = array( 'success' => false, 'message' => 'gateway-portability-error-save' );

        $DriverOptions = array();
        $Driver = ( empty( $_POST['Driver'] ) ) ? 'DISABLED' : $_POST['Driver'];

        if( $Driver === 'WEBSERVICE' )
        {
            // Url
            if ( strpos( $_POST[ 'DriverOptions' ][ 'Url' ], 'http' ) !== 0 ) {
                $_POST[ 'DriverOptions' ][ 'Url' ] = 'http://' . $_POST[ 'DriverOptions' ][ 'Url' ];
            }
            $url_parsed = ( empty( $_POST[ 'DriverOptions' ][ 'Url' ] ) ) ? array() : parse_url( $_POST[ 'DriverOptions' ][ 'Url' ] );

            if ( empty( $url_parsed ) )
            {
                $return[ 'message' ] = $app->translate( 'gateway-portability-error-empty' );
                return JSONencode( $return );

            }
            elseif( !preg_match( "/\b(?:(?:https?):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $_POST[ 'DriverOptions' ][ 'Url' ] ) )
            {
                $return[ 'message' ] = $app->translate( 'gateway-portability-error-invalid-Url' );
                return JSONencode( $return );
            }

            $DriverOptions[ 'Url' ] =  $_POST[ 'DriverOptions' ][ 'Url' ];

            // Method
            if( empty( $_POST[ 'DriverOptions' ][ 'Method' ] ) || !in_array( $_POST[ 'DriverOptions' ][ 'Method' ], array( 'GET', 'POST' ) ) )
            {
                $return[ 'message' ] = $app->translate( 'gateway-portability-error-invalid-Method' );
                return JSONencode( $return );
            }

            $DriverOptions[ 'Method' ] = $_POST[ 'DriverOptions' ][ 'Method' ];

            // ResponsePattern
            $DriverOptions[ 'ResponsePattern' ] = ( empty( $_POST[ 'DriverOptions' ][ 'ResponsePattern' ] ) ) ? '' : $_POST[ 'DriverOptions' ][ 'ResponsePattern' ];

            // Timeout
            $DriverOptions[ 'Timeout' ] = 500;

            if( !empty( $_POST[ 'DriverOptions' ][ 'Timeout' ] ) )
            {
                if ( !is_numeric( $_POST[ 'DriverOptions' ][ 'Timeout' ] ) || (int)$_POST[ 'DriverOptions' ][ 'Timeout' ] < 0 )
                {
                    $return[ 'message' ] = $app->translate( 'gateway-portability-error-invalid-timeout' );
                    return JSONencode( $return );
                }

                $DriverOptions[ 'Timeout' ] =  (int)$_POST[ 'DriverOptions' ][ 'Timeout' ];
            }

            // Errors
            $DriverOptions[ 'ErrorMaxToSleep' ] = ( isset( $_POST[ 'DriverOptions' ][ 'ErrorMaxToSleep' ] ) && is_numeric( $_POST[ 'DriverOptions' ][ 'ErrorMaxToSleep' ] ) ) ? (int)$_POST[ 'DriverOptions' ][ 'ErrorMaxToSleep' ] : 0;
            $DriverOptions[ 'ErrorSleepTime' ] = ( isset( $_POST[ 'DriverOptions' ][ 'ErrorSleepTime' ] ) && is_numeric( $_POST[ 'DriverOptions' ][ 'ErrorSleepTime' ] ) ) ? (int)$_POST[ 'DriverOptions' ][ 'ErrorSleepTime' ] : 0;

            // AdditionalParams
            if ( !empty( $_POST[ 'DriverOptions' ][ 'AdditionalParams' ] ) )
            {
                $DriverOptions[ 'AdditionalParams' ] = $_POST[ 'DriverOptions' ][ 'AdditionalParams' ];
            }

            // Http Auth
            if( !empty( $_POST[ 'DriverOptions' ][ 'Username' ] ) )
            {
                if( empty( $_POST[ 'DriverOptions' ][ 'Password' ] ) )
                {
                    $return[ 'message' ] = $app->translate( 'form-error-empty' );
                    return JSONencode( $return );
                }

                $DriverOptions[ 'Username' ] = $_POST[ 'DriverOptions' ][ 'Username' ];
                $DriverOptions[ 'Password' ] = $_POST[ 'DriverOptions' ][ 'Password' ];
            }
        }

        try
        {
            $gatewayyaml = new KGatewayYaml();

            $gatewayyaml->setPortability( $Driver, $DriverOptions );
            $gatewayyaml->save();

            if ( reload( 'k3lreload' ) === 'OK' ) {
               $return = array( 'success' => true, 'message' => $app->translate( 'gateway-portability-saved' ) );
            }
        }
        catch( Exception $e )
        {
            $return['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $return );
    }

    function _databaseSummaryAndImport( )
    {
        require_once KCONFIG . '/classes/KGatewayPortabilityImport.php';

        $app = KSystem::getInstance( );
        $portability = KGatewayPortabilityImport::getInstance( );
        $fmt = new KFormatHelper( );

        $buff = "<fieldset><legend>{$app->translate( 'gateway-portability-local-summary' )}</legend>";
        $buff .= '<table id="gateway-portability-local-summary" class="gateway-table zebra"><thead>';
        $buff .= "<tr><th>{$app->translate( 'gateway-portability-local-summary-source' )}</th><th>{$app->translate( 'gateway-portability-local-summary-count' )}</th><th>{$app->translate( 'gateway-portability-local-summary-update' )}</th></tr>";
        $buff .= '</thead><tbody></tbody></table></fieldset>';
        $buff .= "<br /><div class='floatRight'><input type='button' value='{$app->translate( 'gateway-portability-local-import' )}' id='gateway-portability-local-import-button' /></div><div style='clear: both;' />";

        $buff .= '<div id=\'gateway-portability-local-import-form-div\'>';
        $buff .= "<table id='gateway-portability-local-import' class='gateway-table-modal-form'><tbody><tr><td class='label'><label for='gateway-portability-local-import-file'>{$app->translate( 'gateway-portability-local-import-file' )}</label>: {$fmt->help( 'gateway-portability-local-import-file-help' )}</td><td><input type='file' id='gateway-portability-local-import-file' /><span id='gateway-portability-local-import-file-info'>&nbsp;</span></td></tr>";
        $buff .= "<tr><td class='label'><label for='gateway-portability-local-import-type'>{$app->translate( 'gateway-portability-local-import-type' )}</label>:</td><td>";
        $types = $portability->getAvailableImportTypes();
        if( count( $types ) == 0 )
        {
            return '';
        }
        elseif( count( $types ) == 1 )
        {
            $typename = $app->translate( "gateway-portability-local-import-type-{$types[0]}" );
            $buff .= "<input type='hidden' id='gateway-portability-local-import-type' value='{$types[0]}' /> {$typename}";
        }
        else
        {
            $buff .= '<select id=\'gateway-portability-local-import-type\'>';
            foreach( $portability->getAvailableImportTypes() as $type )
            {
                $key = "gateway-portability-local-import-type-{$type}";
                $buff .= "<option value='{$type}'>{$app->translate( $key )}</option>";
            }
            $buff .= '</select>';
        }
        $buff .= '</td></tr>';
        $buff .= "<tr><td class='label'>{$app->translate( 'gateway-portability-local-import-format' )}: {$fmt->help( 'gateway-portability-local-import-format-help' )}</td><td><div id='gateway-portability-local-import-field-format'><select id='gateway-portability-local-import-field-format-tpl' class='displayNone'><option>&nbsp;</option>";
        foreach( $portability->getAvailableFormats() as $_fmt )
        {
            $key = "gateway-portability-local-import-format-{$_fmt}";
            $buff .= "<option value=\"{$_fmt}\">{$app->translate( $key )}</option>";
        }
        $buff .= '</select><ol id="gateway-portability-local-import-field-format-list"></ol></div></td></tr>';
        $buff .= "<tr><td class='label'><label for='gateway-portability-local-import-field-delimiter'>{$app->translate( 'gateway-portability-local-import-field-delimiter' )}</label>:</td><td><input type='text' value=',' id='gateway-portability-local-import-field-delimiter' class='field-config' maxlength='1' /></td></tr>";
        $buff .= "<tr><td class='label'><label for='gateway-portability-local-import-field-closure'>{$app->translate( 'gateway-portability-local-import-field-closure' )}</label>: {$fmt->help( 'gateway-portability-local-import-field-closure-help' )}</td><td><input type='text' value='\"' id='gateway-portability-local-import-field-closure' class='field-config' maxlength='1' /></td></tr>";
        $buff .= "<tr><td class='label'>{$app->translate( 'gateway-portability-local-import-options' )}:</td><td class='textAlignLeft'>";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-remove-all-content-first' /> <label for='gateway-portability-local-import-remove-all-content-first'>{$app->translate( 'gateway-portability-local-import-remove-all-content-first' )} {$fmt->help( 'gateway-portability-local-import-remove-all-content-first-help' )}</label><br />";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-ignore-first-line' /> <label for='gateway-portability-local-import-ignore-first-line'>{$app->translate( 'gateway-portability-local-import-ignore-first-line' )} {$fmt->help( 'gateway-portability-local-import-ignore-first-line-help' )}</label><br />";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-incremental' /> <label for='gateway-portability-local-import-incremental'>{$app->translate( 'gateway-portability-local-import-incremental' )} {$fmt->help( 'gateway-portability-local-import-incremenetal-help' )}</label><br />";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-ignore-invalid' /> <label for='gateway-portability-local-import-ignore-invalid'>{$app->translate( 'gateway-portability-local-import-ignore-invalid' )} {$fmt->help( 'gateway-portability-local-import-ignore-invalid-help' )}</label>";
        $buff .= '</td></tr></tbody></table>';
        // upload bar
        $buff .= "<div id='gateway-portability-local-import-progress' class='displayNone'><br /><br />{$app->translate( 'gateway-portability-local-import-sending-file' )}<br /><br /><br />";
        $buff .= '<div id=\'gateway-portability-local-import-progress-bar\'><div class="progress-label">&nbsp;</div></div></div>';
        $buff .= '</div>';

        return $buff;
    }

    function showLocalPortabilityGW( )
    {
        return _databaseSummaryAndImport( );
    }

    function importPortabilityFileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayPortabilityImport.php';

        $app = KSystem::getInstance( );

        $return = array( 'success' => false, 'message' => 'gateway-portability-local-import-error' );
        try
        {
            if ( $_FILES['files']['error'][0] != UPLOAD_ERR_OK )
                throw new Exception( "gateway-portability-local-upload-error" );

            $portability = KGatewayPortabilityImport::getInstance( );

            //TODO: check input data
            $tmp = $portability->createTemporaryFileName( $_FILES['files']['name'][0] );

            if ( move_uploaded_file( $_FILES['files']['tmp_name'][0], $tmp ) === false )
                throw new Exception( "gateway-portability-local-upload-error" );

            $options = new KGatewayPortabilityOptions( );

            $options->fieldDelimiter = $_POST['FieldDelimiter'];
            $options->fieldClosure = $_POST['FieldClosure'];
            $options->ignoreErrors = $_POST['IgnoreErrors'] == 'true';
            $options->ignoreFirstLine = $_POST['IgnoreFirstLine'] == 'true';
            $options->incremental = $_POST['Incremental'] == 'true';
            $options->removeAllContentFirst = $_POST['RemoveAllContent'] == 'true';

            $portability->run( $tmp, $_POST['Type'], $_POST['Format'], $options );

            $return = array( 'success' => true, 'message' => $app->translate( 'gateway-portability-local-import-started' ) );
        }
        catch( Exception $e )
        {
            $return['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $return );
    }

    function showWebservicePortabilityGW()
    {
        $app = KSystem::getInstance( );

        // --------------------------------------------------------------------
        // Service config
        $buffer = '<fieldset>';
        $buffer .= '<legend>' . $app->translate( 'gateway-portability-webservice-form-title' ) . '</legend>';
        $buffer .= '<table class="zebra simpleTable gateway-table-form">';

        // Url
        $buffer .= '<tr class="portability-Url">';
        $buffer .= '<td class="label"><label for="portability-Url">' . $app->translate( 'gateway-portability-webservice-url' ) . '</label> <img class="gateway-tooltip" src="/imagens/tooltip.png" title="' . $app->translate('gateway-portability-webservice-url-help') . '" /></td>';
        $buffer .= '<td class="field gateway-form-field-container-right"><input type="text" id="portability-Url" maxlength="1000" style="width:350px;" placeholder="http://example.com:8080/?number=${number}"/></td>';
        $buffer .= '</tr>';

        // Method
        $buffer .= '<tr class="portability-Method">';
        $buffer .= '<td class="label"><label>' . $app->translate( 'gateway-portability-webservice-method' ) . '</label></td>';
        $buffer .= '<td class="field gateway-form-field-container-right">';
        $buffer .= '<input type="radio" id="portability-Method-GET" name="portability[Method]" value="GET" checked="checked"/> <label for="portability-Method-GET"> GET </label>';
        $buffer .= '  <input type="radio" id="portability-Method-POST" name="portability[Method]" value="POST"/> <label for="portability-Method-POST"> POST </label>';
        $buffer .= '</td>';
        $buffer .= '</tr>';

        // ResponsePattern
        $buffer .= '<tr class="portability-ResponsePattern">';
        $buffer .= '<td class="label"><label for="portability-ResponsePattern">' . $app->translate( 'gateway-portability-webservice-responsepattern' ) . '</label> <img class="gateway-tooltip" src="/imagens/tooltip.png" title="' . $app->translate('gateway-portability-webservice-responsepattern-help') . '" /></td>';
        $buffer .= '<td class="field gateway-form-field-container-right"><input type="text" id="portability-ResponsePattern" maxlength="100" style="width:200px;"/></td>';
        $buffer .= '</tr>';

        // Timeout
        $buffer .= '<tr class="portability-Timeout">';
        $buffer .= '<td class="label"><label for="portability-Timeout">' . $app->translate( 'gateway-portability-webservice-timeout' ) . '</label> <img class="gateway-tooltip" src="/imagens/tooltip.png" title="' . $app->translate('gateway-portability-webservice-timeout-help') . '" /></td>';
        $buffer .= '<td class="field gateway-form-field-container-right">';
        $buffer .= '<select id="portability-Timeout">';
        // from 0.1 to 2.0 seconds with 0.1 second increment
        for( $i = 1; $i < 20; ++$i )
        {
            $value = $i * 100;
            $label = round( $i / 10, 1 );
            $buffer .= "<option value=\"{$value}\">{$label}s</option>";
        }
        $buffer .= '</select>';
        $buffer .= '</td>';
        $buffer .= '</tr>';

        // AdditionalParams
        $buffer .= '<tr class="portability-AdditionalParams" style="display:none;">';
        $buffer .= '<td class="label"><label>' . $app->translate( 'gateway-portability-webservice-additionalparams' ) . '</label> <img class="gateway-tooltip" src="/imagens/tooltip.png" title="' . $app->translate('gateway-portability-webservice-additionalparams-help') . '" /></td>';
        $buffer .= '<td class="field gateway-form-field-container-right"><a id="gateway-portability-webservice-additionalparams-add" href="javascript:;">' . $app->translate('gateway-portability-webservice-additionalparams-add') . '</a></td>';
        $buffer .= '</tr>';

        $buffer .= '</table>';
        $buffer .= '</fieldset>';
        $buffer .= '<br />';

        // --------------------------------------------------------------------
        // Auth
        $buffer .= '<fieldset>';
        $buffer .= '<legend>' . $app->translate( 'gateway-portability-webservice-httpauth-title' ) . '</legend>';
        $buffer .= '<table class="zebra simpleTable gateway-table-form auth">';

        // Username
        $buffer .= '<tr class="portability-Username"><td class="label"><label for="portability-Username">' . $app->translate('Username') . '</label></td><td class="field gateway-form-field-container-right"><input type="text" id="portability-Username" value="" maxlength="100"/></td></tr>';

        // Password
        $buffer .= '<tr class="portability-Password"><td class="label"><label for="portability-Password">' . $app->translate('Password') . '</label></td><td class="field gateway-form-field-container-right"><input type="password" id="portability-Password" value="" maxlength="100"/></td></tr>';

        $buffer .= '</table>';
        $buffer .= '</fieldset>';
        $buffer .= '<br />';

        // --------------------------------------------------------------------
        // Errors
        $buffer .= '<fieldset>';
        $buffer .= '<legend><input type="checkbox" id="kgateway-portability-webservice-errors" class="form-fielset-open-close-check"/> <label for="kgateway-portability-webservice-errors">' . $app->translate( 'gateway-portability-webservice-errors-title' ) . '</label></legend>';

        $buffer .= '<div class="form-fielset-open-close-container" style="display:none;">';
        $buffer .= '<table class="zebra simpleTable gateway-table-form">';

        // Max errors
        $buffer .= '<tr class="portability-webservice-ErrorMaxToSleep">';
        $buffer .= '<td class="label">';
        $buffer .= '<label for="portability-webservice-ErrorMaxToSleep">' . $app->translate('gateway-portability-webservice-ErrorMaxToSleep') . '</label> <img class="gateway-tooltip" src="/imagens/tooltip.png" title="' . $app->translate('gateway-portability-webservice-errormaxtosleep-help') . '" />';
        $buffer .= '</td>';
        $buffer .= '<td class="field gateway-form-field-container-right">';
        $buffer .= '<input type="text" id="portability-webservice-ErrorMaxToSleep" value="" maxlength="2"/>';
        $buffer .= '</td>';
        $buffer .= '</tr>';

        // Sleep time
        $buffer .= '<tr class="portability-webservice-ErrorSleepTime">';
        $buffer .= '<td class="label">';
        $buffer .= '<label for="portability-webservice-ErrorSleepTime">' . $app->translate('gateway-portability-webservice-ErrorSleepTime') . '</label> <img class="gateway-tooltip" src="/imagens/tooltip.png" title="' . $app->translate('gateway-portability-webservice-errorsleeptime-help') . '" />';
        $buffer .= '</td>';
        $buffer .= '<td class="field gateway-form-field-container-right">';
        $buffer .= '<input type="text" id="portability-webservice-ErrorSleepTime" value="" maxlength="2"/>';
        $buffer .= '</td>';
        $buffer .= '</tr>';

        $buffer .= '</table>';
        $buffer .= '</div>';

        $buffer .= '</fieldset>';

        return $buffer . _databaseSummaryAndImport( );
    }

