<?php
    @session_start( );

    $AjaxFunctions['showKhompChanResources'] = 'showKhompChanResources';
    $AjaxFunctions['showKhompContexts'] = 'showKhompContexts';
    $AjaxFunctions['showKhompChans'] = 'showKhompChans';
    $AjaxFunctions['showKhompChanGroups'] = 'showKhompChanGroups';
    $AjaxFunctions['showKhompChanCadences'] = 'showKhompChanCadences';
    $AjaxFunctions['showKhompFxsBranches'] = 'showKhompFxsBranches';
    $AjaxFunctions['showKhompHotlines'] = 'showKhompHotlines';
    $AjaxFunctions['showKhompBranchOptions'] = 'showKhompBranchOptions';
    $AjaxFunctions['showKhompFxsOptions'] = 'showKhompFxsOptions';
    $AjaxFunctions['showKhompFXO'] = 'showKhompFXO';
    $AjaxFunctions['showKhompE1'] = 'showKhompE1';
    $AjaxFunctions['makeSetVar'] = 'makeSetVar';
    $AjaxFunctions['getChannelRange'] = 'getChannelRange';
    $AjaxFunctions['getFxsBranches'] = 'getFxsBranches';
    $AjaxFunctions['makeFXSOptionLine'] = 'makeFXSOptionLine';
    $AjaxFunctions['selectDeviceBranch'] = 'selectDeviceBranch';
    $AjaxFunctions['selectDeviceBranchHotline'] = 'selectDeviceBranchHotline';
    $AjaxFunctions['getFXSTable'] = 'getFXSTable';
    $AjaxFunctions['removeSection'] = 'removeSection';
    $AjaxFunctions['restoreDefault'] = 'restoreDefault';
    $AjaxFunctions['translate'] = 'translate';

    function dbg($msg)
    {
        echo '<pre>' . $msg . '</pre>';
    }
    function vdbg($var)
    {
        echo '<pre>' . var_export($var, true) . '</pre>';
    }

    function removeSection()
    {
        $sec = $_REQUEST['section'];
        $sec = str_replace('_','+',$sec);

        $file = file_get_contents('/etc/asterisk/khomp.conf');
        if(!$file) return 'khomp.conf not found!';

        $lines = explode("\n", $file);
      
        $begin=-1; $end=count($lines);
        for($i=0; $i < $end; ++$i)
        {
            if($begin < 0)
            {
                $pattern = '/^\s*\[' . $sec . '\].*/';
                if(preg_match($pattern, $lines[$i]))
                {   //Found section start
                    $begin = $i;
                }
            }
            else //searching of section's end
            {
                $pattern = '/^\s*\[\S*?\].*/'; //A generic section name
                if(preg_match($pattern, $lines[$i]))
                {
                    $end = $i-1;
                    break;
                }
            }
        }
        // Section not found? Create it!
        if($begin < 0)
            return 'could not find section'; // this is not an error

        array_splice($lines, $begin, $end - $begin + 1);

        $file = fopen('/etc/asterisk/khomp.conf', "w");
        if(!$file) return 'khomp.conf not found!';

        fwrite($file, implode("\n", $lines));
        fclose($file);

        return $sec . ' removed.';
    }

    function getChannelRange( )
    {
        Global $_SESSION;
        Global $sistema;
        $wc = $_REQUEST['wc'];
        $type = $_REQUEST['type'];

        $serial = explode('.', $wc, 2);
        $range = trim($serial[1], "[]");
        if($serial[0] != "*")
        {
            $board = $sistema->getDevicePositionBySerial($serial[0]);
            if($board<0)
                return 'error: could not find board';
        }
        else
        {
            if($type!='Tech')
                return 'error: no serial';
        }

        switch($type)
        {
            case 'Channel':
                $chans = explode('-', $range);
                if($chans[0] == $chans[1])
                    $range = $chans[0];

                return 'B'.$board.'C'.$range;
                break;
            case 'Device':
                return 'B'.$board;
            case 'Links':
                $chans = explode('-', $range);
                if($chans[0] == $chans[1])
                    $range = $chans[0];
                return 'B'.$board.'L'.$range;
            case 'Tech':
            {
                $tech = $range;
                Global $sistema;
                if($tech == 'E1')
                {
                    $links = $sistema->getE1Links();
                    $map = array();
                    foreach($links as $l)
                    {
                        $tmp = explode('.', $l, 2);
                        $board = $sistema->serialToBoard($tmp[0]);
                        if($board>=0)
                        {
                            if(!array_key_exists($board, $map))
                                $map[$board] = '';
                            $map[$board] .= $tmp[1] . ',';
                        }
                    }
                    $chans='';
                    foreach($map as $b => $l)
                    {
                        $tmp = explode(',', $l);
                        $min = min($tmp);
                        $chans .= 'B' . $b . 'L' . ($min==0 ? "0" : "{$min}") . '-' . max($tmp) . '_';
                    }
                    return rtrim($chans, '_');
                }

                $chanMap = $sistema->getTechChannels($tech);
                $chans='';
                foreach($chanMap as $m)
                {
                    $chans .= 'B'.$m['board'].'C'.$m[0].'-'.$m[1].'_';
                }
                return rtrim($chans, '_');
            }
            default:
                return 'error: invalid range type';
        }
        return "error: wtf"; //won't reach here
    }

    function tooltip($name)
    {
        Global $sistema, $image_dir;
        $str = $sistema->retTranslate('short-tooltip-'.$name);
        if(strpos($str, 'tooltip') !==false)
            return '';

        $text = ($sistema->retTranslate('tooltip-'.$name));
        $text = '  <img class="help-tooltip" title="'.$text.'" alt="tooltip" src="'.$image_dir.'/imagens/tooltip.png">';

        return $str . $text;
    }

    function makeButtons($name, $custom=false, $editable=false)
    {
        Global $image_dir, $sistema;

        $buff  = "<span style='float:right'>";

        if($editable)
        {
            $buff .= "<a href='#!' onclick=\"editKhompChanPerfil(this,'${name}');\">";
            $buff .= "<img name=${name}_edit src='${image_dir}/imagens/edit.png' title='";
            $buff .= $sistema->retTranslate( 'edit' )."' /></a>";
        }

        $buff .= "<a href='#!' onclick=\"restoreDefault(this,'${name}');\">";
        $buff .= "<img width='16px' name=${name}_restore src='${image_dir}/imagens/default-config.png' ";
        $buff .= "title='" . $sistema->retTranslate( 'restore_default' )."' /></a>";

        if($custom)
        {
            $buff .= '<a href="#!" onclick="deleteRow(this)">';
            $buff .= '<img  src="'.$image_dir.'/imagens/remove.png" ';
            $buff .= 'title="'.$sistema->retTranslate('remove').'"></a></td>';
        }
        
        $buff .= "</span>";

        return $buff;
    }

    function getKhompOption($name, $value, $custom=false)
    {
        Global $sistema;
        $possibleValues=false;
        $values=false;

        switch($name)
        {
            // Checkboxes:
            //[globals]
            case 'dial-string-like-dahdi':
            case 'ccss-enable':
            case 'freepbx-callerid':

            //[channels]
            case 'echo-canceller':
            case 'auto-gain-control':
            case 'out-of-band-dtmfs':
            case 'dtmf-suppression':
            case 'auto-fax-adjustment':
            case 'pulse-forwarding':
            case 'r2-strict-behaviour':
            case 'immediate-sharp-dial':
            case 'ignore-letter-dtmfs':
            case 'fxo-send-pre-audio':
            case 'drop-collect-call':
            case 'callerid-inheritance':
            case 'pendulum-native':
            case 'pendulum-incoming':
                $buff  = "<td>".tooltip($name)."</td>";
                $buff .= "<td>${name}</td>";
                $buff .= "<td name=${name}>";
                $checked = (strcasecmp($value, 'yes')==0 or strcasecmp($value, 'true')==0) ? 'checked=\'checked\'' : '';
                $buff .= "<input id='{$name}' type='checkbox' name='{$name}' {$checked} >";
                $buff .= makeButtons($name,$custom);
                $buff .= "</td>";
                break;

                // Dropdown menus:
                // [globals]

            case 'load-error':
                $possibleValues = array('failure', 'skip');
                break;
            //case 'audio-rx-sync':
                //$possibleValues = array('auto', 'softtimer-thread', 'softtimer-multi-thread',
                //'softtimer-kernel');
                //break;
            case 'kommuter-activation':
                $possibleValues = array('auto', 'manual');
                break;
                // [channels]
            case 'r2-hangup-behaviour':
                $possibleValues = array('force-disconnect', 'disconnect', 'release');
                break;
            case 'qsig-transfer-facility':
                $possibleValues = array('qsig-ct', 'qsig-ct-rr', 'qsig-ct-pr', 'qsig-ssct',
                'any', 'none');
                break;
            case 'flash-behaviour':
                $possibleValues = array('xfer', 'pendulum', 'auto', 'none');
                break;

                //Multiselect
            case 'log-to-console':
                $values = array('errors', 'warnings', 'events', 'commands',
                    'modem', 'link', 'standard');
                break;
            case 'log-to-disk':
                $values = array('errors', 'warnings', 'messages', 'commands', 'modem',
                'link', 'functions', 'standard', 'debugging', 'diagnostic');
                break;
            case 'drop-options':
                //$values = array('message_box', 'human_answer', 'answering_machine',
                //'carrier_message', 'fax', 'unknown');
                $buff  = "<td>".tooltip($name).'</td>';
                $buff .= "<td>${name}</td>";
                $buff .= "<td name=${name}>";
                $buff .= "<div id='drop-options-menu' class='multiSelDiv'>";
                $buff .= makeDropOptions( explode(',', $value) );
                $buff .= "</div>";
                $buff .= "<div style='display:inline-block;float:right'>";
                $buff .= makeButtons($name,$custom);
                $buff .= "</div>";
                $buff .= "</td>";
                return $buff;
                break;

            default: // Text field
                global $image_dir;
                $buff  = "<td>".tooltip($name)."</td>";
                $buff .= "<td>${name}</td>";
                $buff .= "<td name=${name} class='plaintext";
                switch($name)
                {
                    case "fxs-global-orig":
                    //case "audio-packet-length":
                    case 'fax-adjustment-timeout':
                    case "kommuter-timeout":
                    case "r2-preconnect-wait":
                    case "output-volume":
                    case "input-volume":
                    case "callgroup":
                    case "pickupgroup":
                    case "fxo-user-xfer-delay":
                    case "disconnect-delay":
                    case "delay-ringback-co":
                    case "delay-ringback-pbx":
                    case "fxo-busy-disconnection":
                    case "fxs-digit-timeout":
                    case "pendulum-timeout":
                        $buff .= ' number';
                        break;
                }
                $buff .= "'> <span class='plaintext'>" . $value . "</span>";
                $buff .= makeButtons($name,$custom,true);
                $buff .= "</td>";
                break;
        }

        if($possibleValues) //dropdown
        {
            $buff = "<td>".tooltip($name).'</td>';
            $buff .= "<td>${name}</td>";
            $buff .= '<td name='.$name.'><select id="'.$name.'_dropdown" name="'.$name.'" >';
            foreach ($possibleValues as $v)
            {
                $selected = ($v == $value) ? 'selected' : '';
                $buff .= "<option value='$v' $selected>$v</option>";
            }
            $buff .= '</select>';
            $buff .= makeButtons($name,$custom);
            $buff .= "</td>";
        }
        else if($values) //multiselect
        {
            $buff  = "<td>".tooltip($name).'</td>';
            $buff .= "<td>${name}</td>";
            $buff .= "<td name=${name}>";
            $buff .= "<div class='multiSelDiv'>";
            $buff .= makeMultiselect($values, explode(',', $value), $name);
            $buff .= "</div>";
            $buff .= "<div style='display:inline-block;float:right'>";
            $buff .= makeButtons($name,$custom);
            $buff .= "</div>";
            $buff .= "</td>";
        }

        return $buff;
    }
    function restoreDefault()
    {
        $opt = $_REQUEST['opt'];
        $custom = $_REQUEST['custom'];
        $defs = loadDefaultKhompConfig();
        $globals = $defs['geral']['globals'];
        $channels= $defs['channels']['channels'];
        if(array_key_exists($opt, $globals))
            return getKhompOption($opt, $globals[$opt], $custom);
        if(array_key_exists($opt, $channels))
            return getKhompOption($opt, $channels[$opt], $custom);
    }
    function is_option($name, $opt)
    {
        if($opt == 'context')
        {
            if(strpos($name, 'context') !== false)
                return true;
            else
                return false;
        }
        else
        {
            if(strpos($name, 'context') !== false)
                return false;
        }
        if($name == 'immediate-sharp-dial')
        {
            if($opt != 'fxs')
                return false;
            return true;
        }
        if($name == 'qsig-transfer-facility')
        {
            if($opt != 'e1')
                return false;
            return true;
        }
        switch($opt)
        {
            case 'e1':
                if(strpos($name, 'r2') !== false)
                    return true;
                return false;
            case 'fxs':
                if(strpos($name, 'dialtone') !== false or strpos($name, 'fxs') !== false or strpos($name, 'pendulum') !== false)
                    return true;
                return false;
            case 'fxo':
                if(strpos($name, 'fxo') !== false)
                    return true;
                return false;
        }
    }
    function is_trunk_option($name)
    {
        return is_option($name, 'fxs') or
               is_option($name, 'e1') or
               is_option($name, 'fxo') or
               is_option($name, 'context');
    }
    function is_fxs_option($opt)
    {
        return is_option($opt, 'fxs');
    }

    function makeHelpText($name)
    {
        Global $sistema;
        $ret = "<fieldset><div id='${name}-help-text'>";
        $text = $sistema->retTranslate($name.'-help-text');
        $ret .= $text . "</div></fieldset>";
        if($text != '' and $text != ($name.'-help-text'))
            return $ret;
        return '';
    }

    function makeTableHeader($name)
    {
        Global $sistema;
        $buff = makeHelpText($name);
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( $name ) . "</legend>";
        $buff .= "<span>";
        $buff .= "<table class='zebra chan_opt_table' id='table_${name}'><thead>";
        $buff .= "<tr><th width='40%'>";
        if(substr($name, 0, 9) == 'channels-')
        {
            $buff .= '<a href="#!" onclick="removeTable(this)">';
            $buff .= '<img align="left" src="'.$image_dir.'/imagens/remove_white.png" title="Remover"> </a>';
        }
        $buff .= $sistema->retTranslate( 'description' ) . "</th>";
        $buff .= "<th width='30%'>" . $sistema->retTranslate( 'option' ) . "</th>";
        $buff .= "<th width='30%'>" . $sistema->retTranslate( 'value' ) . "</th>";
        $buff .= "</tr></thead><tbody>";
        return $buff;
    }

    function showKhompChanResources( )
    {
        Global $sistema;
        $Kconf_arr = loadKhompConfig( );

        $buff  = makeTableHeader('general');

        $geral = $Kconf_arr['geral']['globals'];

        foreach($geral as $name => $value)
        {
            if(strpos($name, 'context') !== false)
                continue;
            if(is_fxs_option($name))
                continue;
            $buff .= "<tr>";
            $buff .= getKhompOption($name,$value);
            $buff .= "</tr>";
        }
        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelOptions();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= makeMultiselectScript();
        return $buff;
    }
    function showKhompContexts( )
    {
        Global $sistema;
        $Kconf_arr = loadKhompConfig( );

        $buff  = makeTableHeader('contexts');

        $geral = $Kconf_arr['geral']['globals'];

        foreach($geral as $name => $value)
        {
            if(strpos($name, 'context') === false)
                continue;
            $buff .= "<tr>";
            $buff .= getKhompOption($name,$value);
            $buff .= "</tr>";
        }
        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelOptions();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        return $buff;
    }
    function makeSetVar( )
    {
        return _makeSetVar('', $_GET['parent_section']);
    }
    function _makeSetVar($opt, $parent='table_channels')
    {
        Global $sistema;
        Global $image_dir;
        $section = 'setvar_'.$parent;
        $buff  = "<fieldset><legend>" . $sistema->retTranslate( 'setvar' ) . "</legend>";
        $buff .= "<span id='KhompChans'>";
        $buff .= "<table class='zebra' id='table_${section}'><thead>";
        $buff .= "<tr><th width='35%'>" . $sistema->retTranslate( 'option' ) . "</th>";
        $buff .= "<th width='35%'>" . $sistema->retTranslate( 'value' ) . "</th>";
        $buff .= "<th width='30%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        if($opt)
        foreach($opt as $name => $value)
        {
            $buff .= "<tr>";
            $buff .= "<td>${name}</td>";
            $buff .= "<td name=${name} class='plaintext'>";
            $buff .= $value;
            $buff .= "</td>";
            $buff .= "<td><a href='#!' onclick=\"editKhompOption(this);\">";
            $buff .= "<img name=${name}_edit src='${image_dir}/imagens/edit.png' title='";
            $buff .= $sistema->retTranslate( 'edit' )."'  /></a>";
            $buff .= '<a href="#!" onclick="deleteRow(this)">';
            $buff .= '<img src="'.$image_dir.'/imagens/remove.png" title="'.$sistema->retTranslate('remove').'"></a>';
            $buff .= "</td></tr>";
        }
        
        $buff .= "</tbody></table>";

        $buff .= "<br>";
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input name='add_var' type='button' onclick=\"addChannelVar(this);\" value='".$sistema->retTranslate('newvar')."' />";
        $buff .= "</div>";
        $buff .= "</span>";
        $buff .= "</fieldset>";
        $buff .= "</fieldset>"; // Parent table

        return $buff;
    }

    function makeMultiselect($values, $defaults, $id)
    {
        $buff = '
        <dl id="'.$id.'" class="dropdown" > 
            <dt class="hida_dt" onclick="dropdownOnClick(this)">
                <span  class="hida" id='.$id.' >';
                if(!$defaults[0])
                    $buff .= '<span title="None">None</span>';
                else
                    foreach($defaults as $d)
                        $buff.="<span title=\"${d}\">${d}".($d!=end($defaults)?",&nbsp;":"")."</span>";
                $buff .= '</span>
            </dt>
          
            <dd>
                <div class="multiSelect" align="left">
                    <ul class="dropSel">';
                    foreach($values as $v)
                    {
                        $checked = in_array($v, $defaults) ? 'checked="checked"' : '';
                        $buff .= "<li> <input type=\"checkbox\" ${checked} value=\"${v}\" ";
                        $buff .= "onclick='multiSelectOnClick(this)' /> ${v} </li>";
                    }
                    $buff .= '</ul>
                </div>
            </dd>   
        </dl>';
        return $buff;
    }

    function makeDropOptions($values)
    {
        if(!$values[0])
            $values = array('None');
        $buff = '<div class="hida_dt" onclick="initDropOptionsAssistant(this)">';
        foreach($values as $v)
            $buff.="${v}" . ($v!=end($values)?",&nbsp;":"");
        $buff .= "</div>";
            
        return $buff;
    }

    function makeMultiselectScript()
    {
        return '
        <script>
        $(document).bind(\'click\', function (e) {
            var $clicked = $(e.target);
            if (!$clicked.parents().hasClass("dropdown"))
                $(".dropdown dd ul").hide();
        });

        </script>';
    }

    function showKhompChans( )
    {
        Global $sistema, $image_dir;
        $Kconf_arr = loadKhompConfig( );
        $buff  = "";
        $create_add_chan_button = true;
        $prev_section='';
        foreach($Kconf_arr['channels'] as $section => $opt)
        {
            if(substr($section, 0, 6) == 'setvar')
            {
                //Removing "add setvar table" button
                $buff = substr($buff, 0, $index[0]) . substr($buff, $index[1]);
                //removing the last </fieldset>
                $buff = substr($buff, 0, -11) . _makeSetVar($opt, "table_" . $prev_section);
                continue;
            }
            else
                $prev_section = $section;
            if($create_add_chan_button and $section != 'channels')
            {
                $create_add_chan_button = false;
                $buff .= '<div align="center"><br>';
                $buff .= "<input id='addChanButton' type='button' onclick=\"askNewChannelName();\" style='font-size: 14px' value='";
                $buff .= $sistema->retTranslate( 'newchansection' ) . "' /><br></div>";
                $buff .= '<div id="askNewChanField" align=\'center\' ></div>';
            }
            $buff .= makeTableHeader($section);
            foreach($opt as $name => $value)
            {
                if($section == 'channels' and is_trunk_option($name))
                    continue;
                $buff .= "<tr>";
                $buff .= getKhompOption($name,$value, ($section != "channels"));
                $buff .= "</tr>";
            }
            $buff .= "</tbody></table>";

            $buff .= "<br>";
            $buff .= "<div class='textAlignRight'>";
            $index[0] = strlen($buff);
            $buff .= "<input name=addSetvarTableButton type='button' onclick=\"addSetvarTable(this);\" value='" . $sistema->retTranslate( 'addsetvar' ) . "' />";
            $index[1] = strlen($buff);
            if($section != "channels")
            {
                $buff .= "<input name='add_rule_${section}' type='button' onclick=\"addChannelRule('table_${section}');\" value='" . $sistema->retTranslate( 'newrule' ) . "' />";
            }
            $buff .= "</div>";
            $buff .= "<div class='setvarDiv'></div>";
            $buff .= "</span>";
            $buff .= "</fieldset>";

        }
        if($create_add_chan_button)
        {
            $create_add_chan_button = false;
            $buff .= '<div align="center"><br>';
            $buff .= "<input id='addChanButton' type='button' onclick=\"askNewChannelName();\" style='font-size: 14px' value='";
            $buff .= $sistema->retTranslate( 'newchansection' ) . "' /><br></div>";
            $buff .= '<div id="askNewChanField" align=\'center\' ></div>';
        }
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<br>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelOptions();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= makeMultiselectScript();


        return $buff;
    }

    function makeOptionLine($td1, $td2)
    {
        Global $image_dir;
        $buff  = "<tr><td>" . $td1 . "</td>";
        $buff .= "<td class='plaintext'>" . $td2 . "</td>";
        $buff .= "<td>";
        $buff .= "<a href='#!' onclick=\"editKhompOption(this);\">";
        $buff .= '<img src="'.$image_dir.'/imagens/edit.png" title="Edit" /></a>';
        $buff .= "<a href='#!' onclick=\"deleteRow(this);\">";
        $buff .= '<img src="'.$image_dir.'/imagens/remove.png" title="remove" /></a>';
        $buff .= "</td></tr>";
        return $buff;
    }

    function showKhompChanGroups( )
    {
        Global $sistema;

        $Kconf_arr = loadKhompConfig( );
        $groups = $Kconf_arr['geral']['groups'];

        $buff = makeHelpText('groups');
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'groups' ) . "</legend>";
        $buff .= "<span id='KCGroups'>";
        $buff .= "<table class='zebra' id='table_groups' ><thead>";

        $i = 0;

        $groupsSize = sizeof( $groups );
        $groupsVars = $groupsSize > 0 ? array_keys( $groups ) : 0;

        $buff .= "<tr><th width='20%'>" . $sistema->retTranslate( 'name' ) . "</th>";
        $buff .= "<th width='60%'>" . $sistema->retTranslate( 'Expression' ) . "</th>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        for( $i = 0; $i < $groupsSize; $i++ )
        {
            $buff .= makeOptionLine($groupsVars[$i], $groups[$groupsVars[$i]]);
        }

        if( $groupsSize == 0 )
            $buff .= "<tr><td colspan='3' class='null_cell'>" . $sistema->retTranslate( 'NGroup' ) . "</td></tr>";

        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div style='width: 50%; float:left'>";
        $buff .= "<input type='button' id='bAddKCGroup' onClick='addOptionRow(\"table_groups\");' value='" . $sistema->retTranslate( 'addGroup' ) . "'>";
        $buff .= "</div>";
        $buff .= "<div class='textAlignRight' style='width: 50%; float:right'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelSectionsGeneric();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        return $buff;
    }

    function showKhompTrunkOptions($tech)
    {
        Global $sistema;
        $Kconf_arr = loadKhompConfig( );

        $buff  = makeTableHeader("${tech}-options");

        $opts = array_merge($Kconf_arr['geral']['globals'], $Kconf_arr['channels']['channels']);

        foreach($opts as $name => $value)
        {
            if(!is_option($name, $tech))
                continue;
            $buff .= "<tr>";
            $buff .= getKhompOption($name,$value);
            $buff .= "</tr>";
        }
        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelOptions();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        return $buff;
    }

    function showKhompFxsOptions( )
    {
        return showKhompTrunkOptions('fxs');
    }
    function showKhompE1( )
    {
        return showKhompTrunkOptions('e1');
    }
    function showKhompFXO( )
    {
        return showKhompTrunkOptions('fxo');
    }

    function showKhompFxsBranches( )
    {
        Global $sistema;

        $Kconf_arr = loadKhompConfig( );
        $FBranches = $Kconf_arr['geral']['fxs-branches'];

        $buff = makeHelpText('fxs-branches');
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'fxs-branches' ) . "</legend>";
        $buff .= "<span id='KCFBranche'>";
        $buff .= "<table class='zebra' id='table_fxs-branches' ><thead>";

        $FBranchesSize = sizeof( $FBranches );
        $FBranchesVars = $FBranchesSize > 0 ? array_keys( $FBranches ) : 0;

        $buff .= "<tr><th width='20%'>" . $sistema->retTranslate( 'Branches' ) . "</th>";
        $buff .= "<th width='60%'>" . $sistema->retTranslate( 'serial' ) . "</th>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        for( $i = 0; $i < $FBranchesSize; $i++ )
        {
            $buff .= makeOptionLine($FBranchesVars[$i], $FBranches[$FBranchesVars[$i]]);
        }

        if( $FBranchesSize == 0 )
            $buff .= "<tr><td colspan='3' class='null_cell'>" . $sistema->retTranslate( 'NFBranche' ) . "</td></tr>";

        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div style='width: 50%; float:left'>";
        $buff .= "<input type='button' id='bAddKCFBranche' onClick=\"initFXSAssistant('getBranchAssistant','&name=fxs-branches&func=branchSelected')\" value=\"" . $sistema->retTranslate( 'addFBranche' ) . "\">";
        $buff .= "</div>";
        $buff .= "<div class='textAlignRight' style='width: 50%; float:right'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelSectionsGeneric();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        return $buff;
    }

    function showKhompHotlines( )
    {
        Global $sistema;

        $Kconf_arr = loadKhompConfig( );
        $FHotlines = $Kconf_arr['geral']['fxs-hotlines'];

        $buff = makeHelpText('fxs-hotlines');
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'fxs-hotlines' ) . "</legend>";
        $buff .= "<span id='KCFHotline'>";
        $buff .= "<table class='zebra' id='table_fxs-hotlines'><thead>";

        $i = 0;

        $FHotlinesSize = sizeof( $FHotlines );
        $FHotlinesVars = $FHotlinesSize > 0 ? array_keys( $FHotlines ) : 0;

        $buff .= "<tr><th width='20%'>" . $sistema->retTranslate( 'Branches' ) . "</th>";
        $buff .= "<th width='60%'>" . $sistema->retTranslate( 'Number' ) . "</th>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        for( $i = 0; $i < $FHotlinesSize; $i++ )
        {
            $buff .= makeOptionLine($FHotlinesVars[$i], $FHotlines[$FHotlinesVars[$i]]);
        }

        if( $FHotlinesSize == 0 )
            $buff .= "<tr><td colspan='3' class='null_cell'>" . $sistema->retTranslate( 'NFHotlines' ) . "</td></tr>";

        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div style='width: 50%; float:left'>";
        $buff .= "<input type='button' id='bAddKCFHotline' onClick=\"initFXSAssistant('getBranchAssistant','&name=branch-hotline&func=branchSelected')\" value=\"" . $sistema->retTranslate( 'addFHotline' ) . "\">";

        $buff .= "</div>";
        $buff .= "<div class='textAlignRight' style='width: 50%; float:right'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelSectionsGeneric();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        return $buff;
    }


    function _makeFXSOptionTr($chan, $callerid, $values)
    {
        Global $image_dir;
        $class = strlen($chan)==0 ? 'class="invalidRow"' : '';
        $buff  = "<tr ${class}><td>${chan}</td>";
        $buff .= "<td class='plaintext' name='${chan}'>" . $callerid . "</td>";
        $buff .= "<td class='plaintext'>" . $values . "</td>";
        $buff .= "<td>";
        $buff .= "<a href='#!' onclick=\"editFXSRowOption(this);\">";
        $buff .= '<img src="'.$image_dir.'/imagens/edit.png" title="Edit" /></a>';
        $buff .= "<a href='#!' onclick=\"deleteRow(this);\">";
        $buff .= '<img src="'.$image_dir.'/imagens/remove.png" title="remove" /></a>';
        $buff .= "</td></tr>";
        return $buff;
    }

    function makeFXSOptionLine()
    {
        return _makeFXSOptionLine($_GET['branch'], $_GET['opts'], $_GET['serial']);
    }


    function _makeFXSOptionLine($branch, $values, $serial)
    {
        $buff = '';
        $range = explode('-',$branch);

        $bm = new branchManager();

        if(count($range)>1)
        {
            $beg = $range[0];
            $end = $range[1];
            $callerids = $bm->get_callerids_from_serial_sorted( $serial );
            for($i = array_search($beg, $callerids); ; ++$i)
            {
                $chan = $bm->get_bxcy_from_callerid( $callerids[$i] );
                $buff .= _makeFXSOptionTr($chan, $callerids[$i], $values);
                if($callerids[$i] == $end)
                    break;
            }
        }
        else
        {
            $chan = $bm->get_bxcy_from_callerid( $range[0] );
            $buff .= _makeFXSOptionTr($chan, $range[0], $values);
        }

        return $buff;
    }

    function showKhompBranchOptions( )
    {
        Global $sistema, $image_dir;

        $Kconf_arr = loadKhompConfig( );
        $FOptions = $Kconf_arr['geral']['fxs-options'];

        $buff = makeHelpText('branch-options');
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'branch-options' ) . "</legend>";
        $buff .= "<span id='KCFOption'>";
        $buff .= "<table class='zebra' id='table_branch-options'><thead>";

        $i = 0;

        $FOptionsSize = sizeof( $FOptions );
        $FOptionsVars = $FOptionsSize > 0 ? array_keys( $FOptions ) : 0;

        $buff .= "<tr><th width='15%'>" . $sistema->retTranslate( 'channel' ) . "</th>";
        $buff .= "<th width='15%'>" . $sistema->retTranslate( 'branch' ) . "</th>";
        $buff .= "<th width='60%'>" . $sistema->retTranslate( 'options' ) . "</th>";
        $buff .= "<th width='10%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        $bm = new branchManager();
        for( $i = 0; $i < $FOptionsSize; $i++ )
        {
            $branch = $FOptionsVars[$i];
            $values = $FOptions["${branch}"];

            if(preg_match('/[bB](\d+)[cC](\d+)/', $branch))
            {
                $bxcy = getBoardChanFromStr($branch);
                $chan = 'B'.$bxcy[0].'C'.$bxcy[1];
                $callerid = $bm->get_callerid_from_bxcy($chan);
            }
            else
            {
                $callerid = $bm->get_callerid_from_branch($branch);
                $chan = $bm->get_bxcy_from_callerid($callerid);
            }

            if ( preg_match('/.*calleridnum\s*:\s*(\d+).*/', $values) )
            {
                // Remove calleridnum option from line.
                $values = preg_replace('/(.*)calleridnum\s*:\s*\d+(.*)/', '$1$2', $values);
                $values = preg_replace('/\|\s*\|/', '|', trim($values,'| '));
            }

            $class = strlen($chan)==0 ? 'class="invalidRow"' : '';
            $buff .= "<tr {$class}><td>${chan}</td>";
            $buff .= "<td class='plaintext' name='${chan}' >" . $callerid . "</td>";
            $buff .= "<td class='plaintext'>" . $values . "</td>";
            $buff .= "<td>";
            $buff .= "<a href='#!' onclick=\"editFXSRowOption(this);\">";
            $buff .= '<img src="'.$image_dir.'/imagens/edit.png" title="Edit" /></a>';
            $buff .= "<a href='#!' onclick=\"deleteRow(this);\">";
            $buff .= '<img src="'.$image_dir.'/imagens/remove.png" title="remove" /></a>';
            $buff .= "</td></tr>";
        }

        if( $FOptionsSize == 0 )
            $buff .= "<tr><td colspan='4' class='null_cell'>" . $sistema->retTranslate( 'NFOptions' ) . "</td></tr>";

        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div style='width: 50%; float:left'>";
        $buff .= "<input type='button' id='bAddKCFOption' onClick=\"initFXSAssistant('getFXSAssistant');\" value=\"" . $sistema->retTranslate( 'addFOption' ) . "\">";
        $buff .= "</div>";
        $buff .= "<div class='textAlignRight' style='width: 50%; float:right'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveFXSOptions();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";

        return $buff;
    }

    function showKhompChanCadences( )
    {
        Global $sistema;

        $Kconf_arr = loadKhompConfig( );
        $cadences = $Kconf_arr['geral']['cadences'];

        if($Kconf_arr['geral']['globals']['dial-string-like-dahdi'] != "no")
        {
            foreach($cadences as $k => $v)
            {
                if(!is_numeric($k))
                    unset($cadences[$k]);
            }
            $default = array(
            '125,125,2000,4000',
            '250,250,500,1000',
            '125,125,125,125',
            '1000,500,2000,4000');
            for($i=1; $i<5; ++$i)
                if(!array_key_exists($i, $cadences))
                    $cadences[$i] = $default[$i-1];
        }

        $buff = makeHelpText('cadences');
        $buff .= "<fieldset><legend>" . $sistema->retTranslate( 'Cadences' ) . "</legend>";
        $buff .= "<span id='KCCadence'>";
        $buff .= "<table class='zebra' id='table_cadences'><thead>";

        $cadenceSize = sizeof( $cadences );
        $cadenceVars = $cadenceSize > 0 ? array_keys( $cadences ) : 0;

        $buff .= "<tr>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'Name' ) . "</th>";
        $buff .= "<th width='60%'>" . $sistema->retTranslate( 'ConfiguracaoTons' ) . "</th>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        for( $i = 0; $i < $cadenceSize; $i++ )
        {
            $buff .= makeOptionLine($cadenceVars[$i], $cadences[$cadenceVars[$i]]);
        }

        if( $cadenceSize == 0 )
        {
            $buff .= "<tr><td colspan='3' class='null_cell'>" . $sistema->retTranslate( 'NCadence' ) . "</td></tr>";
        }

        $buff .= "</tbody></table>";
        $buff .= "</span>";
        $buff .= "</fieldset>";

        $buff .= "<br>";
        $buff .= "<div style='width: 50%; float:left'>";
        $buff .= "<input type='button' id='bAddKCCadence' onClick=\"addOptionRow('table_cadences');\" value=\"" . $sistema->retTranslate( 'addCadence' ) . "\">";
        $buff .= "</div>";
        $buff .= "<div class='textAlignRight' style='width: 50%; float:right'>";
        $buff .= "<input id='saveChannelOptionsButton' type='button' onclick=\"saveChannelSectionsGeneric();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        return $buff;
    }


    //************** aux functions *******************//
    function loadDefaultKhompConfig()
    {
        return array (
          'geral' => 
          array (
            'globals' => 
            array (
              'dial-string-like-dahdi' => 'no',
              'load-error' => 'failure',
              'context-digital' => 'khomp-DD-LL',
              'context-fxs' => 'khomp-DD-CC',
              'context-fxs-alt' => 'khomp-DD',
              'context-fxo' => 'khomp-DD-CC',
              'context-fxo-alt' => 'khomp-DD',
              'context-gsm-call' => 'khomp-DD-CC',
              'context-gsm-call-alt' => 'khomp-DD',
              'context-gsm-sms' => 'khomp-sms-DD-CC',
              'context-gsm-ussd' => 'khomp-ussd-DD-CC',
              //'context-gsm-wait' => 'khomp-wait-DD-CC',
              'context-pr' => 'khomp-DD-CC',
              'log-to-console' => 'standard',
              'log-to-disk' => 'standard',
              'fxs-global-orig' => '00',
              //'audio-rx-sync' => 'auto',
              //'audio-packet-length' => '160',
              'kommuter-activation' => 'auto',
              'kommuter-timeout' => '10',
              'ccss-enable' => 'false',
              'freepbx-callerid' => 'no',
              'co-dialtone-digits' => '',
            ),
            'cadences' =>
            array (
              'co-dialtone'  => '0,0',
              'vm-dialtone'  => '1000,100,100,100',
              'pbx-dialtone' => '1000,100',
              'fast-busy'    => '100,100',
              'ringback'     => '1000,4000',
              'waiting-call' => '100,100,100,3700',
              'ring'         => '1000,4000',
            ),
          ),
          'channels' => 
          array (
            'channels' => 
            array (
              'echo-canceller' => 'yes',
              'auto-gain-control' => 'no',
              'out-of-band-dtmfs' => 'yes',
              'dtmf-suppression' => 'yes',
              'auto-fax-adjustment' => 'yes',
              'fax-adjustment-timeout' => '30',
              'pulse-forwarding' => 'no',
              'r2-strict-behaviour' => 'no',
              'r2-preconnect-wait' => '250',
              'r2-hangup-behaviour' => 'force-disconnect',
              'output-volume' => '0',
              'input-volume' => '0',
              'amaflags' => 'default',
              'callgroup' => '0',
              'pickupgroup' => '0',
              'accountcode' => '',
              'language' => '',
              'mohclass' => 'default',
              'fxo-user-xfer-delay' => '1000',
              'immediate-sharp-dial' => 'no',
              'dialtone-cadence' => 'pbx-dialtone',
              'vm-dialtone-cadence' => 'vm-dialtone',
              'co-dialtone-cadence' => 'co-dialtone',
              'disconnect-delay' => '0',
              'delay-ringback-co' => '1500',
              'delay-ringback-pbx' => '2500',
              'ignore-letter-dtmfs' => 'yes',
              'fxo-send-pre-audio' => 'yes',
              'fxo-busy-disconnection' => '1250',
              'fxs-digit-timeout' => '7',
              'drop-collect-call' => 'no',
              'drop-options' => '',
              'qsig-transfer-facility' => 'qsig-ct',
              'flash-behaviour' => 'xfer',
              'pendulum-digits' => '',
              'pendulum-hangup-digits' => '',
              'pendulum-native' => 'yes',
              'pendulum-incoming' => 'yes',
              'pendulum-timeout' => '20000',
              'callerid-inheritance' => 'no',
            ),
          ),
        );
    }

    function loadKhompConfig( )
    {
        $fileContent = is_file('/etc/asterisk/khomp.conf') ?
            file('/etc/asterisk/khomp.conf', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES) :
            file( 'C:\\khomp.conf', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
        $sectionName = '';
        $varName = '';

        $Kconf_arr = loadDefaultKhompConfig();

        for( $x = 0; $x < sizeof( $fileContent ); $x++ )
        {
            $line = explode(';', $fileContent[$x]); //Ignoring comments
            $line = trim($line[0]);
            if( @ereg( "\[", $line ) )
            {
                //sessao
                //$sectionName = explode( "]", $line );
                //$sectionName = explode( "[", $sectionName[0] );
                //$sectionName = $sectionName[1];
                $sectionName = trim($line, "[]");
                if( @ereg( 'channels', $sectionName ) )
                    $sectionLocal = 'channels';
                else
                    $sectionLocal = 'geral';
                $varName = '';
                $Kconf_arr[$sectionLocal][$sectionName]['dummy'] = ""; //to keep the array ordered
                unset($Kconf_arr[$sectionLocal][$sectionName]['dummy']);
            }
            elseif( @ereg( "=", $line ) )
            {
                //variavel
                $varName = explode( "=", $line, 2 );
                $value = trim( $varName[1] );
                $varName = trim( $varName[0] );
                if($varName == 'setvar')
                {
                    $varName = explode("=", $value);
                    $value = trim($varName[1]);
                    $varName = trim($varName[0]);
                    $Kconf_arr[$sectionLocal]['setvar_'.$sectionName][$varName] = $value;
                }
                else
                {
                    $Kconf_arr[$sectionLocal][$sectionName][$varName] = $value;
                }
            }
        }

        return $Kconf_arr;
    }
    
    function getSpecificOptValue($opt, $section='globals')
    {
        $conf = loadKhompConfig();
        if( @ereg( 'channels', $section ) )
            $sectionLocal = 'channels';
        else
            $sectionLocal = 'geral';
        if($opt == false)
        {
            if( isset($conf[$sectionLocal][$section]) )
                return $conf[$sectionLocal][$section];            
        }
        else
        {
            if( isset($conf[$sectionLocal][$section][$opt]) )
                return $conf[$sectionLocal][$section][$opt];
        }
        return false;
    }
    function getFxsBranches()
    {
        $conf = loadKhompConfig();
        if(!isset($conf['geral']['fxs-branches']))
            return 'false';
        $ret='';
        foreach($conf['geral']['fxs-branches'] as $branch => $serials)
            $ret .= $branch.'='.$serials.';';
        if($ret!='')
            return rtrim($ret,";");
        return 'false';
    }

    function getBoardChanFromStr($bxcy)
    {
        if(!preg_match('/[bB](\d+)[Cc](\d+)/', $bxcy))
            return false;

        $tmp = preg_replace('/[bB](\d+)[Cc](\d+)/', '$1;$2', $bxcy);
        $tmp = explode(';', $tmp);
        return array(intval($tmp[0]), intval($tmp[1]));
    }

    function makeFXSOptionTable()
    {
        Global $sistema;
        // table
        $buff  = "<table id='FXSTable' width='100%' class='zebra'><thead>";
        $buff .= "<tr><th width='40%'>" . $sistema->retTranslate( 'option' ) . "</th>";
        $buff .= "<th width='40%'>" . $sistema->retTranslate( 'value' ) . "</th>";
        $buff .= "<th width='20%'>" . $sistema->retTranslate( 'operation' ) . "</th>";
        $buff .= "</tr></thead><tbody>";
        //rows
        $buff .= "</tbody></table>";
        $buff .= "<br>";
        //$buff .= "<div class='textAlignRight'>";
        //$buff .= "<input type='button' onclick=\"addFXSRule();\" value='" . $sistema->retTranslate( 'newrule' ) . "' />";
        //$buff .= "</div>";
        return $buff;
    }
    function selectDeviceBranchHotline( )
    {
        Global $sistema;
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;
        if(!isset($serial))
            return 'no serial';
        $globalOrigSize = strlen( (string) getSpecificOptValue('fxs-global-orig') );

        //if(!array_key_exists($serial, $map))
            //return "No branches configured in the selected device (serial: {$serial})";

        $buff  = '<b>'.$sistema->retTranslate('selectBranch').': </b>';
        $buff .= '<select onchange=\'deviceBranchChange(this);\' id="selectBranchDropdown0">';
        $bm = new branchManager();
        $callerids = $bm->get_callerids_from_serial_sorted( $serial );
        foreach( $callerids as $i )
            $buff .= "<option value='$i'>$i</option>";
        $buff .= '</select>';
        ///////

        $input_text = isset( $_REQUEST['extra'] ) ? $_REQUEST['extra'] : 'Hotline number: ';
        $buff .= "<br><b>${input_text}</b>";
        $buff .= '<input id="hotline_input" maxlength="150" class="inputText" type="text" />';

        ///////
        $buff .= "<br><br><input type='button' class='floatRight' onClick=\"saveHotlineAssistant();\" value='".$sistema->retTranslate( "add" )."'/>";

        return $buff;
    }
    function selectDeviceBranch( )
    {
        Global $sistema;
        $globalOrig = (string) getSpecificOptValue('fxs-global-orig');
        $serial = isset( $_REQUEST['serial'] ) ? $_REQUEST['serial'] : NULL;
        if(!isset($serial))
            return 'no serial';

        $buff  = '<b>'.$sistema->retTranslate('Device').': </b>';
        $buff .= "<span id='dev_serial'>{$serial}</span>";
        $buff .= '<b>'.$sistema->retTranslate('selectBranch').': </b>';
        $buff .= '<select onchange=\'deviceBranchChange(this);\' id="selectBranchDropdown0">';

        //if(!array_key_exists($serial, $map))
            //return "No branches configured in the selected device (serial: {$serial})";
        $bm = new branchManager();
        $callerids = $bm->get_callerids_from_serial_sorted( $serial );

        foreach( $callerids as $callerid )
            $buff .= "<option "." value='{$callerid}'>{$callerid}</option>";
        $buff .= '</select>';
        
        $buff .= ' - ';

        $buff .= '<select onchange=\'deviceBranchChange(this);\' id="selectBranchDropdown1" >';
        foreach( $callerids as $callerid )
            $buff .= "<option "." value='{$callerid}'>{$callerid}</option>";
        $buff .= '</select>';

        $buff .= '<br><br>';
        $buff .= '<fieldset>';
        $buff .= makeFXSOptionTable();
        $buff .= '</fieldset>';
        $buff .= "<br><br><input type='button' class='floatRight' onClick=\"saveFXSAssistant();\" value='".$sistema->retTranslate( "add" )."'/>";

        return $buff;
    }
    function getFXSTable( )
    {
        Global $sistema;
        $b = $_REQUEST['branch'];
        $buff  = "<b>Selected branch: <span id='branchNum'>$b</span></b><br><br>";
        $buff .= makeFXSOptionTable();
        $buff .= "<br><br><input type='button' class='floatRight' onClick=\"saveFXSAssistant();\" value='".$sistema->retTranslate( "add" )."'/>";
        return $buff;
    }

    function addFieldsetToData( $data, $legend, $open )
    {
        $return = "";
        if( $open )
        {
            $this->firstFieldSet = false;
            $disp = "style='display:block'";
            $strPart = "- ";
        }
        else
        {
            $disp = "style='display:none'";
            $strPart = "+ ";
        }
        $return .= "<a href='#' class='collapsePara' onClick='changeArrow(this);'>" . $strPart . $legend . "</a>";
        $return .= "<fieldset $disp>\n";
        $return .= $data;
        $return .= "</fieldset><br>";
        return $return;
    }

    function translate()
    {
        Global $sistema;
        $words = explode(';', $_REQUEST['words']);
        $ret = array();
        foreach( $words as $w )
            array_push( $ret, $sistema->retTranslate( $w ) );

        return implode(';', $ret);
    }

    function chanDescription( $name )
    {
        Global $sistema;

        $toFind = array( "B", "S", "C", "L", "R" );
        if( $name == 'channels' )
            return '-';
        $description = str_replace( 'channels-', '', $name );
        ///(((([bB])[ ]*([0-9]+))|(([sS])[ ]*([0-9]+)))[ ]*(([cClL])[ ]*([0-9]+)[
        // ]*([-][ ]*([0-9]+))?)?)|(([rR])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)/

        $newNames = explode( "+", strtoupper( $description ) );
        $newDescription = $sistema->retTranslate( 'applyedTo' ) . ":<br>";

        for( $y = 0; $y < sizeof( $newNames ); $y++ )
        {
            $newName = $newNames[$y];
            if( @ereg( "G", $newName ) )
                $groups[] = strtolower( substr( $newName, 1 ) );
            else
            {
                if( @ereg( "S", $newName ) )
                {
                    $sParts = explode( "S", $newName );
                    for( $i = 1; $i < sizeof( $sParts ); $i++ )
                    {
                        $str = $sParts[$i];
                        $ctrLength = strlen( $str );
                        $finalStr = '';
                        for( $x = 0; $x < $ctrLength; $x++ )
                        {
                            if( !in_array( $str[$x], $toFind ) )
                                $finalStr .= $str[$x];
                            else
                                $x = $ctrLength;
                        }
                        $serials[] = $finalStr;
                    }
                }
                if( @ereg( "B", $newName ) )
                {
                    $bParts = explode( "B", $newName );
                    for( $i = 1; $i < sizeof( $bParts ); $i++ )
                    {
                        $str = $bParts[$i];
                        $ctrLength = strlen( $str );
                        $finalStr = '';
                        for( $x = 0; $x < $ctrLength; $x++ )
                        {
                            if( !in_array( $str[$x], $toFind ) )
                                $finalStr .= $str[$x];
                            else
                                $x = $ctrLength;
                        }
                        $boards[] = $finalStr;
                    }
                }
                if( @ereg( "L", $newName ) )
                {
                    $lParts = explode( "L", $newName );
                    for( $i = 1; $i < sizeof( $lParts ); $i++ )
                    {
                        $str = $lParts[$i];
                        $ctrLength = strlen( $str );
                        $finalStr = '';
                        for( $x = 0; $x < $ctrLength; $x++ )
                        {
                            if( !in_array( $str[$x], $toFind ) )
                                $finalStr .= $str[$x];
                            else
                                $x = $ctrLength;
                        }
                        $links[] = $finalStr;
                    }
                }
                if( @ereg( "C", $newName ) )
                {
                    $cParts = explode( "C", $newName );
                    for( $i = 1; $i < sizeof( $cParts ); $i++ )
                    {
                        $str = $cParts[$i];
                        $ctrLength = strlen( $str );
                        $finalStr = '';
                        for( $x = 0; $x < $ctrLength; $x++ )
                        {
                            if( !in_array( $str[$x], $toFind ) )
                                $finalStr .= $str[$x];
                            else
                                $x = $ctrLength;
                        }
                        $channels[] = $finalStr;
                    }
                }
                if( @ereg( "R", $newName ) )
                {
                    $rParts = explode( "R", $newName );
                    for( $i = 1; $i < sizeof( $rParts ); $i++ )
                    {
                        $str = $rParts[$i];
                        $ctrLength = strlen( $str );
                        $finalStr = '';
                        for( $x = 0; $x < $ctrLength; $x++ )
                        {
                            if( !in_array( $str[$x], $toFind ) )
                                $finalStr .= $str[$x];
                            else
                                $x = $ctrLength;
                        }
                        $ramals[] = $finalStr;
                    }
                }
            }
            $start = false;

            for( $i = 0; $i < sizeof( $boards ); $i++ )
                $newDescription .= $sistema->retTranslate( 'Device' ) . " " . $boards[$i] . ' ';

            for( $i = 0; $i < sizeof( $serials ); $i++ )
                $newDescription .= $sistema->retTranslate( 'serial' ) . " " . $serials[$i] . ' ';

            for( $i = 0; $i < sizeof( $links ); $i++ )
                $newDescription .= $sistema->retTranslate( 'Link' ) . " " . $links[$i] . ' ';

            for( $i = 0; $i < sizeof( $channels ); $i++ )
                $newDescription .= $sistema->retTranslate( 'channel' ) . " " . $channels[$i] . ' ';

            for( $i = 0; $i < sizeof( $ramals ); $i++ )
                $newDescription .= $sistema->retTranslate( 'Ramal' ) . " " . $ramals[$i] . ' ';

            for( $i = 0; $i < sizeof( $groups ); $i++ )
                $newDescription .= $sistema->retTranslate( 'group' ) . " " . $groups[$i] . ' ';

            $newDescription .= "<br>";

            $boards = array( );
            $serials = array( );
            $channels = array( );
            $links = array( );
            $ramals = array( );
            $groups = array( );
        }

        return $newDescription;
    }
