<?php
    $AjaxFunctions['showNotification'] = 'showNotification';
    $AjaxFunctions['getNotificationConfiguration'] = 'getNotificationConfiguration';
    $AjaxFunctions['saveNotificationConfiguration'] = 'saveNotificationConfiguration';

    function showNotification()
    {
        $app = KSystem::getInstance();

        return "<fieldset><legend>{$app->translate( 'gateway-notification' )}</legend>"
            . "<div id='gateway-notification-need-save' class='gateway-notification-need-reload displayNone'>{$app->translate( 'gateway-notification-need-save' )}</div><br />"
            . "<fieldset><legend>{$app->translate( 'gateway-notification-default-transport' )}</legend>"
                . "<table id='gateway-notification-default-transport' class='gateway-table zebra'><thead><th>{$app->translate( 'gateway-notification-type' )}</th><th>{$app->translate( 'gateway-notification-transport' )}</th></thead><tbody></tbody></table>"
            . '</fieldset><br />'
            . "<fieldset><legend>{$app->translate( 'gateway-notification-transports' )}</legend>"
                . "<input type='button' id='gateway-notification-add-transport' value='{$app->translate( 'add' )}' /><br /><br />"
                . "<table id='gateway-notification-transports' class='gateway-table zebra'><thead><th>{$app->translate( 'gateway-notification-transport' )}</th><th>{$app->translate( 'gateway-notification-transport-configuration' )}</th><th>{$app->translate( 'Options' )}</th></thead><tbody></tbody></table>"
            . '</fieldset>'
            . "<br /><div class='textAlignRight'><input type='button' id='gateway-notification-save' value='{$app->translate( 'save' )}' /></div>"
            . '</fieldset>';
    }

    function getNotificationConfiguration()
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KNotificationYaml.php';

        $yaml = new KNotificationYaml();
        return JSONencode( $yaml->getYaml() );
    }

    function saveNotificationConfiguration()
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KNotificationYaml.php';

        $app = KSystem::getInstance();

        $yaml = new KNotificationYaml();
        $ret = array( 'message' => $app->translate( 'gateway-notification-error-save' ), 'success' => false );

        try
        {
            $yaml->setYaml( $_POST );
            $yaml->save();
            $ret = array( 'message' => $app->translate( 'gateway-notification-saved' ), 'success' => true );
        }
        catch( Exception $e )
        {
            $ret['message'] = $app->translate( $e->getMessage() );
        }
        return JSONEncode( $ret );
    }
