<?php
    @session_start( );

    $AjaxFunctions['showFax'] = 'showFax';
    $AjaxFunctions['saveFax'] = 'saveFax';
    $AjaxFunctions['showCallAnalyzer'] = 'showCallAnalyzer';
    $AjaxFunctions['saveCallAnalyzer'] = 'saveCallAnalyzer';
    $AjaxFunctions['showAutoCallAnalyzer'] = 'showAutoCallAnalyzer';
    $AjaxFunctions['showAutoEchoCanceller'] = 'showAutoEchoCanceller';
    $AjaxFunctions['showAutoDTMFSupression'] = 'showAutoDTMFSupression';
    $AjaxFunctions['showAutoAGC'] = 'showAutoAGC';
    $AjaxFunctions['showAutoDropCollectCall'] = 'showAutoDropCollectCall';
    $AjaxFunctions['showHMPAnalytics'] = 'showHMPAnalytics';
    $AjaxFunctions['saveHMPAnalytics'] = 'saveHMPAnalytics';

    $AjaxFunctions['getAssistant'] = 'getAssistant';
    $AjaxFunctions['getFXSAssistant'] = 'getFXSAssistant';
    $AjaxFunctions['getBranchAssistant'] = 'getBranchAssistant';
    $AjaxFunctions['getDropOptionAssistant'] = 'getDropOptionAssistant';

    function showFax( )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= "<div id='Fax'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>Fax</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'NumeroPadraoFax' ) . "</td>";
        $buff .= "<td align='right'>";
        $ID = $sysYAML->getValue( 'ID' );
        $buff .= "<input id='ID' class='inputText' type='text' maxlength='20' value='{$ID}'  >";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'UseHeaderText' ) . "</td>";
        $buff .= "<td align='center' class='width110'>";
        $tmp = $sysYAML->getValue( 'UseHeader' );
        $UseHeader = $tmp == 'yamlError' ? 'false' : $tmp;
        $checked = getBooleanValue( $UseHeader )? 'checked' : '';
        $buff .= "<input name='UseHeader' id='UseHeader' value='' type='checkbox' $checked>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'HeaderText' ) . "</td>";
        $buff .= "<td align='right'>";
        $HeaderText = $sysYAML->getValue( 'HeaderText' );
        $buff .= "<input id='HeaderText' class='inputText' type='text' maxlength='20' value='{$HeaderText}' >";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "</tbody></table>";
        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveFaxB' type='button' onclick=\"saveFax();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;
    }

    function saveFax( )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );
            $data_arr = explode( ',', $data );

            foreach( $data_arr as $d )
            {
                $field = explode( '=', $d );
                $sysYAML->createVar($field[0], 'Fax', $field[1]);
            }
            $sysYAML->deleteVar('AddTimeout');

            $sysYAML->save( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function showCallAnalyzer( )
    {
        Global $sistema;
        $sysYAML = loadSystemYaml( );

        $longRange = range(0, 60000, 100);
        $shortRange = range(0, 10000, 10);
        $analysisRange = range(2000, 60000, 100);

        $buff = '';
        $buff .= "<div id='CallAnalyser' >";
        $buff .= "<fieldset id='CallAnalyzerFields'>";
        $buff .= "<legend>Call analyzer</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'><label for='AnalysisTimeOutIncoming'>" . $sistema->retTranslate( 'AnalysisTimeOutIncoming' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'AnalysisTimeOutIncoming', '', '15000' );
        $buff .= make_select('AnalysisTimeOutIncoming', $analysisRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='AnalysisTimeOutOutgoing'>" . $sistema->retTranslate( 'AnalysisTimeOutOutgoing' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'AnalysisTimeOutOutgoing', '', '3000' );
        $buff .= make_select( 'AnalysisTimeOutOutgoing', $analysisRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='Duration600Hz'>" . $sistema->retTranslate( 'Duration600Hz' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'Duration600Hz', '', '500' );
        $buff .= make_select( 'Duration600Hz', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='Tolerance600Hz'>" . $sistema->retTranslate( 'Tolerance600Hz' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'Tolerance600Hz', '', '150' );
        $buff .= make_select( 'Tolerance600Hz', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='FilterTolerance600Hz'>" . $sistema->retTranslate( 'FilterTolerance600Hz' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'FilterTolerance600Hz', '', '200' );
        $buff .= make_select( 'FilterTolerance600Hz', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='CellularBoxDuration'>" . $sistema->retTranslate( 'CellularBoxDuration' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'CellularBoxDuration', '', '450' );
        $buff .= make_select( 'CellularBoxDuration', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='CellularBoxTolerance'>" . $sistema->retTranslate( 'CellularBoxTolerance' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";

        $current = $sysYAML->getValue( 'CellularBoxTolerance', '', '100' );
        $buff .= make_select( 'CellularBoxTolerance', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='CollectCallDuration'>" . $sistema->retTranslate( 'CollectCallDuration' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'CollectCallDuration', '' , '450' );
        $buff .= make_select( 'CollectCallDuration', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='CollectCallTolerance'>" . $sistema->retTranslate( 'CollectCallTolerance' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $current = $sysYAML->getValue( 'CollectCallTolerance', '', '100' );
        $buff .= make_select( 'CollectCallTolerance', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='AnswerDuration'>" . $sistema->retTranslate( 'AnswerDuration' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'AnswerDuration', '', '150' );
        $buff .= make_select( 'AnswerDuration', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='AnswerSilenceDuration'>" . $sistema->retTranslate( 'AnswerSilenceDuration' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'AnswerSilenceDuration', '', '1000' );
        $buff .= make_select( 'AnswerSilenceDuration', $shortRange, $tmp );
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='AnswerFilterDuration'>" . $sistema->retTranslate( 'AnswerFilterDuration' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'AnswerFilterDuration', '', '100' );
        $buff .= make_select( 'AnswerFilterDuration', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='PreVoiceDuration'>" . $sistema->retTranslate( 'PreVoiceDuration' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'PreVoiceDuration', '', '240' );
        $buff .= make_select( 'PreVoiceDuration', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        
        $buff .= "<tr><td align='left'><label for='CustomCellBoxTimeout'>" . $sistema->retTranslate( 'CustomCellBoxTimeout' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'CustomCellBoxTimeout', '', '1500' );
        $buff .= make_select( 'CustomCellBoxTimeout', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='MinRingbackTime'>" . $sistema->retTranslate( 'MinRingbackTime' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'MinRingbackTime', '', '500' );
        $buff .= make_select('MinRingbackTime', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='MinVoiceTimeAnsweringMachine'>" . $sistema->retTranslate( 'MinVoiceTimeAnsweringMachine' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'MinVoiceTimeAnsweringMachine', '', '1400' );
        $buff .= make_select('MinVoiceTimeAnsweringMachine', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='ClassifyUnknownAnsweringMachine'>" . $sistema->retTranslate( 'ClassifyUnknownAnsweringMachine' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'ClassifyUnknownAnsweringMachine', '', 'false' );
        $checked = getBooleanValue( $tmp )? 'checked' : '';
        $buff .= "<input name='ClassifyUnknownAnsweringMachine' id='ClassifyUnknownAnsweringMachine' value='' type='checkbox' $checked>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='WaitAnswerToComplete'>" . $sistema->retTranslate( 'WaitAnswerToComplete' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'WaitAnswerToComplete', '', 'true' );
        $checked = getBooleanValue( $tmp )? 'checked' : '';
        $buff .= "<input name='WaitAnswerToComplete' id='WaitAnswerToComplete' value='' type='checkbox' $checked>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'><label for='StartAtFirstTone'>" . $sistema->retTranslate( 'StartAtFirstTone' ) . "</label></td>";
        $buff .= "<td width='15%' align='center'>";
        $tmp = $sysYAML->getValue( 'StartAtFirstTone', '', 'true' );
        $checked = getBooleanValue( $tmp )? 'checked' : '';
        $buff .= "<input name='StartAtFirstTone' id='StartAtFirstTone' value='' type='checkbox' $checked>";
        $buff .= "</td>";
        $buff .= "</tr>";

        //inserir campos antes disto
        $buff .= "</table>";
        $buff .= "</fieldset>";
        $buff .= "</br>";

        //--------------------------------
        $buff .= "<tr><td align='left' colspan='2'>";
        $buff .= '<fieldset><legend>'. $sistema->retTranslate('CustomCellBoxFrequencies') . '</legend>';
        $buff .= "<table class='zebra' id='CustomCellBoxFrequencies'><thead>";
        $buff .= "<tr>";
        $buff .= "<th>" .$sistema->retTranslate( 'CustomCellBoxFrequency' ) ."</th>";
        $buff .= "<th>" .$sistema->retTranslate( 'CustomCellBoxDuration' ) ."</th>";
        $buff .= "<th>" .$sistema->retTranslate( 'CustomCellBoxTolerance' ) ."</th>";
        $buff .= "<th>" .$sistema->retTranslate( 'delete' )."</th>";
        $buff .= "<tr/></thead>";

        $buff .= "<tbody>";

        $defaultFreqs = array( 
            array( 'Frequency' => '720', 'Duration' => '300', 'Tolerance' => '100'),
            array( 'Frequency' => '300', 'Duration' => '210', 'Tolerance' => '60')
        );

        $tmp = $sysYAML->getValue("CustomCellBoxes", '', $defaultFreqs);
        foreach($tmp as $key => $value )
            $buff .= createCustomCellBoxesRow( $value['Frequency'], $value['Duration'], $value['Tolerance'] );
        
        $buff .= "</tbody></table>";
        $buff .= "<br />";
        $buff .= "<input class='floatRight' id='addNewCustomCellBoxesRow' type='button' onclick='addNewCustomCellBoxFrequency();' value='". $sistema->retTranslate('CustomCellBoxNewFrequency'). "' />";
        $buff .= "</fieldset></td></tr>";
        //--------------

        $buff .= "</table>";
        $buff .= "</fieldset>";
        $buff .= '<br />';
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveCallAnalyzerB' type='button' onclick=\"saveCallAnalyzer();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br />";
        $buff .= "</div>";

        //tabela somente com o valor padrao para ser inserido com JS ao clicar no botao.
        $buff .= "<table style='display:none;' id='CustomCellBoxesEmptyRow'>". createCustomCellBoxesRow( 300, 200, 100 ) . "</table>";

        return $buff;
    }

    function createCustomCellBoxesRow( $frequency, $duration, $tolerance )
    {
        global $sistema, $image_dir;
        $buff = "";

        $buff .= "<tr>";
        $buff .= "<td>";
        $buff .= make_select( 'Frequency', range(50,4000,5), $frequency );
        $buff .= "</td>";

        $buff .= "<td>";
        $buff .= make_select( 'Duration', range(10, 10000, 10), $duration );
        $buff .= "</td>";

        $buff .= "<td>";
        $buff .= make_select( 'Tolerance', range(10,200,10), $tolerance );
        $buff .= "</td>";

        $buff .= "<td><a href='#' onclick='removeCustomCellBoxFrequency(this);' >";
        $buff .= "<img src='{$image_dir}/imagens/remove.png' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "' />";
        $buff .= "</td></tr>";
        return $buff;
    }

    function createCadenceAssistant( $first = true )
    {
        Global $sistema;

        $buff = '';

        if( $first )
            $buff = "<div id='dialog-modal' title='" . $sistema->retTranslate( 'CadencesAssistant' ) . "'>";

        $buff .= "<p>Init Cadence Assistant</p>";
        $buff .= "<div id='looper'>";

        $FXOChannels = $sistema->getFXOChannels( );
        if( sizeof( $FXOChannels ) != 0 )
        {
            $buff .= "<form>";
            $buff .= "<table>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "Device" ) . "</td>";
            $buff .= "<td align='left'>" . getFXODevices( ) . "</td>";
            $buff .= "</tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "Channel" ) . "</td>";
            $buff .= "<td align='left' id='fxoDeviceChannelsList'>";
            $FXO = $sistema->getFirstFXODevice( );
            $buff .= getFXODeviceChannels( $FXO );
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "NumeroRamalLigacoes" ) . "</td>";
            $buff .= "<td align='left'>";
            $buff .= "<input id='busy' type='text' onkeyup='validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "NumeroRingBack" ) . "</td>";
            $buff .= "<td align='left'>";
            $buff .= "<input id='ringback' type='text' onkeyup='validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "NumeroInvalido" ) . "</td>";
            $buff .= "<td align='left'>";
            $buff .= "<input id='invalid' type='text' onkeyup='validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td colspan='2'>";
            $buff .= "<button type='button' onClick='initAssintant();'>" . $sistema->retTranslate( "gerarCadencias" ) . "</button>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "</table>";
            $buff .= "</form>";
        }
        // else
            // $buff .= $sistema->retTranslate( "NDevice4Assitance" );


        $buff .= "</div>";
        if( $first )
            // $buff .= "</div>";


        return $buff;
    }

    require_once KROOT . '/json_util.php';
    function saveCallAnalyzer( )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $ret = '';

            $syscfg = loadSystemYaml( );
            # TODO - Merge 2015/04/20 - Verificar a ordem dessas chamadas e a necessidade delas
            $data_arr = objectToArray(JSONdecode($data));

            $sysYaml = $syscfg->getYaml();
            $sysYaml['CallAnalyzer'] = $data_arr;
            $syscfg->setYaml($sysYaml);
            $syscfg->save();

            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }
    
    function objectToArray($d)
    {
        if (is_object($d))
            $d = get_object_vars($d);

        return (is_array($d)) ? array_map(__FUNCTION__, $d) : $d;
    }    

    function showAutoCallAnalyzer( $createCadenceAssistant = true )
    {
        Global $sistema, $image_dir;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="AutoCallAnalyser" >';
        $buff .= '<fieldset>';
        $buff .= '<legend>Call analyzer</legend>';

        $ACCs = $sysYAML->getValue( 'AutoCallAnalyzer' );
        $finalACCs = array( );
        if( $ACCs != '' )
            $finalACCs = explode( ", ", $ACCs );
        $AutoCallAnalyzer = $finalACCs;
        $AutoCallAnalyzerValue = $sysYAML->getValue( 'AutoCallAnalyzer' );

        $AutoCallAnalyzerSize = sizeof( $AutoCallAnalyzer );

        $buff .= "<div id='AutoCallAnalyserList'>";
        $buff .= "<input type='hidden' id='AutoCallAnalyserValue' name='AutoCallAnalyserValue' value='$AutoCallAnalyzerValue'/>";

        if( $AutoCallAnalyzerSize > 0 )
        {
            $buff .= "<table id='AutoCallAnalyserTable' class='zebra'>";
            $buff .= '<thead><tr><th>' . $sistema->retTranslate( 'FaixaCA' ) .'</th>';
            $buff .= '<th>'. $sistema->retTranslate( 'options' ) .'</th></tr></thead><tbody>';

            for( $x = 0; $x < $AutoCallAnalyzerSize; $x++ )
            {
                $subAutoCallAnalyzer = explode( '.', $AutoCallAnalyzer[$x] );
                $buff .= '<tr><td>' . getSentence( $AutoCallAnalyzer[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"removeACAanalyzer('$AutoCallAnalyzer[$x]');\">";
                $buff .= "<img src='{$image_dir}/imagens/remove.png' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= "</td></tr>";
            }
            $buff .= "</tbody></table>";
        }
        else
            $buff .= '<div class="textAlignCenter" >' . $sistema->retTranslate( 'NAutoCallAnalyzer' ) . '</div>';

        $buff .= "</div>";
        $buff .= "<input type='button' class='floatRight' onclick=\"initAssistant('ACAnalyzer');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= "</fieldset>";
        $buff .= "</div>";

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function showAutoEchoCanceller( $showAutoEchoCanceller = true )
    {
        Global $sistema, $image_dir;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="AutoEchoCanceller"><fieldset>';
        $buff .= '<legend>' . $sistema->retTranslate( 'AutoEchoCanceller' ) . '</legend>';

        $AECs = $sysYAML->getValue( 'AutoEchoCanceller' );
        $finalAECs = array( );
        if( $AECs != '' )
            $finalAECs = explode( ", ", $AECs );
        $AutoEchoCanceller = $finalAECs;

        $AutoEchoCancellerValue = $sysYAML->getValue( 'AutoEchoCanceller' );
        $AutoEchoCancellerSize = sizeof( $AutoEchoCanceller );

        $buff .= '<div id="AutoEchoCancellerList">';
        $buff .= "<input type='hidden' id='AutoEchoCancellerValue' name='AutoEchoCancellerValue' value='$AutoEchoCancellerValue'/>";

        if( $AutoEchoCancellerSize > 0 )
        {
            $buff .= "<table id='AutoEchoCancellerSize' class='zebra'>";
            $buff .= '<thead><tr><th>' . $sistema->retTranslate( 'FaixaCE' ) . '</th><th>'.$sistema->retTranslate('options').'</th></tr></thead><tbody>';

            for( $x = 0; $x < $AutoEchoCancellerSize; $x++ )
            {
                $buff .= '<tr><td>' . getSentence( $AutoEchoCanceller[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"removeAECancel('$AutoEchoCanceller[$x]')\">";
                $buff .= "<img src='{$image_dir}/imagens/remove.png' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
            $buff .= '</tbody></table>';
        }
        else
            $buff .= '<div class="textAlignCenter">' . $sistema->retTranslate( 'NAutoEchoCanceller' ) . '</div>';

        $buff .= '</div>';

        $buff .= "<input type='button' class='floatRight' onclick=\"initAssistant('AECancel');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</fieldset>';
        $buff .= '</div>';

        if( $showAutoEchoCanceller )
            $buff .= createCadenceAssistant( );

        return $buff;

    }

    function showAutoDTMFSupression( $createCadenceAssistant = true )
    {
        Global $sistema, $image_dir;

        $sysYAML = loadSystemYaml( );

        $buff = '';

        $buff .= '<div id="AutoDtmfSuppression" >';
        $buff .= '<fieldset>';
        $buff .= '<legend>' . $sistema->retTranslate( 'AutoDtmfSuppression' ) . '</legend>';

        $ADSs = $sysYAML->getValue( 'AutoDtmfSuppression' );
        $finalADSs = array( );
        if( $ADSs != '' )
            $finalADSs = explode( ", ", $ADSs );
        $AutoDtmfSuppression = $finalADSs;

        $AutoDtmfSuppressionValue = $sysYAML->getValue( 'AutoDtmfSuppression' );
        $AutoDtmfSuppressionSize = sizeof( $AutoDtmfSuppression );

        $buff .= '<div id="AutoDtmfSuppressionList">';
        $buff .= "<input type='hidden' id='AutoDtmfSuppressionValue' name='AutoDtmfSuppressionValue' value='$AutoDtmfSuppressionValue'/>";

        if( $AutoDtmfSuppressionSize > 0 )
        {
            $buff .= "<table id='AutoDtmfSuppressionSize' class='zebra'>";
            $buff .= '<thead><tr><th>' . $sistema->retTranslate( 'FaixaADSup' ) . '</th><th>'.$sistema->retTranslate('options').'</th></tr></thead><tbody>';
            for( $x = 0; $x < $AutoDtmfSuppressionSize; $x++ )
            {
                $buff .= '<tr><td>' . getSentence( $AutoDtmfSuppression[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"removeADSupression('$AutoDtmfSuppression[$x]')\">";
                $buff .= "<img src='{$image_dir}/imagens/remove.png' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
            $buff .= '</tbody></table>';
        }
        else
            $buff .= '<div class="textAlignCenter">' . $sistema->retTranslate( 'NAutoEchoCanceller' ) . '</div>';

        $buff .= '</span>';
        $buff .= "<input type='button' class='floatRight' onclick=\"initAssistant('ADSup');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</fieldset>';
        $buff .= '</div>';

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function showAutoAGC( $createCadenceAssistant = true )
    {
        Global $sistema, $image_dir;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="AutoAGC">';
        $buff .= '<fieldset>';
        $buff .= '<legend>AGC</legend>';

        $AAGCs = $sysYAML->getValue( 'AutoAGC' );
        $finalAAGCs = array( );

        if( $AAGCs != '' )
            $finalAAGCs = explode( ", ", $AAGCs );
        $AutoAGC = $finalAAGCs;
        $AutoAGCValue = $sysYAML->getValue( 'AutoAGC' );

        $AutoAGCSize = sizeof( $AutoAGC );
        $buff .= '<div id="AutoAGCList">';
        $buff .= "<input type='hidden' id='AutoAGCValue' name='AutoAGCValue' value='$AutoAGCValue'/>";

        if( $AutoAGCSize > 0 )
        {
            $buff .= '<table id="AutoAGCSize" class="zebra">';
            $buff .= '<thead><tr><th>' . $sistema->retTranslate( 'FaixaAAGC' ) . '</th><th>'.$sistema->retTranslate('options').'</th></tr></thead><tbody>';
            for( $x = 0; $x < $AutoAGCSize; $x++ )
            {
                $buff .= '<tr><td>' . getSentence( $AutoAGC[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"removeAAGC('$AutoAGC[$x]');\">";
                $buff .= "<img src='{$image_dir}/imagens/remove.png' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
            $buff .= '</tbody></table>';
        }
        else
            $buff .= '<div class="textAlignCenter">' . $sistema->retTranslate( 'NAutoEchoCanceller' ) . '</div>';
        $buff .= '</div>';

        $buff .= "<input type='button' class='floatRight' onclick=\"initAssistant('AAGC');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</div>';
        $buff .= '</fieldset>';

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function showAutoDropCollectCall( $createCadenceAssistant = true )
    {
        Global $sistema, $image_dir;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="DropCollectCalls">';
        $buff .= '<fieldset>';
        $buff .= '<legend>' . $sistema->retTranslate( 'DropCollectCalls' ) . '</legend>';
        $DCCs = $sysYAML->getValue( 'DropCollectCalls' );

        $finalDCCs = array( );
        $keys = array_keys( $DCCs );
        for( $i = 0; $i < sizeof( $keys ); $i++ )
            $finalDCCs[] = $keys[$i];
        $DropCollectCalls = $finalDCCs;
        $DropCollectCallsSize = sizeof( $DropCollectCalls );

        $buff .= '<div id="DropCollectCallsList">';
        $buff .= "<input type='hidden' id='DropCollectCallsTotal' name='DropCollectCallsTotal' value='$DropCollectCallsSize'/>";

        if( $DropCollectCallsSize > 0 )
        {
            $buff .= '<table class="zebra">';
            $buff .= '<thead><tr><th>' . $sistema->retTranslate( 'Description' ) . '</th>';
            $buff .= '<th>' . $sistema->retTranslate( 'Configuration' ) . '</th>';
            $buff .= '<th>' . $sistema->retTranslate( 'options' ) . '</th></tr></thead><tbody>';
            for( $x = 0; $x < $DropCollectCallsSize; $x++ )
            {
                $buff .= "<tr>";
                $buff .= '<td width="30%">';
                $subDropCollectCalls = explode( '.', $DropCollectCalls[$x] );
                $buff .= getSentence( $DropCollectCalls[$x] );
                $buff .= '</td><td>';
                $value = $sysYAML->getValue( $DropCollectCalls[$x], 'Features|DropCollectCalls' );

                if( $value == 'yamlError' )
                    $value = "";

                $buff .= printDropCollectCall( $DropCollectCalls[$x], $x, $value );
                $buff .= '</td><td>';
                $buff .= "<a href='#' onClick=\"removeDCCall('$DropCollectCalls[$x]');\">";
                $buff .= "<img src='{$image_dir}/imagens/remove.png' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
            $buff .= '</tbody></table>';
        }
        else
            $buff .= '<div class="textAlignCenter">' . $sistema->retTranslate( 'NDropCollectCalls' ) . '</div>';

        $buff .= '</br>';
        $buff .= "<input type='button' class='floatRight' onclick=\"initAssistant('DCCall');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</div>';
        $buff .= '</fieldset>';
        $buff .= '</br>';

        if( $DropCollectCallsSize > 0 )
            $buff .= "<input type='button' class='floatRight' onclick=\"saveDCCallConfigs('$DropCollectCallsSize');\" value='Salvar'>";

        $buff .= '</div>';

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function getAssistant( )
    {
        Global $sistema;

        $type = isset( $_REQUEST['type'] ) ? $_REQUEST['type'] : NULL;

        if( isset( $type ) )
        {
            $divName = '';

            switch($type)
            {
                case 'ACAnalyzer':
                    $divName = 'AutoCallAnalyser';
                    break;
                case 'AECancel':
                    $divName = 'AutoEchoCanceller';
                    break;
                case 'ADSup':
                    $divName = 'AutoDtmfSuppression';
                    break;
                case 'AAGC':
                    $divName = 'AutoAGC';
                    break;
                case 'DCCall':
                    $divName = 'DropCollectCalls';
                    break;
                case 'ChanRange':
                    $divName = 'ChanRange';
                    break;
            }
            $return = '';
            $return .= "<div id='tabs'>";
            $return .= "<ul>";

            $return .= "<li><a href='#tabs-0' onClick=\"changeWCSubType('Device');\">" . $sistema->retTranslate( "Device" ) . "</a></li>";
            $return .= "<li><a href='#tabs-1' onClick=\"changeWCSubType('Links');\">" . $sistema->retTranslate( "Links" ) . "</a></li>";
            $return .= "<li><a href='#tabs-2' onClick=\"changeWCSubType('Channel');\">" . $sistema->retTranslate( "Channel" ) . "</a></li>";
            $return .= "<li><a href='#tabs-3' onClick=\"changeWCSubType('Tech');\">" . $sistema->retTranslate( "Technology" ) . "</a></li>";
            if($divName != 'ChanRange')
            {
                $return .= "<li><a href='#tabs-4' onClick=\"changeWCSubType('All');\">" . $sistema->retTranslate( "All" ) . "</a></li>";
            }
            $return .= "</ul>";
            $return .= "<div id='tabs-0'>";
            $return .= "<p>" . getDeviceForm( ) . "</p>";
            $return .= "</div>";
            $return .= "<div id='tabs-1'>" . getLinksForm( ) . "</div>";
            $return .= "<div id='tabs-2'>" . getChannelForm( ) . "</div>";
            $return .= "<div id='tabs-3'>" . getTechForm( ) . "</div>";
            if($divName != 'ChanRange')
            {
                $return .= "<div id='tabs-4'>";
                $return .= "<p>" . $sistema->retTranslate( "TodasDevicesCanais" ) . "</p>";
                $return .= "</div>";
            }

            $return .= "</div>";
            $return .= "<br>";
            $return .= "<input type='button' class='floatRight' onClick=\"saveAssistant('{$divName}');\" value='" . $sistema->retTranslate( "add" ) . "' />";
            $return .= "<input type='hidden' value='{$type}' name='WCType' id='WCType' />";
            $tech = 'Device';
            $return .= '<input type="hidden" value="'.$tech.'" name="WCSubType" id="WCSubType" />';
            return $return;
        }
    }
    function getFXSAssistant( )
    {
        Global $sistema;
        $name  = $sistema->retTranslate('branch-options');
        $buff  = "<fieldset><legend>${name}</legend>";
        $buff .= '<span id="selectBranchMsg">';
        $buff .= $sistema->retTranslate('selectBranchMethod').'<br><br>';
        $buff .= "</span>";
        $buff .= "<span id='manualBranch'>";
        $buff .= '<b>' . $sistema->retTranslate('branch') . ': </b>';
        $buff .= '<input id="branch_input" maxlength="150" class="inputText" type="text" />';
        $buff .= '<input type="button" onclick="getFXSTable();" value="Ok">';
        $buff .= "</span>";

        $buff .= showDevices(null);

        $buff .= "</fieldset>";
        return $buff;
    }
    function getDropOptionAssistant( )
    {
        Global $sistema;
        $name  = $sistema->retTranslate('drop-options');
        $buff  = "<fieldset><legend>heeey</legend>";
        $buff .= '<span id="selectBranchMsg">';
        $buff .= $sistema->retTranslate('hueheuheu').'<br><br>';
        $buff .= "</span>";

        $buff .= '<table id="drop-options-table" class="zebra"><tbody>';
        $buff .= '</tbody></table>';

        $buff .= "</fieldset>";
        return $buff;
    }
    function getBranchAssistant( )
    {
        Global $sistema;
        $name = $sistema->retTranslate($_REQUEST['name']);
        $func = $sistema->retTranslate($_REQUEST['func']);

        $buff  = "<fieldset><legend>${name}</legend>";
        $buff .= '<span id="selectBranchMsg">';
        $buff .= $sistema->retTranslate('selectBranchMethod').'<br><br>';
        $buff .= "</span>";
        $buff .= "<span id='manualBranch'>";
        $buff .= '<b>' . $sistema->retTranslate('branch') . ': </b>';
        $buff .= '<input id="branch_input" maxlength="150" class="inputText" type="text" />';
        $buff .= '<input type="button" onclick="'.$func.'();" value="Ok">';
        $buff .= "</span>";

        //if( $name != 'Ramais' )
            $buff .= showDevices(null);

        $buff .= "</fieldset>";
        return $buff;
    }


    function showHMPAnalytics( )
    {
        require_once KCONFIG . '/classes/KHMPAnalyticsYaml.php';

        $app = KSystem::getInstance();
        $sysYAML = loadSystemYaml( );

        $analytics = 'HMP Analytics';
        if( IS_GATEWAY )
        {
            $analytics = 'Analytics';
        }

        $buff = '';
        $buff .= '<div id="call-classifier">';
        $buff .= '<fieldset>';
        $buff .= '<legend>'.$analytics.'</legend>';

        $buff .= '<table id="hmp-analytics-table" class="zebra"><tbody>';

        $buff .= '<tr><td class="textAlignLeft"><label for="AnswerSilenceDuration">'.$app->translate('AnswerSilenceDuration'). '</label> ' .
        '<img class="help-tooltip" title="'.$app->translate('AnswerSilenceDuration-tooltip').'" alt="tooltip" src="/imagens/tooltip.png">'.
        '</td><td class="textAlignRight">';
        $asd = $sysYAML->getValue('AnswerSilenceDuration', 'HMPAnalytics');
        $asd = $asd == 'yamlError' || $asd == '' ? 1000 :  $asd ;
        
        $buff .= constructSelector($asd, 300,3000,100,'AnswerSilenceDuration', '');
        $buff .= '</td></tr>';
        
        $buff .= '<tr><td class="textAlignLeft"><label for="SilenceTimeout">'.$app->translate('SilenceTimeout') . '</label> ' .
        '<img class="help-tooltip" title="'.$app->translate('SilenceTimeout-tooltip').'" alt="tooltip" src="/imagens/tooltip.png">'.
        '</td><td class="textAlignRight">';
        $st = $sysYAML->getValue('SilenceTimeout', 'HMPAnalytics');
        $st = $st == 'yamlError' || $st == '' ? 3000 : $st;
        $buff .= constructSelector($st, 1000,10000,500,'SilenceTimeout', '');
        $buff .='</td></tr>';

        if( ! IS_GATEWAY )
        {
            $buff .= '<tr><td class="textAlignLeft">'.$app->translate('DefaultLocale').'</td>';
            $buff .= '<td class="textAlignRight">';

            $locales = KHMPAnalyticsYaml::getSupportedLocales();

            $DetectionLocale = $sysYAML->getValue( 'DetectionLocale', 'System', 'pt-BR' );

            $buff .= '<select id="DetectionLocale" name="DetectionLocale">';
            foreach( $locales as $l )
            {
                $display = $app->translate( $l );
                $buff .= $DetectionLocale === $l ? "<option selected='selected' value='{$l}'>{$display}</option>" : "<option value='{$l}'>{$display}</option>";
            }
            $buff .= '</select></td></tr>';
        }

        $buff .= '</tbody></table>';

        $buff .= '<br><div class="textAlignRight">';
        $buff .= '<input id="saveHMPAnalytics" type="button" value="'.$app->translate('save').'" onclick="saveHMPAnalytics();">';
        $buff .= '</div>';

        $buff .= '</fieldset>';

        if ( ! IS_GATEWAY )
        {
            $buff .= '<br>';
            
            $buff .= '<fieldset>';
            $buff .= '<legend>'.$app->translate('classificationPatterns').'</legend>';
            
            $analytics_version = 0;

            if( !isset( $_SESSION['Analytics::version'] ) )
            {
                $output = array();
                $errcode = -1;

                if( PHP_OS == "WINNT" )
                {
                    exec( KROOT . '\\..\\..\\Server\\k3lserver.exe --analytics-version', $output, $errcode );
                }
                else
                {
                    exec( '/usr/sbin/k3lserver --analytics-version 2>&1', $output, $errcode );
                }

                if( $errcode == 0 )
                {
                    $analytics_version = $output[0];
                }

                $_SESSION['Analytics::version'] = $analytics_version;
            }
            else
            {
                $analytics_version = $_SESSION['Analytics::version'];
            }

            $buff .= '<div id="ktabs">';

            foreach( $locales as $l )
            {
                $selected = '';

                if ( $DetectionLocale === $l )
                {
                    $selected = ' selected';
                }

                $buff .= '<div id="ktabs-'.$l.'" class="tab'.$selected.'">';

                $analytics_yaml = new KHMPAnalyticsYaml( $l );

                $classification = array(
                    'Voice Mail' => array(),
                    'Interception Announcement' => array(),
                    'Forward Announcement' => array(),
                    'Portability Identification' => array(),
                    'Ringback Signal' => array(),
                    'Fax' => array()
                );

                $patterns_yaml = $analytics_yaml->getAllPatterns();
                $patterns_version = $analytics_yaml->getVersion();

                foreach ($patterns_yaml as $key => $value)
                {
                    $classification[$value['Classification']][] = $value['Name'];
                }

                $number_of_patterns = 0;

                $buff .= '<div id="holder-tables-classifier">';
                $buff .=    '<table class="zebra textAlignLeft">';
                $buff .=    '<tbody>';


                foreach( $classification as $k => $v )
                {
                    $buff .=    '<tr><td colspan=3 class="td_spc"><div class="head_cl">' .$app->translate($k) . '</div></td></tr>';

                    $pattern_names = '';

                    if( sizeof($v) > 0)
                    {
                        foreach( $v as $idx => $names )
                        {
                            $pattern_names .= '<div class="marginLeft25px">'.$names.'</div>';
                            $number_of_patterns++;
                        }
                    }
                    else
                    {
                        $pattern_names .= '<div class="marginLeft25px">-</div>';
                    }

                    $buff .=    '<tr><td colspan=3 class="padding0">'.$pattern_names.'</td></tr>';
                }

                $buff .=        '<tr>';
                $buff .=            '<td><div class="head_cltotal">Total: '.$number_of_patterns.'</div></td>';
                $buff .=            '<td><div class="head_clversion">'.$app->translate('PatternsVersion').': '.$patterns_version.'</div></td>';
                $buff .=            '<td><div class="head_clversion">'.$analytics.' '.$app->translate('Version').': '.$analytics_version.'</div></td>';
                $buff .=        '</tr>';
                $buff .=    '</tbody>';
                $buff .=    '</table>';

                $buff .=    '<div class="classifier-blockscreen"><div>'.$app->translate('classifier-blockscreen').'</div></div>';

                $buff .= '</div>';

                $buff .= '</div>';
            }

            $buff .= '</div>';

            $buff .= '</fieldset>';
        }

        $buff .= '</div>';

        return $buff;
    }
    
    function saveHMPAnalytics( )
    {
        if(isset($_REQUEST['data']))
        {
            $app = KSystem::getInstance();
            $sysYAML = loadSystemYaml( );
        
            $arr_param = json_decode($_REQUEST['data']);
 
            foreach ($arr_param as $k => $v)
            {
                switch ($k)
                {
                    case 'AnswerSilenceDuration':
                    case 'SilenceTimeout' :
                        $sysYAML->changeVarValue($k, (int)$v, 'HMPAnalytics');
                        break;
                    case 'DetectionLocale':
                        $sysYAML->changeVarValue($k, $v, 'System' );
                    default:
                        break;
                }
            }
            
            $sysYAML->save();
        }
        
        return JSONencode(array( 'success' => true, 'message' => $app->translate( 'ConfiguracaoSalva' ) ) );
    }

    /********** aux functions ****************/
    function constructSelector($value, $min, $max, $jump, $idComp='', $classComp='')
    {
        
        $buff = "<select id='{$idComp}' class='{$classComp}' >";
        for( $i = $min; $i <= $max; $i+=$jump )
        {
            $is_active = intval( $value ) == intval( $i );
            
            $selected = $is_active ? "selected='selected'" : "";
            $buff .= "<option {$selected} value='{$i}'>{$i}</option>";
        }
        $buff .= '</select>';
        return $buff;
    }

    function printDropCollectCall( $DeviceChannel, $number, $value = "" )
    {
        Global $sistema;

        $return = "<table border='0' class='noZebra'>";
        $return .= "<tr>";
        $return .= "<td align='left'>";
        $return .= $sistema->retTranslate( "BlockResponse" );
        $return .= "</td>";
        $return .= "<td valign='top' align='right'>";
        $options = array( "Busy", "Invalid number", "Out of service" );
        $return .= "<select name='DropCollectCallsC$number' id='DropCollectCallsC$number' >";
        $valueBlockResponse = $value['BlockResponse'];

        $optionValue = $valueBlockResponse == "" ? 'Busy' : $valueBlockResponse;

        for( $st = 0; $st < sizeof( $options ); $st++ )
        {
            $selected = $options[$st] == $optionValue ? 'selected' : '';
            $return .= "<option value='$options[$st]' $selected>$options[$st]</option>";
        }

        $return .= "</select>";
        $return .= "</td>";
        $return .= "</tr>";

        $return .= "<tr>";
        $return .= "<td align='left'>" . $sistema->retTranslate( "DoubleAnswerDelay" ) . "</td>";
        $return .= "<td valign='top' align='right'>";
        $return .= "<select name='DropCollectCallsF$number' id='DropCollectCallsF$number' >";

        $valueDoubleAnswerDelay = isset( $value['DoubleAnswerDelay'] ) ? $value['DoubleAnswerDelay'] : NULL;
        if( !isset( $valueDoubleAnswerDelay ) )
            $intValue = 500;
        else
            $intValue = $valueDoubleAnswerDelay;

        for( $st = 0; $st < 2000; $st += 50 )
        {
            if( $st == 50 )
                $st += 50;
            if( $st == $intValue )
                $selected = "selected";
            else
                $selected = "";
            $return .= "<option value='$st' $selected>$st</option>";
        }

        $return .= "</select>";
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "<tr>";

        $valueAutoBlock = $value['AutoBlock'];
        if( getBooleanValue( $valueAutoBlock ) )
            $checked = "checked";
        else
            $checked = "";

        $return .= "<td align='left'>" . $sistema->retTranslate( "AutoBlock" ) . "</td>";
        $return .= "<td align='right'>";

        $tmp = explode( ".", $DeviceChannel );
        if( !isset( $tmp[1] ) )
            $tmp[1] = "*";

        $DeviceChannel = implode( ".", $tmp );
        $return .= "<input type='hidden' id='DropCollectCallsA$number' name='DropCollectCallsA$number' value='$DeviceChannel'/>";
        $return .= "<input class='checkbox' name='DropCollectCallsB$number' id='DropCollectCallsB$number' value='' type='checkbox' $checked>";
        $return .= "</td>";
        $return .= "</td>";
        $return .= "</tr>";

        if( !IS_GATEWAY )
        {
            $return .= "<tr>";
            $valueDropCallAnalyzer = $value['DropCallAnalyzer'];
            if( getBooleanValue( $valueDropCallAnalyzer ) )
                $checked = "checked";
            else
                $checked = "";
    
            $return .= "<td align='left'>" . $sistema->retTranslate( "DropCallAnalyzer" ) . "</td>";
            $return .= "<td align='right'>";
            $return .= "<input class='checkbox' name='DropCollectCallsD$number' id='DropCollectCallsD$number' value='' type='checkbox' $checked> ";
            $return .= "</td>";
            $return .= "</tr>";
        }

        $return .= "<tr>";
        $valueAutoDoubleAnswer = $value['AutoDoubleAnswer'];

        if( getBooleanValue( $valueAutoDoubleAnswer ) )
            $checked = "checked";
        else
            $checked = "";

        $return .= "<td align='left'>" . $sistema->retTranslate( "AutoDoubleAnswer" ) . "</td>";
        $return .= "<td align='right'>";
        $return .= "<input class='checkbox' name='DropCollectCallsE$number' id='DropCollectCallsE$number' value='' type='checkbox' $checked>";
        $return .= "</td>";
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "</table>";

        return $return;
    }

    function getSentence( $DCC )
    {
        Global $sistema;
        $suDCC = explode( ".", $DCC );

        if( !isset( $suDCC[1] ) )
            $suDCC[1] = '*';

        $sentence = '';

        if( $suDCC[0] == "*" && $suDCC[1] == "*" )
        {
            $sentence = $sistema->retTranslate( "TDeviceCahnnels" );
        }
        elseif( @ereg( "\[", $suDCC[1] ) )
        {
            // extens�o do cannal tanto ao tanto no dipositivo x
            $tnpSC = explode( "-", $suDCC[1] );
            $SC = substr( $tnpSC[0], 1 );
            $EC = substr( $tnpSC[1], 0, (strlen( $tnpSC[1] ) - 1) );
            $sentence = $sistema->retTranslate( "extFrom" ) . " $SC " . $sistema->retTranslate( "to" ) . " $EC " . $sistema->retTranslate( "atDevice" ) . " " . $suDCC[0];
        }
        elseif( $suDCC[1] == "FXO" || $suDCC[1] == "FXS" || $suDCC[1] == "E1" || $suDCC[1] == "GSM" )
        {
            // todos os dispositivos que usam tecnologia x
            $sentence = $sistema->retTranslate( "TDevices" ) . " " . $suDCC[1];
        }
        elseif( $suDCC[0] != "*" && $suDCC[1] == "*" )
        {
            //dispositivo x
            $sentence = $sistema->retTranslate( "TChannelsFromdevice" ) . " " . $suDCC[0];
        }
        elseif( $suDCC[0] != "*" && $suDCC[1] != "*" )
        {
            // link x no dispositivo y
            $sentence = $sistema->retTranslate( "link" ) . " " . $suDCC[1] . " " . $sistema->retTranslate( "atDevice" ) . " " . $suDCC[0];
        }
        return $sentence;
    }
