<?php
    require_once KCONFIG . '/classes/classKGatewayUtil.php';
    require_once KCONFIG . '/classes/KGatewayYaml.php';

    $AjaxFunctions['showTimeRestraintsGW'] = 'showTimeRestraintsGW';
    $AjaxFunctions['newTimeRestraintsGW'] = 'newTimeRestraintsGW';
    $AjaxFunctions['editTimeRestraintsGW'] = 'newTimeRestraintsGW';
    $AjaxFunctions['saveTimeRestraintsGW'] = 'saveTimeRestraintsGW';
    $AjaxFunctions['removeTimeRestraintsGW'] = 'removeTimeRestraintsGW';

    function showTimeRestraintsGW( )
    {
        $app = KSystem::getInstance( );

        $buffer = '';
        $kyaml = new KGatewayYaml( );
        $yaml = $kyaml->getYaml( );

        $buffer .= "<fieldset><legend>{$app->translate( 'TimeRestraints' )}</legend>";
        $buffer .= "<div id='TimeRestraintsDivTable'>";
        $buffer .= "<input type='button' value='{$app->translate( 'newTimeRestraints' )}' onClick='newTimeRestraints();' /><br /><br />";

        if( sizeof((array_values( $yaml['TimeRestraints'] ))) > 0 )
        {
            $buffer .= "<table id='TimeRestraintsTable' class='gateway-table zebra'><thead><tr>";
            $buffer .= "<th>{$app->translate( 'name' )}</th>";
            $buffer .= "<th class='gateway-table-options'>{$app->translate( 'options' )}</th></tr></thead><tbody>";

            foreach( $yaml['TimeRestraints'] as $time )
            {
                $trName = htmlspecialchars( $time['Name'], ENT_QUOTES );
                $buffer .= "<tr>";
                $buffer .= "<td>{$time['Name']}</td>";
                $buffer .= "<td class='gateway-table-options'><a href='#' onClick=\"editTimeRestraints('{$trName}');\"><img border='0' src='/imagens/edit.png' title='{$app->translate( 'edit' )}' /></a>";
                $buffer .= "<a href='#' onClick=\"removeTimeRestraints('{$trName}');\"><img border='0' src='/imagens/remove.png' title='{$app->translate( 'delete' )}' /></a></td>";
                $buffer .= "</tr>";
            }
            $buffer .= "</tbody></table>";

        }
        else
        {
            $buffer .= $app->translate( 'noTimeRestraints' );
        }

        $buffer .= '</div></fieldset>';

        return $buffer;

    }

    function newTimeRestraintsGW( )
    {
        global $sistema;

        $name = isset( $_POST['name'] ) ? $_POST['name'] : '';

        if( $name != '' )
        {
            //TODO: implement function to search time restraints by name in
            // KGatewayYaml
            //$kyaml = new KGatewayYaml( );
            $ret = searchTimeRestraintsByName( $name );
            $time = $ret['time'];
            $pos = $ret['pos'];
        }
        else
        {
            $time = array( 'Name' => '', 'Hour' => '', 'WDay' => '', 'Day' => '', 'Month' => '' );
            $pos = '';
        }

        if( $time['Hour'] != '' )
        {
            $checkedHour = 'checked';
            $displayHour = 'block';
        }
        else
        {
            $checkedHour = '';
            $displayHour = 'none';
        }

        $tmp = explode( '-', $time['Hour'] );
        if( sizeof( $tmp ) > 1 )
        {
            $from = explode( ':', $tmp[0] );
            $to = explode( ':', $tmp[1] );
        }
        else
        {
            $from = array( 0 => '00', 1 => '00' );
            $to = array( 0 => '00', 1 => '00' );
        }

        $trName = htmlspecialchars( $time['Name'], ENT_QUOTES );

        $buffer = $sistema->retTranslate( 'name' ) . ": <input id='timeRestraintsName'type='text' value='${trName}'/></br></br>";
        $buffer .= "<table border='0' class='zebra width550p'>";
        $buffer .= "<tr class='height28'>";
        $buffer .= "<td class='width25'>";
        $buffer .= "<input type='checkbox' $checkedHour id='checkHour' onclick='showHourTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= "<td >";
        $buffer .= $sistema->retTranslate( 'hour' );
        $buffer .= "</br></br><table id='hourTable' class='width275 marginLeft25px' style='display:$displayHour;'>";
        $buffer .= "<td class='width220'>";
        $buffer .= $sistema->retTranslate( 'start' ) . ':';
        $buffer .= "<input class='width20' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"hour\",\"from\");' type='text' id='fromHour' value='$from[0]'/>:";
        $buffer .= "<input class='width20' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"minutes\",\"from\");' type='text' id='fromMinutes' value='$from[1]'/>";
        $buffer .= '</td>';
        $buffer .= '<td class="width15">';
        $buffer .= "<a href='#' onclick='up(\"from\");'><img src='/imagens/up.png' border='0'></a></br>";
        $buffer .= "<a href='#' onclick='down(\"from\");'><img src='/imagens/down.png' border='0'></a>";
        $buffer .= '</td>';

        $buffer .= '<td class="width50">';
        $buffer .= '</td>';

        $buffer .= '<td class="width220">';
        $buffer .= $sistema->retTranslate( 'end' ) . ':';
        $buffer .= "<input class='width20' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"hour\",\"to\");' type='text' id='toHour' value='$to[0]'/>:";
        $buffer .= "<input class='width20' maxlength='2' onkeydown='return onlyIntegerNumbers(event);' onclick='setPosition(\"minutes\",\"to\");' type='text' id='toMinutes' value='$to[1]'/>";
        $buffer .= '</td>';
        $buffer .= '<td class="width15">';
        $buffer .= "<a href='#' onclick='up(\"to\");'><img src='/imagens/up.png' border='0'></a></br>";
        $buffer .= "<a href='#' onclick='down(\"to\");'><img src='/imagens/down.png' border='0'></a>";
        $buffer .= '</td>';
        $buffer .= '</tr>';
        $buffer .= '</table>';
        $buffer .= "<input type='hidden' id='fromPosition'  value='hour'/>";
        $buffer .= "<input type='hidden' id='toPosition'  value='hour'/>";
        $buffer .= '</td>';
        $buffer .= '</tr>';

        if( $time['WDay'] != '' )
            $days = explode( ',', $time['WDay'] );
        else
            $days = array( );

        $displayWeekDay = sizeof( $days ) > 0 ? 'block' : 'none';
        $checkWeekDay = sizeof( $days ) > 0 ? 'checked' : '';

        $buffer .= "<tr class='height28'>";
        $buffer .= "<td class='width25'>";
        $buffer .= "<input type='checkbox' id='checkWeekDay' $checkWeekDay onclick='showWeekDaysTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= '<td>';

        $buffer .= $sistema->retTranslate( 'weekDays' );
        $checkDom = in_array( 0, $days ) ? 'selected' : '';
        $checkSeg = in_array( 1, $days ) ? 'selected' : '';
        $checkTer = in_array( 2, $days ) ? 'selected' : '';
        $checkQua = in_array( 3, $days ) ? 'selected' : '';
        $checkQui = in_array( 4, $days ) ? 'selected' : '';
        $checkSex = in_array( 5, $days ) ? 'selected' : '';
        $checkSab = in_array( 6, $days ) ? 'selected' : '';

        $buffer .= "<br><br><select id='weekDay-combo' multiple='multiple'>";
        $buffer .= "<option $checkDom value='0'>" . $sistema->retTranslate( 'Dom' ) . "</option>";
        $buffer .= "<option $checkSeg value='1'>" . $sistema->retTranslate( 'Seg' ) . "</option>";
        $buffer .= "<option $checkTer value='2'>" . $sistema->retTranslate( 'Ter' ) . "</option>";
        $buffer .= "<option $checkQua value='3'>" . $sistema->retTranslate( 'Qua' ) . "</option>";
        $buffer .= "<option $checkQui value='4'>" . $sistema->retTranslate( 'Qui' ) . "</option>";
        $buffer .= "<option $checkSex value='5'>" . $sistema->retTranslate( 'Sex' ) . "</option>";
        $buffer .= "<option $checkSab value='6'>" . $sistema->retTranslate( 'Sab' ) . "</option>";
        $buffer .= "</select>";

        $buffer .= '</td>';
        $buffer .= '</tr>';
        $buffer .= "<tr class='height28'>";

        if( $time['Day'] != '' )
            $days = explode( ',', $time['Day'] );
        else
            $days = array( );
        $displayDay = sizeof( $days ) > 0 ? '' : 'display:none;';
        $checkDay = sizeof( $days ) > 0 ? 'checked' : '';

        $buffer .= "<td class='width25'>";
        $buffer .= "<input type='checkbox' id='checkMonthDay' $checkDay onclick='showMonthDayTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= '<td>';
        $buffer .= $sistema->retTranslate( 'monthDays' );
        $buffer .= "<br></br><table id='monthDayTable' style='$displayDay' class='width500' border='0' >";
        $buffer .= '<tr>';
        for( $i = 1; $i < 32; $i++ )
        {
            $check = in_array( $i, $days ) ? 'checked' : '';
            $buffer .= '<td>';
            if( $i < 10 )
                $buffer .= "<input type='checkbox' id='day$i' $check value='$i'><label for='day$i'>&nbsp;&nbsp;$i</label></input>";
            else
                $buffer .= "<input type='checkbox' id='day$i' $check value='$i'><label for='day$i'>$i</label></input>";

            $buffer .= '</td>';
            $buffer .= $i % 7 == 0 ? '</tr><tr>' : '';
        }
        $buffer .= '</tr>';
        $buffer .= '</table>';
        $buffer .= '</td>';
        $buffer .= '</tr>';

        if( $time['Month'] != '' )
            $meses = explode( ',', $time['Month'] );
        else
            $meses = array( );
        $displayMonth = sizeof( $meses ) > 0 ? '' : 'display:none;';
        $checkMonth = sizeof( $meses ) > 0 ? 'checked' : '';

        $buffer .= "<tr class='height28' >";
        $buffer .= "<td class='width25'>";
        $buffer .= "<input type='checkbox' $checkMonth id='checkMonth' onclick='showMonthTable();' value=''></input>";
        $buffer .= '</td>';
        $buffer .= '<td>';
        $buffer .= $sistema->retTranslate( 'months' );
        $meses = explode( ',', $time['Month'] );

        $checkJan = in_array( 1, $meses ) ? 'selected' : '';
        $checkFev = in_array( 2, $meses ) ? 'selected' : '';
        $checkMar = in_array( 3, $meses ) ? 'selected' : '';
        $checkAbr = in_array( 4, $meses ) ? 'selected' : '';
        $checkMai = in_array( 5, $meses ) ? 'selected' : '';
        $checkJun = in_array( 6, $meses ) ? 'selected' : '';
        $checkJul = in_array( 7, $meses ) ? 'selected' : '';
        $checkAgo = in_array( 8, $meses ) ? 'selected' : '';
        $checkSet = in_array( 9, $meses ) ? 'selected' : '';
        $checkOut = in_array( 10, $meses ) ? 'selected' : '';
        $checkNov = in_array( 11, $meses ) ? 'selected' : '';
        $checkDez = in_array( 12, $meses ) ? 'selected' : '';

        $buffer .= "<br><br><select id='month-combo' multiple='multiple'>";
        $buffer .= "<option $checkJan value='1'>" . $sistema->retTranslate( 'Jan' ) . "</option>";
        $buffer .= "<option $checkFev value='2'>" . $sistema->retTranslate( 'Fev' ) . "</option>";
        $buffer .= "<option $checkMar value='3'>" . $sistema->retTranslate( 'Mar' ) . "</option>";
        $buffer .= "<option $checkAbr value='4'>" . $sistema->retTranslate( 'Abr' ) . "</option>";
        $buffer .= "<option $checkMai value='5'>" . $sistema->retTranslate( 'Mai' ) . "</option>";
        $buffer .= "<option $checkJun value='6'>" . $sistema->retTranslate( 'Jun' ) . "</option>";
        $buffer .= "<option $checkJul value='7'>" . $sistema->retTranslate( 'Jul' ) . "</option>";
        $buffer .= "<option $checkAgo value='8'>" . $sistema->retTranslate( 'Ago' ) . "</option>";
        $buffer .= "<option $checkSet value='9'>" . $sistema->retTranslate( 'Set' ) . "</option>";
        $buffer .= "<option $checkOut value='10'>" . $sistema->retTranslate( 'Out' ) . "</option>";
        $buffer .= "<option $checkNov value='11'>" . $sistema->retTranslate( 'Nov' ) . "</option>";
        $buffer .= "<option $checkDez value='12'>" . $sistema->retTranslate( 'Dez' ) . "</option>";
        $buffer .= "</select>";

        $buffer .= '</td>';
        $buffer .= '</tr>';
        $buffer .= "</table><br />";

        $buffer .= "<input type='hidden' id='TimeRestraintsId' value='{$trName}' />";
        $buffer .= "<input type='hidden' id='TimeRestraintsPos' value='{$pos}' />";
        $buffer .= "<div class='textAlignRight'>";
        $buffer .= "<input type='button' onclick='backTimeRestraints();' value='" . $sistema->retTranslate( 'back' ) . "' />";
        $buffer .= "<input type='button' onclick='saveTimeRestraints();' value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buffer .= "</div>";

        return $buffer;
    }

    //TODO: convert this function to use json communication
    function saveTimeRestraintsGW( )
    {
        $app = KSystem::getInstance( );

        $id = isset( $_POST['id'] ) ? $_POST['id'] : NULL;
        $pos = isset( $_POST['TimeRestraintsPos'] ) ? $_POST['TimeRestraintsPos'] : NULL;
        $data = isset( $_POST['data'] ) ? $_POST['data'] : NULL;

        try
        {
            if( isset( $data ) )
            {
                $timeTMP = array( );
                $arrData = explode( '|', $data );

                foreach( $arrData as $campoValor )
                {
                    $arrCV = explode( '=', $campoValor );
                    $timeTMP[$arrCV[0]] = $arrCV[1];
                }

                //TODO: implement function to set time restraints in KGatewayYaml
                $kyaml = new KGatewayYaml( );
                $yaml = $kyaml->getYaml( );
                $newTimeRestraints = $id == '' ? true : false;

                if( $newTimeRestraints )
                {
                    for( $i = 0; $i < sizeof( $yaml['TimeRestraints'] ); $i++ )
                    {
                        if( $yaml['TimeRestraints'][$i]['Name'] == $timeTMP['Name'] )
                            return "nok|{$app->translate( 'NameAlreadyUsed' )}";
                    }
                    $qtdeTimeRestraints = $yaml['TimeRestraints'] == '' ? 0 : sizeof( $yaml['TimeRestraints'] );
                    $kyaml->createAddValue( $qtdeTimeRestraints, "TimeRestraints", $timeTMP );
                }
                else
                {
                    $kyaml->changeVarValue( $pos, $timeTMP, 'TimeRestraints' );
                }
                $kyaml->save( );

                return "ok|{$app->translate( 'TimeRestraintSaved' )}";
            }
        }
        catch( Exception $e )
        {
            return "nok|{$app->translate( $e->getMessage() )}";
        }
    }

    function removeTimeRestraintsGW( )
    {
        $name = isset( $_POST['name'] ) ? $_POST['name'] : null;

        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );

        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-time-restraints-delete-error' ) );

        try
        {
            if( !is_null( $name ) )
            {
                //TODO: implement function to remove time restraints in
                // KGatewayYaml
                $kyaml = new KGatewayYaml( );
                $yaml = $kyaml->getYaml( );
                foreach( $yaml['TimeRestraints'] as $idx => $time )
                {
                    if( $time['Name'] == $name )
                    {
                        $inUse = false;
                        foreach( $yaml['Routes'] as $route )
                        {
                            if( $route['Time'] == $time['Name'] )
                            {
                                $inUse = true;
                                break;
                            }
                        }
                        if( $inUse )
                        {
                            $reply['message'] = $app->translate( 'gateway-time-restraints-delete-error-inuse' );
                        }
                        else
                        {
                            unset( $yaml['TimeRestraints'][$idx] );
                            $kyaml->setYaml( $yaml );
                            $kyaml->save( );
                            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-time-restraints-deleted' ) );
                        }
                        break;
                    }
                }
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    //TODO: remove this function and implement it inside KGatewayYaml
    function searchTimeRestraintsByName( $name, $yaml = null )
    {
        if( is_null( $yaml ) )
        {
            $kyaml = new KGatewayYaml( );
            $yaml = $kyaml->getYaml( );
        }
        for( $i = 0; $i < sizeof( $yaml['TimeRestraints'] ); $i++ )
        {
            if( $yaml['TimeRestraints'][$i]['Name'] == $name )
                return $r = array( 'pos' => $i, 'time' => $yaml['TimeRestraints'][$i] );
        }
        return '';
    }
