<?php
    require_once KCONFIG . '/classes/classKYaml.php';

    class KDevicesYamlException extends KYamlException
    {
    }

    class KDevicesYaml extends KYaml
    {
        static private $self = null;
        public $ebsIpAddresses = array( );

        public function __construct( )
        {
            if( IS_GATEWAY )
            {
                $this->ebsIpAddresses = array( '172.31.249.2', '172.31.249.6', '172.31.249.10', '172.31.249.14', '172.31.249.18', '172.31.249.22', '172.31.249.26', '172.31.249.30' );
            }
            $app = KSystem::getInstance( );
            parent::__construct( $app->getConfigDir( ) . DIRECTORY_SEPARATOR . 'devices.yaml' );
        }

        static public function getInstance()
        {
            if ( is_null( self::$self ) )
            {
                self::$self = new KDevicesYaml();
            }
            return self::$self;
        }

        /**
         * Assign IP address using the ebsIpAddresses array as reference.
         *
         * This method will always set addresses from the first device, until
         * it has ebsIpAddresses available, when end of any of the arrays is
         * reached, the method bails out.
         */
        public function selfAssignEbsIpAddresses( )
        {
            foreach( $this->yaml['Devices'] as $idx => &$dev )
            {
                if( !isset( $this->ebsIpAddresses[$idx] ) )
                {
                    break;
                }
                $serial = array_keys( $dev );
                $dev[$serial[0]]['IP'] = $this->ebsIpAddresses[$idx];
            }
        }

        /**
         * Count defined devices
         *
         * @return int
         */
        public function countDevices( )
        {
            return count( $this->yaml['Devices'] );
        }

    }
