<?php

    class KProfiles
    {
        var $profilesYaml, $defaultProfiles, $profileData;

        function __construct( )
        {
            Global $sistema, $_SESSION;
            $this->defaultProfiles = array( 'R2', 'ISDN', 'ISUP', 'ISDNNetwork', 'GSM', 'FXS', 'LineSide', 'CASEL7', 'E1LC', 'Open CAS', 'Open CCS', 'FXO' );
            $this->profilesYaml = new KYaml( $sistema->getConfigDir( ) . "/profiles.yaml" );
            $this->profileData = $this->profilesYaml->getYaml( );
        }

        function getDefaultProfiles( )
        {
            return $this->profileData['ChannelGroupProfiles'];
        }

        function saveProfiles( )
        {
            $this->profilesYaml->save( );
        }

        function getProfilePosition( $name )
        {
            $profiles = $this->getDefaultProfiles( );
            $profileSize = sizeof( $profiles );
            for( $x = 0; $x < $profileSize; $x++ )
            {
                $keys = array_keys( $profiles[$x] );
                if( $keys[0] == $name )
                    return $x;
            }
            return '';
        }

        function createProfile( $name, $profile )
        {
            Global $_SESSION;
            $profiles = $this->getDefaultProfiles( );
            $profileSize = sizeof( $profiles );
            $position = '';
            $position = $this->getProfilePosition( $name );
            if( !is_int( $position ) )
                $position = $profileSize;
            $this->profilesYaml->createVar( $name, "ChannelGroupProfiles|$position", $profile );
            $this->profileData = $this->profilesYaml->getYaml( );
            return true;
        }

        function deleteProfile( $name )
        {
            Global $_SESSION;
            $position = $this->getProfilePosition( $name );
            $this->profilesYaml->deleteVar( $position, "ChannelGroupProfiles" );
            $profilesData = $this->profilesYaml->getYaml( );
            $keys = array_keys( $profilesData['ChannelGroupProfiles'] );
            for( $i = 0; $i < sizeof( $keys ); $i++ )
                $profiles['ChannelGroupProfiles'][] = $profilesData['ChannelGroupProfiles'][$keys[$i]];
            $this->profilesYaml->yaml = $profiles;
            $this->profileData = $this->profilesYaml->getYaml( );
            $_SESSION['profilesYaml'] = serialize( $this->profilesYaml );
            return true;
        }

        function getProfile( $name, $nProfileData = "" )
        {
            if( $nProfileData == "" )
            {
                $tempProfiles = $this->profileData['ChannelGroupProfiles'];
                $pSize = sizeof( $this->profileData['ChannelGroupProfiles'] );
            }
            else
            {
                $tempProfiles = $nProfileData['ChannelGroupProfiles'];
                $pSize = sizeof( $nProfileData['ChannelGroupProfiles'] );
            }

            for( $x = 0; $x < $pSize; $x++ )
            {
                $profileKeys = array_keys( $tempProfiles[$x] );
                if( $profileKeys[0] == $name )
                    return $tempProfiles[$x];
            }
        }

        function checkDefaultProfiles( $defaultProfilesData )
        {
            Global $_SESSION;
            for( $x = 0; $x < sizeof( $defaultProfilesData['ChannelGroupProfiles'] ); $x++ )
            {
                $keys = array_keys( $defaultProfilesData['ChannelGroupProfiles'][$x] );

                if( !is_int( $this->getProfilePosition( $keys[0] ) ) )
                {
                    $profiles = $this->getDefaultProfiles( );
                    $position = sizeof( $profiles );
                    $this->profilesYaml->createVar( $keys[0], "ChannelGroupProfiles|$position", $defaultProfilesData['ChannelGroupProfiles'][$x][$keys[0]] );
                    $this->profileData = $this->profilesYaml->getYaml( );
                    $_SESSION['profilesYaml'] = serialize( $this->profilesYaml );
                }
            }
        }

        function resetDefaultProfiles( )
        {
            Global $sistema;

            $profilesYaml = new KYaml( $sistema->getConfigDir( ) . "/profiles.yaml" );
            $defaultProfiles = new KYaml( dirname( __FILE__ ) . "/../defaultConfig/defaultProfiles.yaml" );
            $defaultProfilesData = $defaultProfiles->getYaml( );
            $this->checkDefaultProfiles( $defaultProfilesData );

            for( $x = 0; $x < sizeof( $defaultProfilesData['ChannelGroupProfiles'] ); $x++ )
            {
                $keys = array_keys( $defaultProfilesData['ChannelGroupProfiles'][$x] );
                $position = $this->getProfilePosition( $keys[0] );
                $profilesYaml->changeVarValue( $position, $defaultProfilesData['ChannelGroupProfiles'][$x], 'ChannelGroupProfiles' );
            }
            $profilesYaml->save( );
        }

    }