<?php
    class KService
    {
        var $service, $validTypes;

        function __construct( $serviceName )
        {
            $this->service = $serviceName;
            $this->validTypes = array( 2 => 'auto', 3 => 'demand', 4 => 'disabled' );
            if( @ereg( " ", $this->service ) )
                $this->service = "\"" . $this->service . "\"";
        }

        function getStartupType( )
        {
            $command = "qc " . $this->service;
            $scReturn = $this->sendSpecificCommand( $command );
            if(isset($scReturn[4]))
            {
                $pieces = explode( ":", $scReturn[4] );
                return $this->validTypes[trim( $pieces[1] ) * 1];
            }
            else
                return NULL;
        }

        function changeStartupType( $type )
        {
            Global $_SESSION;
            if( in_array( $type, $this->validTypes ) )
            {
                $_SESSION['services'][$this->service]['startup'] = $type;
                return true;
            }
            return false;
        }

        function changeStartup( $type )
        {
            if( in_array( $type, $this->validTypes ) )
            {
                $command = "config " . $this->service . " start= $type";
                $scReturn = $this->sendSpecificCommand( $command );
                return true;
            }
            return false;
        }

        function getStatus( )
        {
            $command = "query " . $this->service;
            $scReturn = $this->sendSpecificCommand( $command );
            $pieces = explode( ":", $scReturn[3] );
            return trim( $pieces[1] );
        }

        function sendSpecificCommand( $command )
        {
            $systemRoot = exec( "echo %systemRoot%" );
            $fileLocation = "$systemRoot/system32/sc.exe";
            exec( $fileLocation . " $command", $scReturn );
            return $scReturn;
        }

        function getValidTypes( )
        {
            return $this->validTypes;
        }

    }