<?php
    if( file_exists( '/etc/elastix.conf' ) )
        session_name( 'elastixSession' );
    @session_start( );

    $AjaxFunctions['analyseLogDownload'] = 'analyseLogDownload';

    function analyseLogDownload( )
    {
        $type = isset( $_REQUEST['type'] ) ? $_REQUEST['type'] : NULL;
        if( isset( $type ) )
        {
            switch($type)
            {
                case '24hours':
                    return getLastLogsDownload( 1 );

                case '48hours':
                    return getLastLogsDownload( 2 );
            }
        }
    }

    function getBasicLogsList( )
    {
        $basicLogsFiles = array( 'sysinfo.log', 'messages.log', 'crash.log', 'link.log', 'k3l.log' );

        $logdir = LogUtil::getLogDir( );
        $basicLogs = array( );

        foreach( $basicLogsFiles as $file )
        {
            if( file_exists( $logdir . $file ) )
                $basicLogs[] = $logdir . $file;
        }

        if( file_exists( $logdir . 'config' ) )
        {
            $configDir = scandir( $logdir . 'config' );
            foreach( $configDir as $configFile )
            {
                if( $configFile != "." && $configFile != ".." )
                    $basicLogs[] = $logdir . "config" . DIRECTORY_SEPARATOR . $configFile;
            }
        }

        return $basicLogs;

    }

    //auc functions
    function getBasicLogsDownloadFile( )
    {
        return getFileSizeStyle( sizeMe( getBasicLogsList( ) ) );
    }

    function getLastLogsDownload( $days )
    {
        $lastDayfiles = array( );
        $logdir = LogUtil::getLogDir( );

        $lastDayfiles = getBasicLogsList( );

        $dirsToScan = array( $logdir, $logdir . "old" . DIRECTORY_SEPARATOR );

        foreach( $dirsToScan as $dir )
        {
            $filesLogDir = scandir( $dir );
            foreach( $filesLogDir as $fld )
            {
                $file = $dir . $fld;

                if( $fld != "." && $fld != ".." && !is_dir( $file ) )
                {
                    if( !in_array( $file, $lastDayfiles ) )
                    {
                        $stats = stat( $file );
                        if( $stats[9] > (time( ) - (86400 * $days)) )
                            $lastDayfiles[] = $file;
                    }
                }
            }
        }

        if( PHP_OS != "WINNT" )
        {
            if( is_dir( '/etc/asterisk/' ) )
            {
                $astk = scandir( '/etc/asterisk/' );
                foreach( $astk as $f )
                {
                    if( $f != "." && $f != ".." )
                        $lastDayfiles[] = '/etc/asterisk/' . $f;
                }
            }
            if( file_exists( '/var/log/asterisk/full' ) )
                $lastDayfiles[] = '/var/log/asterisk/full';
            elseif( file_exists( '/var/log/asterisk/messages' ) )
                $lastDayfiles[] = '/var/log/asterisk/messages';

            $fsbin = shell_exec('whereis freeswitch');
            $fullpath = strchr($fsbin, "/");
            if( $fullpath != '' )
            {
                $fspath = substr($fullpath, 0, strpos($fullpath, 'bin'));
                $confpath = $fspath;
                $confpath .= 'conf/';
                if( is_dir( $confpath ) )
                {
                    $fsk = scandir( $confpath );
                    foreach( $fsk as $f )
                    {
                        if( $f != "." && $f != ".." )
                            $lastDayfiles[] = $confpath . $f;
                    }
                }
                if( function_exists( 'posix_getuid' ) )
                    $root = posix_getuid( ) == 0;
                else
                {
                    $ret = shell_exec( 'whoami' );
                    $root = strcasecmp( $ret, 'root' );
                }
                $prepend = $root ? '' : '/usr/bin/sudo -u root ';
                $fslog = shell_exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh logpath 2>&1");
                if( $fslog != '' )
                {
                    $fslog = str_replace("\n", "", $fslog);
                    $fslog = str_replace("\r", "", $fslog);
                    $fslog .= '/';
                    $filesLogDir = scandir( $fslog );
                    foreach( $filesLogDir as $fld )
                    {
                        $file = $fslog . $fld;

                        if( $fld != "." && $fld != ".." && !is_dir( $file ) )
                        {
                            if( !in_array( $file, $lastDayfiles ) )
                            {
                                $stats = stat( $file );
                                if( $stats[9] > (time( ) - (86400 * $days)) )
                                    $lastDayfiles[] = $file;
                            }
                        }
                    }
                }
            }
        }

        return getFileSizeStyle( sizeMe( $lastDayfiles ) );
    }

    function getAllLogsDownload( )
    {
        $logdir = LogUtil::getLogDir( );
        $objects = scandir( $logdir );
        sort( $objects );
        foreach( $objects as $obj )
        {
            if( $obj != "." && $obj != ".." )
            {
                if( !is_dir( $logdir . $obj ) )
                    $sizeMe[] = $logdir . $obj;
                else
                    $sizeMe[] = $logdir . $obj;
            }
        }
        return getFileSizeStyle( sizeMe( $sizeMe ) );
    }

    function sizeMe( $sizeMe )
    {
        Global $_SESSION;
        $total = 0;
        $zipMe = array( );
        foreach( $sizeMe as $k => $v )
        {
            $total += filesize( $v );
            $zipMe[] = $v;
        }
        $_SESSION['logZipMe'] = $zipMe;
        return $total;
    }
?>
