<?php
    require_once KROOT . '/util.php';

    function debug($var, $flag="a")
    {
        $file = fopen("/var/www/debug_file", $flag);
        fwrite($file, var_export($var, true)."\n");
        fclose($file);
    }

    $AjaxFunctions['diagnosticMode'] = 'diagnosticMode';
    $AjaxFunctions['showSettingLogs'] = 'showSettingLogs';
    $AjaxFunctions['saveSettingLogs'] = 'saveSettingLogs';
    function process_mask($line)
    {
        $mask = array();
        $ip = explode("/", $line[1]);
        if(array_key_exists(1, $ip)) //ip addr
        {
            $bits=$ip[1];
            for($i=0; $i < 4; ++$i)
            {
                $b=0;
                if($bits>=8)
                {
                    $b=8; $bits-=8;
                }
                else
                {
                    $b = $bits;
                    $bits = 0;
                }
                $mask[$i] = pow(2,$b)-1;
            }
        }
        else //ifconfig
        {
            if(array_key_exists(3, $line)) //ip addr
                $mask = $line[3];
            else
                $mask = $line[2]; //idk if this should happen

            $mask = explode(":", $mask);
            $mask = explode(".", $mask);
        }
        return $mask;
    }
    function check_ip()
    {
        $cmd = "if [ $(command -v ip) ]; then ip addr; else ifconfig; fi | grep \"\<inet\>\"";
        $output = array();
        exec($cmd, $output, $retval);
        $ips = array();
        $masks = array();
        $cmd  = "if [ $(command -v ip && command -v awk) ]; then ";
        $cmd .= "ip addr | awk '$0 ~ /state/{($0 ~ /state UP/) ? state=\"UP\" : state=\"DOWN\"} $0 ~ /inet / {print state}';";
        $cmd .= "else if [ command -v awk ]; then ifconfig | awk '$0 ~ /inet /{print \"UP\"}' fi fi";
        $states = array();
        exec($cmd, $states);
        //Removing down states
        for($i=0; $i<count($states); ++$i)
        {
            if($states[$i] != "UP")
                array_splice($states, $i, 1);
        }
        foreach($output as $ip)
        {
            $ip = explode(" ", trim($ip));
            array_push($masks, process_mask($ip));

            $ip = explode("/", $ip[1]);
            $ip = explode(".", $ip[0]);
            array_push($ips, $ip);
        }
        for($i=0; $i<count($ips); ++$i)
        {
            for($j=$i+1; $j<count($ips); ++$j)
            {
                $equal=true;
                for($k=0; $k<count($ips[0])-1; ++$k)
                {
                    if( ($ips[$i][$k] & $masks[$i][$k]) != ($ips[$j][$k] & $masks[$j][$k]) )
                    {
                        $equal = false;
                        break;
                    }
                }
                if($equal)
                {
                    Global $sistema;
                    $msg  = $sistema->retTranslate( 'error-network-interfaces1' );
                    $ip = explode(" ", trim($output[$i]));
                    $msg .= $ip[1];
                    $msg .= ' '.$sistema->retTranslate( 'and' ).' ';
                    $ip = explode(" ", trim($output[$j]));
                    $msg .= $ip[1];
                    $msg .= $sistema->retTranslate( 'error-network-interfaces2' );

                    return '|'.$msg;
                }
            }
        }
        return '';
    }

    function diagnosticMode( )
    {
        Global $sistema;
        $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : NULL;

        if( isset( $action ) )
        {
            if( $action == 'active' )
            {
                if( PHP_OS == "WINNT" )
                    return setFullLog( true, $_REQUEST );
                else
                {
                    if( is_file( "/usr/sbin/kmpserver" ) )
                        return setFullLog( true, $_REQUEST );
                    else
                    {
                        $out = array( );
                        if( is_file( '/usr/sbin/kdiagnostic_run.sh' ) )
                        {

                            if( function_exists( 'posix_getuid' ) )
                                $root = posix_getuid( ) == 0;
                            else
                            {
                                $ret = shell_exec( 'whoami' );
                                $root = strcasecmp( $ret, 'root' );
                            }

                            if( $root )
                                $prepend = '';
                            else
                                $prepend = '/usr/bin/sudo -u root ';

                            exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh start 2>&1", $out, $success );

                            if( $success == 0 )
                                return 'ok|' . $sistema->retTranslate( 'diagnosticModeActivated' ) . check_ip();
                            else
                                return getDiagnosticErrorMessage( $out );
                        }
                        else
                            return 'notok|' . $sistema->retTranslate( 'diagnosticModeNotFound' );
                    }
                }
            }
            else
            {
                if( PHP_OS == "WINNT" )
                    return setFullLog( false, $_REQUEST );
                else
                {
                    if( is_file( "/usr/sbin/kmpserver" ) )
                        return setFullLog( false, $_REQUEST );
                    else
                    {
                        if( is_file( '/usr/sbin/kdiagnostic_run.sh' ) )
                        {
                            $out = array( );
                            if( function_exists( 'posix_getuid' ) )
                                $root = posix_getuid( ) == 0;
                            else
                            {
                                $ret = shell_exec( 'whoami' );
                                $root = strcasecmp( $ret, 'root' );
                            }

                            $prepend = $root ?  '' : '/usr/bin/sudo -u root ';
                            exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh stop 2>&1", $out, $success );

                            if( $success == 0 )
                                return 'ok|' . $sistema->retTranslate( 'diagnosticModeDeactivated' );
                            else
                                return 'notok|' . getDiagnosticErrorMessage( $out );
                        }
                        else
                            return 'notok|' . $sistema->retTranslate( 'diagnosticModeNotFound' );
                    }
                }
            }
        }
    }

    function showSettingLogs( )
    {
        Global $sistema;

        $klog = new Klogs( dirname( __FILE__ ) . '/../logs.xml' );
        $return = "";
        $return .= printDownloadTable( );
        $return .= "<fieldset id='logsTable'><legend>Logs</legend></br>";
        $return .= printDiagnosticModeTable( $klog );
        $return .= "<span id='showSettingsLogs' onclick='showSettingsLogsAdvanced();'>" . $sistema->retTranslate( 'advancedLogSettings' ) . " »</span>";
        $return .= "<span id='hideSettingsLogs' onclick='hideSettingsLogsAdvanced();'>" . $sistema->retTranslate( 'hideAdvancedLogSettings' ) . " «</span>";
        $return .= $klog->createForm( );
        $return .= "</br></fieldset>";

        return $return;
    }

    function saveSettingLogs( )
    {
        Global $sistema;
        $klog = new Klogs( 'logs.xml' );

        $apply = $_REQUEST['apply'];
        unset( $_REQUEST['apply'] );

        if( $klog->saveLogConfig( ) )
        {
            if( $apply == 'yes' )
            {
                if( reload( "reload" ) == 'OK' )
                    return 'ok|' . $sistema->retTranslate( 'K3LRealoaded' );
                else
                    return 'notok|' . $sistema->retTranslate( 'K3LNRunning' );
            }
        }
        else
            return 'notok|' . $sistema->retTranslate( 'K3LNRunning' );
    }

    //aux funcs

    function printDownloadTable( )
    {
        Global $image_dir;
        $app = KSystem::getInstance();
        
        $return = "";
        $return .= "<fieldset id='downloadTable' class='textAlignCenter' ><legend>" . $app->translate( 'downloads' ) . "</legend></br>";

        $return .= "<table class='simpleTable' ><tbody>";
        $return .= "<td align='right' width='50%'>" . $app -> translate('logsLast');
        $return .= '<select id="logPackage" class="minwidth80px marginRight10px marginLeft5px">';
        $return .= '<option class="i18n" key="24hours" value="24hours">'.$app->translate('24hours').'</option>';
        $return .= '<option class="i18n" key="48hours" value="48hours">'.$app->translate('48hours').'</option>';
        $return .= '</select></td>';
        $return .= "<td align='left' width='50%'>";
        $return .= '<input class="diagnosticModeButton" id="diagModeActive" type="button" value="'.$app->translate('download').'" onclick="analyseDownloadSize();" >';
        $return .= "</td></tbody></table>";

        $return .= "<a id='lastLogZip' href=''>";
        $return .= "<input type='button' style='display:none' name='downloadZipButton' id='downloadZipButton' value='' onclick='' ></a>";
        $return .= "</br></fieldset></br>";

        return $return;
    }

    function printDiagnosticModeTable( $klog )
    {
        Global $sistema;

        $return = "";

        $return .= "<table id='diagnosticModeTable' class='simpleTable' border='0'><tbody>";
        $return .= "<td align='right' width='50%'><b>" . $sistema->retTranslate( 'diagnosticMode' ) . "</b></td>";
        $return .= "<td align='left' width='50%'>";

        $displayA = '';
        $displayB = '';

        if( PHP_OS == "WINNT" )
        {
            if( $klog->logConfig['KLoggerFullLog'] == 'true' )
            {
                $displayA = "display:none";
                $displayD = "display:block";
            }
            else
            {
                $displayA = "display:block";
                $displayD = "display:none";
            }
        }
        else
        {
            if( is_file( "/usr/sbin/kmpserver" ) )
            {
                if( $klog->logConfig['KLoggerFullLog'] == 'true' )
                {
                    $displayA = "display:none";
                    $displayD = "display:block";
                }
                else
                {
                    $displayA = "display:block";
                    $displayD = "display:none";
                }
            }
            else
            {
                $out = array( );
                if( is_file( '/usr/sbin/kdiagnostic_run.sh' ) )
                {

                    if( function_exists( 'posix_getuid' ) )
                        $root = posix_getuid( ) == 0;
                    else
                    {
                        $ret = shell_exec( 'whoami' );
                        $root = strcasecmp( $ret, 'root' );
                    }

                    if( $root )
                        $prepend = '';
                    else
                        $prepend = '/usr/bin/sudo -u root ';
                    exec( "{$prepend}/usr/sbin/khomp-sudo /usr/sbin/kdiagnostic_run.sh status", $out, $ret );
                    if( $ret == 0 )
                    {
                        if( $out[0] == 'ACTIVE' )
                        {
                            $displayA = "display:none";
                            $displayD = "display:block";
                        }
                        else
                        {
                            $displayA = "display:block";
                            $displayD = "display:none";
                        }
                    }
                    else
                        return getDiagnosticErrorMessage( $ret );
                }
            }
        }
        if( $displayA != '' && $displayD != '' )
        {
            $return .= "<input class='diagnosticModeButton' id='diagModeActive' style='" . $displayA . "' type='button' onclick=\"diagnosticMode('active');\" value='" . $sistema->retTranslate( 'active' ) . "'>";
            $return .= "<input class='diagnosticModeButton' id='diagModeDesactive' style='" . $displayD . "' type='button' onclick=\"diagnosticMode('deactive');\" value='" . $sistema->retTranslate( 'deactive' ) . "'>";
        }

        $return .= "</td>";
        $return .= "</tbody></table></br>";

        return $return;
    }

    function setFullLog( $boo )
    {
        Global $sistema;

        if( PHP_OS == "WINNT" )
        {
            $k3lServer = new KService( 'k3lServer' );
            $status = trim( $k3lServer->getStatus( ) );

            if( $status == '4  RUNNING' )
            {
                $log = new Klogs( 'logs.xml' );
                $log->logConfig['KLoggerFullLog'] = $boo ? 'true' : 'false';
                $log->saveLogConfig( );
                exec( "..\\..\\..\\Tools\\kwebhelper reload" );

                if( $boo )
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeActivated' );
                else
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeDeactivated' );
            }
            else
                return 'notok|' . $sistema->retTranslate( 'diagnosticModeCantBeActivated' );
        }
        else
        {
            if( (bool) exec( 'ps cax | grep -i k3lserver | grep -v grep' ) )
            {
                $log = new Klogs( 'logs.xml' );
                $log->logConfig['KLoggerFullLog'] = $boo ? 'true' : 'false';
                $log->saveLogConfig( );
                exec( "/usr/sbin/kwebhelper reload" );

                if( $boo )
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeActivated' );
                else
                    return 'ok|' . $sistema->retTranslate( 'diagnosticModeDeactivated' );
            }
            else
                return 'notok|' . $sistema->retTranslate( 'diagnosticModeCantBeActivated' );
        }
    }

    function getDiagnosticErrorMessage( $ret )
    {
        Global $sistema;

        switch($ret)
        {
            case 1:
                $return = $sistema->retTranslate( 'genericError' ) . "<BR>";
                break;
            case 2:
                $return = $sistema->retTranslate( 'permissionDenied' ) . "<BR>";
                break;
            case 3:
                $return = $sistema->retTranslate( 'ProgramsNotFound' ) . "<BR>";
                break;
            case 4:
                $return = $sistema->retTranslate( 'K3LServerInactive' ) . "<BR>";
                break;
            case 5:
                $return = $sistema->retTranslate( 'chan_khompNotLoaded' ) . "<BR>";
                break;
            case 6:
                $return = $sistema->retTranslate( 'mod_khompNotLoaded' ) . "<BR>";
                break;
            case 7:
                $return = $sistema->retTranslate( 'softPBXInactive' ) . "<BR>";
                break;
            default:
                $return = $sistema->retTranslate( 'genericError' ) . "<BR>";
                break;
        }
        return $return;
    }
