<?php
    @session_start( );

    $AjaxFunctions['monitoringMessageLog'] = 'monitoringMessageLog';
    $AjaxFunctions['showMoreLogs'] = 'showMoreLogs';
    $AjaxFunctions['showMessage'] = 'showMessage';

    function monitoringMessageLog( )
    {
        $logdir = LogUtil::getLogDir( );
        $file = $logdir . "messages.log";

        if( file_exists( $file ) )
        {
            $newSize = sprintf( "%u", filesize( $file ) );

            if( isset( $_SESSION['lastLine'] ) )
                $oldSize = $_SESSION['lastLine'];
            else
                $oldSize = 0;

            if( $oldSize < $newSize )
            {
                $handle = @fopen( $file, "r" );
                fseek( $handle, $oldSize );
                while( !feof( $handle ) )// Loop til end of file.
                {
                    $line = (trim( fgets( $handle ) ));
                    $sub = substr( $line, 0, 2 );
                    if( $sub == "W|" || $sub == "E|" || $sub == "I|" )
                        $newLines[] = $line;
                }
                $_SESSION['lastLine'] = $newSize;

                return JSONencode( $newLines );
            }
            else
                return JSONencode( array( ) );
        }
        else
            return "<br>" . $sistema->retTranslate( 'messagesNotfound' );
    }

    function showMoreLogs( )
    {
        $app = KSystem::getInstance();

        $oper = isset( $_REQUEST['oper'] ) ? $_REQUEST['oper'] : NULL;
        $paginator = isset( $_REQUEST['paginator'] ) ? $_REQUEST['paginator'] : NULL;
        $file = isset( $_REQUEST['file'] ) ? $_REQUEST['file'] : NULL;

        if( $paginator == NULL )
            $paginator = 300000;
        
        if( isset( $oper ) && isset( $file ) )
        {
            $khompDir = LogUtil::getLogDir();
            $file = base64_decode( $file );

            if( strncmp( $file, $khompDir, strlen( $khompDir ) ) == 0 )
            {
                $handle = fopen( $file, "r" );
                $response = array( );
                $fileSize = filesize( $file );

                if( $paginator > $fileSize )
                    $paginator = $fileSize;

                $isMessageLog = strpos( $file, 'messages.log' ) !== false;

                switch ($oper)
                {
                    case 'first':
                        $start = 0;
                        $end = $paginator;
                        $atual = fseek( $handle, $start );
                        break;

                    case 'last':
                        $start = $fileSize - $paginator;
                        $end = $fileSize;
                        $atual = fseek( $handle, $start );
                        break;

                    case 'back':
                        if( $_SESSION['first'] - $paginator <= 0 )
                            $start = 0;
                        else
                            $start = $_SESSION['first'] - $paginator;

                        $end = $_SESSION['first'];
                        $atual = fseek( $handle, $start );
                        $response['endOfFile'] = false;
                        break;

                    default:
                        //forward
                        $start = $_SESSION['last'];
                        $end = $_SESSION['last'] + $paginator;
                        $atual = fseek( $handle, $start );

                        if( $end >= $fileSize )
                            $response['endOfFile'] = true;
                        else
                            $response['endOfFile'] = false;
                        break;
                }
                $response['first'] = $start;
                $response['last'] = $end;
                $_SESSION['first'] = $start;
                $_SESSION['last'] = $end;
                $response['fileSize'] = $fileSize;
                $count = 0;

                while( !feof( $handle ) && $atual < $end )
                {
                    $line = fgets( $handle );
                    if( $line != " " )
                    {
                        if( $isMessageLog )
                        {
                            $sub = substr( $line, 0, 2 );
                            if( $sub == "W|" || $sub == "E|" || $sub == "I|" )
                            {
                                $response['lines'][$count] = $line;
                                $count++;
                            }
                        }
                        else
                        {
                            $response['lines'][$count] = utf8_encode( $line );
                            $count++;
                        }
                    }
                    $atual = ftell( $handle );
                }
                fclose( $handle );
                return JSONencode( $response );

            }
            else
                return $app->translate( 'noFilesOrNoPermission' );
        }
    }

    function showMessage( )
    {
        global $sistema, $image_dir;

        $logdir = LogUtil::getLogDir( );
        $file = $logdir . "messages.log";

        $return = "";

        if( file_exists( $file ) )
        {
            $return .= "<input type='hidden' value='0' id='delayRefresh' />";
            $return .= "<div id='topMessages'>";
            $return .= "<fieldset id='fieldsetMessage'>";
            $return .= "<legend>" . $sistema->retTranslate( 'lastMessages' ) . "</legend>";
            $return .= "<div id='divRefreshDelay'>" . $sistema->retTranslate( 'refreshDelay' );
            $return .= "<select id='refreshDelay' onchange='setRefreshDelay(this.value);'>";
            $return .= "<option value='0'>" . $sistema->retTranslate( 'notRefresh' ) . "</option>";
            $return .= "<option value='30'>" . $sistema->retTranslate( 'delay3' ) . "</option>";
            $return .= "<option value='10'>" . $sistema->retTranslate( 'delay2' ) . "</option>";
            $return .= "<option value='2'>" . $sistema->retTranslate( 'delay1' ) . "</option>";
            $return .= "</select>";

            $return .= "<span>&nbsp;</span>";

            $_filesize = filesize( $file );
            if( $_filesize > 100000 )
            {
                $return .= $sistema->retTranslate( 'paginate' ) . " <select id='paginator'>";
                $return .= "<option value='100000'>100kb</option>";
                $return .= "<option value='300000'>300kb</option>";
                $return .= "<option value='500000'>500kb</option>";
                $return .= "<option value='1000000'>1Mb</option>";
                $return .= "</select><br /><br />";

                $file64 = base64_encode( $file );

                $return .= "<div id='navigatorSection'>";
                $return .= "<input type='button' id='first' onclick=\"showMoreMessages('first', '{$file64}');\" value='" . $sistema->retTranslate( 'first' ) . "' />";
                $return .= "<input type='button' id='back' onclick=\"showMoreMessages('back', '{$file64}');\" value='" . $sistema->retTranslate( 'showPreviousLines' ) . "'/>";
                $return .= "<input type='button' disabled='true' class='backgroundGray' id='forward' onclick=\"showMoreMessages('forward', '$file64');\" value='" . $sistema->retTranslate( 'showLastLines' ) . "' />";
                $return .= "<input type='button' disabled='true' class='backgroundGray' id='last' onclick=\"showMoreMessages('last', '$file64');\" value='" . $sistema->retTranslate( 'last' ) . "' />";
                $return .= "</div>";
            }
            $return .= "</div>";
            $return .= '</fieldset>';
            $return .= "<br />";
            $return .= "</div>";

            $return .= "<div id='showMessages'>";
            $return .= "<table border='0' id='tabelaMessages'>";
            $return .= "<tbody>";

            $handle = @fopen( $file, "r" );
            $oldStop = ftell( $handle );
            $start = $_filesize - 100000;
            $end = $_filesize;
            $atual = fseek( $handle, $start );

            while( $atual < $end )
            {
                $line = fgets( $handle, 4096 );
                $atual = ftell( $handle );
                $startsWith = substr( $line, 0, 2 );

                if( $startsWith == "W|" )
                {
                    $return .= "<tr><td class='warning'>$line</td></tr>";
                }
                else if( $startsWith == "E|" )
                {
                    $return .= "<tr><td class='logerror'>$line</td></tr>";
                }
                else if( $startsWith == "I|" )
                {
                    $return .= "<tr><td class='info'>$line</td></tr>";
                }
            }

            $_SESSION['first'] = $start;
            $_SESSION['lastLine'] = ftell( $handle );
            $return .= '</tbody></table></div>';
        }
        else
            $return .= "<br />" . $sistema->retTranslate( 'messagesNotfound' );

        return $return;
    }
