<?php

    class KMessages
    {
        // Atributos da classe
        var $messageFile, $firstDatePosition, $lastDatePosition;

        // Metodo construtor
        function __construct( $file )
        {
            $this->messageFile = $file;
            $this->firstDatePosition = $this->getFirstDatePosition( );
            $this->lastDatePosition = $this->getLastDatePosition( );
        }

        function getLine( $seek )
        {
            $fp = fopen( $this->messageFile, "r" );
            fseek( $fp, $seek );
            return fgets( $fp );
        }

        function getFirstDatePosition( )
        {
            $fp = fopen( $this->messageFile, "r" );
            while( true )
            {
                $seek = ftell( $fp );
                if( ($line = fgets( $fp )) == false )
                    break;

                if( @ereg( "([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})", $line ) )
                {
                    fclose( $fp );
                    return $seek;
                }
            }
            return 0;
        }

        function getDate( $line )
        {
            if( @ereg( "([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})", $line ) )
            {
                $tmp = explode( " ", $line );
                return substr( $tmp[0], 2 );
            }
            return false;
        }

        function getTime( $line )
        {
            if( @ereg( "([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})", $line ) )
            {
                $tmp = explode( " ", $line );
                return trim( $tmp[1] );
            }
            return false;
        }

        function getLastDatePosition( )
        {
            $fp = fopen( $this->messageFile, "a" );
            $file = new RevFile( $this->messageFile );
            while( !$file->sof( ) )
            {
                $line = $file->GetLine( );
                if( @ereg( "([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})", $line ) )
                {
                    $file->closeFile( );
                    return $file->seekPos;
                }
            }
            //return fseek($fp,filesize($this->messageFile));
        }

    }

    class RevFile
    {

        var $FileName;
        var $FileHandle;
        var $FilePos;
        var $seekPos;

        function closeFile( )
        {
            fclose( $this->FileHandle );
            return true;
        }

        function __construct( $filename )
        {

            $this->FileName = $filename;

            $this->FileHandle = @fopen( $filename, "r" ) or die( "Could not open file $filename\n" );

            // Find EOF
            if( !(fseek( $this->FileHandle, 0, SEEK_END ) == 0) )
                die( "Could not find end of file in $filename\n" );

            // Store file position
            $this->FilePos = ftell( $this->FileHandle );

            // Check that file is not empty or doesn;t contain a single newline
            if( $this->FilePos < 2 )
                die( "File is empty\n" );

            // Position file pointer just before final newline
            // i.e. Skip EOF
            $this->FilePos -= 1;
        }

        function GetLine( )
        {
            $pos = $this->FilePos - 1;
            $ch = " ";
            $line = "";
            while( $ch != "\n" && $pos >= 0 )
            {
                fseek( $this->FileHandle, $pos );
                $ch = fgetc( $this->FileHandle );

                // Decrement out pointer and prepend to the line
                // if we have not hit the new line
                if( $ch != "\n" )
                {
                    $pos = $pos - 1;
                    $line = $ch . $line;
                }
            }
            $this->FilePos = $pos;
            $this->seekPos = $pos + 1;
            return $line . "\n";
        }

        function sof( )
        {
            return ($this->FilePos <= 0);
        }

    }