(function (Khomp) {

    /// Called party number (pg 67)

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;
    var attributes = InformationElements.attributes;
    var Util = Khomp.Util;

    InformationElements.elementsDecoders[0x70] = function (values) {

        var objValue = {};

        /// Octet 3
        var octet3 = values.shift();

        /// Type of number (bits 7,6,5)
        var typeOfNumber = (octet3 & 0x70) >> 4;

        /// Numbering plan identification (octeto 3, bits 4,3,2,1)
        var numberPlanIdentification = (octet3 & 0x0f);

        objValue['Numbering plan'] = attributes[0x27][numberPlanIdentification] || numberPlanIdentification;
        objValue['Type of number'] = attributes[0x36][typeOfNumber] || typeOfNumber;

        /// Octet 4 em diante
        // var octet4 = values;

        /// Number digits (octeto 4) tabela IA5 characters
        objValue['Number digits'] = Util.translateIA5(values);

        return objValue;
    };
})(Khomp);