(function (Khomp) {

    /// Called party subaddress (pg 69)

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;
    var attributes = InformationElements.attributes;
    var Util = Khomp.Util;

    InformationElements.elementsDecoders[0x71] = function (values) {

        var objValue = {};

        var octet3;
        var octet4x;

        /// octet3
        octet3 = values.shift();

        var typeOfSubaddress = (octet3 & 0x70) >> 4;

        /// bits 7,6,5 octeto 3
        objValue['Type of subaddress'] = attributes[0x37][typeOfSubaddress] || typeOfSubaddress;

        if (typeOfSubaddress === 0x02) {

            /// NOTE 1 – The odd/even indicator is used when the type of subaddress is "user specified" and the coding is BCD.
            /// bit 4 octeto 3
            var oddEvenIndicator = (octet3 & 0x08) >> 3;
            objValue['Odd/even indicator'] = attributes[0x28][oddEvenIndicator] || oddEvenIndicator;
        }

        objValue['Subaddress information'] = '';
        while (values.length) {
            octet4x = values.shift();
            objValue['Subaddress information'] += Util.translateIA5(octet4x);
        }

        return objValue;

    };

})(Khomp);