(function (Khomp) {

    /// Cause
    /// Página 72 ITU Q.931. Detalhes na Q.850.

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;
    var attributes = InformationElements.attributes;

    InformationElements.elementsDecoders[0x08] = function (values) {

        var objValue = {};
        var octet3 = values.shift();
        var codingStandard = (octet3 & 0x60) >> 5;
        var location = (octet3 & 0x0f);

        objValue['Coding standard'] = attributes[0x06][codingStandard] || codingStandard;
        objValue.Location = attributes[0x16][location] || location;

        var extensionIndicatorOct3 = (((octet3 & 0x80) >> 7) === 0) ? true : false;

        if (extensionIndicatorOct3) {
            /// Recommendation... acho que não tem na Q.931. Ver Q.850 Cause format.
        }

        var octet4 = values.shift();
        var causeValue = (octet4 & 0x7f);

        objValue.Cause = attributes[0x03][causeValue] || causeValue;

        var octet;
        var key;
        /// Diagnostics
        while (values.length) {

            octet = values.shift();

            objValue.Diagnostics = (objValue.Diagnostics) ? (objValue.Diagnostics + ', ' + octet) : octet;

        }

        return objValue;
    };

})(Khomp);
