(function (Khomp) {

    /// Segmented message
    /// Página 98 da ITU Q931.

    var ISDN = Khomp.ISDN;
    var InformationElements = ISDN.InformationElements;

    InformationElements.elementsDecoders[0x00] = function (values) {

        var objValue = {};
        var attributes = {
            'First segment indicator' : {
                0x00 : 'Subsequent segment to first segment',
                0x01 : 'First segment of segmented message'
            }
        };

        var octet3 = values.shift();
        var octet4 = values.shift();

        var firstSegmentIndicator = (octet3 & 0x80) >> 7;
        var numberOfSegmentsRemaining = (octet3 & 0x7f);

        objValue['First segment indicator'] = attributes['First segment indicator'][firstSegmentIndicator] || firstSegmentIndicator;
        objValue['Number of segments remaining'] = numberOfSegmentsRemaining;

        var segmentedMessageType = (octet4 & 0x7f);
        objValue['Segmented message type'] = (segmentedMessageType);

        return objValue;

    };

})(Khomp);
