(function (Khomp) {

    /// ----------------------------------------------------------------------------------------------
    /// Utils: funções auxiliares

    var Util = Khomp.Util = {

        paddingLeft : function (value, length) {

            length = length || 0;

            return (length > value.toString().length) ? this.paddingLeft("0" + value, length) : value;
        },

        binToNumber : function (num) {
            return parseInt(num, 2);
        },

        binToHex : function (num) {
            return this.numberToHex(this.binToNumber(num));
        },

        numberToBin : function (num, paddingLeft) {
            paddingLeft = paddingLeft || 8;
            num = (typeof num === 'string') ? this.hexToNumber(num) : num;
            return this.paddingLeft((num).toString(2), paddingLeft);
        },

        numberToHex : function (number) {
            return this.paddingLeft(number.toString(16).toUpperCase(), 2);
        },

        hexToNumber : function (hexaString) {
            return parseInt(hexaString, 16);
        },

        hexToBin : function (hexString) {
            return this.numberToBin(this.hexToNumber(hexString));
        },

        arrayMapHexToNumber : function (arrayHexa) {

            var aux = [];

            for (var i = 0; i < arrayHexa.length; i++) {
                aux.push(this.hexToNumber(arrayHexa[i]));
            }

            return aux;
        },

        /// bits contados de 1 a 8. Exemplo:
        /// 1 0 1 0 1 1 1 0   -> número de exemplo
        /// | | | | | | | |
        /// 8 7 6 5 4 3 2 1   -> posição dos bits
        testBit : function (num, bit) {
            return ((num >> (bit - 1)) % 2 !== 0);
        },

        setBit : function (num, bit) {
            return num | 1 << (bit - 1);
        },

        clearBit : function (num, bit) {
            return num & ~(1 << (bit - 1));
        },

        getBitsString : function (num, posicaoBits) {

            num = (typeof num === 'string') ? this.hexToNumber(num) : num;
            var bits = [];

            for (var i = 0; i < posicaoBits.length; i++) {
                bits.push((this.testBit(num, posicaoBits[i])) ? 1 : 0);
            }

            return bits.join('');
        },

        toAscii : function (code) {
            code = (typeof code === 'string') ? this.hexToNumber(code) : code;
            return String.fromCharCode(code);
        },
        /// ---------------------------------------------------------------------------------------------------
        /// Extraído de: http://djh1.webfactional.com/html/ascii.html
        /**
            @method translateIA5
            @param {Array} data Lista com os charcodes...
            @return {String}
        */
        translateIA5 : function (data) {

            data = (typeof data === 'string') ? data.split(' ') : data;

            return String.fromCharCode.apply(null, data);
        }
    };

})(Khomp);
