function setRefreshDelay( delay )
{
    if( delay > 0 )
    {
        $( '#delayRefresh' ).val( delay );
        $( '#refreshing' ).show( );
    }
    else
    {
        $( '#delayRefresh' ).val( delay );
        $( '#refreshing' ).hide( );
    }
    startMonitoringMessageLog( );
}

function startMonitoringMessageLog( )
{
    $.kajax(
    {
        data : "ajaxTo=monitoringMessageLog",
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( ln )
        {
            countLines = countElements( ln );
            if( countLines > 0 )
            {
                var newLines = new Array( );
                for( var i = 0; i < countElements( ln ); i++ )
                    newLines[i] = ln[i];
                refreshTable( newLines );
                setScrollAtBottom( '#showMessages' );
            }
        }
    } );
    var bool = $( "#delayRefresh" ).val( ) > 0;
    if( bool )
        setTimeout( "startMonitoringMessageLog()", getRefreshDelay( ) * 1000 );
}

function getRefreshDelay( )
{
    return $( '#delayRefresh' ).val( );
}

function refreshTable( array )
{
    var table = document.getElementById('tabelaMessages').getElementsByTagName("TBODY")[0];

    for( var j = 0; j < array.length; j++ )
    {
        if( array[j] != null )
        {
            if( isValidLine( array[j] ) )
            {
                var newLine = array[j];
                var row = document.createElement( "tr" );
                var name = getNameLine( newLine );
                row.setAttribute( 'name', name );
                var td = document.createElement( "td" );
                td.className = name;
                td.appendChild( document.createTextNode( newLine ) );
                row.appendChild( td );
                table.appendChild( row );
            }
        }
    }
}

function isValidLine( line )
{
    line = line.substring( 0, 2 );
    if( line == "W|" || line == "I|" || line == "E|" )
        return true;
    else
        return false;
}

function getNameLine( charLine )
{
    switch (charLine[0])
    {
        case 'W':
            return "warning";
        case 'I':
            return 'info';
        case 'E':
            return 'error';
    }
}

function showMoreMessages( oper, file )
{
    var paginator = $( '#paginator' ).val( );
    $( '#refreshing' ).show( );

    jQuery.kajax(
    {
        type : "POST",
        data : "ajaxTo=showMoreLogs&file=" + file + "&oper=" + oper + "&paginator=" + paginator,
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( json )
        {
            var countLines = countElements( json['lines'] );
            if( countLines > 0 )
            {
                printNewTable( countLines, json['lines'] );

                // top of the file
                if( json['first'] <= 0 )
                {
                    $( '#forward, #last' ).removeClass( ).addClass( 'green-light' );
                    $( '#back, #first' ).removeClass( ).addClass( 'backgroundGray' );
                    $( '#first, #back' ).attr( 'disabled', 'true' );
                    $( '#last, #forward' ).removeAttr( 'disabled' );
                }
                else
                {
                    //middle of file
                    if( json['last'] < json['fileSize'] && json['first'] > 0 )
                    {
                        $( '#back, #forward, #first, #last' ).removeClass( ).addClass( 'green-light' );
                        $( '#back, #forward, #first, #last' ).removeAttr( 'disabled' );
                    }
                    //end of file
                    else
                    {
                        $( '#back, #first' ).removeClass( ).addClass( 'green-light' );
                        $( '#forward, #last' ).removeClass( ).addClass( 'backgroundGray' );
                        $( '#forward, #last' ).attr( 'disabled', 'true' );
                        $( '#back, #first' ).removeAttr( 'disabled' );
                    }
                }
            }
            $( '#refreshing' ).hide( );
        }
    } );
}

function printNewTable( countLines, lines )
{
    var div = document.getElementById( 'showMessages' );
    var table = document.getElementById( 'tabelaMessages' );
    div.removeChild( table );

    tab = document.createElement( 'table' );
    tab.setAttribute( 'id', 'tabelaMessages' );
    tab.setAttribute( 'border', '1' );
    tbody = document.createElement( 'tbody' );
    tab.appendChild( tbody );
    div.appendChild( tab );
    li = new Array( );

    for( i = 0; i < countLines; i++ )
    {
        if( lines[i] != null )
        {
            nameLine = getNameLine( lines[i] );
            li[i] = document.createElement( 'tr' );
            li[i].setAttribute( 'class', nameLine );
            td = document.createElement( 'td' );
            td.setAttribute( 'class', nameLine );
            text = document.createTextNode( lines[i] );
            td.appendChild( text );
            li[i].appendChild( td );
            tbody.appendChild( li[i] );
        }
    }
}
