<?php

    function showDirTree( )
    {
        Global $sistema;

        $logdir = getLogDir( );

        $result = getDirTree( $logdir );

        $return = "";
        $return .= "<ul name='tree' id='browser' class='filetree'>";
        $return .= "<li class='closed'>";
        $return .= "<span id='messageMenu' class='folder hover fontWeightBold' onclick=\"javascript:showMessages('messageMenu');\">";
        $return .= $sistema->retTranslate( 'resume' );
        $return .= "</span>";
        $return .= "</li>";
        $return .= "<li class='closed'>";
        $return .= "<span id='settingsMenu' class='folder hover' onclick=\"javascript:showSettings('settingsMenu');\">";
        $return .= $sistema->retTranslate( 'logs' );
        $return .= "</span>";
        $return .= "</li>";

        $tempDir = $result['dir'];

        $return .= "<li class='closed'>";
        $return .= "<span id='logsMenu' class='folder' onClick=\"javascript:showDir('" . base64_encode( $tempDir ) . "',this);\">";
        $return .= $sistema->retTranslate( 'dir' );
        $return .= "</span>";

        if( isset( $result['sdir'] ) )
            $return .= "<ul>" . getSdirTree( $result['sdir'] ) . "</ul>";

        $return .= "</li>";
		
        if( IS_GATEWAY )
        {
            $CDRdir = "/var/local/ftp/cdr/";
            $result2 = getDirTree( $CDRdir );
            $tempDir2 = $result2['dir'];
		
            $return .= "<li class='closed'>";
            $return .= "<span id='downloadCDRMenu' class='folder' onClick=\"javascript:showCDRDir('" . base64_encode( $tempDir2 ) . "',this);\">";
            $return .= "CDR";
            $return .= "</span>";
		
            if( isset( $result2['sdir'] ) )
                $return .= "<ul>" . getSCDRdirTree( $result2['sdir'] ) . "</ul>";
				
            $return .= "</li>";
        }
        
        //if( IS_GATEWAY or IS_CHANNEL )
        if( true )
        {
            $return .= "<li class='closed'>";
            $return .= "<span id='packetCapture' class='folder' onClick=\"javascript:showPacketCapture( this );\">";
            $return .= $sistema->retTranslate( 'packet_capture' );
            $return .= "</span>";
            $return .= "</li>";
        }
		
        $return .= "</ul>";

        return $return;
    }

    function getSdirTree( $dirTreeArray )
    {
        $return = "";
        for( $x = 0; $x < sizeof( $dirTreeArray ); $x++ )
        {
            $tmpSdir = explode( DIRECTORY_SEPARATOR, $dirTreeArray[$x]['dir'] );
            $return .= "<li class='closed'>";
            $return .= "<span class='folder hover' onClick=\"javascript:showDir('" . base64_encode( $dirTreeArray[$x]['dir'] ) . "',this);\">";
            $return .= $tmpSdir[sizeof( $tmpSdir ) - 1];
            $return .= "</span>";

            if( isset( $dirTreeArray[$x]['sdir'] ) )
                $return .= "<ul>" . getSdirTree( $dirTreeArray[$x]['sdir'] ) . "</ul>";
            $return .= "</li>";
        }
        return $return;
    }

    function getSCDRdirTree( $dirTreeArray )
    {
        $return = "";
        for( $x = 0; $x < sizeof( $dirTreeArray ); $x++ )
        {
            $tmpSdir = explode( DIRECTORY_SEPARATOR, $dirTreeArray[$x]['dir'] );
            $return .= "<li class='closed'>";
            $return .= "<span class='folder hover' onClick=\"javascript:showCDRDir('" . base64_encode( $dirTreeArray[$x]['dir'] ) . "',this);\">";
            $return .= $tmpSdir[sizeof( $tmpSdir ) - 1];
            $return .= "</span>";

            if( isset( $dirTreeArray[$x]['sdir'] ) )
                $return .= "<ul>" . getSdirTree( $dirTreeArray[$x]['sdir'] ) . "</ul>";
            $return .= "</li>";
        }
        return $return;
    }

    function getDirTree( $dir )
    {
        $tmpDir = $dir;

        $dirTree = array( );
        $dirTree['dir'] = $dir;
        $sdirCount = 0;
        $dir = dir( $dir );

        while( ($sDir = $dir->read( )) !== false )
        {
            if( $sDir != '.' && $sDir != '..' )
            {
                if( is_dir( $tmpDir . $sDir ) )
                    $dirTree['sdir'][$sdirCount++] = getDirTree( $tmpDir . $sDir );
            }
        }
        if( isset( $dirTree['sdir'] ) && $dirTree['sdir'] != null )
            sort( $dirTree['sdir'] );

        return $dirTree;
    }

    function getLogDir( )
    {
        if( PHP_OS == "WINNT" )
        {
            if( !isset( $_SESSION['logdir'] ) )
            {
                $winVersion = PHP_WINDOWS_VERSION_MAJOR . "." . PHP_WINDOWS_VERSION_MINOR;
                $logdir = exec( '..\\..\\..\\Tools\\kwebhelper configdir' );
                $sysdata = explode( "\\", $logdir );
                if( $winVersion >= 6.0 )
                {
                    if( sizeof( $sysdata ) <= 3 )
                        $logdir = $sysdata[0] . "\\ProgramData\\" . $sysdata[1] . "\\logdir\\";
                    else
                        $logdir = $sysdata[0] . "\\" . $sysdata[1] . "\\" . $sysdata[2] . "\\logdir\\";
                }
                elseif( $winVersion > 5.0 && $winVersion <= 5.2 )
                    $logdir = $sysdata[0] . "\\" . $sysdata[1] . "\\" . $sysdata[2] . "\\khomp\\logdir\\";

                $_SESSION['logdir'] = $logdir;
            }
            $logdir = $_SESSION['logdir'];
        }
        else
            $logdir = "/var/log/khomp/";

        return $logdir;
    }
