<?php
    require_once 'constants.php';
    require_once KROOT . '/classes/KSystem.php';
    $app = KSystem::getInstance( );

    $login = isset( $_REQUEST['login'] ) ? $_REQUEST['login'] : NULL;
    $password = isset( $_REQUEST['password'] ) ? $_REQUEST['password'] : NULL;

    if( is_null( $login ) || is_null( $password ) )
    {
        header( 'Location: /?error=Kerr1' );
        exit ;
    }

    require_once KROOT . '/util.php';
    require_once KCONFIG . '/classes/classKYaml.php';

    $filename = getUsersConfig( );

    if( is_file( $filename ) )
    {
        $KYaml = new KYaml( $filename );
        $users = $KYaml->yaml;

        // User authenticated via challenge response, create temporary user
        // to bypass normal authentication and permission checks for
        // administration screen
        if( $app->authenticationUsingChallengeResponse() && $app->authenticationResponse( $password ) )
        {
            $login = KSystem::CHALLENGE_RESPONSE_USER;
            $users['Users'][KSystem::CHALLENGE_RESPONSE_USER] = array(
                'password' => md5( "KWebPortal{$password}" ),
                'administration' => 'full'
            );
        }

        if( isset( $users['Users'][$login] )
            && $users['Users'][$login]['password'] == md5( "KWebPortal{$password}" )
        )
        {
            $_SESSION['login'] = $login;
            // set permissions
            $_SESSION['loginAccess'] = $users['Users'][$login];
            unset( $_SESSION['loginAccess']['password'] );
            if( !IS_GATEWAY )
            {
                $app->setTimeZone($_REQUEST['timezone']);
            }
            if( $app->hasPermission( 'monitoring', array( 'read', 'full' ) ) )
            {
                if( IS_GATEWAY )
                {
                    header( 'Location: /KWebMonitor/index.php?location=naps' );
                }
                else
                {
                    header( 'Location: /KWebMonitor/index.php?location=devices' );
                }
            }
            elseif( $app->hasPermission( 'configuration' ) )
            {
                header( 'Location: /KWebConfig/index.php' );
            }
            elseif( $app->hasPermission( 'diagnostic' ) )
            {
                header( 'Location: /KWebLogViewer/index.php' );
            }
            else
            {
                header( 'Location: /KWebConfig/index.php?location=admin' );
            }
        }
        else
        {
            header( 'Location: /?error=Kerr1' );
        }
    }
    else
    {
        header( 'Location: /?error=Kerr2' );
    }
