<?php
    class Topo
    {
        static function printTopo( $section, $accessConfig, $accessMonitoring, $accessDiag, $accessAdm, $modulo_pai = '' )
        {
            $app = KSystem::getInstance( );

            $buffer = '';
            $buffer .= '<div id="topo">';
            $buffer .= '<div>';
            $buffer .= "<img src='{$modulo_pai}/imagens/logo.png' align='left' alt='Khomp' title='Khomp'>";
            $buffer .= '</div>';
            $buffer .= '<div class="flag">';
            $buffer .= "<img src='{$modulo_pai}/imagens/flags/sflagBrasil.png' alt='{$app->translate( 'portuguese' )}' title='{$app->translate( 'portuguese' )}' class='cursorHand' onclick=\"changeSystemLanguage('pt-br');\" />&nbsp;";
            $buffer .= "<img src='{$modulo_pai}/imagens/flags/sflagEnglish.png' alt='{$app->translate( 'english' )}' title='{$app->translate( 'english' )}' class='cursorHand' onclick=\"changeSystemLanguage('en-us');\" />&nbsp;";
            $buffer .= "<img src='{$modulo_pai}/imagens/flags/sflagSpain.png' alt='{$app->translate( 'spanish' )}' title='{$app->translate( 'spanish' )}' class='cursorHand' onclick=\"changeSystemLanguage('es-es');\" />";
            $buffer .= '</div>';
            $buffer .= '<div class="autenticacao">';

            if( $accessConfig == 'full' )
            {
                $sectionConfig = $section == 'config' ? 'fontWeightBold' : ''; 
                $buffer .= "<a class ='{$sectionConfig}' href='{$modulo_pai}/KWebConfig/index.php' >{$app->translate( 'config-home' )}</a>";
            }
            if( $accessMonitoring != 'none' )
            {
                $sectionMonitor = $section == 'monitoring' ? 'fontWeightBold' : '';
                $location = IS_GATEWAY ? 'naps' : 'devices';
                $buffer .= "<a class='marginLeft25px {$sectionMonitor}' href='{$modulo_pai}/KWebMonitor/index.php?location={$location}' >{$app->translate( 'monitoring-home' )}</a>";
            }
            if( $accessDiag == 'full' )
            {
                $sectionDiag = $section == 'diagnostic' ? 'fontWeightBold' : ''; 
                $buffer .= "<a class='marginLeft25px {$sectionDiag}' href='{$modulo_pai}/KWebLogViewer/index.php' >{$app->translate( 'analyser-home' )}</a>";
            }
            if( $accessAdm )
            {
                $sectionAdm = $section == 'administration' ? 'fontWeightBold' : '';
                $buffer .= "<a class='marginLeft25px {$sectionAdm}'  href='{$modulo_pai}/KWebConfig/index.php?location=admin' >{$app->translate( 'adm-home' )}</a>";
            }
            if( $section != '' )
                $buffer .= "<a class='marginLeft25px' href='{$modulo_pai}/?action=logoff' >{$app->translate( 'exit' )}</a>";

            $buffer .= '</div></div>';

            require_once KROOT . '/classes/KLicense.php';
            try
            {
                $manager = new KLicenseManager( );
                $expired = array( );
                $expirewarning = array( );
                foreach( $manager->getLicenses() as $license )
                {
                    if( $license->isExpired( ) )
                    {
                        $expired[] = "{$license->id} ({$license->serial_number})";
                    }
                    elseif( $license->willExpire( ) )
                    {
                        $expirewarning[] = "{$license->id} ({$license->serial_number})";
                    }
                }
                if( count( $expired ) > 0 )
                {
                    $licenses = implode( ', ', $expired );
                    $buffer .= "<div id='license-expired-error'><img src='/imagens/alert.png' />{$app->translate( 'license-expired-error' )}: {$licenses}</div>";
                }
                if( count( $expirewarning ) > 0 )
                {
                    $licenses = implode( ', ', $expirewarning );
                    $buffer .= "<div id='license-will-expire-warning'>{$app->translate( 'license-will-expire-warning' )}: {$licenses}</div>";
                }
            }
            catch( KLicenseManagerException $e )
            {
                /*TODO: ignore errors?*/
            }

            return $buffer;
        }

    }
