<?php
    @session_start( );

    require_once 'chartPopulator.php';
    $AjaxFunctions['getQuadChartsData'] = 'getQuadChartsData';
    $AjaxFunctions['getChartsForAllLinks'] = 'getChartsForAllLinks';

    function getChartsForAllLinks( )
    {
        $app = KSystem::getInstance( );
        $serial = isset( $_REQUEST['serial'] ) ? trim( $_REQUEST['serial'] ) : NULL;

        if( $serial != '' )
        {
            $linkCount = Populator::getLinkCount( $serial );
            $arr_response['success'] = TRUE;
            $arr_response['message'] = '';
            for( $i = 0; $i < $linkCount; $i++ )
                $arr_response['content'][$i] = getCallStatusChartData( $serial, $i, NULL );

            return JSONencode( $arr_response );
        }
        else
            return JSONencode( $exit = array( 'success' => false, 'message' => $app->translate( 'needSerial' ) ) );
    }

    function getQuadChartsData( )
    {
        $arr_response = array( );
        $serial = isset( $_REQUEST['serial'] ) ? trim( $_REQUEST['serial'] ) : NULL;
        $link = isset( $_REQUEST['link'] ) ? trim( $_REQUEST['link'] ) : NULL;
        $channel = isset( $_REQUEST['channel'] ) ? trim( $_REQUEST['channel'] ) : NULL;

        $arr_ch = getChannelStatusChartData( $serial, $link );
        $arr_st = getCallStatusChartData( $serial, $link, $channel );
        $arr_fail = getFailStatusChartData( $serial, $link, $channel );

        $arr_response['content']['ChannelStatus'] = $arr_ch;
        $arr_response['content']['CallStatus'] = $arr_st;
        $arr_response['content']['FailStatus'] = $arr_fail;

        $arr_response['success'] = TRUE;
        $arr_response['message'] = '';

        return JSONencode( $arr_response );
    }

    function getChannelStatusChartData( $serial = NULL, $link = NULL )
    {
        $app = KSystem::getInstance( );
        if( isset( $serial ) )
        {
            if( isset( $link ) )
            {
                $f = ChartPopulator::getTotalFailByLink( $serial, $link );
                $b = ChartPopulator::getTotalBusyByLink( $serial, $link );
                $i = ChartPopulator::getTotalIdleByLink( $serial, $link );
            }
            else
            {
                $f = ChartPopulator::getTotalFailByDevice( $serial );
                $b = ChartPopulator::getTotalBusyByDevice( $serial );
                $i = ChartPopulator::getTotalIdleByDevice( $serial );
            }

            $arr = array( array( $app->translate( 'chart_leg_fail' ), intval( $f ) ), array( $app->translate( 'chart_leg_idle' ), intval( $i ) ), array( $app->translate( 'chart_leg_busy' ), intval( $b ) ) );

            $data = array( 'success' => true, 'message' => '', 'content' => $arr );
        }
        else
            $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );

        return $data;
    }

    function getCallStatusChartData( $serial = NULL, $link = NULL, $channel = NULL )
    {
        $app = KSystem::getInstance( );
        if( isset( $serial ) )
        {
            if( isset( $link ) )
            {
                $info = ChartPopulator::getCallStatsByLink( $serial, $link );
            }
            else if( isset( $channel ) )
            {
                $info = ChartPopulator::getCallStatsByChannel( $serial, $channel );
            }
            else
            {
                $info = ChartPopulator::getCallStatsByDevice( $serial );
            }

            if( intval( implode( '', $info ) ) )
            {
                $incoming = intval( $info[0] );
                $qtde = intval( $info[1] );
                $completed = intval( $info[2] );
                $fail = intval( $info[3] );

                $not_asw = $qtde != ($completed + $fail) ? $qtde - ($completed + $fail) : 0;
                $incOut = array( array( $app->translate( 'chart_leg_outgoing' ), $qtde ), array( $app->translate( 'chart_leg_incoming' ), $incoming ) );

                if( $qtde > 0 )
                {
                    $incDet = array( array( $app->translate( 'chart_leg_failed' ), $fail ), array( $app->translate( 'chart_leg_completed' ), $completed ), array( $app->translate( 'chart_leg_others' ), $not_asw ) );
                    $arr = array( $incOut, $incDet );
                    $msg = '';
                }
                else
                {
                    $msg = $app->translate( 'chart_leg_nodata' );
                    $arr = array( $incOut );
                }

                $data = array( 'success' => true, 'message' => $msg, 'content' => $arr );
            }
            else
                $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );
        }
        else
            $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );

        return $data;
    }

    function getFailStatusChartData( $serial = NULL, $link = NULL, $channel = NULL )
    {
        $app = KSystem::getInstance( );
        if( isset( $serial ) )
        {
            if( isset( $link ) )
            {
                $info = ChartPopulator::getFailStatsByLink( $serial, $link );
            }
            else if( isset( $channel ) )
            {
                $info = ChartPopulator::getFailStatsByChannel( $serial, $channel );
            }
            else
            {
                $info = ChartPopulator::getFailStatsByDevice( $serial );
            }

            if( intval( implode( '', $info ) ) )
            {
                $arr = array( array( $app->translate( 'chart_leg_ch_busy' ), intval( $info[0] ) ), array( $app->translate( 'chart_leg_not_answered' ), intval( $info[1] ) ), array( $app->translate( 'chart_leg_rejected' ), intval( $info[2] ) ), array( $app->translate( 'chart_leg_changed_numb' ), intval( $info[3] ) ), array( $app->translate( 'chart_leg_invalid_numb' ), intval( $info[4] ) ), array( $app->translate( 'chart_leg_no_service' ), intval( $info[5] ) ), array( $app->translate( 'chart_leg_congestion' ), intval( $info[6] ) ), array( $app->translate( 'chart_leg_network_fail' ), intval( $info[7] ) ), array( $app->translate( 'chart_leg_other_fail' ), intval( $info[8] ) ) );
                $data = array( 'success' => true, 'message' => '', 'content' => $arr );
            }
            else
                $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );
        }
        else
            $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );

        return $data;
    }
