<?php
    require_once ('constants_snmp.php');
    class ChartPopulator extends Constants_SNMP
    {
        public static function getMiniChartDataByDevice( $arr_devices )
        {
            $tag_out = self::K3LDEVICESTATSOUTGOING;
            $tag_comp = self::K3LDEVICEOUTGOINGCOMPLETED;
            $tag_err = self::K3LDEVICEOUTGOINGERROR;
            $arr_seriais = array( );
            foreach( $arr_devices as $k => $v )
            {
                $serial = $v['serial'];
                $query = "OID {$tag_out}.{$serial};OID {$tag_comp}.{$serial};OID {$tag_err}.{$serial}";
                Querist::ask( $query, $resp );
                $resp = explode( ';', $resp );

                $comp = intval( $resp[1] );
                $err = intval( $resp[2] );
                $qty = intval( $resp[0] );
                $not_asw = $qty != ($comp + $err) ? $qty - ($comp + $err) : 0;
                $arr_seriais[$serial] = array( $comp, $err, $not_asw );
            }
            return $arr_seriais;
        }

        public static function getMiniChartDataByLink( $arr_devices )
        {
            $tag_out = self::K3LDEVICELINKSTATSOUTGOING;
            $tag_comp = self::K3LDEVICELINKOUTGOINGCOMPLETED;
            $tag_err = self::K3LDEVICELINKOUTGOINGERROR;

            $arr_seriais = array( );
            foreach( $arr_devices as $k => $v )
            {
                $serial = $v['serial'];
                for( $i = 0; $i < sizeof( $v['links'] ); $i++ )
                {
                    $query = "OID {$tag_out}.{$serial}.{$i};OID {$tag_comp}.{$serial}.{$i};OID {$tag_err}.{$serial}.{$i}";
                    Querist::ask( $query, $resp );
                    $resp = explode( ';', $resp );

                    $comp = intval( $resp[1] );
                    $err = intval( $resp[2] );
                    $qty = intval( $resp[0] );
                    $not_asw = $qty != ($comp + $err) ? $qty - ($comp + $err) : 0;
                    $arr_seriais["{$serial}-{$i}"] = array( $comp, $err, $not_asw );
                }
            }
            return $arr_seriais;
        }

        public static function getMiniChartDataByChannel( $device, $link, $gc )
        {
            $tag_out = self::K3LDEVICECHANNELSTATSOUTGOING;
            $tag_comp = self::K3LDEVICECHANNELSTATSOUTGOINGCOMPLETED;
            $tag_err = self::K3LDEVICECHANNELSTATSOUTGOINGERROR;

            $serial = $device['serial'];
            for( $i = $gc[0]; $i <= $gc[1]; $i++ )
            {
                $query_out[] = "OID {$tag_out}.{$serial}.{$i}";
                $query_comp[] = "OID {$tag_comp}.{$serial}.{$i}";
                $query_err[] = "OID {$tag_err}.{$serial}.{$i}";
            }
            Querist::ask( implode( ';', $query_out ), $resp_out );
            Querist::ask( implode( ';', $query_comp ), $resp_comp );
            Querist::ask( implode( ';', $query_err ), $resp_err );

            $resp_out = explode( ';', $resp_out );
            $resp_comp = explode( ';', $resp_comp );
            $resp_err = explode( ';', $resp_err );

            $arr_seriais = array( );
            $i = 0;
            for ($j=$gc[0]; $j <= $gc[1] ; $j++)  
            {
                $comp = intval( $resp_comp[$i] );
                $err = intval( $resp_err[$i] );
                $qty = intval( $resp_out[$i] );
                $not_asw = $qty != ($comp + $err) ? $qty - ($comp + $err) : 0;
                $arr_seriais["$serial-$j"] = array( $comp, $err, $not_asw );
                $i++;
            }
            return $arr_seriais;
        }

        public static function getTotalIdleByDevice( $serial )
        {
            $tag = self::K3LDEVICECHANNELCOUNTIDLE;
            Querist::ask( "OID $tag.$serial", $idle_total );
            return $idle_total;
        }

        public static function getTotalIdleByLink( $serial, $link = '0' )
        {
            $tag = self::K3LDEVICELINKCHANNELCOUNTIDLE;
            Querist::ask( "OID $tag.$serial.$link", $idle_total );
            return $idle_total;
        }

        public static function getTotalBusyByDevice( $serial )
        {
            $tag = self::K3LDEVICECHANNELCOUNTBUSY;
            Querist::ask( "OID $tag.$serial", $busy_total );
            return $busy_total;
        }

        public static function getTotalBusyByLink( $serial, $link = '0' )
        {
            $tag = self::K3LDEVICELINKCHANNELCOUNTBUSY;
            Querist::ask( "OID $tag.$serial.$link", $busy_total );
            return $busy_total;
        }

        public static function getTotalFailByDevice( $serial )
        {
            $tag = self::K3LDEVICECHANNELCOUNTFAIL;
            Querist::ask( "OID $tag.$serial", $fail_total );
            return $fail_total;
        }

        public static function getTotalFailByLink( $serial, $link )
        {
            $tag = self::K3LDEVICELINKCHANNELCOUNTFAIL;
            Querist::ask( "OID $tag.$serial.$link", $fail_total );
            return $fail_total;
        }

        public static function getCallStatsByDevice( $serial )
        {
            $arr_oids = array( self::K3LDEVICESTATSINCOMING, self::K3LDEVICESTATSOUTGOING, self::K3LDEVICEOUTGOINGCOMPLETED, self::K3LDEVICEOUTGOINGERROR );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getCallStatsByLink( $serial, $link )
        {
            $arr_oids = array( self::K3LDEVICELINKSTATSINCOMING, self::K3LDEVICELINKSTATSOUTGOING, self::K3LDEVICELINKOUTGOINGCOMPLETED, self::K3LDEVICELINKOUTGOINGERROR );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$link}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getCallStatsByChannel( $serial, $channel )
        {
            $arr_oids = array( self::K3LDEVICECHANNELSTATSINCOMING, self::K3LDEVICECHANNELSTATSOUTGOING, self::K3LDEVICECHANNELSTATSOUTGOINGCOMPLETED, self::K3LDEVICECHANNELSTATSOUTGOINGERROR );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$channel}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getFailStatsByDevice( $serial )
        {
            $arr_oids = array( self::K3LDEVICECALLFAILBUSY, self::K3LDEVICECALLFAILNOANSWER, self::K3LDEVICECALLFAILREJECTED, self::K3LDEVICECALLFAILCHANGEDNUMBER, self::K3LDEVICECALLFAILINVALIDNUMBER, self::K3LDEVICECALLFAILOUTOFSERVICE, self::K3LDEVICECALLFAILCONGESTION, self::K3LDEVICECALLFAILNETWORKFAILURE, self::K3LDEVICECALLFAILOTHER );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            
            // $stats = "1;1;1;1;1;1;1;1;1";
            return explode( ';', $stats );
        }

        public static function getFailStatsByLink( $serial, $link )
        {
            $arr_oids = array( self::K3LDEVICELINKCALLFAILBUSY, self::K3LDEVICELINKCALLFAILNOANSWER, self::K3LDEVICELINKCALLFAILREJECTED, self::K3LDEVICELINKCALLFAILCHANGEDNUMBER, self::K3LDEVICELINKCALLFAILINVALIDNUMBER, self::K3LDEVICELINKCALLFAILOUTOFSERVICE, self::K3LDEVICELINKCALLFAILCONGESTION, self::K3LDEVICELINKCALLFAILNETWORKFAILURE, self::K3LDEVICELINKCALLFAILOTHER );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$link}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            
            // $stats = "1;1;1;1;1;1;1;1;1";
            return explode( ';', $stats );
        }

        public static function getFailStatsByChannel( $serial, $channel )
        {
            $arr_oids = array( self::K3LDEVICECHANNELSTATSCALLFAILBUSY, self::K3LDEVICECHANNELSTATSCALLFAILNOANSWER, self::K3LDEVICECHANNELSTATSCALLFAILREJECTED, self::K3LDEVICECHANNELSTATSCALLFAILCHANGEDNUMBER, self::K3LDEVICECHANNELSTATSCALLFAILINVALIDNUMBER, self::K3LDEVICECHANNELSTATSCALLFAILOUTOFSERVICE, self::K3LDEVICECHANNELSTATSCALLFAILCONGESTION, self::K3LDEVICECHANNELSTATSCALLFAILNETWORKFAILURE, self::K3LDEVICECHANNELSTATSCALLFAILOTHER );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$channel}}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            
            // $stats = "1;1;1;1;1;1;1;1;1";
            return explode( ';', $stats );
        }

    }
