<?php
    @session_start( );

    $AjaxFunctions['resetDevice'] = 'resetDevice';
    $AjaxFunctions['resetGSMChannel'] = 'resetGSMChannel';
    $AjaxFunctions['clearChannelStats'] = 'clearChannelStats';

    function resetDevice( )
    {
        $app = KSystem::getInstance( );
        if( verifyUserPermission( ) )
        {
            if( isset( $_REQUEST['board'] ) )
            {
                $board = preg_replace( '/[^0-9]/', '', $_REQUEST['board'] );
                $ip = isset( $_SESSION['DeviceList'][$board]['IP'] ) ? $_SESSION['DeviceList'][$board]['IP'] : NULL;

                if($ip)
                {
                    $kwebhelper = PHP_OS == 'WINNT' ? KROOT . "\\..\\..\\Tools\\kwebhelper resetmodule" : "/usr/sbin/kwebhelper resetmodule";
                    $r = exec( "{$kwebhelper} {$ip}", $output, $excode );
    
                    if( $excode )
                        $response = array( 'success' => TRUE, 'message' => $app->translate( 'resetDeviceSuccess' ) );
                    else
                        $response = array( 'success' => FALSE, 'message' => $app->translate( 'resetDeviceFail' ) );
                }
                else
                    $response = array( 'success' => FALSE, 'message' => $app->translate( 'resetDeviceFail' ) );

                return JSONencode( $response );
            }
            else
                return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( 'seriaNotInformed' ) ) );
        }
        else
            return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( 'userNoPermission' ) ) );
    }

    function resetGSMChannel( )
    {
        $app = KSystem::getInstance( );
        if( verifyUserPermission( ) )
        {
            if( isset( $_REQUEST['serial'] ) && isset( $_REQUEST['channel'] ) )
            {
                try
                {
                    if( Populator::resetGSMChannel( $_REQUEST['serial'], $_REQUEST['channel'] ) )
                        $response = array( 'success' => TRUE, 'message' => $app->translate( 'GSMChannelRestart' ) );
                    else
                        $response = array( 'success' => FALSE, 'message' => $app->translate( 'GSMChannelRestartFail' ) );
                    return JSONencode( $response );
                }
                catch(Exception $e)
                {
                    return JSONencode( array( 'success' => FALSE, 'message' => $app->translate( $e->getMessage( ) ) ) );
                }
            }
            else
                return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( 'seriaChannelNotInformed' ) ) );
        }
        else
            return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( 'userNoPermission' ) ) );
    }

    function clearChannelStats( )
    {
        $app = KSystem::getInstance( );
        if( verifyUserPermission( ) )
        {
            try
            {
                if( isset( $_REQUEST['serial'] ) && isset( $_REQUEST['channel'] ) )
                {
                    if( Populator::clearChannelStats( $_REQUEST['serial'], $_REQUEST['channel'] ) )
                        $response = array( 'success' => TRUE, 'message' => $app->translate( 'clearChannelStatSuccess' ) );
                    else
                        $response = array( 'success' => FALSE, 'message' => $app->translate( 'clearChannelStatFail' ) );

                    return JSONencode( $response );
                }
                else
                    return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( 'seriaChannelNotInformed' ) ) );
            }
            catch(Exception $e)
            {
                return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( $e->getMessage( ) ) ) );
            }

        }
        else
            return JSONencode( array( 'sucess' => FALSE, 'message' => $app->translate( 'userNoPermission' ) ) );
    }

    function verifyUserPermission( )
    {
        return (array_key_exists( 'login', $_SESSION ) && $_SESSION['loginAccess']['monitoring'] == 'full');
    }
