<?php
    @session_start( );
    $AjaxFunctions['updateDataDevices'] = 'updateDataDevices';

    function updateDataDevices( )
    {
        $app = KSystem::getInstance( );
        try
        {
            if( Populator::isK3LConnected( ) )
            {
                if( isset( $_SESSION['DeviceList'][0] ) )
                {
                    $changed = FALSE;
                    for( $i = 0; $i < count( $_SESSION['DeviceList'] ); $i++ )
                    {
                        $temp = Populator::populateDevice( $_SESSION['DeviceList'][$i] );
                        if( $temp != $_SESSION['DeviceList'][$i] )
                        {
                            $_SESSION['DeviceList'][$i] = $temp;
                            $changed = TRUE;
                        }
                    }
                    $json_response['Devices'] = $changed ? $_SESSION['DeviceList'] : array( );
                    $newData = ChartPopulator::getMiniChartDataByDevice( $_SESSION['DeviceList'] );
                    if(isset($_SESSION['DeviceMiniCharts']))
                    {
                        if($newData != $_SESSION['DeviceMiniCharts'])
                        {
                            $json_response['MiniCharts'] = $newData;
                            $_SESSION['DeviceMiniCharts'] = $json_response['MiniCharts'];
                        }
                        else
                            $json_response['MiniCharts'] = array();
                    }
                    else
                    {
                        $json_response['MiniCharts'] = $newData;
                        $_SESSION['DeviceMiniCharts'] = $json_response['MiniCharts'];
                    }
                    
                    $json_response['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $json_response['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $json_response );
                }
                else
                {
                    $CountDevices = 0;
                    $CountDevices = Populator::getDeviceCount( );
                    for( $i = 0; $i < (int)$CountDevices; $i++ )
                    {
                        $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                        $device = Populator::populateDevice( $device );
                        $deviceList[$i] = $device;
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $json_response['Devices'] = $deviceList;
                    $json_response['MiniCharts'] = ChartPopulator::getMiniChartDataByDevice( $deviceList );
                    $json_response['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $json_response['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $json_response );
                }
            }
            else
            {
                throw new Exception( 'k3lDown' );
            }

        }
        catch(Exception $e)
        {
            $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
            $ret['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
            return JSONencode( $ret );
        }
    }
