<?php
    @session_start( );
    $AjaxFunctions['updateDataLinks'] = 'updateDataLinks';

    function updateDataLinks( )
    {
        $app = KSystem::getInstance( );
        try
        {
            if( Populator::isK3LConnected( ) )
            {
                if( isset( $_SESSION['DeviceList'][0] ) )
                {
                    $deviceList = $_SESSION['DeviceList'];
                    $deviceUpdated = array( );
                    $changed = FALSE;
                    for( $i = 0; $i < count( $deviceList ); $i++ )
                    {
                        $tmp = Populator::populateLink( $deviceList[$i] );
                        if( $tmp != $deviceList[$i] )
                        {
                            $deviceList[$i] = $tmp;
                            $_SESSION['DeviceList'] = $deviceList;
                            $changed = TRUE;
                        }
                    }
                    $json_response['Devices'] = $changed ? $_SESSION['DeviceList'] : array( );
                    $newData = ChartPopulator::getMiniChartDataByLink( $_SESSION['DeviceList'] );
                    if(isset($_SESSION['LinkMiniCharts']))
                    {
                        if($newData != $_SESSION['LinkMiniCharts'])
                        {
                            $json_response['MiniCharts'] = $newData;
                            $_SESSION['LinkMiniCharts'] = $json_response['MiniCharts'];
                        }
                        else
                            $json_response['MiniCharts'] = array();
                    }
                    else
                    {
                        $json_response['MiniCharts'] = $newData;
                        $_SESSION['LinkMiniCharts'] = $json_response['MiniCharts'];
                    }
                    $json_response['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $json_response['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $json_response );
                }
                else
                {
                    $deviceList = array( );
                    $CountDevices = 0;
                    $CountDevices = Populator::getDeviceCount( );
                    for( $i = 0; $i < (int)$CountDevices; $i++ )
                    {
                        $links_count = 0;
                        $links_count = Populator::getLinkCount( $i );
                        if( $links_count > 0 )
                        {
                            $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                            $device = Populator::populateLink( $device );
                            $deviceList[] = $device;
                        }
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $json_response['Devices'] = $deviceList;
                    $json_response['MiniCharts'] = ChartPopulator::getMiniChartDataByLink( $deviceList );
                    $json_response['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $json_response['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );

                    return JSONencode( $json_response );
                }
            }
            else
            {
                throw new Exception( 'k3lDown' );
            }
        }
        catch(Exception $e)
        {
            $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
            $ret['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
            return JSONencode( $ret );
        }
    }
