var autoUpdateTimer = null;
var autoUpdateDelay = 0;

function updateData( justRefresh, module )
{
    switch (module)
    {
        case 'Devices':
            updateDataDevices( justRefresh );
            break;
        case 'Links':
            updateDataLinks( justRefresh );
            break;
        case 'Channels':
            updateDataChannels( justRefresh );
            break;
        case 'Services':
            updateDataServices( justRefresh );
            break;
        case 'NAPs':
            kgatewayMonitorNapStatus( );
            break;
        case 'SIMCards':
            kgatewayMonitorSimCardsStatus( );
            break;
    }

    if( !justRefresh )
    {
        updateDataTimer( module );
    }
}

function updateDataTimer( module )
{
    if( autoUpdateTimer )
    {
        clearTimeout( autoUpdateTimer );
    }
    if( autoUpdateDelay )
    {
        autoUpdateTimer = setTimeout( "updateData( false, '" + module + "')", autoUpdateDelay );
    }
}

function enableAutoUpdate( module, updatenow )
{
    $( '#monitoring-on' ).show( );
    $( '#monitoring-off' ).hide( );
    autoUpdateDelay = $( "#refreshDelay" ).val( ) * 1000;
    if( updatenow )
    {
        updateData( false, module );
    }
    else
    {
        updateDataTimer( module );
    }
}

function disableAutoUpdate( )
{
    $( '#monitoring-on' ).hide( );
    $( '#monitoring-off' ).show( );
    autoUpdateDelay = 0;
}

function getRefreshDelay( module )
{
    jQuery.kajax(
    {
        data : "ajaxTo=getRefreshDelay",
        url : GLOBALAjaxURL,
        dataType : "html",
        success : function( resp )
        {
            responseText = resp.replace( /[\r\n]+/g, "" );
            if( parseInt( responseText ) > 0 )
            {
                switch (responseText)
                {
                    case '0':
                        var index = '0';
                        break;
                    case '2':
                        var index = '2';
                        break;
                    case '10':
                        var index = '10';
                        break;
                    case '30':
                        var index = '30';
                        break;
                    default:
                        var index = '0';
                }
                $( '#refreshDelay' ).val( index );
                enableAutoUpdate( module, false );
            }
        }
    } );
}

function setRefreshDelay( delay, module )
{
    jQuery.kajax(
    {
        data : "ajaxTo=setRefreshDelay&delay=" + delay,
        url : GLOBALAjaxURL,
        dataType : "text",
        type : "POST",
        success : function( resp )
        {
            resp = resp.replace( /[\r\n]+/g, "" );
            if( parseInt( resp ) > 0 )
            {
                enableAutoUpdate( module, true );
            }
            else
            {
                disableAutoUpdate( );
            }
        }
    } );
}
    
function hideDiv( )
{
    $( "#popup" ).hide( 'slow' );
    $( '.blockscreen' ).addClass( 'displayNone' );
}

function colorMe( id )
{
    $comp = $( '#' + id );
    if( $comp != null )
        $comp.removeClass( 'green-dark' ).addClass( 'green-light' );
}