<?php
    require_once ('populator.php');
    require_once ('querist.php');
    require_once ('monitorService.php');

    class MonitorChannel
    {
        function __construct( )
        {
            if( Populator::isK3LConnected( ) )
            {
                $CountDevices = 0;
                $CountDevices = Populator::getDeviceCount( );
                for( $i = 0; $i < $CountDevices; $i++ )
                {
                    $device = array( 'serial' => '', 'model' => '', 'board' => $i, 'links' => array( ) );
                    $device = Populator::prePopulateChannels( $device );
                    $deviceList[$i] = $device;
                }
                $_SESSION['DeviceList'] = $deviceList;
                $_SESSION['errorMessage'] = MonitorService::checkMediaServerMessages( );
            }
            else
            {
                throw new Exception( 'k3lDown' );
            }
        }

        public static function getMessages( )
        {
            Global $image_dir;
            $app = KSystem::getInstance( );
            $alertMessage = $app->translate( MonitorService::getWarningMessage( ) );

            if( isset( $_SESSION['errorMessage'] ) && $_SESSION['errorMessage'] != '' )
            {
                $style1 = '';
                $style2 = 'displayNone';
            }
            elseif( isset( $alertMessage ) && $alertMessage != '' )
            {
                $style2 = '';
                $style1 = 'displayNone';
            }
            else
            {
                $style2 = 'displayNone';
                $style1 = 'displayNone';
            }

            $buff = '';
            $buff .= "<div id='divErrorMessage' class='errorMessage {$style1}' >";
            $buff .= "<img class='errorIco' src='{$image_dir}/imagens/error.png' />";
            $buff .= '<div id="divErrorMessageLine">' . $_SESSION['errorMessage'] . '</div>';
            $buff .= '</div>';
            $buff .= "<div id='divAlertMessage' class='errorMessage {$style2}' >";
            $buff .= "<img class='errorIco' src='{$image_dir}/imagens/error.png' />";
            $buff .= "<div id='divAlertMessageLine'>{$alertMessage}</div>";
            $buff .= '</div>';
            return $buff;
        }

        public static function getDevices( )
        {
            $app = KSystem::getInstance( );
            $buffer = '';

            $buffer .= '<input type="hidden" value="channels" id="current-monitoring" />';
            if( isset( $_SESSION['DeviceList'][0] ) && sizeof( $_SESSION['DeviceList'] > 0 ) )
            {
                $buffer .= '<div class="channels-holder">';
                $buffer .= '<div class="accordian-holder">';
                $buffer .= '<div class="accordian-blocker"></div>';
                $buffer .= '<div id="accordian-devices-channels">';
                $buffer .= '<ul><li class="active-devices"><h3 class="h3devices ImOpened background-dark"><span></span>' . $app->translate( 'devices' ) . '</h3><ul class="sanfona">';

                $deviceList = $_SESSION['DeviceList'];
                for( $i = 0; $i < count( $deviceList ); $i++ )
                {
                    $serial = $deviceList[$i]['serial'];
                    $board_num = $deviceList[$i]['board'];
                    $links_count = 0;
                    $links_count = Populator::getLinkCount( $i );
                    $type = Populator::getDeviceType( $serial );

                    if( $links_count > 0 )
                    {
                        if( !isset( $deviceList[$i]['isE1'] ) )
                            $deviceList[$i]['isE1'] = Populator::isE1( );

                        $isE1 = $deviceList[$i]['isE1'];
                    }

                    //NOT MODULAR
                    $buttonName = $app->translate( $deviceList[$i]['model'] ) . ' - ' . $serial;
                    if( $type != 22 )
                    {
                        if( $links_count > 0 )
                        {
                            $buffer .= "<li class='li-device'><label>{$buttonName}</label><ul>";

                            $link_ = ($type == 24 || $type == 3) ? 'HI' : '';
                            foreach( $deviceList[$i]['links'] as $k => $v )
                            {
                                $linkName = Populator::getLinkName( $serial, $k, $link_ );
                                $linkName = $linkName != '' ? $linkName : "Link $k";
                                $buffer .= "<li class='subitemm' onclick='exibicao({$k}, {$i}, this);'><a>{$linkName}</a></li>";
                            }
                            $buffer .= '</ul></li>';
                        }
                        elseif( $type == 17 ) //( $serial == 99 )
                        {
                            $buffer .= "<li class='li-device'><label>{$buttonName}</label><ul>";
                            $voip_count = Populator::getVoIPChannelCount( $serial );
                            $qtde_voip_pages = ceil( $voip_count / 50 );
                            $max = 49;
                            $min = 0;
                            for( $q = 1; $q <= $qtde_voip_pages; $q++ )
                            {
                                if( $q == $qtde_voip_pages )
                                    $max = $voip_count - 1;
                                $buffer .= "<li class='subitemm' onclick='exibicaoGC({$serial}, {$board_num}, 99, \"{$min}|{$max}\", this);' ><a>" . $app->translate( 'channels' ) . " {$min} - {$max}</a></li>";
                                $min = $min + 50;
                                $max = $max + 50;
                            }
                            $buffer .= '</ul></li>';
                        }
                        else
                        {
                            $buffer .= "<li class='li-device'><label>{$buttonName}</label><ul>";
                            $ch_count = (Populator::getChannelCount( $serial )) - 1;
                            $buffer .= "<li class='subitemm' onclick='exibicao(99,{$board_num}, this);' ><a>" . $app->translate( 'channels' ) . " 0 - {$ch_count}</a></li></ul></li>";
                        }
                    }
                    else
                    {
                        if( $links_count > 0 )
                        {
                            $buffer .= "<li class='li-device'><label>{$buttonName}</label><ul>";
                            $link_pass = $type == 24 || $type == 3 ? 'HI' : '';
                            foreach( $deviceList[$i]['links'] as $k => $v )
                            {
                                $linkName = Populator::getLinkName( $serial, $k, $link_pass );
                                $linkName = $linkName != '' ? $linkName : "Link $k";
                                $buffer .= "<li class='subitemm' onclick='exibicao({$k}, {$i}, this);' ><a>{$linkName}</a></li>";
                            }

                            if( $deviceList[$i]['type'] == 22 )
                            {
                                $chCount = Populator::getChannelCount( $serial );
                                $ch = $isE1 ? 30 : 24;
                                $startCh = ($links_count * $ch);

                                if( $startCh < $chCount )
                                    $buffer .= "<li class='subitemm' onclick='showModularChannels({$board_num}, {$serial}, 99, {$startCh}, {$chCount}, this);' ><a>" . $app->translate( 'othersChannels' ) . '</a></li>';
                            }
                            $buffer .= '</ul></li>';
                        }
                        else
                        {
                            $chCount = Populator::getChannelCount( $serial );
                            $buffer .= "<li class='li-device'><label>{$buttonName}</label><ul>";
                            $buffer .= "<li class='subitemm' onclick='showModularChannels({$board_num}, {$serial}, 99, 0, {$chCount}, this);' ><a>";
                            $buffer .= $app->translate( 'channels' ) . ' 0 - ' . ($chCount - 1) . '</a></li></ul></li>';
                        }
                    }
                }
                $buffer .= '</ul></li>';
                $buffer .= '<li><h3 class="ImClosed h3Columns background-dark"><span></span>' . $app->translate( 'columns' ) . '</h3><ul class="sanfona">';

                $fields = array( 'channel', 'signaling', 'status', 'details', 'dialNumber', 'callDuration', 'averageTimeCalls', 'inbound', 'outbound', 'sim_card', 'oper', 'strength', 'IMEI', 'ICCID', 'options' );
                foreach( $fields as $k => $v )
                {
                    $buffer .= "<li><div><input onclick='executeFilter(this);' type='checkbox' id='{$v}' value='{$v}' />";
                    $buffer .= "<label for='{$v}'>" . $app->translate( $v ) . "</label></div></li>";
                }
                $buffer .= '</ul></li>';
                $buffer .= '</ul></div>';
                $buffer .= '</div><div class="holder-exibicao"><div id="exibicao"></div></div>';
            }
            else
                $buffer .= $app->translate( 'noChannels' );

            return $buffer;
        }

    }
