<?php
    require_once ('populator.php');
    require_once ('querist.php');
    require_once ('monitorService.php');
    require_once ('monitorDevice.php');

    class MonitorLink
    {
        function __construct( )
        {
            if( Populator::isK3LConnected( ) )
            {
                $deviceList = array( );
                $CountDevices = 0;
                $CountDevices = Populator::getDeviceCount( );
                for( $i = 0; $i < (int)$CountDevices; $i++ )
                {
                    $links_count = 0;
                    $links_count = Populator::getLinkCount( $i );
                    if( $links_count > 0 )
                    {
                        $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                        $device = Populator::populateLink( $device );
                        $deviceList[] = $device;
                    }
                }
                unset($_SESSION['LinkMiniCharts']);
                $_SESSION['DeviceList'] = $deviceList;
                $_SESSION['errorMessage'] = MonitorService::checkMediaServerMessages( );
            }
            else
            {
                throw new Exception( 'k3lDown' );
            }
        }

        public static function showLinks( )
        {
            Global $image_dir;
            $app = KSystem::getInstance( );
            $alertMessage = $app->translate( MonitorService::getWarningMessage( ) );

            if( isset( $_SESSION['errorMessage'] ) && $_SESSION['errorMessage'] != '' )
            {
                $style1 = '';
                $style2 = 'displayNone';
            }
            elseif( isset( $alertMessage ) && $alertMessage != '' )
            {
                $style2 = '';
                $style1 = 'displayNone';
            }
            else
            {
                $style2 = 'displayNone';
                $style1 = 'displayNone';
            }

            $buffer = '';
            $buffer .= "<div id='divErrorMessage' class='errorMessage $style1' >";
            $buffer .= "<img class='errorIco' src='$image_dir/imagens/error.png' />";
            $buffer .= '<div id="divErrorMessageLine">' . $_SESSION['errorMessage'] . '</div>';
            $buffer .= "</div>";

            $buffer .= "<div id='divAlertMessage' class='errorMessage $style2' >";
            $buffer .= "<img class='errorIco' src='$image_dir/imagens/error.png' />";
            $buffer .= '<div id="divAlertMessageLine">' . $alertMessage . '</div>';
            $buffer .= '</div>';

            $buffer .= '<input type="hidden" value="links" id="current-monitoring" />';

            if( isset( $_SESSION['DeviceList'][0] ) && sizeof( $_SESSION['DeviceList'] ) > 0 )
            {
                $deviceList = $_SESSION['DeviceList'];
                $buffer .= '<table id ="linkTable" border="1" class="tabelaLinks zebra">';
                $buffer .= '<thead><tr>';
                $buffer .= '<th class="link" scope="col">' . $app->translate( 'link' ) . '</th>';
                $buffer .= '<th class="status" scope="col">' . $app->translate( 'status' ) . '</th>';
                $buffer .= '<th class="label-alarms" scope="col">' . $app->translate( 'alarms' ) . '</th>';
                $buffer .= '<th class="variations" scope="col">' . $app->translate( 'variations' ) . '</th>';
                $buffer .= '<th class="signaling" scope="col">' . $app->translate( 'signaling' ) . '</th>';
                $buffer .= '<th class="options" scope="col">' . $app->translate( 'options' ) . '</th>';
                $buffer .= '</tr></thead><tbody>';

                $column = 0;
                for( $i = 0; $i < count( $deviceList ); $i++ )
                {
                    $serial = $deviceList[$i]['serial'];
                    if( count( $deviceList[$i]['links'] ) > 0 )
                    {
                        for( $j = 0; $j < count( $deviceList[$i]['links'] ); $j++ )
                        {
                            $column++;
                            $id = $j;
                            $link = $serial . '.' . $id;
                            $linkString = $link;
                            $buffer .= "<tr><td id='links-{$serial}-link-{$id}' >";

                            $linkPassive = FALSE;
                            if( isset( $deviceList[$i]['type'] ) )
                            {
                                if( $deviceList[$i]['type'] == 24 || $deviceList[$i]['type'] == 3 )
                                {
                                    $linkString .= ' (' . MonitorDevice::getRX( $id ) . ')';
                                    $linkPassive = TRUE;
                                }
                            }
                            else
                                $linkString .= '';

                            $linkString .= $deviceList[$i]['links'][$j]['nick'] != '' ? ' - ' . utf8_decode( $deviceList[$i]['links'][$j]['nick'] ) : '';
                            $buffer .= "<label class='serial-sync'>{$linkString}</label>";
                            $buffer .= $deviceList[$i]['links'][$j]['sync'] ? '<label class="sync">&nbsp;(Sync)</label>' : '<div class="sync">&nbsp;</label>';

                            $buffer .= '</td>';
                            $buffer .= "<td id='links-{$serial}-status-{$id}'><b>" . $deviceList[$i]['links'][$j]['status'] . "</b></td>";

                            $buffer .= "<td class='alarms' id='links-{$serial}-alarms-{$id}' >";
                            if( isset( $deviceList[$i]['links'][$j]['alarms'] ) )
                            {
                                $alarms = $deviceList[$i]['links'][$j]['alarms'];
                                $existAlarm = false;
                                foreach( $alarms as $key => $value )
                                {
                                    if( $value )
                                    {
                                        $buffer .= $app->translate( $key ) . '</br>';
                                        $existAlarm = true;
                                    }
                                }
                                if( !$existAlarm )
                                    $buffer .= '<b>-</b>';
                            }
                            else
                                $buffer .= '<b>' . $app->translate( 'deviceUnreacheable' ) . '</b>';
                            $buffer .= '</td>';
                            $buffer .= "<td class='alarms' id='links-{$serial}-variations-{$id}' >";

                            $existsVariations = existsVariations( $deviceList[$i]['links'][$j]['variations'] );

                            $viewImg = $existsVariations ? 'view2' : 'view1';
                            $buffer .= "<span id='links-{$serial}-variations-span-{$id}' >";
                            $buffer .= "<a href='#' onclick='viewVariations(event,{$serial},{$id}); return true;' >";
                            $buffer .= "<img class='marginRight3px' title='{$app->translate('toView')}' src='$image_dir/imagens/{$viewImg}.png' />";
                            $buffer .= '</a>';
                            $buffer .= '</span>';
                            if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                            {
                                $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'clean'" . ");updateDataLinks(true);\" >";
                                $buffer .= "<img title='{$app->translate('clearVariationsStats')}' src='$image_dir/imagens/clear.png' />";
                                $buffer .= '</a>';
                                $buffer .= '</td>';
                            }

                            $buffer .= "<td id='links-{$serial}-signaling-{$id}' >" . $deviceList[$i]['links'][$j]['signaling'] . '</td>';
                            $buffer .= "<td class='alarms displayFlex' id='links-{$serial}-options-{$id}' >";
                            if( $_SESSION['loginAccess']['monitoring'] == 'full' )
                            {
                                $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'restart'" . ");\" >";
                                $buffer .= "<img title='{$app->translate('resetLink')}' class='marginRight5px marginTop12px' src='$image_dir/imagens/reset.png' />";
                                $buffer .= '</a>';

                                if( $linkPassive )
                                {
                                    $buffer .= "<a><img class='marginTop12px' title='{$app->translate('toBlockDenied')}' src='$image_dir/imagens/blockdenied.png' /></a>";
                                    if( $j & 1 )
                                        $buffer .= "<a><img class='chartDenied' src='$image_dir/imagens/chartdenied.png' title='" . $app->translate( 'generateChartsDenied' ) . "' /></a>";
                                    else
                                        $buffer .= "<div class='miniChart' id='chart{$serial}-{$j}' ></div>";
                                }
                                else
                                {
                                    $buffer .= "<a href='#' onclick=\"operationLink(" . $serial . "," . $id . ",'block'" . ");\" >";
                                    $buffer .= "<img class='marginTop12px' title='{$app->translate('toBlock')}' src='$image_dir/imagens/block.png' /></a>";
                                    $buffer .= "<div class='miniChart' id='chart{$serial}-{$j}' ></div>";
                                }
                            }
                            else
                                $buffer .= '-';
                            $buffer .= '</td>';
                        }
                    }
                    $buffer .= '</tr>';
                }
                $buffer .= '</tbody></table>';
                $buffer .= '<input type="hidden" id="lang" value="' . $app->getLanguage( ) . '" name="lang" />';
            }
            else
                $buffer .= '<span id="noDeviceLink">' . $app->translate( 'noDeviceLink' ) . '</span>';

            $buffer .= "<script>updateDataLinks(true);</script>";
            return $buffer;
        }
    }

    function existsVariations( $a )
    {
        $existe = 0;
        foreach( $a as $key => $value )
        {
            if( $value > 0 )
                $existe++;
        }
        return $existe > 0 ? true : false;
    }
