<?php
    /* Only for debug proposes use ?example */
    if( isset( $_REQUEST['example'] ) )
        error_reporting( E_ALL );

    /* Important defines */
    define( 'QUERY_INFORMATION_PORT', 14130 );
    define( 'QUERY_INFORMATION_HOST', '127.0.0.1' );
    define( 'SOCKET_CONNECTION_BUFFER_SIZE', 2048 );

    /*
     * Handle the socket connection
     */
    class SocketConnection
    {
        /* Handles the connection resources (endpoint for communication) */
        private $socket_handle;

        public function __construct( $host = QUERY_INFORMATION_HOST, $port = QUERY_INFORMATION_PORT, $socket_domain = AF_INET, $socket_type = SOCK_STREAM )
        {
            $this->socket_handle = socket_create( AF_INET, SOCK_STREAM, SOL_TCP );
            @socket_connect( $this->socket_handle, $host, $port );
        }

        public function __destruct( )
        {
            @socket_shutdown( $this->socket_handle );
            @socket_close( $this->socket_handle );
        }

        /*
         * Write and Receive data from a connection
         * already stabilished, return true/false
         */
        public function writeAndRecv( &$data_in, &$data_out )
        {
            if( !$this->socket_handle )
                return false;
            if( @socket_write( $this->socket_handle, $data_in, strlen( $data_in ) ) === false )
                return false;

            socket_recv( $this->socket_handle, $data_out, SOCKET_CONNECTION_BUFFER_SIZE, MSG_WAITALL );
            return true;
        }

    }